 /*
    Parrior.cs - Custom Warrior class for mmoglider - by pontus


    Special factions
    Horde
        2 - Orc
        5 - Forsaken (UD)
        6 - Tauren
      116 - Troll
     1610 - blood elf

    Alliance
        1 - Human
        3 - Dwarf
        4 - Night Elf
      115 - Gnome  
     1629 - Dranei
*/

/*

  Key features
    Can kill stuff

  Philisophy when adding features:
    Keep it simple
    Test alot
    Lots of configuration
    Try not to make combat moves static (react to current conditions rather than having fixed seqeuences)
    

  Release history

  0.0.1 - Initial public alpha relase
    Features
      Rend, Heroic Strike, Battle Shout, Thunderclap, Charge, Add Avoidance, Smart pulling
      Lots of misc non-class specifics stuff from Pogue v0.5.0
    Fixes

  0.2.4 - Reached lvl 24
    New Features
      Overpower works. That was a a bit tricky, relies on combat log parsing for the dodge
      Shield Bash, Cleave, Execute
      Avoid aggroing neutrals on AoE effects
      Many more configuration options
      Backup if too close to charge
    Fixes
      Charge is smoother
      Sometimes we got "I am stuck" after a charge, should be fixed now

  0.3.1 - Reached lvl 31 ( no berserker stance yet though)
    New Features
      Don't waste all rage on HS if we want to do something else
      Recast thunderclap, rend, hamstring and demoshout if it was dodged/resisted/missed or other reasons
      Sunder Armor
      Saves information about mobs behavior in a file
      Stance changing, it changes to battle as needed for charge. 
      Mortal Strike (not tested with MS on the key, might need some tweeks to work fine)
      Pummel, its using the same logic as shield bash and that works good. 
    Fixes
      Cleave works
      Lots and lots of small tweaks eveywhere


  0.3.6 - Reached lvl 36
    New Features
      Detects if a mob is immune to rend
      Fight back in PvP, if attacked (Uses the same routine as regulat fightning)
    Fixes
      Mounting before loot fixed. And dismount before charge. 
      Cleave works better, not distrupted by heroic strike
      Sunder Armor has higher priority
      Charge logic more robust!?


  0.4.2 -
    New Features
      Slam
      Sweeping Strikes      
      Shield Slam (untested)
      Bloodthirst
      Bloodrage
      MS works better not that I can test it for real :p
      Added option for min rage when to Heroic Strike
      Change stance to reach Pummel, configurable
      The ability to use different stance when fighting casters
    Fixes
      Thunder Clap duration depends on level now
      Thunder Clap and Demoarlizing Shout should not be spammed on leftover adds anymore. We might miss some, but that's better than spamming. 
      Same with rend, if it was resisted or missed it will not be recast. Safer this way until I fix it another way. 
      
  0.4.6 - Major protection spec improvements, and some fury love
    New Features
      Revenge
      Last Stand
      Concussion Blow
      Shield Block (used primarily to enable the revenge skill)
      Stance change from defensive to battle do execute
      Option to change stance when we got adds
      Berserker Rage
    Fixes
      Cleave has higher priority, only the most important skills are allowed to use rage when cleave is in the air
      The file that saves information on mobs was cleared if you started glideing but was too far away from the profile.
      Aborts the attack sequence any time a mob is dead. A bit snapper to move on to the next mob. 


   0.5.2
     New Features
       Checking of keys on action bars before starting to glide. 
       Rampage
       Tauren War Stomp :p
       Homemade eating function. Should avoid some oddities with the builtin function. 
       Intercept
     Fixes
       Tries do charge more than once
       Some tweaks to mount code
       A little oddity if pulling a ranged mob with ranged before realizing it is ranged. It was blacklisted. 
       Fixed a bug in the configuration screen. Usable item1 had the wrong text for the condition "We got adds"
       Potion Life configuration was ignored and forgotten.
       
   0.6.2
     New Features
       Support for Focused Rage talent
       Bloodrage before charge as an option
       Undead racial Cannibalize
       Victory Rush
       Jump out from AoE effects (Spore Cloud, Chemical Flames, Flame Wave) 
       Configurable max rage to loose when changing stance. It will not change stance if we loose more rage that the configured value. 
       Option to disable keycheck at startup. 
     Fixes
       It tried to use hamstring in defensive stance. 
       Starts to try to charge at 30yds distance. It often suceeds at larger range than 25. 

   0.6.7
     New Features
       Active PvP works, lots of PvP tweaks. Tested in AV. 
       Dismount if we are close to a mine. Mining mounted works bad, only the one "hack" on the mine is performed. 
       Death Wish. Not tested but the logic is simple
       Move to get adds in front of us
     Fixes
       Cannibalize might work. I got no easy way to test it. 
       
   0.6.7 Tank
     New Features
       Party protection mode. 

   0.6.8 
     New Features
       Slam Spam. Slam can be configured in a "spam mode", when the Rage limit to activate slam is reached Slam is repeated as much as possible the the next 6 seconds
     Fixes
       Add detection did not work properly in party gliding
       Follower mode in party gliding should not complain about bad tag anymore
       Added some workarounds for gliderbugs causing the initial keycheck to fail
       Frostwolf mount added. 

   0.6.9
     New Features
       You can put commanding shout on the key for battle shout if you prefer that. 
       Changed the way mob tendencies are loaded/saved to a file. tnx to Tearinitup537 for some structure of things. 
       Possibily to stop learning a mobs behavior. Edit the file MobTendencies.txt while glider is not running. 
       Refreshes sunders if they are about to time out (after 25s). Parrior is an imba tank :p
       Intimidating - Bandage
       Weight/Sharpeninig stones, both for main and offhand. The weapon buff must be named "stone"-something
       Support for food and potion buffs. Same idea as trinkets, general and configurable. 
     Fixes
       Mount buff detection more flexible, any mount should be possible.
       Some small tweaks to charge. Tries faster to charge after a failed charge
       A few totems addes to the list of things to not run away from. I'll add Hamuts new CreatureType when it is released. 

   0.7.0
     Fixes
       Sharpening/Weightstones fixed, the weapon buff detection looked for the wrong buffname
       Intimdating-Bandage fixed
       New key added for Mount. Not relying on Gliders defult key. 
       Added Parrior.Mount and Parrior.Bandage as new keys

   0.7.1
     New Features
       Whirlwind, it's a new key too. Update you keys.xml.      
       Automatic detection of buff name of buff items (food/potions). If you leave the configured name empty it will automaticaly detect the buff name and change configuration. 
       Improved in combat movement and speed of combat moves. Handles Stuns much better
       Taunt to protect party members
       Tendency editor in the configuration dialog
     Fixes
       Stop meleeing before Intimidating-Bandage
       Removed the "ran away" check if we are fighting monsters.
       Tweaked the eating of buff food to wait a little before eating to get us out of combat.
       Better at HS spam if needed, you might want to up the min rage for HS a bit, or it will steal rage from other abilities

   0.7.2
     New features
       You can save and load settings from the configuration dialog. 
       Shadowmeld if players are near. Tries to shadowmeld before glider does "Stopping patrol". Totally untested
       Prevents glider from wanting go to buy water on vendor profiles
     Fixes
       Some tweaks to victory rush, works better now
       Checking for defensive stance before taunt

   0.7.3
     New features
       Keeps on killing until all adds are dead in one-kill mode
     Fixes
       Fixed a facing bug after running from potential adds
       Not avoiding totems as potential adds
       The newly added battle stance test at startup had some issues. 
       Shadowmeld again, might work this time
       Improved disabling/enabling of combatlog/chatlog parsing. Works better in one-kill mode now. 
       GConfig2.dll changed the current path after saving/loading setting in another dir that the glider basedir. Made things crash. 
       Added that last third talent in Tactical Mastery. 


   DOCUMENTATION OF MOBTENDENCIES
     
     Behaviour of mobs is learned by Parriors and the moves are adapted to that. 
     Sometimes it learns wrong and a new feature is added to adjust that and to lock that mob.
     The information is saved to a file in the Classes folder named MobTendencies.txt. The format of that file is very simple
     and you can edit it by hand using any texteditor (notepad works just fine). 
     Each line in that file corresponds to one mob. 
     A typical line would be: 
Deadwood Gardener:caster
or
Withered Giant:caster,unmovable 

     One tendency that is sometimes added when it should not be is the "unmovable" tendency. That tendency means
     that if we run from that mob it will not follow. This tencency is set if a mob is capable of doing ranged damage. 
     That will make parrior never range pull theese mobs and not move if potential adds are getting close.
     In some cases mobs are primary melee but on rare occations they do some ranged damage, that can 
     make Parrior classify theese as unmovable when they can actually be moved. To fix this you can edit the MobTendencies.txt
     by hand and lock that entry. 
     For example if the Deadwood Pathfinder above was indeed movable and Parrior had made a mistake then change the line to
Withered Giant:caster,locked 
     The "locked" will make Parrior not learn anything on that mob. It will stay as listed in the file.




   ISSUES
     After a mob has finished casting a spell glider keeps on reporting that it is casting. Leading to shieled bash/plummel being used when mob is not casting. 

   TODO/IDEAS
     Berserker Rage to break fear
     Party mode as follower. 
     If we get a caster as add and it is standing out of melee range, 
     Handle totems that mobs drop. 
     Charge can put you under water, that is not good. 
     Make a proper tanking mode for party glider, add control
     Check that all keys are really populated. Cry if it is not but do not use the skill.
     Make KeepSafeSleep more clever, it can look very bottish in crowded places
     Presets for GConfig2. Some kind of menu where you can save/load presets for the configuration tab


  COMBAT SKILLS. AND HOW TO CONFIGURE THEM
     How should the user be able to configure the fighting?

     One is idea is to put priorities on all abilities. It will always save rage to do a higher 
     priority move before a lower prio one unles the high-prio is on CD or it is pointless to do it. 
     Typical high-prio moves should be things that you don't have to do often, such as rend or
     thunder-clap, or situational moves such as overpower. "Rage dumpers" such as slam and 
     heroic strike should be lower prio.
     The question is how do you create a simple configuration interface for this? Some kind of
     list where you could drag/drop all skills and prioritize them would be nice. 

     The highest priority could be a "always keep enough rage to be able to perform theese if needed"

     Complementing this with that for each skill you can configure the conditions for when to use it. 

     Conditions and options for each skill   
       Hard means hard coded condition, coded into theclass
       Option means a option configurable in the config dialog window
       * mens it is implemented


       * Hamstring (lvl 8, 10 rage, battle, berserker, lasts 15s)
         * Hard:   Don't use if already applied to target
         * Hard:   Only applied to known runners
	 * Hard: Max target health 50%
	 * Option: Use

       * Shield Bash (lvl 12, 10 rage, battle, def, 12 s CD, silence(school) for 6s)
         Hard:   Shield equipped
         * Hard:   Target is casting
	 * Option: Use
	 * Option: Max target health
	 Option: Switch to shield to reach it
	 
       * Pummel  (lvl 38, 10 rage, silence)
         * Hard:   Target is casting
	 * Option: Use
	 * Option: Max target health         
	 * Option: Switch stance to reach (how much rageloss is acceptable?)

       * Execute  (lvl 24, battle, berserk, 15 rage)
         * Hard:   Target <= 20% health
	 * Option: Use
	 Option: Don't use when we got adds

       * Overpower (lvl 12, 5 rage, Battle)
         * Hard:   Target dodged
	 * Option: Use
	 Option: Switch stance to reach
 
       * Battle Shout(lvl 1, 10 rage, lasts 2 min)
         * Hard:   Don't use if already applied
	 * Option: Use

       * Demoralizing Shout(lvl 14, 10 rage, lasts 30s)
         * Hard:   Don't use if already applied
	 * Hard:   Don't use if we will agro close neutral mobs
	 * Option: Use
	 Option: Max target health (if its only one mob)
	 * Option: Use only for adds

       * Thunder Clap (lvl 6, 20 rage, battle, def, lasts 10s)
         * Hard:   Don't use if already applied
	 * Hard:   Don't use if we will agro close neutral mobs
	 * Option: Never/target high hp/close add/Always

       * Rend (lvl 4, 10 rage, battle, def, last 9-21s)
         * Hard:   Don't use if already applied
	 * Hard:   Don't rend immune mobs
	 * Option: Use
	 Option: Don't use when we got adds

       * Sunder Armor (lvl 10, 12-15 rage, stacks 5, lasts 30s)
         * Option: Use
         * Option: How many to stack
	 Option: Don't use when we got adds

       * Mortal Strike (lvl 40, 30 rage, 6s cooldown)
	 * Option: Use
         Option: Don't use when we got adds
         	 
       * Cleave (lvl 20, 20 Rage, 5 yd range) "next melee"
         * Hard:   Use only for adds
	 * Option: Use
	 
       * Heroic Strike (lvl1, 15-12 rage) "next melee"
	 * Option: Use
	 * Option: Min Rage
	 * Option: Interval, whats the idea with this really???
         Option: Don't when adds

       * Slam (lvl 30, 15 rage, 0.5-1.5s cast) 
	 * Option: Use
	 * Option: Min rage wait for it to complete before other skills are tried

       * Shield Slam (lvl 40, 20 rage, 31pt protecion, 6s CD)
         * Option: Use

       * Sweeping Strikes (lvl 30, 30 rage, battle, 30s cooldown, Your next 5 melee attacks strike an additional nearby opponent.)
         * Hard: At least 1 add
	 * Hard: Current target has HP>40%
         * Option: Use

       * Bloodrage (lvl 10, generates 20 rage at the cost of HP, puts you in combat for 10s)
         * Hard: My HP >= 50%
         * Option: Never/Target has high hp/Save for adds
         * Option: Min My HP when to use

       * Bloodthirst (lvl 38, 30 rage, 6s CD, good dmg, successful melee attacks will restore 10 health, 8s duration)
         * Option: Always/Target has high HP/Never

       * Revenge (lvl 14, 5 rage, def stance, must follow a block, dodge or parry)
         Option: Use

       * Concussion Blow (lvl 40 def,15 Rage, Stuns the opponent for 5 sec. 45s cooldown)
         * Options: Use
	 * Options: Save to stop spellcasts

       * Last Stand (lvl 20, temporarily grants you 30% of your maximum health for 20 sec. 8 min CD)
         * Option: Use
         * Option: Max my HP 
	 
       * Shield Block (lvl 16, 10 rage, def, 5s CD)
         * Hard: Use to enable revenge
         * Option: Use

      * Berserker Rage (lvl 32, Bersek, immune to Fear/Incap and generating extra rage when taking damage for 10s. 30s CD
        * Option: Never/Target has high hp/Save for adds

      * Rampage (lvl 50, 20 Rage, AP +30/40/50, after a crit. stack up to 5 times. 30s duration)
        * Option: Never/Target has high hp/Always

      * Intercept (lvl 30, 10 rage, Bersek, charge in combat, 3s stun, 30s CD), hmm another spell breaker?
        * Option : Use

      * Victory Rush  (lvl 62, battle berserk, Instant attack.  Can only be used within 20 sec after you kill an enemy

      * Death Wish (lvl 30, 10 rage, damage done +20%, immune to Fear, damage taken +5%.  Lasts 30 sec. 3 min CD
        * Option: Never/Adds/High HP

      * Commanding Shout (lvl 68, 10 rage, increases max HP, keeps same % HP left, overwrites Battle shout)
         Hard: Can be used instead of battleshout

      * Intimidating Shout (lvl 22, 25 rage, 10 yards, fear 5 mobs, 3 min CD)
         Intimidating bandage

       Whirlwind  (lvl 36, 25 rage, Bersek, attack up to 4 enemies within 8 yards, 10s CD)
         Option: Use
         Option: How many adds (within 8 yds)
         Option: Min Rage

       Devastate (lvl 50, 15 rage, 1h weapon. instant attack 50% of weapon dmg plus 15 for each Sunder

       Recklessness (lvl 50, Berserker, 30 min CD, crit with most attacks the next 15 sec, damage taken + 20%.)

       Shield Wall (lvl 28 def, reduce damage taken by 75% for 10 sec. 30 min CD)
         Another lifesaver

       Retaliation (lvl 20, battle, 30 min CD!!!!) 
         Option: Use
         Option: How many adds
       
       Disarm (lvl18 def, 20 rage, Disarm the enemy's weapon for 10 sec.) 
         Option: Use
         Hard: detect disarm immune mobs
	 
      * Taunt 

     SKIP
       Mocking Blow (lvl 16 , 10 rage, battle, 2 min CD)
       Intervene (lol)
       Piercing Howl( lvl 20, daze all in 10yds, 50% slower for 6s)

     PRESETS
       1H <lvl40
       2H <lvl40
       Prot
       2H MS
       DW Fury
       2H Fury

     KEYS

       Combat (bar 5)
         1 Ranged
         2 Rend (GCD probe, don't move this)
         3 Thunder Clap
         4 Charge
         5 Cleave
         6 Heroic Strike
         7 Overpower
         8 Execute
         9 Mortal Strike/Shield Slam/Bloodthirst
         0 Sweeping Strikes/Shield Block/Rampage
         - Potion
         = Revenge

       Rest (bar 6)
         1 Food
         2 Battle Shout/Commanding Shout
         3 Demo Shout
         4 Sunder Armor
         5 Berserker Rage
         6 Slam
         7 Hamstring
         8 Pummel
         9 Shield Bash
         0 Blood Rage
         - Bandage
         = Hearth

       Bar 2
         1 Use item 1
         2 Use item 2
         3 Use item 3
         4 Use item 4
         5 Defensive Stance
         6 Battle Stance
         7 Berserker Stance
         8 Concussion Blow/Death Wish
         9 Last Stand
         0 Victory Rush
         - Undead Cannibalize/Tauren War Stomp/NE Shadowmeld
         = Intercept


       Bar 4
         1 Intimidating Shout
         2 Taunt
         3 Mocking Blow
         4 Main Hand Weapon Buff (Sharpening/Weight - stone)
         5 Off Hand Weapon Buff (Sharpening/Weight - stone)
         6 Buff consumable 1
         7 Buff consumable 2
         8 Buff consumable 3
         9 Mount
         0 Whirlwind
         

    */


//////////////////////////////////////////////////////////////////////////
//

//!Reference: WowTriangles.dll
//!Reference: System.Drawing.dll
//    !Reference: AdvancedMap.dll

//!Class: Glider.Common.Objects.Parrior

using System;
using System.Collections.Generic;
using System.Threading;
using System.Reflection;
using System.Text;
using Glider.Common.Objects;
using System.Windows.Forms;
using System.Drawing;

using TaskParser;
using WowTriangles;
// using AdvancedMap;

namespace Glider.Common.Objects
{

    public class Parrior : PPather
    {
        string version = "0.7.3p3";

        #region Parrior props

        enum PullStyle_e { Ranged, Charge, Walk }
        enum ChaseStyle_e { Chase, ChaseSafe, NoChase }
        enum ItemUse_e { NoUse, MyHealth50, MyHealth25, MobHealth75, MobHealth50, SaveForAdds, Feared }
        enum BuffUse_e { NoUse, Food, Potion }
        enum PvPStyle_e { Active, FightBack, Die };
        enum SlamMode_e { Never, OneShot, Spam };
        enum Stance_e { Battle, Defensive, Berserker, Unknown };
        enum SkillCondition_e
        {
            Never,
            Always,
            Mob50HP,
            Add,
            CloseAdd,
            BeforeCharge,
            Silence
        };


        // Configurable parameters

        PullStyle_e PullStyle = PullStyle_e.Charge;
        bool PullRangedAvoidAdds = true;

        ChaseStyle_e ChaseStyle = ChaseStyle_e.ChaseSafe;
        bool ShootRunners = true;   // Shoot runners

        bool RunFromAddsInCombat = true;  // Move away if mobs are getting to close while in combat
        int AvoidAddDistance = 18;    // Avoid adds when the get this close to me
        int AvoidAddDistanceCombat = 23;   // Avoid adds when the get this close to me

        int LurkTime = 8;     // Max time to lurk waiting for potential adds to walk away
        int SneakTime = 10;    // Max time to try to get behind a mob

        int MyPullDistance;

        double PotionLife = 1.0;

        int ChargeRange = 24;

        bool UseRend;
        bool UseIntercept = true;
        bool UseConcussion;
        bool SaveConcussionForCast;
        bool UseExecute;
        bool UseVictoryRush;
        bool UseBattleShout;
        bool UseOverpower;
        bool UseRevenge;
        bool UseShieldBash;
        bool UseShieldBlock;
        bool UsePummel;
        bool UseLastStand;
        bool UseDisarm;
        double LastStandLife;

        bool UseIntimidatingBandage;
        double IntimidatingBandageLife;

        bool PummelChangeStance = true;
        int SilenceHealth;

        bool UseHamstring;
        bool UseMS;
        bool UseShieldSlam;
        bool UseSweeping;
        SlamMode_e UseSlam;
        int SlamMinRage;

        int WhirlwindAdds;
        int WhirlwindMinRage;

        bool UseHeroic;
        int HeroicMinRage;

        SkillCondition_e UseThunder;
        SkillCondition_e UseDemo;
        SkillCondition_e UseCleave;
        SkillCondition_e UseBloodrage;
        SkillCondition_e UseSunder;
        SkillCondition_e UseBloodthirst;
        SkillCondition_e UseBerserkerRage;
        SkillCondition_e UseDeathWish;
        SkillCondition_e UseRampage;
        SkillCondition_e UseWarStomp;
        bool UseShadowmeld;

        bool UseCannibalize;
        int SunderStack;

        int HeroicCost;
        int SunderCost;
        //int ExecuteCost; 
        int ThunderTalents;
        int ThunderCost;
        int BoomingTalents;
        int TacticalTalents;
        int FocusedRage;
        int WhirlwindTalents;
        int TauntTalents;
        int RageLeftOnStanceChange;
        int MaxRageLoss = 5;

        int HeroicInterval;  // in ms

        Stance_e StanceInCombat;
        Stance_e CasterStance;
        Stance_e AddStance;
        Stance_e PvPStance;

        bool SpamAlot = true;
        bool NoKeyCheck = false;
        bool NoJumpFromAoE = false;

        bool UseMount = true;
        int MountDistance = 50;

        ItemUse_e UseItem1 = ItemUse_e.NoUse;
        int UseItem1CD = 60;
        GSpellTimer UseItem1Timer;

        ItemUse_e UseItem2 = ItemUse_e.NoUse;
        int UseItem2CD = 60;
        GSpellTimer UseItem2Timer;

        ItemUse_e UseItem3 = ItemUse_e.NoUse;
        int UseItem3CD = 60;
        GSpellTimer UseItem3Timer;

        ItemUse_e UseItem4 = ItemUse_e.NoUse;
        int UseItem4CD = 60;
        GSpellTimer UseItem4Timer;


        BuffUse_e BuffItem1 = BuffUse_e.NoUse;
        string BuffName1 = "";

        BuffUse_e BuffItem2 = BuffUse_e.NoUse;
        string BuffName2 = "";

        BuffUse_e BuffItem3 = BuffUse_e.NoUse;
        string BuffName3 = "";

        bool AvoidOtherFaction = false;
        bool AvoidSameFaction = false;



        int RestHealth;
        bool UseBandage;
        int BandageHealth;
        int HarvestRange;

        PvPStyle_e PvPStyle = PvPStyle_e.FightBack;


        bool WeaponBuffMain;
        bool WeaponBuffOff;

        bool BeTank = false;
        bool UseTaunt = false;
        int TankSeconds = 5;

        ////
        // no configuration dialog for the ones below

        bool keymasher = true;
        int StanceDanceSleep = 600;
        bool SkipWaypoints = true; // Enable my special waypoint skipper, run post-combat
        double MaxDistanceFromStart = 35; // Prevent to get too far of track in PvP
        bool NoLineupAdds = false;

        bool WaitForChargeCooldown = false;


        // End configuration

        GSpellTimer AddBackup = new GSpellTimer(4 * 1000);
        GSpellTimer ForceNoMount = new GSpellTimer(6 * 1000);

        GSpellTimer Feared = new GSpellTimer(30000);
        GSpellTimer RendTimer = new GSpellTimer(9 * 1000, false);
        GSpellTimer DisarmTimer = new GSpellTimer(60 * 1000, false);
        GSpellTimer HeroicTimer;
        GSpellTimer ThunderTimer = new GSpellTimer(10 * 1000, false);
        GSpellTimer DemoTimer = new GSpellTimer(30 * 1000, false);
        GSpellTimer RampageTimer = new GSpellTimer(25 * 1000, false); // renew it it is only 5s left
        GSpellTimer HamstringTimer = new GSpellTimer(15 * 1000);
        GSpellTimer SweepingTimer = new GSpellTimer(30 * 1000, true);
        GSpellTimer BloodrageTimer = new GSpellTimer(60 * 1000, true);
        GSpellTimer ConcussionTimer = new GSpellTimer(45 * 1000, false);
        GSpellTimer LastStandTimer = new GSpellTimer(8 * 60 * 1000, false);
        GSpellTimer BerserkerRageTimer = new GSpellTimer(30 * 1000, false);
        GSpellTimer IntimidatingTimer = new GSpellTimer(3 * 60 * 1000, false);
        GSpellTimer WhirlwindTimer = new GSpellTimer(10 * 1000, false);
        GSpellTimer TauntTimer = new GSpellTimer(120 * 1000, false);

        GSpellTimer VictoryRushTimer = new GSpellTimer(20 * 1000, false);
        GSpellTimer DeathWishTimer = new GSpellTimer(3 * 60 * 1000, false);


        GSpellTimer PummelTimer = new GSpellTimer(10 * 1000, true);
        GSpellTimer WarStompTimer = new GSpellTimer(120 * 1000, true);
        GSpellTimer ShieldBashTimer = new GSpellTimer(12 * 1000, true);
        GSpellTimer ShieldBlockTimer = new GSpellTimer(7 * 1000, true);

        GSpellTimer BattleStanceTimer = new GSpellTimer(15 * 1000);

        GSpellTimer CombatTimer = new GSpellTimer(0);
        GSpellTimer LastKillTimer = new GSpellTimer(0);

        GSpellTimer AttackTimer = new GSpellTimer(0);
        GSpellTimer StanceChangeTimer = new GSpellTimer(8000); // After a stance change in combat wait this long to change back to default stance
        GSpellTimer SunderTimer = new GSpellTimer(25 * 1000); // renew sunder timer


        double CombatStartHealth = 0;
        GLocation MyCombatStartLocation;

        int LandedSunders = 0;
        double ZMax = 10;

        int evades = 0;
        bool sawAnEvade = false;

        Stance_e Stance = Stance_e.Unknown;

        bool StandingInAoE = false; // Combat log parser set this flag


        TendencyManager MobTendencies = new TendencyManager();
        bool ParriorRunning = false;

        #endregion

        #region GGameClass overrides
        public override string DisplayName
        { 
          get { return "PathParrior " + version + " " + base.DisplayName; }
        }

        public override void Startup()
        {
            Context.Log(DisplayName + " loaded");

            MobTendencies.LoadFromFile();
            Context.Log("Loaded tendency info on " + MobTendencies.GetMobCount() + " mobs");

            Context.CombatLog += new GContext.GCombatLogHandler(Context_CombatLog);
            Context.ChatLog += new GContext.GChatLogHandler(Context_ChatLog);

            base.Startup();
        }

        public override void Shutdown()
        {
            Context.CombatLog -= new GContext.GCombatLogHandler(Context_CombatLog);
            Context.ChatLog -= new GContext.GChatLogHandler(Context_ChatLog);
            Context.Log(DisplayName + " unloaded");

            base.Shutdown();
        }

        public override void OnStartGlide()
        {
            LoadConfig();
            MobTendencies.LoadFromFile();
            Context.Log("Loaded tendency info on " + MobTendencies.GetMobCount() + " mobs");

            base.OnStartGlide();
            mover.Stop();


            Feared.ForceReady();
            VictoryRushTimer.ForceReady();


            int td = ThunderDuration();
            ThunderTimer = new GSpellTimer(td, false);
            Context.Log("Thunder Clap duration is : " + (td / 1000) + " seconds");
            int rd = RendDuration();
            RendTimer = new GSpellTimer(rd, false);
            Context.Log("Rend duration is : " + (rd / 1000) + " seconds");
            int dd = DemoDuration();
            DemoTimer = new GSpellTimer(dd, false);
            Context.Log("Demoralizing Shout duration is : " + (dd / 1000) + " seconds");


            // Flip bars to stop glider from being confused
            IsKeyPopulated("Parrior.Battle");
            IsKeyPopulated("Parrior.Rend");

            UpdateStanceFromKeys();
            if (!NoKeyCheck)
                CheckKeys();

            // Just to sync stances
            //Context.Log("Sync stances");
            //DefensiveStance();
            //BerserkerStance();
            //BattleStance();

            //PassiveMode();

        }


        public override void OnStopGlide()
        {
            mover.Stop();
            MobTendencies.SaveToFile();
            Context.Log("Saved tendency info on " + MobTendencies.GetMobCount() + " mobs");



            base.OnStopGlide();
        }


        private void SetConfigValueFromContext(object configDialog, string vKey)
        {
            PropertyInfo pKey;
            PropertyInfo pValue;
            string vValue = Context.GetConfigString(vKey);
            Type type = configDialog.GetType();
            //Setup Entry Points to pass Values
            pKey = type.GetProperty("ConfigKey");
            pValue = type.GetProperty("ConfigValue");
            if (pKey != null && pValue != null)
            {
                pKey.SetValue(configDialog, vKey, null);
                pValue.SetValue(configDialog, vValue, null);
            }
        }

        //Custom GetConfigValue
        private string GetConfigValue(object configDialog, string vKey)
        {
            PropertyInfo pKey;
            PropertyInfo pValue;
            Type type = configDialog.GetType();
            //Setup Entry Points to pass Values
            pKey = type.GetProperty("ConfigKey");
            pValue = type.GetProperty("ConfigValue");
            if (pKey != null && pValue != null)
            {
                pKey.SetValue(configDialog, vKey, null);
                return (pValue.GetValue(configDialog, null)).ToString();
            }
            return "";
        }

        private void SetConfigValueFromDialog(object configDialog, string vKey)
        {
            string val = GetConfigValue(configDialog, vKey);
            Context.SetConfigValue(vKey, val, true);
        }

        public override GConfigResult ShowConfiguration()
        {
            String baseDir = AppDomain.CurrentDomain.BaseDirectory;
            Assembly asm = System.Reflection.Assembly.LoadFile(baseDir + "\\Classes\\GConfig2.dll");

            foreach (Type loadedType in asm.GetTypes())
            {
                if (loadedType.Name == "GConfig")
                {
                    MobTendencies.SaveToFile();
                    Context.Log("Saved tendency info on " + MobTendencies.GetMobCount() + " mobs");

                    PropertyInfo pi;
                    object configDialog = loadedType.GetConstructor(new Type[] { }).Invoke(new object[] { });
                    MethodInfo showDialogMethod = loadedType.GetMethod("ShowDialog", new Type[] { });
                    Type type = configDialog.GetType();

                    // ### ADD MORE
                    SetConfigValueFromContext(configDialog, "Parrior.PullDistance");

                    // Special skills
                    SetConfigValueFromContext(configDialog, "Parrior.HeroicInterval");
                    SetConfigValueFromContext(configDialog, "Parrior.UseHeroic");
                    SetConfigValueFromContext(configDialog, "Parrior.HeroicMinRage");

                    SetConfigValueFromContext(configDialog, "Parrior.UseRend");
                    SetConfigValueFromContext(configDialog, "Parrior.BeTank");
                    SetConfigValueFromContext(configDialog, "Parrior.UseTaunt");
                    SetConfigValueFromContext(configDialog, "Parrior.TankSeconds");
                    SetConfigValueFromContext(configDialog, "Parrior.UseIntercept");
                    SetConfigValueFromContext(configDialog, "Parrior.UseConcussion");
                    SetConfigValueFromContext(configDialog, "Parrior.SaveConcussionForCast");
                    SetConfigValueFromContext(configDialog, "Parrior.UseShieldBash");
                    SetConfigValueFromContext(configDialog, "Parrior.UseShieldBlock");
                    SetConfigValueFromContext(configDialog, "Parrior.UsePummel");
                    SetConfigValueFromContext(configDialog, "Parrior.PummelChangeStance");
                    SetConfigValueFromContext(configDialog, "Parrior.UseWarStomp");
                    SetConfigValueFromContext(configDialog, "Parrior.UseShadowmeld");
                    SetConfigValueFromContext(configDialog, "Parrior.UseCannibalize");
                    SetConfigValueFromContext(configDialog, "Parrior.SilenceHealth");
                    SetConfigValueFromContext(configDialog, "Parrior.UseExecute");
                    SetConfigValueFromContext(configDialog, "Parrior.UseVictoryRush");
                    SetConfigValueFromContext(configDialog, "Parrior.UseBattleShout");
                    SetConfigValueFromContext(configDialog, "Parrior.UseOverpower");
                    SetConfigValueFromContext(configDialog, "Parrior.UseRevenge");
                    SetConfigValueFromContext(configDialog, "Parrior.UseThunder");
                    SetConfigValueFromContext(configDialog, "Parrior.UseDemo");
                    SetConfigValueFromContext(configDialog, "Parrior.UseCleave");
                    SetConfigValueFromContext(configDialog, "Parrior.UseBloodrage");
                    SetConfigValueFromContext(configDialog, "Parrior.UseSunder");
                    SetConfigValueFromContext(configDialog, "Parrior.UseRampage");
                    SetConfigValueFromContext(configDialog, "Parrior.SunderStack");
                    SetConfigValueFromContext(configDialog, "Parrior.UseHamstring");
                    SetConfigValueFromContext(configDialog, "Parrior.UseMS");
                    SetConfigValueFromContext(configDialog, "Parrior.UseBloodthirst");
                    SetConfigValueFromContext(configDialog, "Parrior.UseBerserkerRage");
                    SetConfigValueFromContext(configDialog, "Parrior.UseDeathWish");
                    SetConfigValueFromContext(configDialog, "Parrior.UseShieldSlam");
                    SetConfigValueFromContext(configDialog, "Parrior.UseSweeping");
                    SetConfigValueFromContext(configDialog, "Parrior.UseSlam");
                    SetConfigValueFromContext(configDialog, "Parrior.SlamMinRage");
                    SetConfigValueFromContext(configDialog, "Parrior.UseLastStand");
                    SetConfigValueFromContext(configDialog, "Parrior.UseDisarm");
                    SetConfigValueFromContext(configDialog, "Parrior.LastStandLife");

                    SetConfigValueFromContext(configDialog, "Parrior.WhirlwindAdds");
                    SetConfigValueFromContext(configDialog, "Parrior.WhirlwindMinRage");

                    SetConfigValueFromContext(configDialog, "Parrior.UseIntimidatingBandage");
                    SetConfigValueFromContext(configDialog, "Parrior.IntimidatingBandageLife");

                    //Talents
                    SetConfigValueFromContext(configDialog, "Parrior.HeroicCost");
                    SetConfigValueFromContext(configDialog, "Parrior.SunderCost");
                    //SetConfigValueFromContext(configDialog, "Parrior.ExecuteCost");
                    SetConfigValueFromContext(configDialog, "Parrior.ThunderTalents");
                    SetConfigValueFromContext(configDialog, "Parrior.BoomingTalents");
                    SetConfigValueFromContext(configDialog, "Parrior.TacticalTalents");
                    SetConfigValueFromContext(configDialog, "Parrior.TauntTalents");
                    SetConfigValueFromContext(configDialog, "Parrior.FocusedRage");
                    SetConfigValueFromContext(configDialog, "Parrior.WhirlwindTalents");

                    SetConfigValueFromContext(configDialog, "Parrior.StanceInCombat");
                    SetConfigValueFromContext(configDialog, "Parrior.CasterStance");
                    SetConfigValueFromContext(configDialog, "Parrior.AddStance");
                    SetConfigValueFromContext(configDialog, "Parrior.PvPStance");
                    SetConfigValueFromContext(configDialog, "Parrior.MaxRageLoss");

                    SetConfigValueFromContext(configDialog, "Parrior.UseMount");
                    SetConfigValueFromContext(configDialog, "Parrior.MountDistance");
                    SetConfigValueFromContext(configDialog, "Parrior.PullMethod");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem1");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem2");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem3");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem4");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem1CD");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem2CD");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem3CD");
                    SetConfigValueFromContext(configDialog, "Parrior.UseItem4CD");

                    SetConfigValueFromContext(configDialog, "Parrior.BuffItem1");
                    SetConfigValueFromContext(configDialog, "Parrior.BuffName1");
                    SetConfigValueFromContext(configDialog, "Parrior.BuffItem2");
                    SetConfigValueFromContext(configDialog, "Parrior.BuffName2");
                    SetConfigValueFromContext(configDialog, "Parrior.BuffItem3");
                    SetConfigValueFromContext(configDialog, "Parrior.BuffName3");

                    SetConfigValueFromContext(configDialog, "Parrior.PullRangedAvoidAdds");
                    SetConfigValueFromContext(configDialog, "Parrior.RunnerAction");
                    SetConfigValueFromContext(configDialog, "Parrior.ShootRunner");
                    SetConfigValueFromContext(configDialog, "Parrior.PotionLife");

                    SetConfigValueFromContext(configDialog, "Parrior.ShootIfAdd");
                    SetConfigValueFromContext(configDialog, "Parrior.AvoidAddDist");
                    SetConfigValueFromContext(configDialog, "Parrior.AvoidAddDistCombat");

                    SetConfigValueFromContext(configDialog, "Parrior.LurkTime");
                    SetConfigValueFromContext(configDialog, "Parrior.SneakTime");

                    SetConfigValueFromContext(configDialog, "Parrior.SpamAlot");
                    SetConfigValueFromContext(configDialog, "Parrior.NoKeyCheck");
                    SetConfigValueFromContext(configDialog, "Parrior.NoJumpFromAoE");


                    SetConfigValueFromContext(configDialog, "Parrior.PvPStyle");

                    SetConfigValueFromContext(configDialog, "Parrior.WeaponBuffMainHand");
                    SetConfigValueFromContext(configDialog, "Parrior.WeaponBuffOffHand");



                    //Set Config File
                    pi = type.GetProperty("ConfigXML");
                    if (pi != null) pi.SetValue(configDialog, "PathParrior.XML", null);

                    //Popup Dialog
                    object modalResult = showDialogMethod.Invoke(configDialog, new object[] { });
                    //AppDomain.CurrentDomain.BaseDirectory = baseDir; // Change it back
                    if ((int)modalResult == 1)
                    {
                        //Get Current Values
                        MobTendencies.LoadFromFile();
                        Context.Log("Loaded tendency info on " + MobTendencies.GetMobCount() + " mobs");

                        // ### ADD HERE
                        SetConfigValueFromDialog(configDialog, "Parrior.PullDistance");

                        SetConfigValueFromDialog(configDialog, "Parrior.HeroicInterval");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseHeroic");
                        SetConfigValueFromDialog(configDialog, "Parrior.HeroicMinRage");

                        SetConfigValueFromDialog(configDialog, "Parrior.UseRend");
                        SetConfigValueFromDialog(configDialog, "Parrior.BeTank");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseTaunt");
                        SetConfigValueFromDialog(configDialog, "Parrior.TankSeconds");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseIntercept");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseConcussion");
                        SetConfigValueFromDialog(configDialog, "Parrior.SaveConcussionForCast");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseShieldBash");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseShieldBlock");
                        SetConfigValueFromDialog(configDialog, "Parrior.UsePummel");
                        SetConfigValueFromDialog(configDialog, "Parrior.PummelChangeStance");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseWarStomp");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseCannibalize");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseShadowmeld");
                        SetConfigValueFromDialog(configDialog, "Parrior.SilenceHealth");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseExecute");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseVictoryRush");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseBattleShout");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseOverpower");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseRevenge");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseThunder");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseDemo");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseCleave");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseBloodrage");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseSunder");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseRampage");
                        SetConfigValueFromDialog(configDialog, "Parrior.SunderStack");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseHamstring");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseMS");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseBloodthirst");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseBerserkerRage");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseDeathWish");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseShieldSlam");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseSweeping");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseSlam");
                        SetConfigValueFromDialog(configDialog, "Parrior.SlamMinRage");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseLastStand");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseDisarm");
                        SetConfigValueFromDialog(configDialog, "Parrior.LastStandLife");
                        SetConfigValueFromDialog(configDialog, "Parrior.WhirlwindAdds");
                        SetConfigValueFromDialog(configDialog, "Parrior.WhirlwindMinRage");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseIntimidatingBandage");
                        SetConfigValueFromDialog(configDialog, "Parrior.IntimidatingBandageLife");

                        SetConfigValueFromDialog(configDialog, "Parrior.HeroicCost");
                        SetConfigValueFromDialog(configDialog, "Parrior.SunderCost");
                        //SetConfigValueFromDialog(configDialog, "Parrior.ExecuteCost");
                        SetConfigValueFromDialog(configDialog, "Parrior.ThunderTalents");
                        SetConfigValueFromDialog(configDialog, "Parrior.BoomingTalents");
                        SetConfigValueFromDialog(configDialog, "Parrior.TacticalTalents");
                        SetConfigValueFromDialog(configDialog, "Parrior.TauntTalents");
                        SetConfigValueFromDialog(configDialog, "Parrior.FocusedRage");
                        SetConfigValueFromDialog(configDialog, "Parrior.WhirlwindTalents");


                        SetConfigValueFromDialog(configDialog, "Parrior.StanceInCombat");
                        SetConfigValueFromDialog(configDialog, "Parrior.CasterStance");
                        SetConfigValueFromDialog(configDialog, "Parrior.AddStance");
                        SetConfigValueFromDialog(configDialog, "Parrior.PvPStance");
                        SetConfigValueFromDialog(configDialog, "Parrior.MaxRageLoss");

                        SetConfigValueFromDialog(configDialog, "Parrior.PotionLife");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseMount");
                        SetConfigValueFromDialog(configDialog, "Parrior.MountDistance");

                        SetConfigValueFromDialog(configDialog, "Parrior.PullMethod");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem1");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem2");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem3");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem4");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem1CD");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem2CD");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem3CD");
                        SetConfigValueFromDialog(configDialog, "Parrior.UseItem4CD");

                        SetConfigValueFromDialog(configDialog, "Parrior.BuffItem1");
                        SetConfigValueFromDialog(configDialog, "Parrior.BuffName1");
                        SetConfigValueFromDialog(configDialog, "Parrior.BuffItem2");
                        SetConfigValueFromDialog(configDialog, "Parrior.BuffName2");
                        SetConfigValueFromDialog(configDialog, "Parrior.BuffItem3");
                        SetConfigValueFromDialog(configDialog, "Parrior.BuffName3");

                        SetConfigValueFromDialog(configDialog, "Parrior.PullRangedAvoidAdds");

                        SetConfigValueFromDialog(configDialog, "Parrior.RunnerAction");
                        SetConfigValueFromDialog(configDialog, "Parrior.ShootRunner");

                        SetConfigValueFromDialog(configDialog, "Parrior.ShootIfAdd");
                        SetConfigValueFromDialog(configDialog, "Parrior.AvoidAddDist");
                        SetConfigValueFromDialog(configDialog, "Parrior.AvoidAddDistCombat");
                        SetConfigValueFromDialog(configDialog, "Parrior.LurkTime");
                        SetConfigValueFromDialog(configDialog, "Parrior.SneakTime");

                        SetConfigValueFromDialog(configDialog, "Parrior.SpamAlot");
                        SetConfigValueFromDialog(configDialog, "Parrior.NoKeyCheck");
                        SetConfigValueFromDialog(configDialog, "Parrior.NoJumpFromAoE");

                        SetConfigValueFromDialog(configDialog, "Parrior.PvPStyle");

                        SetConfigValueFromDialog(configDialog, "Parrior.WeaponBuffMainHand");
                        SetConfigValueFromDialog(configDialog, "Parrior.WeaponBuffOffHand");


                        return GConfigResult.Accept;
                    }
                    return GConfigResult.Cancel;
                }
            }
            return GConfigResult.Cancel;

            //return Context.ShowStockConfigDialog(GPlayerClass.Parrior);
        }

        // Don't think we'll be needing any water...
        public override bool ShouldBuyWater { get { return false; } }
        public override bool CanDrink { get { return false; } }

        public override int PullDistance { get { return MyPullDistance; } }

        public override string PowerLabel
        {
            get
            {
                return "Rage";
            }
        }

        public override string PowerValue
        {
            get
            {
                return Me.Rage.ToString();
            }
        }

        public override void CreateDefaultConfig()
        {
            Context.SetConfigValue("Parrior.PullDistance", "30", false);


            Context.SetConfigValue("Parrior.UseRend", "True", false);
            Context.SetConfigValue("Parrior.BeTank", "False", false);
            Context.SetConfigValue("Parrior.UseTaunt", "False", false);
            Context.SetConfigValue("Parrior.TankSeconds", "5", false);
            Context.SetConfigValue("Parrior.UseIntercept", "False", false);
            Context.SetConfigValue("Parrior.UseConcussion", "True", false);
            Context.SetConfigValue("Parrior.SaveConcussionForCast", "True", false);
            Context.SetConfigValue("Parrior.UseShieldBash", "True", false);
            Context.SetConfigValue("Parrior.UseShieldBlock", "False", false);
            Context.SetConfigValue("Parrior.UsePummel", "False", false);
            Context.SetConfigValue("Parrior.PummelChangeStance", "False", false);
            Context.SetConfigValue("Parrior.UseWarStomp", "Never", false);
            Context.SetConfigValue("Parrior.UseCannibalize", "False", false);
            Context.SetConfigValue("Parrior.UseShadowmeld", "False", false);
            Context.SetConfigValue("Parrior.SilenceHealth", "100", false);
            Context.SetConfigValue("Parrior.UseExecute", "True", false);
            Context.SetConfigValue("Parrior.UseVictoryRush", "False", false);
            Context.SetConfigValue("Parrior.UseBattleShout", "True", false);
            Context.SetConfigValue("Parrior.UseOverpower", "True", false);
            Context.SetConfigValue("Parrior.UseRevenge", "True", false);

            Context.SetConfigValue("Parrior.UseThunder", "Close add", false);
            Context.SetConfigValue("Parrior.UseDemo", "Always", false);
            Context.SetConfigValue("Parrior.UseCleave", "Close add", false);
            Context.SetConfigValue("Parrior.UseBloodrage", "Target has high HP", false);
            Context.SetConfigValue("Parrior.UseSunder", "Never", false);
            Context.SetConfigValue("Parrior.UseRampage", "Never", false);
            Context.SetConfigValue("Parrior.SunderStack", "0", false);
            Context.SetConfigValue("Parrior.UseHamstring", "True", false);
            Context.SetConfigValue("Parrior.UseMS", "False", false);
            Context.SetConfigValue("Parrior.UseBloodthirst", "Never", false);
            Context.SetConfigValue("Parrior.UseBerserkerRage", "Never", false);
            Context.SetConfigValue("Parrior.UseDeathWish", "Never", false);
            Context.SetConfigValue("Parrior.UseShieldSlam", "False", false);
            Context.SetConfigValue("Parrior.UseSweeping", "False", false);
            Context.SetConfigValue("Parrior.UseSlam", "Never", false);
            Context.SetConfigValue("Parrior.SlamMinRage", "45", false);
            Context.SetConfigValue("Parrior.UseHeroic", "True", false);
            Context.SetConfigValue("Parrior.HeroicMinRage", "0", false);
            Context.SetConfigValue("Parrior.HeroicInterval", "4", false);
            Context.SetConfigValue("Parrior.WhirlwindAdds", "Do not use", false);
            Context.SetConfigValue("Parrior.WhirlwindMinRage", "0", false);

            Context.SetConfigValue("Parrior.UseLastStand", "False", false);
            Context.SetConfigValue("Parrior.UseDisarm", "False", false);
            Context.SetConfigValue("Parrior.LastStandLife", "25", false);

            Context.SetConfigValue("Parrior.UseIntimidatingBandage", "False", false);
            Context.SetConfigValue("Parrior.IntimidatingBandageLife", "30", false);

            Context.SetConfigValue("Parrior.HeroicCost", "15", false);
            Context.SetConfigValue("Parrior.SunderCost", "15", false);
            //Context.SetConfigValue("Parrior.ExecuteCost", "15", false);
            Context.SetConfigValue("Parrior.ThunderTalents", "0", false);
            Context.SetConfigValue("Parrior.BoomingTalents", "0", false);
            Context.SetConfigValue("Parrior.TacticalTalents", "0", false);
            Context.SetConfigValue("Parrior.TauntTalents", "0", false);
            Context.SetConfigValue("Parrior.FocusedRage", "0", false);
            Context.SetConfigValue("Parrior.WhirlwindTalents", "0", false);

            Context.SetConfigValue("Parrior.StanceInCombat", "Battle", false);
            Context.SetConfigValue("Parrior.CasterStance", "Default", false);
            Context.SetConfigValue("Parrior.AddStance", "Default", false);
            Context.SetConfigValue("Parrior.PvPStance", "Berserker", false);
            Context.SetConfigValue("Parrior.MaxRageLoss", "5", false);

            Context.SetConfigValue("Parrior.UseMount", "False", false);
            Context.SetConfigValue("Parrior.MountDistance", "45", false);

            Context.SetConfigValue("Parrior.PullMethod", "Charge", false);
            Context.SetConfigValue("Parrior.PullRangedAvoidAdds", "True", false);

            Context.SetConfigValue("Parrior.UseItem1", "Do not use", false);
            Context.SetConfigValue("Parrior.UseItem2", "Do not use", false);
            Context.SetConfigValue("Parrior.UseItem3", "Do not use", false);
            Context.SetConfigValue("Parrior.UseItem4", "Do not use", false);
            Context.SetConfigValue("Parrior.UseItem1CD", "120", false);
            Context.SetConfigValue("Parrior.UseItem2CD", "120", false);
            Context.SetConfigValue("Parrior.UseItem3CD", "120", false);
            Context.SetConfigValue("Parrior.UseItem4CD", "120", false);

            Context.SetConfigValue("Parrior.BuffItem1", "Do not use", false);
            Context.SetConfigValue("Parrior.BuffName1", "well fed", false);
            Context.SetConfigValue("Parrior.BuffItem2", "Do not use", false);
            Context.SetConfigValue("Parrior.BuffName2", "strength", false);
            Context.SetConfigValue("Parrior.BuffItem3", "Do not use", false);
            Context.SetConfigValue("Parrior.BuffName3", "winterfall", false);

            Context.SetConfigValue("Parrior.RunnerAction", "Chase while it is safe", false);
            Context.SetConfigValue("Parrior.ShootRunner", "True", false);


            Context.SetConfigValue("Parrior.PotionLife", "25", false);

            Context.SetConfigValue("Parrior.ShootIfAdd", "True", false);

            Context.SetConfigValue("Parrior.AvoidAddDist", "18", false);
            Context.SetConfigValue("Parrior.AvoidAddDistCombat", "19", false);

            Context.SetConfigValue("Parrior.LurkTime", "5", false);
            Context.SetConfigValue("Parrior.SneakTime", "15", false);

            Context.SetConfigValue("Parrior.SpamAlot", "True", false);
            Context.SetConfigValue("Parrior.NoKeyCheck", "False", false);
            Context.SetConfigValue("Parrior.NoJumpFromAoE", "False", false);


            Context.SetConfigValue("Parrior.VendorName", "Kaja", false);


            Context.SetConfigValue("Parrior.PvPStyle", "Fight back", false);

            Context.SetConfigValue("Parrior.WeaponBuffMainHand", "False", false);
            Context.SetConfigValue("Parrior.WeaponBuffOffHand", "False", false);


            Context.SetConfigValue("Parrior.Protected0", "bandage", false);
            Context.SetConfigValue("Parrior.Protected1", "healing potion", false);
            Context.SetConfigValue("Parrior.Protected2", "skinning knife", false);

            for (int i = 3; i < 20; i++)
            {
                string name = String.Format("Parrior.Protected{0}", i);
                Context.SetConfigValue(name, "", false);
            }

            base.CreateDefaultConfig();

        }
        private bool SkillConditionEval(SkillCondition_e cond)
        {
            if (cond == SkillCondition_e.Never) return false;
            if (cond == SkillCondition_e.Always) return true;
            if (cond == SkillCondition_e.Mob50HP && Target != null) return Target.Health >= 0.5;
            if (cond == SkillCondition_e.CloseAdd) return HaveCloseAdd;
            if (cond == SkillCondition_e.Add) return HaveAdd;
            if (cond == SkillCondition_e.Silence && Target != null) return Target.IsCasting;
            return false;
        }

        private bool SkillConditionEvalBeforeCharge(SkillCondition_e cond)
        {
            if (cond == SkillCondition_e.BeforeCharge) return true;
            return false;
        }

        private SkillCondition_e DecodeConditionString(String s)
        {
            switch (s)
            {
                case "True": return SkillCondition_e.Always;
                case "Always": return SkillCondition_e.Always;
                case "Yes": return SkillCondition_e.Always;

                case "False": return SkillCondition_e.Never;
                case "-": return SkillCondition_e.Never;
                case "Never": return SkillCondition_e.Never;
                case "No": return SkillCondition_e.Never;

                case "When close add": return SkillCondition_e.CloseAdd;
                case "Close add": return SkillCondition_e.CloseAdd;

                case "Save for adds": return SkillCondition_e.Add;

                case "Target has high HP": return SkillCondition_e.Mob50HP;
                case "Before Charge": return SkillCondition_e.BeforeCharge;

                case "Interrupt spellcast": return SkillCondition_e.Silence;

            }
            return SkillCondition_e.Never;
        }

        public override void LoadConfig()
        {

            // Some glider settings
            RestHealth = Context.GetConfigInt("RestHealth");
            UseBandage = Context.GetConfigBool("UseBandages");
            BandageHealth = Context.GetConfigInt("BandageHealth");
            HarvestRange = Context.GetConfigInt("HarvestRange");

            AvoidSameFaction = Context.GetConfigBool("AvoidSameFaction");
            AvoidOtherFaction = Context.GetConfigBool("AvoidOtherFaction");

            MyPullDistance = Context.GetConfigInt("Parrior.PullDistance");

            HeroicInterval = Context.GetConfigInt("Parrior.HeroicInterval");
            HeroicTimer = new GSpellTimer(HeroicInterval * 1000, true);
            UseHeroic = Context.GetConfigBool("Parrior.UseHeroic");
            HeroicMinRage = Context.GetConfigInt("Parrior.HeroicMinRage");

            UseRend = Context.GetConfigBool("Parrior.UseRend");
            UseIntercept = Context.GetConfigBool("Parrior.UseIntercept");
            UseConcussion = Context.GetConfigBool("Parrior.UseConcussion");
            SaveConcussionForCast = Context.GetConfigBool("Parrior.SaveConcussionForCast");
            UseShieldBash = Context.GetConfigBool("Parrior.UseShieldBash");
            UseShieldBlock = Context.GetConfigBool("Parrior.UseShieldBlock");
            UsePummel = Context.GetConfigBool("Parrior.UsePummel");
            PummelChangeStance = Context.GetConfigBool("Parrior.PummelChangeStance");
            SilenceHealth = Context.GetConfigInt("Parrior.SilenceHealth");
            UseExecute = Context.GetConfigBool("Parrior.UseExecute");
            UseVictoryRush = Context.GetConfigBool("Parrior.UseVictoryRush");
            UseBattleShout = Context.GetConfigBool("Parrior.UseBattleShout");
            UseOverpower = Context.GetConfigBool("Parrior.UseOverpower");
            UseRevenge = Context.GetConfigBool("Parrior.UseRevenge");
            UseHamstring = Context.GetConfigBool("Parrior.UseHamstring");
            UseMS = Context.GetConfigBool("Parrior.UseMS");
            UseShieldSlam = Context.GetConfigBool("Parrior.UseShieldSlam");
            UseSweeping = Context.GetConfigBool("Parrior.UseSweeping");
            SlamMinRage = Context.GetConfigInt("Parrior.SlamMinRage");

            WhirlwindMinRage = Context.GetConfigInt("Parrior.WhirlwindMinRage");
            string ws = Context.GetConfigString("Parrior.WhirlwindAdds");
            switch (ws)
            {
                case "Do not use": WhirlwindAdds = -1; break;
                case "0": WhirlwindAdds = 0; break;
                case "1": WhirlwindAdds = 1; break;
                case "2": WhirlwindAdds = 2; break;
                case "3": WhirlwindAdds = 3; break;
            }

            UseLastStand = Context.GetConfigBool("Parrior.UseLastStand");
            LastStandLife = Context.GetConfigInt("Parrior.LastStandLife") / 100.0;
            UseDisarm = Context.GetConfigBool("Parrior.UseDisarm");

            UseIntimidatingBandage = Context.GetConfigBool("Parrior.UseIntimidatingBandage");
            IntimidatingBandageLife = Context.GetConfigInt("Parrior.IntimidatingBandageLife") / 100.0;

            UseThunder = DecodeConditionString(Context.GetConfigString("Parrior.UseThunder"));
            UseDemo = DecodeConditionString(Context.GetConfigString("Parrior.UseDemo"));
            UseCleave = DecodeConditionString(Context.GetConfigString("Parrior.UseCleave"));
            UseSunder = DecodeConditionString(Context.GetConfigString("Parrior.UseSunder"));
            UseRampage = DecodeConditionString(Context.GetConfigString("Parrior.UseRampage"));
            UseBloodrage = DecodeConditionString(Context.GetConfigString("Parrior.UseBloodrage"));
            UseBloodthirst = DecodeConditionString(Context.GetConfigString("Parrior.UseBloodthirst"));
            UseBerserkerRage = DecodeConditionString(Context.GetConfigString("Parrior.UseBerserkerRage"));
            UseDeathWish = DecodeConditionString(Context.GetConfigString("Parrior.UseDeathWish"));
            UseWarStomp = DecodeConditionString(Context.GetConfigString("Parrior.UseWarStomp"));

            UseCannibalize = Context.GetConfigBool("Parrior.UseCannibalize");
            UseShadowmeld = Context.GetConfigBool("Parrior.UseShadowmeld");

            SunderStack = Context.GetConfigInt("Parrior.SunderStack");

            BeTank = Context.GetConfigBool("Parrior.BeTank");
            UseTaunt = Context.GetConfigBool("Parrior.UseTaunt");
            TankSeconds = Context.GetConfigInt("Parrior.TankSeconds");

            HeroicCost = Context.GetConfigInt("Parrior.HeroicCost");
            SunderCost = Context.GetConfigInt("Parrior.SunderCost");
            //ExecuteCost    = Context.GetConfigInt("Parrior.ExecuteCost");
            ThunderTalents = Context.GetConfigInt("Parrior.ThunderTalents");
            ThunderCost = 20 - ThunderTalents;
            if (ThunderTalents == 3) ThunderCost -= 1;

            WeaponBuffMain = Context.GetConfigBool("Parrior.WeaponBuffMainHand");
            WeaponBuffOff = Context.GetConfigBool("Parrior.WeaponBuffOffHand");


            BoomingTalents = Context.GetConfigInt("Parrior.BoomingTalents");
            TacticalTalents = Context.GetConfigInt("Parrior.TacticalTalents");
            RageLeftOnStanceChange = 10 + TacticalTalents * 5;
            FocusedRage = Context.GetConfigInt("Parrior.FocusedRage");
            TauntTalents = Context.GetConfigInt("Parrior.TauntTalents");
            TauntTimer = new GSpellTimer((10 - TauntTalents) * 1000);

            WhirlwindTalents = Context.GetConfigInt("Parrior.WhirlwindTalents");
            WhirlwindTimer = new GSpellTimer((10 - WhirlwindTalents) * 1000);

            UseMount = Context.GetConfigBool("Parrior.UseMount");
            MountDistance = Context.GetConfigInt("Parrior.MountDistance");


            string slams = Context.GetConfigString("Parrior.UseSlam");
            switch (slams)
            {
                case "False":
                case "Never": UseSlam = SlamMode_e.Never; break;
                case "Oneshot": UseSlam = SlamMode_e.OneShot; break;
                case "Spam": UseSlam = SlamMode_e.Spam; break;
            }

            string ps = Context.GetConfigString("Parrior.PullMethod");
            switch (ps)
            {
                case "Ranged": PullStyle = PullStyle_e.Ranged; break;
                case "Charge": PullStyle = PullStyle_e.Charge; break;
                case "Walk up": PullStyle = PullStyle_e.Walk; break;
            }

            string ss = Context.GetConfigString("Parrior.StanceInCombat");
            switch (ss)
            {
                case "Defensive": StanceInCombat = Stance_e.Defensive; break;
                case "Battle": StanceInCombat = Stance_e.Battle; break;
                case "Berserker": StanceInCombat = Stance_e.Berserker; break;
            }

            CasterStance = StanceInCombat;
            string casts = Context.GetConfigString("Parrior.CasterStance");
            switch (casts)
            {
                case "Defensive": CasterStance = Stance_e.Defensive; break;
                case "Battle": CasterStance = Stance_e.Battle; break;
                case "Berserker": CasterStance = Stance_e.Berserker; break;
            }

            AddStance = StanceInCombat;
            string adds = Context.GetConfigString("Parrior.AddStance");
            switch (adds)
            {
                case "Defensive": AddStance = Stance_e.Defensive; break;
                case "Battle": AddStance = Stance_e.Battle; break;
                case "Berserker": AddStance = Stance_e.Berserker; break;
            }


            PvPStance = StanceInCombat;
            string pvpstance = Context.GetConfigString("Parrior.PvPStance");
            switch (pvpstance)
            {
                case "Defensive": PvPStance = Stance_e.Defensive; break;
                case "Battle": PvPStance = Stance_e.Battle; break;
                case "Berserker": PvPStance = Stance_e.Berserker; break;
            }

            MaxRageLoss = Context.GetConfigInt("Parrior.MaxRageLoss");

            PullRangedAvoidAdds = Context.GetConfigBool("Parrior.PullRangedAvoidAdds");

            string cs = Context.GetConfigString("Parrior.RunnerAction");
            switch (cs)
            {
                case "Chase": ChaseStyle = ChaseStyle_e.Chase; break;
                case "Chase while it is safe": ChaseStyle = ChaseStyle_e.ChaseSafe; break;
                case "Do not chase": ChaseStyle = ChaseStyle_e.NoChase; break;
            }

            ShootRunners = Context.GetConfigBool("Parrior.ShootRunner");
            PotionLife = Context.GetConfigInt("Parrior.PotionLife") / 100.0;

            AvoidAddDistance = Context.GetConfigInt("Parrior.AvoidAddDist");
            AvoidAddDistanceCombat = Context.GetConfigInt("Parrior.AvoidAddDistCombat");
            if (AvoidAddDistanceCombat == 0)
                RunFromAddsInCombat = false;
            else
                RunFromAddsInCombat = true;


            LurkTime = Context.GetConfigInt("Parrior.LurkTime");
            SneakTime = Context.GetConfigInt("Parrior.SneakTime");

            SpamAlot = Context.GetConfigBool("Parrior.SpamAlot");
            NoKeyCheck = Context.GetConfigBool("Parrior.NoKeyCheck");
            NoJumpFromAoE = Context.GetConfigBool("Parrior.NoJumpFromAoE");


            string ui1 = Context.GetConfigString("Parrior.UseItem1");
            switch (ui1)
            {
                case "Do not use": UseItem1 = ItemUse_e.NoUse; break;
                case "My health <50%": UseItem1 = ItemUse_e.MyHealth50; break;
                case "My health <25%": UseItem1 = ItemUse_e.MyHealth25; break;
                case "Monster health >75%": UseItem1 = ItemUse_e.MobHealth75; break;
                case "Monster health >50%": UseItem1 = ItemUse_e.MobHealth50; break;
                case "We got adds": UseItem1 = ItemUse_e.SaveForAdds; break;
                case "Feared/Charmed/Sleeped": UseItem1 = ItemUse_e.Feared; break;
            }
            UseItem1CD = Context.GetConfigInt("Parrior.UseItem1CD");
            UseItem1Timer = new GSpellTimer(UseItem1CD * 1000);
            UseItem1Timer.ForceReady();


            string ui2 = Context.GetConfigString("Parrior.UseItem2");
            switch (ui2)
            {
                case "Do not use": UseItem2 = ItemUse_e.NoUse; break;
                case "My health <50%": UseItem2 = ItemUse_e.MyHealth50; break;
                case "My health <25%": UseItem2 = ItemUse_e.MyHealth25; break;
                case "Monster health >75%": UseItem2 = ItemUse_e.MobHealth75; break;
                case "Monster health >50%": UseItem2 = ItemUse_e.MobHealth50; break;
                case "We got adds": UseItem2 = ItemUse_e.SaveForAdds; break;
                case "Feared/Charmed/Sleeped": UseItem2 = ItemUse_e.Feared; break;
            }
            UseItem2CD = Context.GetConfigInt("Parrior.UseItem2CD");
            UseItem2Timer = new GSpellTimer(UseItem2CD * 1000);
            UseItem2Timer.ForceReady();


            string ui3 = Context.GetConfigString("Parrior.UseItem3");
            switch (ui3)
            {
                case "Do not use": UseItem3 = ItemUse_e.NoUse; break;
                case "My health <50%": UseItem3 = ItemUse_e.MyHealth50; break;
                case "My health <25%": UseItem3 = ItemUse_e.MyHealth25; break;
                case "Monster health >75%": UseItem3 = ItemUse_e.MobHealth75; break;
                case "Monster health >50%": UseItem3 = ItemUse_e.MobHealth50; break;
                case "We got adds": UseItem3 = ItemUse_e.SaveForAdds; break;
                case "Feared/Charmed/Sleeped": UseItem3 = ItemUse_e.Feared; break;
            }
            UseItem3CD = Context.GetConfigInt("Parrior.UseItem3CD");
            UseItem3Timer = new GSpellTimer(UseItem3CD * 1000);
            UseItem3Timer.ForceReady();


            string ui4 = Context.GetConfigString("Parrior.UseItem4");
            switch (ui4)
            {
                case "Do not use": UseItem4 = ItemUse_e.NoUse; break;
                case "My health <50%": UseItem4 = ItemUse_e.MyHealth50; break;
                case "My health <25%": UseItem4 = ItemUse_e.MyHealth25; break;
                case "Monster health >75%": UseItem4 = ItemUse_e.MobHealth75; break;
                case "Monster health >50%": UseItem4 = ItemUse_e.MobHealth50; break;
                case "We got adds": UseItem4 = ItemUse_e.SaveForAdds; break;
                case "Feared/Charmed/Sleeped": UseItem4 = ItemUse_e.Feared; break;
            }
            UseItem4CD = Context.GetConfigInt("Parrior.UseItem4CD");
            UseItem4Timer = new GSpellTimer(UseItem4CD * 1000);
            UseItem4Timer.ForceReady();


            string bi1 = Context.GetConfigString("Parrior.BuffItem1");
            switch (bi1)
            {
                case "Do not use": BuffItem1 = BuffUse_e.NoUse; break;
                case "Food": BuffItem1 = BuffUse_e.Food; break;
                case "Potion/Usable item": BuffItem1 = BuffUse_e.Potion; break;
            }
            BuffName1 = Context.GetConfigString("Parrior.BuffName1").ToLower();

            string bi2 = Context.GetConfigString("Parrior.BuffItem2");
            switch (bi2)
            {
                case "Do not use": BuffItem2 = BuffUse_e.NoUse; break;
                case "Food": BuffItem2 = BuffUse_e.Food; break;
                case "Potion/Usable item": BuffItem2 = BuffUse_e.Potion; break;
            }
            BuffName2 = Context.GetConfigString("Parrior.BuffName2").ToLower();

            string bi3 = Context.GetConfigString("Parrior.BuffItem3");
            switch (bi3)
            {
                case "Do not use": BuffItem3 = BuffUse_e.NoUse; break;
                case "Food": BuffItem3 = BuffUse_e.Food; break;
                case "Potion/Usable item": BuffItem3 = BuffUse_e.Potion; break;
            }
            BuffName3 = Context.GetConfigString("Parrior.BuffName3").ToLower();


            string pvps = Context.GetConfigString("Parrior.PvPStyle");
            switch (pvps)
            {
                case "Fight back": PvPStyle = PvPStyle_e.FightBack; break;
                case "Active": PvPStyle = PvPStyle_e.Active; break;
                case "Don't fight back": PvPStyle = PvPStyle_e.Die; break;
            }


            base.LoadConfig();
        }

        #endregion


        #region Key checking

        private void CheckKey(string key)
        {
            if (IsKeyPopulated(key))
                Context.Log("GOOD " + key);
            else
                Context.Log("BAD  " + key);
        }


        bool HadWarning = false;
        bool HadError = false;
        private void Warning(string s)
        {
            Context.Log("*** WARNING: " + s);
            HadWarning = true;
        }

        private void Error(string s)
        {
            Context.Log("*** ERROR: " + s);
            HadError = true;
        }

        private bool CheckSkillKey(bool enabled, string keyname, string skillname)
        {
            if (enabled && !IsKeyPopulated(keyname))
            {
                Warning("Found no skill on the " + skillname + " key. Disabling skill");
                enabled = false;
            }

            return enabled;
        }

        private SkillCondition_e CheckSkillKey(SkillCondition_e enabled, string keyname, string skillname)
        {
            if (enabled != SkillCondition_e.Never && !IsKeyPopulated(keyname))
            {
                Warning("Found no skill on the " + skillname + " key. Disabling skill");
                enabled = SkillCondition_e.Never;
            }

            return enabled;
        }

        private SlamMode_e CheckSkillKey(SlamMode_e enabled, string keyname, string skillname)
        {
            if (enabled != SlamMode_e.Never && !IsKeyPopulated(keyname))
            {
                Warning("Found no skill on the " + skillname + " key. Disabling skill");
                enabled = SlamMode_e.Never;
            }

            return enabled;
        }

        private ItemUse_e CheckSkillKey(ItemUse_e enabled, string keyname, string skillname)
        {
            if (enabled != ItemUse_e.NoUse && !IsKeyPopulated(keyname))
            {
                Warning("Found no skill on the " + skillname + " key. Disabling item");
                enabled = ItemUse_e.NoUse;
            }

            return enabled;
        }

        private bool IsKeyReady(String key)
        {
            bool pop = Interface.IsKeyReady(key);
            Thread.Sleep(20);
            pop = Interface.IsKeyReady(key); // Checking twice gives the correct result
            //if(key != "Parrior.Rend")    Context.Log("IsKeyReady " + key + " " + pop);
            return pop;
        }

        private bool IsKeyEnabled(String key)
        {
            Interface.IsKeyEnabled(key);
            Thread.Sleep(20);
            bool pop = Interface.IsKeyEnabled(key); // Checking twice gives the correct result
            //if(key != "Parrior.Rend")          Context.Log("IsKeyEnabled " + key + " " + pop);
            return pop;
        }

        private bool IsKeyPopulated(String key)
        {
            Interface.IsKeyPopulated(key);
            Thread.Sleep(100);
            return Interface.IsKeyPopulated(key);  // Checking twice gives the correct result
        }

        private void CheckKeys()
        {
            HadError = false;
            HadWarning = false;
            Context.Log("Checking you action bars for sanity");


            Context.Log(" -- combat bar  -- ");
            //Thread.Sleep(300); 
            // Check that all keys are populated
            if (!IsKeyPopulated("Parrior.Rend"))
                Error("The cooldown key (Rend) has no skill on it. That is a must, it is used to check global cooldown");


            /*
              XXX = CheckSkillKey(XXX, "Parrior.Defensive", "XXX");
              XXX = CheckSkillKey(XXX, "Parrior.Battle", "XXX");
              XXX = CheckSkillKey(XXX, "Parrior.Berserker", "XXX");
              XXX = CheckSkillKey(XXX, "Common.CooldownProbe", "XXX");
            */


            if (PullStyle == PullStyle_e.Charge && !IsKeyPopulated("Parrior.Charge"))
            {
                Warning("Found no skill on the Charge key. Setting pull to walk up");
                PullStyle = PullStyle_e.Walk;
            }

            if (!IsKeyPopulated("Parrior.Ranged")) Warning("The ranged key has no skill on it");

            // Combat bar
            UseRend = CheckSkillKey(UseRend, "Parrior.Rend", "Rend");
            UseThunder = CheckSkillKey(UseThunder, "Parrior.ThunderClap", "Thunder Clap");
            UseCleave = CheckSkillKey(UseCleave, "Parrior.Cleave", "Cleave");
            UseHeroic = CheckSkillKey(UseHeroic, "Parrior.HeroicStrike", "Heroic Strike");
            UseOverpower = CheckSkillKey(UseOverpower, "Parrior.Overpower", "Overpower");
            UseExecute = CheckSkillKey(UseExecute, "Parrior.Execute", "Execute");


            UseMS = CheckSkillKey(UseMS, "Parrior.MortalStrike", "Mortal Strike");
            UseShieldSlam = CheckSkillKey(UseShieldSlam, "Parrior.ShieldSlam", "Shield Slam");
            UseBloodthirst = CheckSkillKey(UseBloodthirst, "Parrior.Bloodthirst", "Bloodthirst");


            UseRampage = CheckSkillKey(UseRampage, "Parrior.Rampage", "Rampage");
            UseSweeping = CheckSkillKey(UseSweeping, "Parrior.Sweeping", "Sweeping Strikes");
            UseShieldBlock = CheckSkillKey(UseShieldBlock, "Parrior.ShieldBlock", "Shield Block");
            UseRevenge = CheckSkillKey(UseRevenge, "Parrior.Revenge", "Revenge");
            UseIntercept = CheckSkillKey(UseIntercept, "Parrior.Intercept", "Intercept");

            Context.Log(" -- rest bar  -- ");
            //Thread.Sleep(300); 

            // Rest bar
            UseBattleShout = CheckSkillKey(UseBattleShout, "Parrior.BattleShout", "Battle Shout");
            UseDemo = CheckSkillKey(UseDemo, "Parrior.DemoShout", "Demoralizing Shout");
            UseSunder = CheckSkillKey(UseSunder, "Parrior.SunderArmor", "Sunder Armor");
            UseBerserkerRage = CheckSkillKey(UseBerserkerRage, "Parrior.BerserkerRage", "Berserker Rage");
            UseSlam = CheckSkillKey(UseSlam, "Parrior.Slam", "Slam");

            UseHamstring = CheckSkillKey(UseHamstring, "Parrior.Hamstring", "Hamstring");
            UsePummel = CheckSkillKey(UsePummel, "Parrior.Pummel", "Pummel");
            UseShieldBash = CheckSkillKey(UseShieldBash, "Parrior.ShieldBash", "Shield Bash");
            UseBloodrage = CheckSkillKey(UseBloodrage, "Parrior.Bloodrage", "Bloodrage");

            // Bar 2
            Context.Log(" -- bar 2  -- ");
            //Thread.Sleep(300); 


            UseItem1 = CheckSkillKey(UseItem1, "Parrior.UseItem1", "usable item #1");
            UseItem2 = CheckSkillKey(UseItem2, "Parrior.UseItem2", "usable item #2");
            UseItem3 = CheckSkillKey(UseItem3, "Parrior.UseItem3", "usable item #3");
            UseItem4 = CheckSkillKey(UseItem4, "Parrior.UseItem4", "usable item #4");
            UseDeathWish = CheckSkillKey(UseDeathWish, "Parrior.DeathWish", "Death Wish");


            if (!IsKeyPopulated("Parrior.Battle"))
            {
                Error("The key for battle stance has no skill on it.");
            }

            if (!IsKeyPopulated("Parrior.Defensive"))
            {
                if (StanceInCombat == Stance_e.Defensive)
                {
                    Warning("No skill on defensive stance key. Changing Default stance to Battle Stance");
                    StanceInCombat = Stance_e.Battle;
                }
                if (CasterStance == Stance_e.Defensive)
                {
                    Warning("No skill on defensive stance key. Changing Caster stance to Battle Stance");
                    CasterStance = Stance_e.Battle;
                }
                if (AddStance == Stance_e.Defensive)
                {
                    Warning("No skill on defensive stance key. Changing Add stance to Battle Stance");
                    AddStance = Stance_e.Battle;
                }
                if (PvPStance == Stance_e.Defensive)
                {
                    Warning("No skill on defensive stance key. Changing PvP stance to Battle Stance");
                    PvPStance = Stance_e.Battle;
                }
            }

            if (!IsKeyPopulated("Parrior.Berserker"))
            {
                if (StanceInCombat == Stance_e.Berserker)
                {
                    Warning("No skill on berserker stance key. Changing Default stance to Battle Stance");
                    StanceInCombat = Stance_e.Battle;
                }
                if (CasterStance == Stance_e.Berserker)
                {
                    Warning("No skill on berserker stance key. Changing Caster stance to Battle Stance");
                    CasterStance = Stance_e.Battle;
                }
                if (AddStance == Stance_e.Berserker)
                {
                    Warning("No skill on berserker stance key. Changing Add stance to Battle Stance");
                    AddStance = Stance_e.Battle;
                }
                if (PvPStance == Stance_e.Berserker)
                {
                    Warning("No skill on berserker stance key. Changing PvP stance to Battle Stance");
                    PvPStance = Stance_e.Battle;
                }
                if (UsePummel && PummelChangeStance)
                {
                    Warning("No skill on berserker stance key. Disabling change stance to pummel");
                    PummelChangeStance = false;
                }
            }


            UseConcussion = CheckSkillKey(UseConcussion, "Parrior.Concussion", "Concussion Blow");
            UseLastStand = CheckSkillKey(UseLastStand, "Parrior.LastStand", "Last Stand");
            UseDisarm = CheckSkillKey(UseDisarm, "Parrior.Disarm", "Disarm");

            UseWarStomp = CheckSkillKey(UseWarStomp, "Parrior.WarStomp", "War Stomp");
            UseCannibalize = CheckSkillKey(UseCannibalize, "Parrior.Cannibalize", "Cannibalize");
            UseVictoryRush = CheckSkillKey(UseVictoryRush, "Parrior.VictoryRush", "Victory Rush");

            //UseMount = CheckSkillKey(UseMount, "Common.Mount", "Mount");
            //XXX = CheckSkillKey(XXX, "Common.Eat", "XXX");
            //XXX = CheckSkillKey(XXX, "Common.Potion", "XXX");

            Context.Log("Battle stance test");
            Stance = Stance_e.Unknown;
            BattleStance();
            if (!Interface.IsKeyFiring("Parrior.Battle"))
            {
                Context.Log("  Can't see that I am in battle stance");
                HadError = true;
            }


            if (HadError)
            {
                Context.Log("There were critical errors on your bars. Refusing to start glide");
                Context.Log("");
                Context.Log("There are a few possible reasons for this:");
                Context.Log("  1. Your keys.xml is either not correctly set up or you forgot to load the new keys.xml into glider by clicking \"Load\" in the Keys tab in glider settings");
                Context.Log("  2. You are using a bar addon in Wow. They always break critical features in glider that Parrior makes good use of. Example addons that does not work are bongobars, bartender and CT barmod. ");
                Context.Log("  3. You have not put all skills on the correct bars and key on your action bars. ");



                GContext.Main.KillAction("Key setup was bad", false);
            }

            if (HadWarning)
            {
                Context.Log("You had warnings in the key checkup!");
                Context.Log("  One or more keys for skills you have configured to use were not found on the key it was supposed to be on");
            }
            else
            {
                Context.Log("All configured skills and keys were sane");
            }
        }

        #endregion

        #region Stance

        private void UpdateStanceFromKeys()
        {
            if (Interface.IsKeyFiring("Parrior.Defensive")) Stance = Stance_e.Defensive;
            if (Interface.IsKeyFiring("Parrior.Battle")) Stance = Stance_e.Battle;
            if (Interface.IsKeyFiring("Parrior.Berserker")) Stance = Stance_e.Berserker;
        }

        private void ChangeStance(String key, Stance_e targetStance)
        {
            StanceChangeTimer.Reset();
            GSpellTimer t = new GSpellTimer(0);
            WaitForGCD(key, 1000);
            if (IsKeyReady(key))
            {
                SendKey(key);
            }
            GSpellTimer timer = new GSpellTimer(1000);
            do
            {
                UpdateStanceFromKeys();
                if (Stance == targetStance)
                {
                    //Context.Log("  stance change took " + -t.TicksLeft);
                    return;
                }
            } while (!timer.IsReadySlow);
            Context.Log("Change to " + targetStance + " stance failed");
            Stance = Stance_e.Unknown; // buhu
        }

        private void DefensiveStance()
        {
            if (Stance == Stance_e.Defensive) return;
            Spam("Defensive Stance");
            ChangeStance("Parrior.Defensive", Stance_e.Defensive);
        }

        private void BattleStance()
        {
            if (Stance == Stance_e.Battle) return;
            Spam("Battle Stance");
            ChangeStance("Parrior.Battle", Stance_e.Battle);
        }

        private void BerserkerStance()
        {
            if (Stance == Stance_e.Berserker) return;
            Spam("Berserker Stance");
            ChangeStance("Parrior.Berserker", Stance_e.Berserker);
        }

        private void ChangeToStance(Stance_e Stance)
        {
            if (Stance == Stance_e.Defensive) DefensiveStance();
            if (Stance == Stance_e.Battle) BattleStance();
            if (Stance == Stance_e.Berserker) BerserkerStance();
        }

        #endregion



        #region Stone stuff
        void CheckWeaponEnchant(string Key, string Slot)
        {
            long ItemGUID = Context.Items.GetEquippedGUID(Slot);

            if (ItemGUID == 0)
            {
                Context.Log("No item equipped in \"" + Slot + "\"... !?");
                return;
            }

            int[] Enchants = Context.Items.GetItemEnchants(ItemGUID);

            foreach (int OneEnchant in Enchants)
            {
                string EnchantName = Context.Items.GetEnchantName(OneEnchant);

                //Context.Log("enchand: " + EnchantName);
                if (EnchantName != null &&
                            (EnchantName.ToLower().IndexOf("poison") >= 0 ||
                             EnchantName.ToLower().IndexOf("sharpened") >= 0 ||
                             EnchantName.ToLower().IndexOf("weighted") >= 0))
                    return;
            }

            if (Me.IsSitting)
                SendKey("Common.Sit");
            mover.Stop(); Context.Log("CheckWeapon Stop");

            // Made it this far, the item needs stone!
            Context.Debug("Weapon needs enchant in slot: " + Slot);

            int StoneLeft = GContext.Main.Interface.GetActionInventory(Key);

            if (StoneLeft > 1)
            {
                GInterfaceObject CharFrame = Context.Interface.GetByName("CharacterFrame");
                GInterfaceObject SlotSpot = Context.Interface.GetByName("Character" + Slot);

                if (CharFrame == null || SlotSpot == null)
                {
                    Context.Log("Interface angry, couldn't get CharacterFrame or Character" + Slot + "!");
                    return;
                }

                if (!CharFrame.IsVisible)
                {
                    SendKey("Common.Character");

                    Thread.Sleep(1200);

                    if (!CharFrame.IsVisible)
                    {
                        Context.Debug("CharFrame never became visible after keystroke!");
                        return;
                    }
                }


                // Start stone application:
                SendKey(Key);
                Thread.Sleep(1000);
                SlotSpot.ClickMouse(false);
                Thread.Sleep(1000);

                // Get rid of the character screen and wait for channeling:
                SendKey("Common.Character");
                Thread.Sleep(1000);

                GSpellTimer FutileStone = new GSpellTimer(9000, false);

                while (!FutileStone.IsReadySlow && Me.IsCasting && !Me.IsInCombat)
                {
                    if (!Me.IsCasting)
                    {
                        Context.Log("Never entered channeling after stone application!");
                        SendKey("Common.Escape"); // to remove the apply stone move
                        break;
                    }
                }
                SendKey("Common.Escape"); // to remove the apply stone move, if all is ok glider will hande the dialog popup

            }
            else if (StoneLeft == 1)
            {
                Context.Log("One or no stones left. Assume it is a macro and click it anyway");
                CastSpell(Key);
                SendKey("Common.Escape"); // to remove the apply stone move, if all is ok glider will handle the dialog popup
            }
        }

        #endregion

        private bool CanibalizeIfNeeded()
        {
            if (!UseCannibalize) return false;
            if (Me.Health * 100 <= BandageHealth ||
               Me.Health * 100 <= RestHealth)
            {
                // Shoot
                Context.Log("Want to eat corpse");
                if (IsKeyReady("Parrior.Cannibalize"))
                {
                    Context.Log("Cannibalize");
                    CastSpell("Parrior.Cannibalize");

                    Context.Log("Wait for channeling ...");
                    GSpellTimer Futile = new GSpellTimer(12000, false);
                    while (!Futile.IsReadySlow && Me.IsCasting)
                    {
                        if (!Me.IsCasting)
                        {
                            break;
                        }
                    }
                    Context.Log("Took " + (Futile.Duration - Futile.TicksLeft) + "ms");

                    return true;
                }
            }
            return false;
        }
        private bool BandageIfNeeded()
        {
            if (!UseBandage) return false;

            if (Me.Health * 100 > BandageHealth) return false;
            if (IsBandaged()) return false;

            return CastSpell("Parrior.Bandage");
        }

        private bool IsEating()
        {
            GBuff[] buffs = Me.GetBuffSnapshot();
            for (int i = 0; i < buffs.Length; i++)
            {
                if (buffs[i].SpellName == "Food") return true;
            }
            return false;
        }

        private bool IsBandaged()
        {
            GBuff[] buffs = Me.GetBuffSnapshot();
            for (int i = 0; i < buffs.Length; i++)
            {
                if (buffs[i].SpellName == "Bandaged") return true;
            }
            return false;
        }

        private bool EatIfNeeded()
        {
            if (Me.Health * 100 <= RestHealth)
            {
                WaitForCombatToEnd(5000);

                if (!Me.IsInCombat)
                    return Eat();
            }
            return false;
        }

        private bool Eat()
        {
            Context.Log("Eating. " + Interface.GetActionInventory("Common.Eat") + " food left");

            CastSpell("Common.Eat");

            // Now wait, food lasts up to 30s
            GSpellTimer foodWait = new GSpellTimer(30 * 1000);
            bool SwimSpam = false;
            while (!foodWait.IsReadySlow)
            {
                if (Me.IsInCombat)
                {
                    Context.Log("Attacked while eating");
                    break;
                }
                if (!SwimSpam)
                {
                    string red = Context.RedMessage;
                    if (red.Contains("swimming") && !IsEating())
                    {
                        Context.Log(red);
                        SwimSpam = true;
                    }
                }

                if (Me.Health > 0.99) break; // Good to go
            }

            return true;
        }

        string SimilarBuff(string name)
        {
            GBuff[] buffs = Me.GetBuffSnapshot();
            string name_low = name.ToLower();
            for (int i = 0; i < buffs.Length; i++)
            {
                GBuff b = buffs[i];
                String n = b.SpellName.ToLower();
                if (n.Contains(name_low))
                {
                    return b.SpellName;
                }
            }
            return null;
        }

        bool CheckBuff(BuffUse_e use, string name, out string new_name,
                       string key, string ConfigKey)
        {
            new_name = name;
            if (use != BuffUse_e.NoUse)
            {
                if (name != "" && SimilarBuff(name) != null)
                    return false; // got it
                Context.Log("Missing buff '" + name + "'");


                // Check that there are any items left

                int Left = GContext.Main.Interface.GetActionInventory(key);
                if (Left < 1)
                {
                    Context.Log("  But there are no buff items left!");
                    return false;
                }

                int Timeout;
                if (use == BuffUse_e.Food)
                {
                    WaitForCombatToEnd(5000);
                    if (Me.IsInCombat) return false;
                    Context.Log("  Eating buff food");
                    Timeout = 15000;
                }
                else
                {
                    Timeout = 2000;
                }

                BuffSnapshot();
                CastSpell(key); // use
                if (use == BuffUse_e.Food)
                {
                    Thread.Sleep(1000); // Avoid the "Food" buff
                    BuffSnapshot();
                }


                GSpellTimer Futile = new GSpellTimer(Timeout, false); // max 15s wait for buff
                do
                {
                    GBuff buff = FindNewBuff();
                    if (buff != null)
                    {
                        Context.Log("  Got the buff " + buff.SpellName);

                        if (name == "")
                        {
                            Context.Log("  No buff name configured. Setting it to \"" + buff.SpellName + "\"");
                            name = buff.SpellName;
                            new_name = name;
                            Context.SetConfigValue(ConfigKey, buff.SpellName, true);
                        }
                    }
                    if (name != "")
                    {
                        string s = SimilarBuff(name);
                        if (s != null)
                        {
                            return true;
                        }
                    }
                } while (!Me.IsInCombat && !Me.IsDead && !Futile.IsReadySlow);
                if (Futile.IsReady)
                {
                    Context.Log("  Timed out waiting for buff '" + name + "'");
                }
            }
            return false;
        }

        private bool WaitForCombatToEnd(int maxTime)
        {
            if (Me.IsInCombat)
            {
                if (GObjectList.GetNearestAttacker(0) == null)
                {
                    mover.Stop();
                    GUnit Attacker = null;
                    GSpellTimer Futile = new GSpellTimer(maxTime, false);
                    do
                    {
                        Attacker = GObjectList.GetNearestAttacker(0);
                    } while (Me.IsInCombat && Attacker == null && !Futile.IsReadySlow);
                    //if(Attacker != null)
                    //    Spam(" Got attack " + Attacker.Name);
                    if (Futile.IsReady)
                        Context.Log("Timeout waiting for combat flag to be able to eat");
                    //else
                    //Context.Log(" waited " + (5000 - Futile.TicksLeft) + "ms");			
                }
            }
            return !Me.IsInCombat;
        }

        public override bool Rest()
        {
            if (Me.IsDead) return false;
            while (StandingInAoE) // we are inside some AoE effect (posions cloud thunderstom etc)
            {
                Context.Log("Standing on an AoE effect!");
                StepOutOfAoE();
                Thread.Sleep(800); // let him land first
            }

            bool didSomething = false;

            didSomething |= CanibalizeIfNeeded();

            didSomething |= BandageIfNeeded();

            didSomething |= CheckBuff(BuffItem1, BuffName1, out BuffName1,
                                      "Parrior.BuffUsable1", "Parrior.BuffName1");
            didSomething |= CheckBuff(BuffItem2, BuffName2, out BuffName2,
                                      "Parrior.BuffUsable2", "Parrior.BuffName2");
            didSomething |= CheckBuff(BuffItem3, BuffName3, out BuffName3,
                                      "Parrior.BuffUsable3", "Parrior.BuffName3");


            didSomething |= EatIfNeeded();

            if (Me.IsSitting)
                SendKey("Common.Sit");

            if (WeaponBuffMain)
                CheckWeaponEnchant("Parrior.WeaponBuffMainHand", "MainHandSlot");

            if (WeaponBuffOff)
                CheckWeaponEnchant("Parrior.WeaponBuffOffHand", "SecondaryHandSlot");

            return didSomething;
        }



        private bool HaveBattleShoutBuff()
        {
            GBuff[] buffs = Me.GetBuffSnapshot();
            for (int i = 0; i < buffs.Length; i++)
            {
                GBuff b = buffs[i];
                string s = b.SpellName;
                if (s == "Battle Shout") return true;
                if (s == "Commanding Shout") return true;
            }
            return false;
        }

        private int RendDuration()
        {
            /* Assume you have visited trainer
               lvl  rank  duration 
               4   1       9
               10   2      12
               20   3      15
               30   4      18
               50   5      21
               60   6      21
               68   7      21
            */
            int lvl = Me.Level;
            if (lvl >= 50) return 21000;
            if (lvl >= 30) return 18000;
            if (lvl >= 20) return 15000;
            if (lvl >= 10) return 12000;
            return 9000;
        }

        private int DemoDuration()
        {
            return 30 * 1000 * (100 + BoomingTalents * 10) / 100;
        }

        private int ThunderDuration()
        {
            /* Assume you have visited trainer
               lvl  rank  duration 
               6    1     10
               18    2     14
               28    3     18
               38    4     22
               48    5     26
               58    6     30

            */
            int lvl = Me.Level;
            if (lvl >= 58) return 30000;
            if (lvl >= 48) return 26000;
            if (lvl >= 38) return 22000;
            if (lvl >= 28) return 18000;
            if (lvl >= 18) return 14000;
            return 10000;
        }



        private GBuff[] BuffSnap;
        private void BuffSnapshot()
        {
            BuffSnap = Me.GetBuffSnapshot();
            //Context.Log("Snapshot");
            //DumpBuffs();
        }

        // Find a buff not present in last BuffSnapshot
        private GBuff FindNewBuff()
        {
            GBuff[] buffs = Me.GetBuffSnapshot();
            //Context.Log("Search for new");
            //DumpBuffs();
            for (int i = 0; i < buffs.Length; i++)
            {
                GBuff b = buffs[i];
                // O(n^2) FTW
                GBuff old = null;
                for (int j = 0; j < BuffSnap.Length && old == null; j++)
                {
                    GBuff b2 = BuffSnap[j];
                    if (b2.SpellID == b.SpellID)
                    {
                        old = b;
                    }
                }
                if (old == null)
                {
                    //Context.Log("New buff: " + b.SpellName);
                    return b;
                }
            }
            return null;
        }



        private void DumpBuffs()
        {
            GBuff[] buffs = Me.GetBuffSnapshot();
            for (int i = 0; i < buffs.Length; i++)
            {
                Context.Log("buff: " + buffs[i]);
            }
        }


        /////////////////////////////////////////////////////////////////
        // Mounting

        int mountBuffID = 0;
        private bool IsMounted()
        {
            if (mountBuffID == 0) return false;
            GBuff[] buffs = Me.GetBuffSnapshot();
            for (int i = 0; i < buffs.Length; i++)
            {
                if (buffs[i].SpellID == mountBuffID) return true;
            }
            return false;
        }


        private void MountUp()
        {
            if (IsMounted()) return;
            if (Me.IsInCombat) return;
            mover.Stop();
            Context.Log("Mount up");
            BuffSnapshot();
            CastSpell("Parrior.Mount");
            mountBuffID = 0;
            GSpellTimer Futile = new GSpellTimer(1000, false);
            while (!Futile.IsReadySlow)
            {
                Me.SetBuffsDirty();
                GBuff buff = FindNewBuff();
                if (buff != null)
                    mountBuffID = buff.SpellID;
                if (IsMounted()) return;
            }
            Context.Log("Found no mount buff");
        }

        private void Dismount()
        {
            if (!IsMounted()) return;
            //mover.Stop(); // glider waypoint followe gets really sad
            Context.Log("Dismount");
            SendKey("Parrior.Mount");
        }



        /////////////////////////////////////////////////////////////////
        // Shadowmeld

        int shadowBuffID = 0;
        private bool IsShadowmelded()
        {
            if (shadowBuffID == 0) return false;
            GBuff[] buffs = Me.GetBuffSnapshot();
            for (int i = 0; i < buffs.Length; i++)
            {
                if (buffs[i].SpellID == shadowBuffID) return true;
            }
            return false;
        }


        private void Shadowmeld()
        {
            if (IsShadowmelded()) return;
            if (Me.IsInCombat) return;

            mover.Stop();
            Context.Log("Shadowmeld");
            WaitForGCD("Parrior.Shadowmeld", 10 * 1000); // looong wait
            if (!IsKeyReady("Parrior.Shadowmeld"))
            {
                Context.Log("Shadowmeld still on cooldown after 10s. thats odd");
                return;
            }
            BuffSnapshot();
            CastSpell("Parrior.Shadowmeld");
            shadowBuffID = 0;
            GSpellTimer Futile = new GSpellTimer(1000, false);
            while (!Futile.IsReadySlow)
            {
                Me.SetBuffsDirty();
                GBuff buff = FindNewBuff();
                if (buff != null)
                    shadowBuffID = buff.SpellID;
                if (IsShadowmelded()) return;
            }
            Context.Log("Found no shadowmeld buff");
        }

        /////////////////////////////////////////////////////////////////
        // Run run run

        public override void RunningAction()
        {
            UpdateMyPos();

            if (UseShadowmeld)
            {
                bool hide = false;
                hide |= AvoidSameFaction && GetClosestFriendlyPlayer() != null;
                hide |= AvoidOtherFaction && GetClosestPvPPlayer() != null;
                if (hide)
                {
                    mover.Stop();
                    if (!IsShadowmelded())
                    {
                        Context.Log("Shamdowmeld to hide from players");
                        Shadowmeld();
                        if (IsShadowmelded())
                        {
                            Context.Log("  wait a little");
                            GSpellTimer Futile = new GSpellTimer(6000, false);
                            while (!Futile.IsReadySlow && !Me.IsInCombat && !Me.IsDead) ;
                        }
                    }
                }
            }

            if (BattleStanceTimer == null)
            {
                BattleStanceTimer = new GSpellTimer((5 + random.Next(5)) * 1000, false);
            }

            if (BattleStanceTimer.IsReady && PullStyle == PullStyle_e.Charge)
                if (Me.Rage <= RageLeftOnStanceChange + MaxRageLoss)
                    BattleStance();

            if (PvPStyle == PvPStyle_e.Active)
            {
                // Look for a killable...
                GPlayer topwn = GetClosestPvPPlayer();
                do
                {
                    if (topwn != null && !topwn.IsDead &&
                        topwn.DistanceToSelf < PullDistance)
                    {
                        mover.Stop();
                        if (!topwn.SetAsTarget(false))
                        {
                            Context.Log("can not target player " + topwn.Name);
                        }
                        else
                        {
                            //Context.Log("I will not kill " + topwn.Name + ". Lucky him");
                            Context.Log("kill " + topwn.Name + " dead: " + topwn.IsDead);
                            KillTarget(topwn, false);
                        }
                    }
                    topwn = GetClosestPvPPlayer();
                } while(topwn != null && !topwn.IsDead && !Me.IsDead && 
                        topwn.DistanceToSelf < PullDistance);
            }

            if (BeTank)
            {
                List<GUnit> getAggro = FindUnitsAttackingParty(false);
                GetAggroFrom(null, getAggro);
            }

            // Check if glider is running around too damaged
            if (Me.Health * 100 < RestHealth)
            {
                // *Gasp*
                if (DistanceToClosestMonsterFrom(Me) > AvoidAddDistance)
                {
                    mover.Stop();
                    Rest();
                }

            }

            if (UseMount)
            {
                double d = DistanceToClosestMonsterFrom(Me);
                if (DistanceToClosestMine() < HarvestRange + 10)
                {
                    if (IsMounted())
                    {
                        Context.Log("Close to a mine, dismount");
                        Dismount();
                    }
                }
                else if (ForceNoMount.IsReady &&
                        !Me.IsStealth &&
                        !Context.IsCorpseNearby)
                {
                    if (d > MountDistance)
                    {
                        //mover.Stop();  Context.Log("Gasp stop");
                        ForceNoMount.Reset(); // Do not try to mount the next 5 seconds, we might be in water or something
                        MountUp();
                    }
                }
            }

        }


        public override void ApproachingTarget(GUnit Target)
        {
            Context.Log("ApproachingTarget " + Target.Name + " distance " + (int)Target.DistanceToSelf);
            Dismount();
        }

        void ConsiderSkipWP()
        {
            const int maxSkip = 8;
            if (Context.CurrentMode != GGlideMode.Glide) return;
            if (!SkipWaypoints) return;

            GProfile profile = Context.Profile;

            int index = profile.CurrentIndex;
            int i = 0;
            List<GLocation> wps = profile.Waypoints;
            GLocation currentWP = wps[index];
            int newIndex = index;
            foreach (GLocation wp in wps)
            {
                if (i >= index - maxSkip && i <= index + maxSkip)
                {
                    // consider if this is better to go to
                    if (Me.GetDistanceTo(wp) < Me.GetDistanceTo(currentWP))
                    {
                        newIndex = i;
                    }
                }
                i++;
            }
            if (newIndex < index)
            {
                for (i = index; i > newIndex; i--)
                {
                    if (profile.ReverseWaypoints)
                        profile.ConsumeCurrentWaypoint();
                    else
                        profile.SetPreviousWaypoint();
                    Context.Log("Skip waypoint backwards WP #" + i);
                }
            }
            else if (newIndex > index)
            {
                for (i = index; i < newIndex; i++)
                {
                    if (profile.ReverseWaypoints)
                        profile.SetPreviousWaypoint();
                    else
                        profile.ConsumeCurrentWaypoint();
                    Context.Log("Skip waypoint forwards WP #" + i);
                }
            }
        }


        #region KillTarget



        // Some combat state
        Int64 LastTarget = 0;
        int no_retries = 0;
        bool IsRunning = false;

        bool HaveAdd; // we got an add?
        long AddedGUID;
        bool HaveCloseAdd; // we got an add in melee range?
        GUnit CloseAdd = null;
        GUnit Target = null;
       
        int Rage; // available rage

        GSpellTimer NoAggroTimer = new GSpellTimer(2000); // Target is targetting another memeber...


        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////

        /*
          Each skill has 2 function
          bool WantSkill() and bool DoSkill;
	  
          WantSkill should check all contition for performing a skill (except rage) and see if they are met

          DoSkill should check the rage for the skill, if it is too little it can
          reserve rage by subtracting the needed rage from the Rage variable
          return true if the skill has succeeded

        */



        // Hamstring (lvl 8, 10 rage, battle, zerg), last
        private bool WantHamstring()
        {
            if (UseHamstring &&
               (Stance == Stance_e.Battle || Stance == Stance_e.Berserker) &&
               ((IsRunner(Target.Name) && Target.Health < 0.5) || Target.IsPlayer) &&
               HamstringTimer.IsReady)
                return true;
            return false;
        }

        private bool DoHamstring()
        {
            if (Rage >= (10 - FocusedRage))
            {
                // cut him bad!
                Spam("Hamstring");
                return CastSpellAndWaitForRage("Parrior.Hamstring");
            }
            else
                Rage -= (10 - FocusedRage); // want more rage
            return false;
        }


        // Shield bash (lvl 12, 10 rage, battle, def, 12 s CD, silence(school) for 6s!)		
        private bool WantShieldBash()
        {
            if (UseShieldBash &&
               (Stance == Stance_e.Battle || Stance == Stance_e.Defensive) &&
               ShieldBashTimer.IsReady &&
               Target.IsCasting &&
               Target.Health * 100 <= SilenceHealth &&
               IsKeyReady("Parrior.ShieldBash"))
                return true;
            return false;
        }

        private bool DoShieldBash()
        {
            if (Rage >= (10 - FocusedRage))
            {
                Spam("Shield Bash");
                if (CastSpellAndWaitForRage("Parrior.ShieldBash"))
                {
                    ShieldBashTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= (10 - FocusedRage);
            return false;
        }

        // Shield Block (lvl 16, 10 rage, def, 5s CD)
        private bool WantShieldBlock()
        {
            if (UseShieldBlock &&
               Stance == Stance_e.Defensive &&
               ShieldBlockTimer.IsReady &&
               IsKeyReady("Parrior.ShieldBlock") &&
               !IsKeyEnabled("Parrior.Revenge"))
                return true;
            return false;
        }

        private bool DoShieldBlock()
        {
            if (Rage >= 10)
            {
                Spam("Shield Block");
                if (CastSpellAndWaitForRage("Parrior.ShieldBlock"))
                {
                    ShieldBlockTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= 10;
            return false;
        }


        // Pummel (lvl 38, 10 rage, silence)
        private bool WantPummel()
        {
            if (UsePummel &&
               PummelTimer.IsReady &&
               Target.IsCasting &&
               Target.Health * 100 <= SilenceHealth)
            {
                if (Stance != Stance_e.Berserker)
                {
                    // Change stance?!
                    if (PummelChangeStance && Rage <= RageLeftOnStanceChange + MaxRageLoss)
                    {
                        Spam("Stance change to Pummel");
                        BerserkerStance();
                        Thread.Sleep(StanceDanceSleep);
                    }
                }
                if (Stance == Stance_e.Berserker)
                {
                    if (IsKeyReady("Parrior.Pummel"))
                    {
                        return true;
                    }
                }
            }
            return false;
        }

        private bool DoPummel()
        {
            if (Rage >= (10 - FocusedRage))
            {

                Spam("Pummel");
                if (CastSpellAndWaitForRage("Parrior.Pummel"))
                {
                    PummelTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= (10 - FocusedRage);
            return false;
        }


        // War Stomp (Tauren racial, 0.5s cast, 2s stun, 2 min CD)
        private bool WantWarStomp()
        {
            if (SkillConditionEval(UseWarStomp) &&
               WarStompTimer.IsReady)
            {
                if (IsKeyReady("Parrior.WarStomp"))
                {
                    return true;
                }
            }
            return false;
        }

        private bool DoWarStomp()
        {
            Spam("War Stomp");
            CastSpell("Parrior.WarStomp", false, false);
            WarStompTimer.Reset();
            return true;
        }


        // Execute (lvl 24, battle, serk, 15 rage, target < 20%health)
        private bool WantExecute()
        {
            if ((Stance == Stance_e.Battle || Stance == Stance_e.Berserker) &&
               UseExecute && IsKeyEnabled("Parrior.Execute"))
            {
                return true;
            }
            if (UseExecute && Stance == Stance_e.Defensive &&
               Target.Health <= 0.20 && Rage >= (15 - FocusedRage) && Rage <= RageLeftOnStanceChange + MaxRageLoss)
            {
                // Stance dance!
                Spam("Stance change to Execute");
                BattleStance();
                Thread.Sleep(StanceDanceSleep);
                return true;
            }
            return false;
        }

        private bool DoExecute()
        {
            Spam("Execute");
            return CastSpellAndWaitForRage("Parrior.Execute");
        }


        // Victory Rush
        private bool WantVictoryRush()
        {
            if ((Stance == Stance_e.Battle || Stance == Stance_e.Berserker) &&
               !VictoryRushTimer.IsReady &&
               UseVictoryRush)
            {
                return true;
                /*
                  if(IsKeyEnabled("Parrior.VictoryRush"))
                  {
                  return true;
                  }
                  else
                  {
                  Spam("wanted wictory rush but is was not enabled");
                  }
                */
            }
            return false;
        }

        private bool DoVictoryRush()
        {
            if (IsKeyEnabled("Parrior.VictoryRush"))
            {
                Spam("Victory Rush");
                CastSpell("Parrior.VictoryRush", false, true);
                VictoryRushTimer.ForceReady();
                return true;
            }
            else
                VictoryRushTimer.ForceReady();

            return false;
        }

        //Intimidating Shout (lvl 22, 25 rage, 10 yards, fear 5 mobs, 3 min CD)
        private bool WantIntimidatingBandage()
        {
            if (UseIntimidatingBandage &&
               Me.Health < IntimidatingBandageLife &&
               IntimidatingTimer.IsReady &&
               !IsBandaged() &&
               IsKeyReady("Parrior.Intimidating"))
            {
                // I want health                
                return true;
            }
            return false;
        }

        private bool DoIntimidatingBandage()
        {
            if (Rage >= (25 - FocusedRage))
            {
                Spam("Intimidating Shout & Bandage");
                if (Me.IsMeleeing)
                    SendKey("Common.ToggleCombat");
                CastSpell("Parrior.Intimidating");
                IntimidatingTimer.Reset();
                Spam("Bandage");
                CastSpell("Parrior.Bandage");
                //BandageIfNeeded();
                //CheckBandageApply(true);
                Spam("Bandage done");
                if (!Me.IsMeleeing)
                    SendKey("Common.ToggleCombat");
                return true;
            }
            else
                Rage -= (25 - FocusedRage);
            return false;

        }

        //Intimidating Shout (lvl 22, 25 rage, 10 yards, fear 5 mobs, 3 min CD)
        private bool WantIntimidating()
        {
            // PvP move
            return false;
        }

        private bool DoIntimidating()
        {
            return false;
        }


        //Intercept (lvl 30, 10 rage, Bersek, charge in combat, 3s stun, 30s CD), hmm another spell breaker?
        private bool WantIntercept()
        {
            if (UseIntercept &&
               Stance == Stance_e.Berserker &&
               Target.DistanceToSelf > 10.0 &&
               IsKeyEnabled("Parrior.Intercept"))
            {
                return true;
            }
            return false;
        }

        private bool DoIntercept()
        {
            Spam("Intercept");
            return CastSpellAndWaitForRage("Parrior.Intercept");
        }


        // Rampage (lvl 50, 20 Rage, AP +30/40/50, after a crit. stack up to 5 times. 30s duration)
        private bool WantRampage()
        {
            if (RampageTimer.IsReady &&
               SkillConditionEval(UseRampage) &&
               IsKeyEnabled("Parrior.Rampage"))
            {
                return true;
            }
            return false;
        }

        private bool DoRampage()
        {
            if (Rage >= 20)
            {
                Spam("Rampage");
                if (CastSpellAndWaitForRage("Parrior.Rampage"))
                {
                    RampageTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= 20; // !!!
            return false;
        }

        // Bloodrage (lvl 10, generates 20 rage at the cost of HP, puts you in combat for 10s)
        private bool WantBloodrage(bool BeforeCharge)
        {
            if (((!BeforeCharge && SkillConditionEval(UseBloodrage)) || (BeforeCharge && SkillConditionEvalBeforeCharge(UseBloodrage))) &&
               Me.Health >= 0.50 &&
               BloodrageTimer.IsReady &&
               IsKeyReady("Parrior.Bloodrage"))
            {
                return true;
            }
            return false;
        }

        private bool DoBloodrage()
        {
            if (IsKeyReady("Parrior.Bloodrage"))
            {
                Spam("Bloodrage");
                BloodrageTimer.Reset();
                CastSpell("Parrior.Bloodrage", false, true);
                return true;
            }
            return false;
        }


        // Overpower (lvl 12, 5 rage, Battle, Only useable after the target dodges)
        private bool WantOverpower()
        {
            if (Stance == Stance_e.Battle && UseOverpower &&
                IsKeyReady("Parrior.Overpower") && IsKeyEnabled("Parrior.Overpower"))
            {
                return true;
            }
            return false;
        }

        private bool DoOverpower()
        {
            if (Rage >= (5 - FocusedRage) && IsKeyEnabled("Parrior.Overpower"))
            {
                Spam("Overpower");
                bool r = CastSpellAndWaitForRage("Parrior.Overpower");
                return r;
            }
            return false;
        }

        // Revenge (lvl 14, 5 rage, def stance, must follow a block, dodge or parry)
        private bool WantRevenge()
        {
            if (Stance == Stance_e.Defensive && UseRevenge &&
                IsKeyEnabled("Parrior.Revenge") && IsKeyReady("Parrior.Revenge"))
            {
                return true;
            }
            return false;
        }

        private bool DoRevenge()
        {
            if (Rage >= (5 - FocusedRage))
            {
                Spam("Revenge");
                return CastSpellAndWaitForRage("Parrior.Revenge");
            }
            return false;
        }

        // Sunder (lvl 10, 12-15 rage, stacks 5, lasts 30s)       
        private bool WantSunder()
        {
            if (SkillConditionEval(UseSunder) &&
               LandedSunders < SunderStack)
            {
                return true;
            }
            if (LandedSunders > 0 && SunderTimer.IsReady)
                return true; // renew those sunders before they run out
            return false;
        }

        private bool DoSunder()
        {
            if (Rage >= SunderCost)
            {
                if (LandedSunders > 0 && SunderTimer.IsReady)
                    Spam("Sunder Armor (refresh)");
                else
                    Spam("Sunder Armor");
                if (CastSpellAndWaitForRage("Parrior.SunderArmor"))
                    return true;
            }
            else
                Rage -= SunderCost; // I want to sunder!
            return false;
        }

        // Battle shout
        private bool WantBattleShout()
        {
            if (UseBattleShout && !HaveBattleShoutBuff()) return true;
            return false;
        }

        private bool DoBattleShout()
        {
            if (Rage >= (10))
            {
                Spam("Battle Shout");
                return CastSpellAndWaitForRage("Parrior.BattleShout");

            }
            else
                Rage -= (10);
            return false;
        }


        // Demo shout (lvl 14, 10 rage) 
        private bool WantDemoShout()
        {
            if (SkillConditionEval(UseDemo) &&
               DemoTimer.IsReady && Rage >= (10 - FocusedRage))
            {
                if (!IsAnyNeutralNonaggoredClose(12)) // 10yds if official range
                {
                    return true;
                }
            }
            return false;
        }

        private bool DoDemoShout()
        {
            if (Rage >= (10 - FocusedRage))
            {
                Spam("Demoralizing Shout");
                DemoTimer.Reset();
                return CastSpellAndWaitForRage("Parrior.DemoShout");

            }
            else
                Rage -= (10 - FocusedRage);
            return false;
        }

        // Thunder clap (lvl 6, 20 rage, battle, def, 4s cooldown)
        private bool WantThunderClap()
        {
            if ((Stance == Stance_e.Battle || Stance == Stance_e.Defensive) &&
               SkillConditionEval(UseThunder) &&
               ThunderTimer.IsReady && IsKeyReady("Parrior.ThunderClap"))
            {
                if (!IsAnyNeutralNonaggoredClose(10)) // 8yds is official range
                {
                    return true;
                }
                //else
                //    Spam("Skip thunder due to close close non aggroed mobs");
            }
            return false;
        }

        private bool DoThunderClap()
        {
            if (Rage >= (ThunderCost - FocusedRage))
            {
                Spam("Thunder Clap");
                ThunderTimer.Reset();
                return CastSpellAndWaitForRage("Parrior.ThunderClap");
            }
            else
                Rage -= (ThunderCost - FocusedRage); // I want to thunderclap!
            return false;
        }

        // Rend (lvl 4, 10 rage, battle, def)
        private bool WantRend()
        {
            if (UseRend &&
               (Stance == Stance_e.Battle || Stance == Stance_e.Defensive) &&
               !IsRendImmune(Target.Name) &&
               RendTimer.IsReady && Target.Health > 0.5)
            {
                return true;
            }
            return false;
        }


        private bool DoRend()
        {
            if (Rage >= (10 - FocusedRage) && IsKeyReady("Parrior.Rend"))
            {
                Spam("Rend");
                if (CastSpellAndWaitForRage("Parrior.Rend"))
                {
                    RendTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= (10 - FocusedRage); // I want to rend!
            return false;
        }

        private bool WantTaunt()
        {
            if (BeTank && NoAggroTimer.IsReady && UseTaunt && Stance == Stance_e.Defensive &&
               TauntTimer.IsReady && !Target.IsPlayer && IsKeyReady("Parrior.Taunt"))
                return true;
            return false;

        }

        private bool DoTaunt()
        {
            Spam("Taunt");
            CastSpell("Parrior.Taunt", false, true);
            TauntTimer.Reset();
            return true;
        }




        // Concussion Blow (lvl 40 def,15 Rage, Stuns the opponent for 5 sec. 45s cooldown)
        private bool WantConcussion()
        {
            if (UseConcussion &&
               (!SaveConcussionForCast || (SaveConcussionForCast && Target.IsCasting)) &&
               ConcussionTimer.IsReady)
            {
                return true;
            }
            return false;
        }


        private bool DoConcussion()
        {
            if (Rage >= (15 - FocusedRage) && IsKeyReady("Parrior.Concussion"))
            {
                Spam("Concussion Blow");
                if (CastSpellAndWaitForRage("Parrior.Concussion"))
                {
                    ConcussionTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= (15 - FocusedRage); // I want to stun!
            return false;
        }


        // Mortal Strike (lvl 40, 30 rage, 6s cooldown)
        private bool WantMortalStrike()
        {
            if (UseMS && IsKeyReady("Parrior.MortalStrike"))
            {
                return true; // always :p
            }
            return false;
        }

        private bool DoMortalStrike()
        {
            if (Rage >= 30)
            {
                Spam("Mortal Strike");
                return CastSpellAndWaitForRage("Parrior.MortalStrike");
            }
            else
                Rage -= 30; // I want to MS!
            return false;
        }

        //Bloodthirst (lvl 38, 30 rage, 6s CD, good dmg, successful melee attacks will restore 10 health, 8s duration)
        private bool WantBloodthirst()
        {
            if (SkillConditionEval(UseBloodthirst) &&
               IsKeyReady("Parrior.Bloodthirst"))
            {
                return true;
            }
            return false;
        }

        private bool DoBloodthirst()
        {
            if (Rage >= 30)
            {
                Spam("Bloodthirst");
                return CastSpellAndWaitForRage("Parrior.Bloodthirst");
            }
            else
                Rage -= 30; // I want to blood!
            return false;
        }

        // Death Wish (lvl 30, 10 rage, damage done +20%, immune to Fear, damage taken +5%.  Lasts 30 sec. 3 min CD
        private bool WantDeathWish()
        {
            if (SkillConditionEval(UseDeathWish) &&
               DeathWishTimer.IsReady &&
               IsKeyReady("Parrior.DeathWish"))
            {
                return true;
            }
            return false;
        }

        private bool DoDeathWish()
        {
            if (Rage >= 10)
            {
                Spam("Death Wish");

                if (CastSpellAndWaitForRage("Parrior.DeathWish"))
                {
                    DeathWishTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= 10; // I want to die!
            return false;
        }

        // Berserker Rage (lvl 32, Bersek, immune to Fear/Incap, generating extra rage when taking damage for 10s. 30s CD
        private bool WantBerserkerRage()
        {
            if (SkillConditionEval(UseBerserkerRage) &&
               BerserkerRageTimer.IsReady &&
               Stance == Stance_e.Berserker &&
               IsKeyReady("Parrior.BerserkerRage"))
            {
                return true;
            }
            return false;
        }

        private bool DoBerserkerRage()
        {
            Spam("Berserker Rage");
            GSpellTimer t = new GSpellTimer(0);
            CastSpell("Parrior.BerserkerRage", false, true);
            BerserkerRageTimer.Reset();
            return true;
        }

        // Disarm (lvl18 def, 20 rage, Disarm the enemy's weapon for 10 sec.) 
        private bool WantDisarm()
        {
            if (UseDisarm &&
                Stance == Stance_e.Defensive &&
                !IsDisarmImmune(Target.Name) && 
                DisarmTimer.IsReady &&
                IsKeyReady("Parrior.Disarm"))
            {
                return true;
            }
            else
                Rage -= 20-FocusedRage;
            return false;
        }

        private bool DoDisarm()
        {
            Spam("Disarm");
            if (CastSpellAndWaitForRage("Parrior.Disarm"))
            {
                CastSpell("Parrior.Disarm", false, true);
                DisarmTimer.Reset();
                return true;
            }
            return true;
        }



        // Whirlwind  (lvl 36, 25 rage, Bersek, attack up to 4 enemies within 8 yards, 10s CD)
        private bool WantWhirlwind()
        {
            if (WhirlwindAdds != -1 &&
                Stance == Stance_e.Berserker &&
                Rage > WhirlwindMinRage &&
                WhirlwindTimer.IsReady)
            {
                // Cound number of attackables
                int no = NumberOfCloseAttackables(8);
                if (no > WhirlwindAdds)
                {
                    return true;// yeah!
                }
            }
            return false;
        }

        private bool DoWhirlwind()
        {
            if (Rage >= (25 - FocusedRage))
            {
                if (IsKeyReady("Parrior.Whirlwind"))
                {
                    Spam("Whirlwind");
                    if (CastSpellAndWaitForRage("Parrior.Whirlwind"))
                    {
                        WhirlwindTimer.Reset();
                        return true;
                    }
                    else
                        Spam("  Whirlwind failed");

                }
                return false;
            }
            else
                Rage -= (25 - FocusedRage); // Save rage
            return false;
        }


        // Shield Slam (lvl 40, 20 rage, 31pt protecion, 6s CD)
        private bool WantShieldSlam()
        {
            if (UseShieldSlam && IsKeyReady("Parrior.ShieldSlam"))
            {
                return true; // always :p
            }
            return false;
        }

        private bool DoShieldSlam()
        {
            if (Rage >= (20 - FocusedRage))
            {
                Spam("Shield Slam");
                return CastSpellAndWaitForRage("Parrior.ShieldSlam");
            }
            else
                Rage -= (20 - FocusedRage); // I want to board him!
            return false;
        }


        // Sweeping Strikes (lvl 30, 30 rage, battle, 30s cooldown, Your next 5 melee attacks strike an additional nearby opponent.)
        private bool WantSweeping()
        {
            if (UseSweeping && HaveCloseAdd && Target.Health > 0.40 &&
               SweepingTimer.IsReady && IsKeyReady("Parrior.Sweeping"))
            {
                return true; // always :p
            }
            return false;
        }

        private bool DoSweeping()
        {
            if (Rage >= 30)
            {
                Spam("Sweeping Strikes");
                if (CastSpellAndWaitForRage("Parrior.Sweeping"))
                {
                    SweepingTimer.Reset();
                    return true;
                }
            }
            else
                Rage -= 30; // I want to sweep!
            return false;
        }



        // (lvl 30, 15 rage, 0.5-1.5s cast) 
        private GSpellTimer SlamSpamTimer = new GSpellTimer(0);
        private bool WantSlam()
        {
            if (UseSlam != SlamMode_e.Never)
            {
                if (Rage >= SlamMinRage && (UseSlam == SlamMode_e.OneShot))
                {
                    return true;
                }
                if (UseSlam == SlamMode_e.Spam)
                {
                    if (Rage >= SlamMinRage && SlamSpamTimer.IsReady)
                    {
                        SlamSpamTimer = new GSpellTimer(6000);
                        SlamSpamTimer.Reset(); // Start slam spam
                        Spam("Activate Slam Spam");
                        return true;
                    }
                    if ((Rage > (15 - FocusedRage) && !SlamSpamTimer.IsReady))
                    {
                        return true;
                    }
                }
            }
            return false;
        }

        private bool DoSlam()
        {
            Spam("Slam");
            CastSpell("Parrior.Slam", false, false);
            return true;
        }


        // Cleave (lvl 20, 20 Rage, 5 yd range) "next melee"
        private bool WantCleave()
        {
            if (SkillConditionEval(UseCleave) &&
               (UseCleave != SkillCondition_e.CloseAdd ||
                (UseCleave == SkillCondition_e.CloseAdd && CloseAdd != null && IsInFrontOfMe(CloseAdd))) &&
               IsKeyReady("Parrior.Cleave") &&
               !Interface.IsKeyFiring("Parrior.Cleave"))
            {
                // We do not want to cleave the wrong target...
                if (!IsAnyNeutralNonaggoredClose(5)) // 5yds if official range
                    return true;
            }
            return false;
        }

        private bool DoCleave()
        {
            if (Rage >= (20 - FocusedRage))
            {
                Spam("Cleave");
                SendKey("Parrior.Cleave");
                return true;
            }
            else
            {
                Rage -= (20 - FocusedRage); // I want to cleave!
            }
            return false;
        }

        // Heroic strike (lvl1, 15-12 rage) "next melee"
        private bool WantHeroicStrike()
        {
            // This is the rage-dump, works good with 1H at least
            if (UseHeroic && Rage >= HeroicMinRage && HeroicTimer.IsReady &&
               IsKeyEnabled("Parrior.HeroicStrike") &&
               !Interface.IsKeyFiring("Parrior.HeroicStrike") &&
               !Interface.IsKeyFiring("Parrior.Cleave"))
                return true;

            return false;

        }

        private bool DoHeroicStrike()
        {
            if (Rage >= HeroicCost)
            {

                Spam("Heroic Strike");
                HeroicTimer.Reset();
                SendKey("Parrior.HeroicStrike");

                return true;
            }
            return false;
        }

        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////



        public GCombatResult EndCombat(GCombatResult res, GUnit target)
        {
            mover.Stop();


            if (res == GCombatResult.Retry && LastTarget == target.GUID)
            {
                no_retries++;
                if (no_retries > 5) // Max 5 retries on the the same mob
                    res = GCombatResult.Bugged;
            }
            else
                no_retries = 0;
            LastTarget = target.GUID;


            if ((HaveAdd) && res == GCombatResult.Success)
            {
                GUnit Add = GObjectList.FindUnit(AddedGUID);

                if (Add == null)
                {
                    Context.Log("*** Could not find add after combat, id = " + AddedGUID.ToString("x"));
                }
                else if (Add.IsDead)
                {
                    Context.Log("*** Add is dead. " + Add.Name);
                }
                else if (!Add.SetAsTarget(false))
                {
                    Context.Log("*** Could not target add after combat, name = '" + Add.Name + "', id = " + Add.GUID.ToString("x"));
                }
                else
                {
                    // Tell Glider to immediately begin wasting this guy and not rest:
                    res = GCombatResult.SuccessWithAdd;
                }
            }
            else
            {
                if (Me.Target != null)
                    Context.ClearTarget();
            }

            BattleStanceTimer = null;
            Spam("Combat done. lost " + (int)((CombatStartHealth - Me.Health) * 100) + "% health. " + res);
            ForceNoMount.Reset(); // Do not try to mount the next 5 seconds, lootable issues
            ConsiderSkipWP();

            if (Me.IsDead)
            {
                ParriorRunning = false;
                return GCombatResult.Died;
            }

            Spam("  " + (int)(-LastKillTimer.TicksLeft / 1000) + "s since last kill");
            LastKillTimer.Reset();
            if (res == GCombatResult.SuccessWithAdd ||
               res == GCombatResult.Success)
                VictoryRushTimer.Reset();

            if (Context.CurrentMode == GGlideMode.OneKill)
            {
                List<GUnit> getAggro = FindUnitsAttackingParty(true);
                if (getAggro.Count > 0)
                {
                    GUnit Attacker = getAggro[0];
                    if (Attacker != null)
                    {
                        if (Me.Target != Attacker)
                        {
                            Attacker.SetAsTarget(false);
                        }
                        Me.Refresh(true);
                        Attacker = Me.Target;
                        if (Attacker != null)
                        {
                            Attacker.TouchHealthDrop();
                            StartCombat();
                            Context.Log("One-Kill. Kill another " + Attacker.Name);
                            res = KillTarget(Attacker, true);
                        }
                    }
                }

            }

            ParriorRunning = false;
            return res;
        }

        private bool CheckUseItem(ItemUse_e UseItem, GSpellTimer cd, GUnit Monster, string key, bool CloseAdds)
        {
            if (!cd.IsReady) return false;
            if (UseItem == ItemUse_e.NoUse) return false;
            // Check conditions
            if (UseItem == ItemUse_e.MyHealth50)
            {
                if (Me.Health > 0.50) return false;
            }
            else if (UseItem == ItemUse_e.MyHealth25)
            {
                if (Me.Health > 0.25) return false;
            }
            else if (UseItem == ItemUse_e.MobHealth75)
            {
                if (Monster.Health < 0.75) return false;
            }
            else if (UseItem == ItemUse_e.MobHealth50)
            {
                if (Monster.Health < 0.50) return false;
            }
            else if (UseItem == ItemUse_e.SaveForAdds)
            {
                if (!CloseAdds) return false;
            }
            else if (UseItem == ItemUse_e.Feared)
            {
                if (Feared.IsReady) return false;
            }
            if (IsKeyReady(key))
            {
                // Use it   
                cd.Reset();
                //SendKey(key);
                Context.Log("### USE ITEM " + key);
                CastSpell(key);
                //Thread.Sleep(300);
                return true;
            }
            return false;
        }



        private GCombatResult PvPCommonResult(GUnit Unit)
        {
            if (Me.IsDead) return GCombatResult.Died;
            if (Unit.IsDead) return GCombatResult.Success;
            if (Unit.DistanceToSelf > 50) return GCombatResult.Retry; // The slag ran off

            GPlayer p = GetClosestPvPPlayer();
            if (p != null && p.DistanceToSelf + 15 < Unit.DistanceToSelf) return GCombatResult.Retry;
            return GCombatResult.Unknown;
        }

        private bool ChangeToTarget(GUnit unit)
        {
            Face(unit);
            if (!unit.SetAsTarget(false))
            {
                Context.Log("  Can not target mob, run over there");
                // Run over thereo
                Approach(unit, false);
                if (!unit.SetAsTarget(false))
                {
                    Context.Log("  Aaaargh! Can't target new selected target");
                }
                else
                {
                    unit.TouchHealthDrop();
                    StartCombat();
                    KillTargetAggro(unit, false, false);
                    return true;
                }

            }
            else
            {
                unit.TouchHealthDrop();
                StartCombat();
                KillTargetAggro(unit, false, false);
                return true;
            }
            return false;
        }


        private void GetAggroFrom(GUnit unit, bool JustGetAggro)
        {
            if (unit.Target == Me) return;

            Context.Log("Get aggro from target " + unit.Name);
            Face(unit);
            if (!unit.SetAsTarget(false))
            {
                Context.Log("  Can not target mob, run over there");
                // Run over there you slag!
                Approach(unit, false);
                if (!unit.SetAsTarget(false))
                {
                    Context.Log("  Aaaargh! Can't target even after approach. Poor party memebers");
                }
                else
                {
                    unit.TouchHealthDrop();
                    StartCombat();
                    KillTargetAggro(unit, false, JustGetAggro);
                }

            }
            else
            {
                unit.TouchHealthDrop();
                StartCombat();
                KillTargetAggro(unit, false, JustGetAggro);
            }
        }

        private void GetAggroFrom(GUnit CurrentTarget, List<GUnit> units)
        {
            if (units == null) return;
            foreach (GUnit u in units)
            {
                if (u != CurrentTarget) GetAggroFrom(u, CurrentTarget != null);
            }
            if (CurrentTarget != null)
            {
                // Restore global state
                Target = CurrentTarget;
                if (Target.IsDead)
                {
                    Context.Log("  Original mob is dead!");

                }
                else
                {
                    Face(Target);
                    if (!Target.SetAsTarget(false))
                    {
                        Context.Log("  Can not target original mob!");
                    }
                }
            }
        }

        public override GCombatResult KillTarget(GUnit Target, bool IsAmbush)
        {
            return KillTargetAggro(Target, IsAmbush, false);
        }

        private GCombatResult KillTargetAggro(GUnit Target, bool IsAmbush, bool JustGetAggro)
        {
            ParriorRunning = true;
            int ApproachTimeout = 10000;
            MyCombatStartLocation = Me.Location;

            Dismount();
            this.Target = Target;
            CloseAdd = null;

            if (!Target.IsPlayer)
                MobTendencies.AddMob(Target.Name);

            /*
                        if(Target.IsPlayer && !Target.IsTargetingMe && PvPStyle == PvPStyle_e.Active)
                        {
                            Context.Log("I refuse to attack this player");
                            return GCombatResult.Bugged;
                        }
            */

            if (Target.Name == "Wild Sparrowhawk") return GCombatResult.Bugged;
            //if (Target.Name == "Stormpike Bowman") return GCombatResult.Bugged;
            CombatTimer.Reset();
            CombatStartHealth = Me.Health;

            sawAnEvade = false;
            IsRunning = false;
            evades = 0;
            HaveAdd = false;
            LandedSunders = 0;

            RendTimer.ForceReady();
            HeroicTimer.ForceReady();
            DemoTimer.ForceReady();
            ThunderTimer.ForceReady();
            HamstringTimer.ForceReady();
            SunderTimer.ForceReady(); // not sundered
            NoAggroTimer.Reset();

            GSpellTimer PullAway = new GSpellTimer(2000, true); // if we try to avoid adds,...
            GSpellTimer IgnoreBugged = new GSpellTimer(10 * 1000);
            GSpellTimer AggroTimer = null;
            int MoveToLineUpCounter = 0;

            PullAway.ForceReady(); // we are trying to move the mob.

            Context.Log("--- Kill '" + Target.Name + "' lvl " + Target.Level + " distance " + (int)Target.DistanceToSelf + (IsAmbush ? " Ambush" : "") + " ---");

            if (IsCrybaby(Target.Name))
                Context.Log("  this monster cries for help, we have to be extra careful");

            bool isUnmovable = IsUnmovable(Target.Name);


            if (Me.IsInCombat)
            {
                // hmm i am in combat
                IsAmbush = true;
            }

            GUnit Monster = (GUnit)Target;
            if (Target.IsMonster)
            {
                if (!IsAmbush)
                {

                    GCombatResult OpenerResult = DoParriorOpener((GMonster)Monster);
                    mover.Stop();

                    if (!Me.IsMeleeing)
                        CastSpell("Common.ToggleCombat", false, true);

                    if (OpenerResult != GCombatResult.Unknown)   // Well, opener did something, so we're done.
                    {
                        GUnit closer = FindCloserMonster(Target);
                        if (closer != null)
                        {
                            Context.Log("'" + closer.Name + "' (" + closer.DistanceToSelf + ") is closer than '" + Target.Name + "' (" + Target.DistanceToSelf + ")");
                            if (closer.DistanceToSelf > PullDistance)
                            {
                                Context.Log("  But it is too far away");
                                return EndCombat(GCombatResult.Retry, Target);
                            }
                            else
                            {
                                mover.Forwards(false);
                                Face(closer);
                                closer.SetAsTarget(false);
                                return EndCombat(GCombatResult.Retry, Target);
                            }
                        }
                        return EndCombat(OpenerResult, Target);
                    }
                }
            }
            else
            {
                if (Target.IsPlayer)
                {
                    if (PvPStyle == PvPStyle_e.Die)
                    {
                        Context.Log("Attacked by player or crazy glider trying to attack!");
                        Thread.Sleep(2000);
                        if (Me.Target != null)
                            Context.ClearTarget();

                        return EndCombat(GCombatResult.Bugged, Target);
                    }
                    else
                    {
                        Context.Log("Attack player!");
                        CastSpell("Common.ToggleCombat", false, true);
                        ApproachTimeout = 2000;
                        if (!Me.IsInCombat)
                        {
                            DoParriorPvPOpener((GPlayer)Target);
                        }
                    }
                }
            }

            IgnoreBugged.Reset();

            //StanceChangeTimer.ForceReady();
            StanceChangeTimer.SetTicksLeft(StanceChangeTimer.Duration - 3500);  // 3.5s initial stance change delay, 2 skills
            // Ok, combat is on, have at it:
            //GSpellTimer lt = new GSpellTimer(0);
            while (true)
            {
                UpdateMyPos();
                //Context.Log("loop time: " + -lt.TicksLeft);
                //lt.Reset();
                /////////////////////////////////////////////////////////////////
                // Check status, is there any reason to stop fighting?
                /////////////////////////////////////////////////////////////////

                if (Monster.IsPlayer
                    && (Monster.DistanceToSelf > 50 || MyCombatStartLocation.GetDistanceTo(Me.Location) > MaxDistanceFromStart)
                    && !JustGetAggro)
                {
                    Context.Log("Target ran off ");
                    return EndCombat(GCombatResult.Retry, Monster);
                }
                GUnit changetargetto = null;
                if (Monster.IsPlayer && !Monster.IsInMeleeRange && PvPStyle == PvPStyle_e.Active)
                {
                    GPlayer topwn = GetClosestPvPPlayer();
                    if (Monster != topwn)
                    {
                        Context.Log("another player is closer '" + topwn.Name + "'");
                        changetargetto = topwn;
                    }

                }
                if (!Monster.IsPlayer)
                {
                    GUnit closestAgressivePlayer = GetClosestPvPPlayerAttackingMe();
                    if (closestAgressivePlayer != null)
                    {
                        // someone is targetting me

                        if ((PvPStyle == PvPStyle_e.Active) || // some slag targetting me
                           (PvPStyle == PvPStyle_e.FightBack && IsPlayerFaction(Monster))) // ..while I attack a pet
                        {
                            Context.Log("Attcking a mob while some jackass is kicking my ass. Thats stupid");
                            changetargetto = closestAgressivePlayer;
                        }
                    }
                }

                if (changetargetto != null && changetargetto != Target)
                {
                    ChangeToTarget(changetargetto);
                }

                if (Monster.IsDead) return EndCombat(GCombatResult.Success, Target);
                if (Me.IsDead) return EndCombat(GCombatResult.Died, Target);
                if (Me.Target == null || Me.Target != Target)
                {
                    Context.Log("Lost my target"); // Hmm, this is usually because the mob is dead
                    return EndCombat(GCombatResult.Success, Target);
                }

                GCombatResult CommonResult;
                if (Monster.IsMonster)
                {
                    CommonResult = Context.CheckCommonCombatResult((GMonster)Monster, IsAmbush);
                    if(CommonResult != GCombatResult.Unknown)
                        Context.Log("Common said: " + CommonResult);
                }
                else
                    CommonResult = PvPCommonResult(Monster);

                if (CommonResult == GCombatResult.Bugged)
                {
                    if (IgnoreBugged.IsReady)
                        return EndCombat(CommonResult, Target);
                }
                else if (CommonResult != GCombatResult.Unknown)
                {
                    return EndCombat(CommonResult, Target);
                }

                if (evades > 10)
                {
                    // evaded 10 attacks, must be bugged
                    Context.Log("Evaded many times now. must be bugged");
                    return EndCombat(GCombatResult.Bugged, Target);
                }


                /////////////////////////////////////////////////////////////////
                // Tank specials, need to get aggro from something?
                if (BeTank)
                {
                    if (!JustGetAggro)
                    {
                        // See if anything is attacking my party
                        List<GUnit> getAggro = FindUnitsAttackingParty(false);
                        GetAggroFrom(Target, getAggro);
                    }
                    else
                    {
                        // My only goal is to get aggro
                        if (Target.IsTargetingMe && AggroTimer == null)
                        {
                            // Yay! I got aggro
                            Context.Log("I managed to get aggro. Now work it up a little");
                            AggroTimer = new GSpellTimer(TankSeconds * 1000);
                            AggroTimer.Reset();
                        }
                        if (AggroTimer != null && AggroTimer.IsReady)
                        {
                            Context.Log("Built some aggro, back to original mob");
                            return GCombatResult.Success;
                        }
                    }

                    // Track aggro of taret 
                    if (Target.Target == null || Target.IsTargetingMe)
                        NoAggroTimer.Reset();
                }

                /////////////////////////////////////////////////////////////////
                // Running
                /////////////////////////////////////////////////////////////////

                isUnmovable = IsUnmovable(Monster.Name);
                if (Monster.IsCasting) AddCaster(Target.Name);

                /////////////////////////////////////////////////////////////////
                // Run from adds
                if (RunFromAddsInCombat && !isUnmovable &&
                   !(ChaseStyle == ChaseStyle_e.Chase && IsRunning))
                {
                    bool crybaby = IsCrybaby(Monster.Name);
                    double avoidDistance = AvoidAddDistanceCombat + (crybaby ? 8 : 0);
                    GUnit add = KeepSafeSleep(Monster, 100, 1000, avoidDistance);
                    if (add != null)
                    {
                        PullAway.Reset();
                        Spam("avoided an add '" + add.Name + "' d " + (int)add.DistanceToSelf + " level " + add.Level);
                        GProfile profile = Context.Profile;
                        if (profile != null)
                            profile.PlaceBreadcrumb();
                        //GUnit addd = FindClosestPotentialAddSmart(Monster, avoidDistance);	    
                        //if(addd != null) continue; // we need to move more
                    }
                    else
                    {
                        if (StandingInAoE) // we are inside some AoE effect (posions cloud thunderstom etc)
                        {
                            Spam("avoid AoE effect");
                            StepOutOfAoE();
                            PullAway.Reset();
                        }
                    }
                }
                else
                {
                    Thread.Sleep(100);
                }

                if (Monster.IsDead) return EndCombat(GCombatResult.Success, Target);

                if (sawAnEvade)
                {
                    Context.Log("Saw an evade!!! Jump");
                    // this is no good
                    mover.MoveRandom();
                    mover.Jump();
                    Thread.Sleep(100);
                    mover.Stop();
                    sawAnEvade = false;
                }
                if (Monster.IsDead) return EndCombat(GCombatResult.Success, Target);


                /////////////////
                // Chase and Approach logic


                double Distance = Monster.DistanceToSelf;
                bool chased = false;
                if (IsRunning)
                {

                    if (ChaseStyle == ChaseStyle_e.Chase)
                    {
                        if (WantIntercept()) DoIntercept();
                        if (Approach(Monster, false, ApproachTimeout))
                            TweakMelee(Monster);
                        chased = true;
                    }
                    else if (ChaseStyle == ChaseStyle_e.ChaseSafe)
                    {
                        // Chase if it is safe
                        GUnit add = FindPotentialAdd(Monster);
                        if (add == null)
                        {
                            if (WantIntercept()) DoIntercept();
                            if (Approach(Monster, true, ApproachTimeout))
                                TweakMelee(Monster);
                            chased = true;
                            //continue;
                        }
                    }
                }
                else
                {
                    if (PullAway.IsReady)
                    {
                        if (WantIntercept()) DoIntercept();
                        if (Approach(Monster, false, ApproachTimeout))
                            TweakMelee(Monster);
                        else
                        {
                            // FUCK! I cant reach the monster
                        }
                        //continue;
                    }
                    mover.Forwards(false);
                    Face(Monster, 1000);
                }

                if (Monster.IsDead) return EndCombat(GCombatResult.Success, Target);


                /////////////////
                // Move to line up adds in front of me
                if (HaveCloseAdd && !NoLineupAdds && !Target.IsPlayer)
                {
                    //if(UseCleave == SkillCondition_e.CloseAdd || UseSweeping)
                    //{
                    // Check if I got an add behind me
                    if (CloseAdd != null && MoveToLineUpCounter < 3) // max 3 attempts
                    {
                        if (Target.IsTargetingMe && CloseAdd.IsTargetingMe)
                        {
                            // We know who it is
                            if (MoveToGetThemInFront(Target, CloseAdd))
                            {
                                PullAway.Reset();
                                MoveToLineUpCounter++;
                            }
                        }
                    }
                    //}
                }


                /////////////////////////////////////////////////////////////////
                // "Spell Casting", all key pressing to use skills are below
                /////////////////////////////////////////////////////////////////

                if (!Me.IsMeleeing)
                    CastSpell("Common.ToggleCombat", false, true);

                Rage = Me.Rage;
                bool GCD = !IsKeyReady("Parrior.Rend"); // Just to avoid a lot of bar flipping
                HaveCloseAdd = CheckAdditional(Monster);

                //if (HaveCloseAdd && !Target.IsTargetingMe && !IsRunner(Target.Name))
                //    return EndCombat(GCombatResult.Retry, Target);

                /////////////////
                // Stay alive moves

                // Last stand
                if (Me.Health < LastStandLife &&
                    UseLastStand &&
                    LastStandTimer.IsReady &&
                    IsKeyReady("Parrior.LastStand") && Monster.Health > .1)
                {
                    CastSpell("Parrior.LastStand", false, true);
                    LastStandTimer.Reset();
                }

                // Check panic health:
                if (Me.Health < PotionLife && IsKeyReady("Common.Potion") && Monster.Health > .1 && !Monster.IsPlayer)
                {
                    int NumOfPotion = Interface.GetActionInventory("Common.Potion");
                    Context.Log("Potion. Pots left = " + NumOfPotion);
                    CastSpell("Common.Potion");
                    // continue;  if we are out of potions try other panic moves
                }


                if (WantIntimidatingBandage()) if (DoIntimidatingBandage() || Monster.IsDead) continue;

                /////////////////
                // Change stance
                if (Me.Rage <= RageLeftOnStanceChange + MaxRageLoss)
                {
                    Stance_e WantedStance;

                    if (Monster.IsPlayer) WantedStance = PvPStance;
                    else if (HaveCloseAdd) WantedStance = AddStance;
                    else if (IsCaster(Monster.Name)) WantedStance = CasterStance;
                    else WantedStance = StanceInCombat;

                    if (Stance != WantedStance && StanceChangeTimer.IsReady)
                    {
                        ChangeToStance(WantedStance);
                    }
                }

                ////////
                // Handle runners

                if (!GCD && WantHamstring()  && Monster.DistanceToSelf < Context.MeleeDistance+1) 
                  if (DoHamstring()) continue;


                if (IsRunning && ShootRunners && !HaveAdd && !chased &&
                   Monster.DistanceToSelf > Context.RangedDistance &&
                   !Interface.IsKeyFiring("Parrior.Ranged"))
                {
                    // Shoot
                    Spam("Ranged");
                    CastSpell("Parrior.Ranged");
                    continue;
                }
                else
                {
                    if (PullAway.IsReady)
                    {
                        if (!IsRunning || ChaseStyle == ChaseStyle_e.Chase)
                            TweakMelee(Monster);
                    }
                }




                /////////////////
                // Usable items
                if (!CheckUseItem(UseItem1, UseItem1Timer, Monster, "Parrior.UseItem1", HaveCloseAdd))
                    if (!CheckUseItem(UseItem2, UseItem2Timer, Monster, "Parrior.UseItem2", HaveCloseAdd))
                        if (!CheckUseItem(UseItem3, UseItem3Timer, Monster, "Parrior.UseItem3", HaveCloseAdd))
                            CheckUseItem(UseItem4, UseItem4Timer, Monster, "Parrior.UseItem4", HaveCloseAdd);



                /*
                  Interface.IsKeyFiring  - The key is lightning up after skill is used. For things like Raptor strike and Heroic Strike
                  Interface.IsKeyReady   - Cooldown both global cooldown and skill specific cooldown.
                  Interface.IsKeyEnabled - Condition for the skills are met. Such as enough rage or mana
                */

                if (WantCleave()) DoCleave();
                //if (Interface.IsKeyFiring("Parrior.Cleave")) Rage -= (20 - FocusedRage);
                if (WantHeroicStrike()) DoHeroicStrike();
                if (WantTaunt()) DoTaunt();

                if (!GCD && (Monster.IsInMeleeRange))
                {
                    bool did = false;
                    GSpellTimer t = new GSpellTimer(0);


                    // Situationals first
                    if (!did && WantVictoryRush()) if (DoVictoryRush() || Monster.IsDead) did = true;
                    if (!did && WantShieldBash()) if (DoShieldBash() || Monster.IsDead) did = true;
                    if (!did && WantPummel()) if (DoPummel() || Monster.IsDead) did = true;
                    if (!did && WantWarStomp()) if (DoWarStomp() || Monster.IsDead) did = true;
                    if (!did && WantOverpower()) if (DoOverpower() || Monster.IsDead) did = true;
                    if (!did && WantRevenge()) if (DoRevenge() || Monster.IsDead) did = true;
                    if (!did && WantExecute()) if (DoExecute() || Monster.IsDead) did = true;

                    if (!did && WantDeathWish()) if (DoDeathWish() || Monster.IsDead) did = true;
                    if (!did && WantRampage()) if (DoRampage() || Monster.IsDead) did = true;

                    if (!did && WantBloodrage(false)) if (DoBloodrage() || Monster.IsDead) did = true;
                    if (!did && WantBerserkerRage()) if (DoBerserkerRage() || Monster.IsDead) did = true;
                    if (!did && WantDisarm()) if (DoDisarm() || Monster.IsDead) did = true;


                    // Add management is important
                    if (!did && WantSweeping()) if (DoSweeping() || Monster.IsDead) did = true;
                    if (!did && WantDemoShout()) if (DoDemoShout() || Monster.IsDead) did = true;
                    if (!did && WantThunderClap()) if (DoThunderClap() || Monster.IsDead) did = true;


                    if (!did && WantWhirlwind()) if (DoWhirlwind() || Monster.IsDead) did = true;

                    // Misc stuff
                    if (!did && WantBattleShout()) if (DoBattleShout() || Monster.IsDead) did = true;
                    if (!did && WantShieldBlock()) if (DoShieldBlock() || Monster.IsDead) did = true;
                    if (!did && WantConcussion()) if (DoConcussion() || Monster.IsDead) did = true;
                    if (!did && WantRend()) if (DoRend() || Monster.IsDead) did = true;
                    if (!did && WantSunder()) if (DoSunder() || Monster.IsDead) did = true;

                    // "Rage dumpers"
                    if (!did && WantBloodthirst()) if (DoBloodthirst() || Monster.IsDead) did = true;
                    if (!did && WantMortalStrike()) if (DoMortalStrike() || Monster.IsDead) did = true;
                    if (!did && WantShieldSlam()) if (DoShieldSlam() || Monster.IsDead) did = true;
                    if (!did && WantSlam()) if (DoSlam() || Monster.IsDead) did = true;
                    // if (!did && WantHeroicStrike()) if (DoHeroicStrike() || Monster.IsDead) did = true; // Not GCD dependant 

                    if (did)
                    {
                        //Context.Log("did something. it took : " + -t.TicksLeft);
                    }

                }
                else
                {
                    // dont do anything during GCD
                }



            }
        }

        #endregion



        #region Parrior combat helpers

        int SpamLastRage = 0;
        void Spam(string s)
        {
            if (SpamAlot)
            {
                Me.Refresh(true);
                if (s == "")
                {
                    if (SpamLastRage == Me.Rage)
                        return;
                }
                SpamLastRage = Me.Rage;

                double t = (double)(-CombatTimer.TicksLeft) / 1000.0;
                string prefix = String.Format("t {0,4:#0.0} {1,3:##0} ", t, Me.Rage);
                GUnit target = Me.Target;
                if (target != null)
                {
                    int mobHealth = (int)(target.Health * 100);
                    prefix += String.Format("{0,3:##0} ", mobHealth);

                    if (target.IsCasting)
                        prefix += "C ";
                }

                Context.Log(prefix + s);
            }
        }

        enum ApproachResult { CouldNotReach, AddPotential, CloserMonster, Died, InCombat, ReachedDistance, Tagged };

        private bool IsTagged(GUnit unit)
        {
            if (!unit.IsMonster) return false;
            GMonster monster = (GMonster)unit;
            if (Context.Party.Mode == GPartyMode.Follower) return false;
            return monster.IsTagged;
        }

        ApproachResult Approach(GUnit monster, double goalDistance, bool lurk, bool ignoreAdds, bool charge)
        {
            StuckDetecter sd = new StuckDetecter(this, 3, 5);

            GSpellTimer sneakTimeout = new GSpellTimer(SneakTime * 1000, false);
            GSpellTimer tickTime = new GSpellTimer(100, false);

            //bool ToCloseToCharge = false;
            GSpellTimer ChargeTimer = new GSpellTimer(200);
            ChargeTimer.ForceReady();

            EasyMover em = new EasyMover(this, new Location(monster.Location), false, true);
            GSpellTimer NewTargetUpdate = new GSpellTimer(2000);

            // Can only charge in battle stance
            if (Stance != Stance_e.Battle) charge = false;

            do
            {
                UpdateMyPos();
                // Check for stuck
                if (sd.checkStuck())
                {
                    Context.Log("Major stuck on approach. Giving up");
                    return ApproachResult.CouldNotReach;
                }

                double distance = monster.DistanceToSelf;

                if (Me.IsDead) { mover.Stop(); return ApproachResult.Died; }

                if (Me.IsInCombat)
                {
                    mover.Stop();
                    return ApproachResult.InCombat;
                }

                if (IsTagged(monster))
                {
                    // WTF!			
                    mover.Stop();
                    return ApproachResult.Tagged;
                }

                // Check if we reached distance
                if (distance < goalDistance && Math.Abs(monster.Bearing) < PI / 8)
                {
                    mover.Stop();
                    return ApproachResult.ReachedDistance;
                }

                // Check for adds
                GUnit PotentialAdd = FindPotentialAdd(monster);

                // Lurk if it is dangerouns
                if (lurk && PotentialAdd != null)
                {
                    mover.Stop();
                    // add, lurk a little
                    GSpellTimer timeout = new GSpellTimer(LurkTime * 1000, false);
                    Context.Log("Mob has add potential.('" + PotentialAdd.Name + "'). Lurk a bit");
                    while (HasAddPotential(monster) && !timeout.IsReady &&
                          !Me.IsInCombat && !Me.IsDead && !IsTagged(monster) && FindCloserMonster(monster) == null)
                    {
                        UpdateMyPos();
                        KeepSafeSleep(null, 300, 300, AvoidAddDistance);
                    }
                    PotentialAdd = FindPotentialAdd(monster);
                    if (PotentialAdd != null)
                        Context.Log("  Still mobs around");
                    else
                        Context.Log("  Looks safe now");
                }



                /*
                                // Bail out if closer
                                GUnit closer = FindCloserMonster(monster);
                                if (closer != null)
                                {
                                    mover.Stop();
                                    return ApproachResult.CloserMonster;
                                }
                */

                if (PotentialAdd != null && !ignoreAdds)
                {
                    mover.Stop();
                    return ApproachResult.AddPotential;
                }

                distance = monster.DistanceToSelf; // uodate
                //ToCloseToCharge = false;
                if (ChargeTimer.IsReady && charge && distance <= ChargeRange && distance >= 8)
                {
                    if (WaitForChargeCooldown && !IsKeyReady("Parrior.Charge"))
                    {
                        // cooldown
                        mover.Stop();
                        Spam("Wait for Charge cooldown");
                        while (!IsKeyReady("Parrior.Charge") && !Me.IsInCombat)
                            KeepSafeSleep(100);
                    }

                    if (IsKeyReady("Parrior.Charge"))
                    {
                        if (!IsKeyEnabled("Parrior.Charge"))
                        {
                            // can't charge for some odd reason
                            if (Me.Rage <= RageLeftOnStanceChange + MaxRageLoss)
                            {
                                BattleStance();
                                if (distance < 15)
                                {
                                    // ToCloseToCharge = true; // try to back up
                                }
                                else
                                {
                                    //Context.Log("hmm, cant charge. d: " + (int)distance);
                                }
                            }
                        }
                        else
                        {
                            if (WantBloodrage(true)) DoBloodrage();
                            Spam("Charge d " + (int)distance);
                            SendKey("Parrior.Charge");
                            mover.Stop();
                            ChargeTimer.Reset();
                        }
                    }
                }

                // Move
                //double b = BearingToMe(monster);
                distance = monster.DistanceToSelf;

                if (distance < 5)
                {
                    GLocation mloc = monster.Location;

                    bool moved = mover.moveTowardsFacing(Me, mloc, goalDistance, mloc);
                }
                else
                {
                    if (NewTargetUpdate.IsReady)
                    {
                        em.SetNewTarget(new Location(monster.Location));
                        NewTargetUpdate.Reset();
                    }
                    em.move();
                }

                tickTime.Wait();
                tickTime.Reset();
            }
            while (!sneakTimeout.IsReady);

            mover.Stop();
            return ApproachResult.CouldNotReach;
        }

        void SneakToASafeSpotForShoot(GMonster monster, double goalDistance)
        {
            GSpellTimer timeout = new GSpellTimer(4000, false);
            mover.Stop();

            mover.Backwards(true);
            while (monster.DistanceToSelf < goalDistance &&
                  !timeout.IsReadySlow &&
                  !Me.IsInCombat && !Me.IsDead &&
                  !IsTagged(monster) &&
                  FindCloserMonster(monster) == null)
            {
                UpdateMyPos();

                GUnit closest = FindClosestPotentialAdd(monster, 1E100, Me.Location);//GObjectList.GetNearestHostile(Me.Location, 0, true);
                if (closest == null) closest = monster;
                if (closest != monster && closest.DistanceToSelf < monster.DistanceToSelf)
                {
                    Context.Log("Backed into another mob '" + closest.Name + "'. stopping");
                    break;
                }
            }
            mover.Stop();

            Face(monster);
        }

      

        double DistanceToClosestMine()
        {
            GNode[] nodes = GObjectList.GetNodes();
            GNode closest = null;
            foreach (GNode node in nodes)
            {
                if (node.IsMineral)
                {
                    if (closest == null || node.DistanceToSelf < closest.DistanceToSelf)
                        closest = node;
                }
            }
            if (closest == null) return 1E100;
            return closest.DistanceToSelf;
        }

        double DistanceToClosestMonsterFrom(GUnit target)
        {
            GUnit[] Monsters = GObjectList.GetMonsters();
            double minDist = 1E100; // Far far away

            foreach (GMonster Add in Monsters)
            {
                double d = Add.GetDistanceTo(target);
                if (Add != target &&
                   !Add.IsDead &&
                   d < minDist)
                {
                    minDist = d;
                }
            }
            return minDist;
        }

        void CheckForDragalong(GMonster monster, double minDistance)
        {
            if (DistanceToClosestHostileFrom(monster) < minDistance)
                Context.Log("Might pull an extra mob... :(");
        }


        GCombatResult DoParriorOpener(GMonster Monster)
        {

            bool openRanged = true;
            bool safeApproachFailed = false;

            if (PullStyle != PullStyle_e.Ranged)
            {
                openRanged = false;

                bool lurk = true;
                bool ignoreAdds = false;
                bool charge = PullStyle == PullStyle_e.Charge;
                if (Me.Rage <= RageLeftOnStanceChange + MaxRageLoss)
                    if (charge)
                        BattleStance();
                ApproachResult r = Approach(Monster, Context.MeleeDistance, lurk, ignoreAdds, charge);
                //Spam("Approach done. " + r);
                if (r == ApproachResult.CouldNotReach)
                {
                    Context.Log("Never able to approach");
                    if (IsRanged(Monster.Name) || IsUnmovable(Monster.Name)) return GCombatResult.Bugged;
                    openRanged = true; // try too shoot
                    safeApproachFailed = true;
                }
                else if (r == ApproachResult.AddPotential)
                {
                    GUnit add = FindPotentialAdd(Monster);
                    if (add != null)
                    {
                        Context.Log("Target has potential add '" + add.Name + "'");
                        if (PullRangedAvoidAdds)
                            openRanged = true;
                        safeApproachFailed = true;
                    }
                }
                else if (r == ApproachResult.CloserMonster) return GCombatResult.Retry;
                else if (r == ApproachResult.Died) return GCombatResult.Died;
                else if (r == ApproachResult.Tagged) return GCombatResult.OtherPlayerTag;
                else if (r == ApproachResult.InCombat || r == ApproachResult.ReachedDistance)
                {
                    GUnit Attacker = GObjectList.GetNearestAttacker(0);
                    if (Attacker != null && Attacker != Monster) // Got attacked by another mob!
                    {
                        Context.Log("Got attacked by another mob(" + Attacker.Name + ") before engaging the target(" + Monster.Name + ")");
                        return GCombatResult.Retry;
                    }

                    // This is normal
                    if (!Me.IsMeleeing)
                        CastSpell("Common.ToggleCombat", false, true);
                    return GCombatResult.Unknown;
                }
            }

            if ((!openRanged && safeApproachFailed) ||
                (openRanged && IsUnmovable(Monster.Name)))
            {
                // suicidal approach...
                if (openRanged)
                    Context.Log("Wanted to open ranged. But mob is ranged");
                Context.Log("Crazy approach");
                ApproachResult r = Approach(Monster, Context.MeleeDistance, false, true, true);
                if (r == ApproachResult.CouldNotReach)
                {
                    Context.Log("Never able to approach");
                    return GCombatResult.Bugged; // can not reach this one, give up
                }
                else if (r == ApproachResult.Tagged) return GCombatResult.OtherPlayerTag;
                else if (r == ApproachResult.CloserMonster) return GCombatResult.Retry;
                else if (r == ApproachResult.Died) return GCombatResult.Died;
                else if (r == ApproachResult.InCombat || r == ApproachResult.ReachedDistance)
                {
                    GUnit Attacker = GObjectList.GetNearestAttacker(0);
                    if (Attacker != null && Attacker != Monster) // Got attacked by another mob!
                    {
                        Context.Log("Got attacked by another mob(" + Attacker.Name + ") before engaging the target(" + Monster.Name + ")");
                        return GCombatResult.Retry;
                    }

                    // GOGO
                    CastSpell("Common.ToggleCombat", false, true);
                    return GCombatResult.Unknown;
                }
                openRanged = false;
            }

            if (openRanged)
            {
                mover.Stop();

                if (Monster.DistanceToSelf <= Context.RangedDistance)
                {
                    Face(Monster);
                    Context.Log("Open ranged but mob too close, backing a bit");
                    SneakToASafeSpotForShoot(Monster, Context.RangedDistance + 4);
                    if (!Me.IsInCombat && FindCloserMonster(Monster) != null) return GCombatResult.Retry;
                }

                CheckForDragalong(Monster, 15);

                if (!Me.IsInCombat && FindCloserMonster(Monster) != null) return GCombatResult.Retry;

                if (Monster.DistanceToSelf > 8.0)
                {
                    if (Monster.DistanceToSelf > 30.0)
                    {
                        // TODO:This might be us that wandered away...
                        Spam("  Wandered out of range during pull, will try again later");
                        return GCombatResult.Retry;
                    }
                    Context.Log("Open with ranged. Distance to mob: " + (int)Monster.DistanceToSelf);
                    mover.Stop();
                    Face(Monster);
                    CastSpell("Parrior.Ranged");

                    if (!WaitForEngage(Monster))
                    {
                        Spam("  Range pull failed for some reason Red: \"" + Context.RedMessage + "\"");
                        openRanged = false;
                        if (Monster.DistanceToSelf > 30)  // Wandered out, no biggie.
                        {
                            Spam("  Wandered out of range during pull, will try again later");
                            return GCombatResult.Retry;
                        }

                    }
                    CastSpell("Common.ToggleCombat", false, true);

                }
                else
                {
                    Spam("Wanted to open ranged but is too close to me");
                    openRanged = false;
                }
            }

            if (!WaitForEngage(Monster))
            {
                if (Monster.DistanceToSelf > PullDistance)  // Wandered out, no biggie.
                {
                    Context.Log("Wandered out of range during pull, will try again later");
                    return GCombatResult.Retry;
                }
                if (IsRanged(Monster.Name) || IsUnmovable(Monster.Name))
                {
                    // He must have shot back!
                    return GCombatResult.Unknown; // run up and kill it
                }

                Context.Log("Couldn't engage combat with monster, bugged!");
                return GCombatResult.Bugged;
            }

            if (openRanged)
            {
                // Wait for mob to approach me, or until it damages me, or its casting
                double mh = Me.Health;
                GSpellTimer WaitTime = new GSpellTimer(10 * 1000, false);

                Context.Log("Waiting for mob to approach me");
                while (!Monster.IsInMeleeRange &&
                      !Monster.IsDead &&
                      Me.Health == mh &&
                      !Monster.IsCasting &&
                      !WaitTime.IsReady)
                {
                    KeepSafeSleep(Monster, 300, 300);
                    Face(Monster);
                }
            }

            return GCombatResult.Unknown;  // Good to go.
        }

        void DoParriorPvPOpener(GPlayer Player)
        {
            if (Me.Rage <= RageLeftOnStanceChange + MaxRageLoss)
                BattleStance();
            StuckDetecter sd = new StuckDetecter(this, 3, 1);
            while (true)
            {
                UpdateMyPos();
                if (Me.Target == null) return;  // lost target


                if ((Player.DistanceToSelf > 30 || MyCombatStartLocation.GetDistanceTo(Me.Location) > MaxDistanceFromStart))
                    return; // Ran off

                if (sd.checkStuck())
                {
                    Context.Log("Major stuck on approach. Giving up");
                    return;
                }

                if (Player.DistanceToSelf < 8) return; //can not charge
                if (Me.IsInCombat) return;
                if (Me.IsDead) return;

                Face(Player);
                mover.Forwards(true);

                if (IsKeyEnabled("Parrior.Charge"))
                {
                    Spam("Charge");
                    SendKey("Parrior.Charge");
                }
                Thread.Sleep(100);
            }
        }


        bool WaitForEngage(GMonster Monster)
        {
            GSpellTimer Futile = new GSpellTimer(6000, false);

            while (!Futile.IsReadySlow)
            {
                if (Monster.IsMine || IsTagged(Monster) || Monster.TargetGUID == Me.GUID || Me.ComboPoints > 0)
                    return true;

                if (Monster != null)
                {
                    GUnit unit = GObjectList.GetNearestAttacker(Monster.GUID);
                    if (unit != null && unit != Monster)
                    {
                        Context.Log("got attacked by a different mob! " + unit.Name);
                        return false;
                    }
                    if (IsRanged(Monster.Name) || IsUnmovable(Monster.Name))
                    {
                        // What are we doing waiting for him to get here!!!
                        return false;
                    }
                }
            }
            return false;
        }


        

        public bool CheckAdditional(GUnit Target)
        {
            List<GUnit> adds = FindUnitsAttackingParty(true);

            GUnit Extra = null;
            if (adds != null)
            {
                foreach (GUnit Add in adds)
                {
                    if (Add != Target &&
                       (Extra == null || Add.DistanceToSelf < Extra.DistanceToSelf))
                    {
                        Extra = Add;
                    }
                }
            }
            //GUnit Extra = GObjectList.GetNearestAttacker(Target.GUID);

            if (Extra == null)   // No extra.
            {
                return false;
            }
            HaveAdd = true;
            long add = Extra.GUID;
            if (AddedGUID != add)
                Context.Log("*** New add '" + Extra.Name + "'");
            AddedGUID = add;

            if (Extra.DistanceToSelf < Context.MeleeDistance + 2)
            {
                if (CloseAdd == null)
                    Context.Log("*** New close add '" + Extra.Name + "' d: " + Extra.DistanceToSelf);

                CloseAdd = Extra;
                return true;
            }

            return false;
        }


        public override void Disengage(GUnit Target)
        {
            base.Disengage(Target);
            CastSpell("Parrior.IAmNoCoward");
        }


        bool WaitForGCD(string name, int time)
        {
            //name = "Common.CooldownProbe"; 
            GSpellTimer timeout = new GSpellTimer(time, false);
            while (!Interface.IsKeyReady(name) && !timeout.IsReadySlow) ;
            return Interface.IsKeyReady(name);
        }

        bool CastSpellAndWaitForRage(string name)
        {
            return CastSpellAndWaitForRage(name, 1500);
        }

        bool WaitForRageLoss(int time)
        {
            if (keymasher) return true;
            GSpellTimer timeout = new GSpellTimer(time, false);
            int OldRage = Me.Rage;
            do
            {
                int e = Me.Rage;

                if (e > OldRage)
                {
                    //Spam("reset rage old : " + OldRage + " new " + e);
                    OldRage = e; // Got some rage
                }
                if (e != OldRage)
                {
                    //if((timeout.Duration - timeout.TicksLeft) > 1000)
                    //Spam("  waited " + (timeout.Duration - timeout.TicksLeft) + " old : " + OldRage + " new " + e);
                    return true;
                }
            }
            while (!timeout.IsReadySlow);
            //Spam("  wait for rage loss timed out '"+Context.RedMessage+"'");
            return false;
        }

        bool CastSpellAndWaitForRage(string name, int time)
        {
            //CastSpell(name, true, true);
            if (!WaitForGCD(name, 1500)) return false;


            SendKey(name);
            return WaitForRageLoss(time);
        }


        bool CastSpell(string name)
        {
            //Context.Log("Spell: " + name);	    
            return Context.CastSpell(name);
        }

        bool CastSpell(String KeyName, Boolean WaitGCD, Boolean FastReturn)
        {
            //Context.Log("Spell: " + s);	    
            return Context.CastSpell(KeyName, WaitGCD, FastReturn);
        }


        void SendKey(string name)
        {
            //Context.Log("Send: " + name);
            Context.SendKey(name);
        }

        void PressKey(string name)
        {
            //Context.Log("Press : " + name);
            Context.PressKey(name);
        }

        void ReleaseKey(string name)
        {
            //Context.Log("Release: " + name);
            Context.ReleaseKey(name);
        }

        #endregion

        #region Keep safe


        /*
          GUID=f0013c1800010c68,BaseAddr=1b0e9b70,Type=Monster,Name="OLDWorld Trigger (DO NOT DELETE)", Culled=False
        */



        GUnit FindCloserMonster(GUnit monster)
        {
            GUnit hostile = FindClosestPotentialAdd(monster, 1E100, monster.Location);
            //GUnit hostile = GObjectList.GetNearestHostile();
            if (hostile != null && hostile != monster)
            {
                double old_d = monster.DistanceToSelf;
                double new_d = hostile.DistanceToSelf;
                if (new_d + 4 < old_d) return hostile; // 4 is some marging to avoid target-swapping
            }
            return null;
        }

        // Used by whirlwind check
        int NumberOfCloseAttackables(double distance)
        {
            int no = 0;
            GUnit[] adds = GObjectList.GetMonsters();
            foreach (GUnit Add in adds)
            {
                if (Add.IsMonster)
                {
                    if (Add.DistanceToSelf <= distance &&
                       !Add.IsDead &&
                        Add.Reaction != GReaction.Friendly &&
                        !IsStupidItem(Add))
                    {
                        no++;
                    }
                }
            }
            GPlayer[] plys = GObjectList.GetPlayers();

            foreach (GPlayer p in plys)
            {
                if (!p.IsSameFaction)
                {
                    if (p.DistanceToSelf <= distance)
                        no++;
                }
            }
            return no;
        }

        bool IsAnyNeutralNonaggoredClose(double distance)
        {
            GUnit[] adds = GObjectList.GetMonsters();
            if (adds.Length == 0) return false;

            foreach (GUnit Add in adds)
            {
                if (Add.IsMonster)
                {
                    GMonster gm = (GMonster)Add;
                    if (gm.DistanceToSelf <= distance &&
                       !gm.IsDead &&
                       gm.Level > 1 &&
                       !gm.IsInCombat &&
                       gm.Reaction != GReaction.Friendly &&
                       !IsStupidItem(gm))
                    {
                        //Context.Log(gm.Name + " will aggro if we AoE ("+gm.DistanceToSelf+" < "+distance+")");
                        return true; // this one will aggro if we AoE
                    }
                }
            }
            return false;
        }

        GUnit FindPotentialAdd(GUnit target)
        {
            GUnit h = FindClosestPotentialAdd(target, AvoidAddDistance, target.Location);
            return h;
        }

        bool HasAddPotential(GUnit target)
        {
            return FindPotentialAdd(target) != null;
        }


        GUnit FindClosestPotentialAddSmart(GUnit target, double distance)
        {
            GUnit closestAdd = FindClosestPotentialAdd(target, distance, Me.Location);
            return closestAdd;
        }

        GUnit FindClosestPotentialAdd(GUnit target, double distance, GLocation here)
        {
            GUnit[] adds = GObjectList.GetMonsters();
            if (adds.Length == 0) return null;

            GUnit closestgm = null;

            foreach (GUnit Add in adds)
            {
                if (Add.IsMonster)
                {
                    GMonster gm = (GMonster)Add;
                    GLocation loc = PredictedLocation(gm);
                    if (gm != target &&
                        loc.GetDistanceTo(here) < distance &&
                        !gm.IsDead &&
                        !gm.IsTargetingMe && !IsTargetingParty(gm) &&
                        gm.Level > (Me.Level - 20) &&
                        gm.Level > 1 &&
                        gm.Reaction == GReaction.Hostile &&
                        !gm.IsTagged &&
                        Math.Abs(gm.Location.Z - target.Location.Z) < ZMax &&
                        !IsStupidItem(gm))
                    {
                        if (closestgm == null || loc.GetDistanceTo(here) < closestgm.GetDistanceTo(here))
                        {
                            closestgm = gm;
                        }
                    }
                }
            }
            return closestgm;
        }

        /*
          1 - location is front
          2 - location is right
          3 - location is back
          4 - location is left
        */
        int GetLocationDirection(GLocation loc)
        {
            int dir = 0;
            double b = loc.Bearing;
            if (b > -PI / 4 && b <= PI / 4)  // Front
            {
                dir = 1;
            }
            if (b > -3 * PI / 4 && b <= -PI / 4) // Left
            {
                dir = 4;
            }
            if (b <= -3 * PI / 4 || b > 3 * PI / 4) //  Back   
            {
                dir = 3;
            }
            if (b > PI / 4 && b <= 3 * PI / 4) //  Right  
            {
                dir = 2;
            }
            if (dir == 0)
                Context.Log("Odd, no known direction");

            return dir;
        }

        bool IsInParty()
        {
            long[] party = Context.Party.GetPartyMembers();
            if (party.Length == 0) return false;
            return true;
        }

        bool IsTargetingParty(GUnit unit)
        {
            long[] party = Context.Party.GetPartyMembers();
            if (party.Length == 0) return false;
            foreach (long player in party)
            {
                if (unit.TargetGUID == player) return true;
            }
            return false;
        }

        List<GUnit> FindUnitsAttackingParty(bool includeSelf)
        {
            long[] party = Context.Party.GetPartyMembers();
            GUnit[] adds = GObjectList.GetMonsters();

            List<GUnit> mobs = new List<GUnit>();
            foreach (GUnit Add in adds)
            {
                if (Add.IsMonster)
                {
                    bool targetting = false;
                    foreach (long player in party)
                    {
                        if (Add.TargetGUID == player) targetting = true;
                    }
                    if (includeSelf && Add.IsTargetingMe)
                        targetting = true;
                    if (targetting)
                    {
                        //Context.Log("Targeting party: " + Add);
                        mobs.Add(Add);
                    }
                }
            }
            //if(mobs.Size == 0) mobs = null;
            return mobs;
        }


        /*
          returns 
          0 - no add
          1 - potential add front
          2 - potential add right
          3 - potential add back
          4 - potential add left
        */
        int AddDirection(GUnit closestAdd, double distance)
        {
            if (closestAdd == null) return 0;

            double b = closestAdd.Bearing;

            //  Front  b > -PI/4  && b < PI/4 
            //  Left   b > -3PI/4 && b < -PI/4
            //  Back   b < -3PI/4 || b > 3PI/4
            //  Right  b > PI/4   && b < 3PI/4

            string[] dirName = { "-", "in front of me", "right of me", "behind me", "left of me" };

            int dir = 0;

            if (true) //closestAdd.DistanceToSelf < distance)
            {

                dir = GetLocationDirection(closestAdd.Location);
                if (dir == 0)
                    Context.Log("Odd, no known direction");
                //Context.Log("    '" + closestAdd.Name + "' is " + dirName[dir] + " distance " + (int)closestAdd.DistanceToSelf);
            }

            return dir;
        }

        GUnit KeepSafeSleep(int time)
        {
            return KeepSafeSleep(null, time, time);
        }

        GUnit KeepSafeSleep(int safeTime, int unsafeTime)
        {
            return KeepSafeSleep(null, safeTime, unsafeTime);
        }

        GUnit KeepSafeSleep(GUnit ignore, int safeTime, int unsafeTime)
        {
            return KeepSafeSleep(ignore, safeTime, unsafeTime, AvoidAddDistance);
        }
        GUnit KeepSafeSleep(GUnit ignore, int safeTime, int unsafeTime, double distance)
        {

            // TODO: This one should make a more clever choise on where to run

            //GUnit unit = GObjectList.GetNearestAttacker(ignore.GUID);
            //if(unit == null)
            GUnit add = FindClosestPotentialAddSmart(ignore==null?Me:ignore, distance);
            if (add != null)
            {
                if (ignore == null) ignore = add;
                GSpellTimer t = new GSpellTimer(unsafeTime);
                while (!t.IsReady)
                {
                    double heading = Me.Location.GetHeadingTo(add.Location);
                    heading += Math.PI; if (heading > PI * 2) heading -= 2 * PI;
                    GLocation dst = InFrontOf(Me.Location, heading, 50.0);
                    bool moved = mover.moveTowardsFacing(Me, dst, 0, ignore.Location);

                    Thread.Sleep(50);
                    /*
                                int dir = 0;
                                        dir = AddDirection(add, distance);
                    
                                        if (dir != 0)
                                        {
                                        if (dir == 1) mover.Backwards(true);
                                        if (dir == 2) mover.StrafeLeft(true);
                                        if (dir == 3) mover.Forwards(true);
                                        if (dir == 4) mover.StrafeRight(true);
                                        Thread.Sleep(unsafeTime);
                                        if (dir == 1) mover.Backwards(false);
                                        if (dir == 2) mover.StrafeLeft(false);
                                        if (dir == 3) mover.Forwards(false);
                                        if (dir == 4) mover.StrafeRight(false);
                    */
                }
                mover.Stop();
            }
            else
                Thread.Sleep(safeTime);

            return add;
        }

        #endregion


        #region Dont stand/run  in campfires


        void avoidRunInto(GLocation loc)
        {
            // something damgerous is close
            // where is it
            double heading = Me.Location.GetHeadingTo(loc);
            double bearing = Me.Heading - heading;
            if (bearing > PI) bearing -= 2 * PI;
            if (bearing < -PI) bearing += 2 * PI;
            if (bearing <= 0 && bearing > -PI / 2)
            {  // left of me
                mover.StrafeRight(true);
            }
            if (bearing > 0 && bearing < PI / 2)
            {  // right of me
                mover.StrafeLeft(true);
            }
            // lets hope some other move-code stops our strafing!	    
        }


        private GNode LastAvoidedNode = null;
        void avoidRunIntoCampfires()
        {
            GNode[] nodes = GObjectList.GetNodes();
            GNode fireNode = null;
            foreach (GNode node in nodes)
            {
                if (node.DistanceToSelf < 5 && IsBurner(node.Name))
                {
                    fireNode = node;
                }
            }
            if (fireNode != null)
            {
                GLocation loc = fireNode.Location;
                avoidRunInto(loc);
                if (LastAvoidedNode == null || LastAvoidedNode != fireNode)
                    Context.Log("Avoid run into fire " + fireNode.Name);
                LastAvoidedNode = fireNode;
            }
        }

        int lastRandomJump;
        bool chooseNewRandom = true;
        void RandomJump()
        {
            if (chooseNewRandom)
            {
                lastRandomJump = random.Next(2);
            }
            chooseNewRandom = !chooseNewRandom; // jump same direction twice
            switch (lastRandomJump)
            {
                case 0:
                    mover.StrafeRight(true);
                    mover.Jump();
                    Thread.Sleep(100);
                    mover.StrafeRight(false);
                    break;
                case 1:
                    mover.StrafeLeft(true);
                    mover.Jump();
                    Thread.Sleep(100);
                    mover.StrafeLeft(false);
                    break;
            }
        }

        void StepOutOfAoE()
        {
            if (NoJumpFromAoE)
            {
                StandingInAoE = false; // Clear
                return;
            }
            RandomJump();
            StandingInAoE = false; // Clear
        }

        void StepOutOfFire()
        {
            bool found = false;
            GNode[] nodes = GObjectList.GetNodes();
            GNode fireNode = null;
            foreach (GNode node in nodes)
            {
                if (node.DistanceToSelf < 8 && node.Name.Contains("fire"))
                {
                    fireNode = node;
                    found = true;
                }
            }
            if (found)
            {
                Context.Log("Ouch! I stepped in '" + fireNode.Name + "'");
                AddBurner(fireNode.Name);

                RandomJump();
            }

        }

        #endregion

        // A DOT on me   20:14 You suffer 16 Nature damage from Highperch Wyvern's Poison.
        // Throw on me   19:37 Vilebranch Axe Thrower's Throw hits you for 85.
        // Campfire      16:38 You suffer 13 points of fire damage.
        // Poison        23:36 Cursed Ooze is afflicted by Deadly Poison IV (2).
        //               15:35 Northspring Slayer is afflicted by Crippling Poison.
        // 

        //Combat Log watcher


        void Context_CombatLog(string RawTextOriginal)
        {
            if (ParriorRunning == false) return;
            if (RawTextOriginal == null) return;

            /*if (Context.CurrentMode != GGlideMode.Glide && 
              Context.CurrentMode != GGlideMode.OneKill) return;*/

            GUnit Target = Me.Target;
            //Context.Log(" CB: " + RawTextOriginal);
            string RawText = RawTextOriginal.ToLower();

            if (RawText.Contains("you are drowning"))
            {
                // !!!!!!  This is bad !!!!!
                Context.Log("I AM DROWNING!!!!");
                mover.SwimUp(true);
                Thread.Sleep(1000);
                mover.SwimUp(false);

            }
            if (RawText.Contains("you are afflicted") || RawText.Contains("you suffer"))
            {
                if (RawText.Contains("spore cloud") || RawText.Contains("chemical flames") || RawText.Contains("flames wave"))
                {
                    StandingInAoE = true; // Someone should move us!!
                }
            }

            if (RawText.Contains("you suffer"))
            {
                if (!RawText.Contains("from") && RawText.Contains("fire"))
                {
                    // hmm, stading in a fire?!
                    StepOutOfFire();
                }

            }
            else if (RawText.Contains("evade"))
            {
                if (!RawText.Contains("was evaded.")) // hmmm, I evade stuff sometimes
                {
                    sawAnEvade = true;
                    evades++;
                    Context.Log("Evade #" + evades);
                }
            }
            else if (RawText.Contains("hits you") ||
                    RawText.Contains("crits you"))
            {

                int i = RawTextOriginal.IndexOf("\'s");
                if (i != -1)
                {
                    string MonsterName = RawTextOriginal.Substring(0, i);

                    if (RawText.Contains("throw") ||
                       RawText.Contains("shoot"))
                    {
                        // Ranged mob...
                        AddRanged(MonsterName);
                    }
                    if (Target != null && Target.Name == MonsterName)
                    {
                        // my target
                        if (Target.DistanceToSelf > Context.MeleeDistance + 2)
                        {
                            Spam(Target.Name + " hit me from distance " + Target.DistanceToSelf);
                            //if(IsCaster(Me.Target.Name))
                            if (IsCaster(Target.Name) ||
                               IsRanged(Target.Name))
                                AddUnmovable(Target.Name);
                        }
                    }
                }
            }

            // is afflicted by XXX
            if (RawText.Contains("is afflicted by sunder armor"))
            {
                LandedSunders++;
                Spam("  Sunders " + LandedSunders + "/" + SunderStack);
                SunderTimer.Reset();
            }
            else if (RawText.Contains("is afflicted by hamstring"))
            {
                HamstringTimer.Reset();
            }
            else if (RawText.Contains("is afflicted by thunder clap"))
            {
                ThunderTimer.Reset();
            }
            else if (RawText.Contains("is afflicted by rend"))
            {
                RendTimer.Reset();
            }
            else if (RawText.Contains("is afflicted by demoralizing shout"))
            {
                DemoTimer.Reset();
            }
            else if (RawText.Contains("your rend failed") && RawText.Contains("is immune"))
            {
                AddRendImmune(Me.Target.Name);
            }


            if (RawText.Contains("you are afflicted by") &&
                (RawText.Contains("terror") ||
                 RawText.Contains("fear") ||
                 RawText.Contains("terrify") ||
                 RawText.Contains("psychic scream") ||
                 RawText.Contains("shriek") ||
                 RawText.Contains("charm") ||
                 RawText.Contains("sleep") ||
                 RawText.Contains("charm") ||
                 RawText.Contains("sleep") ||
                 RawText.Contains("seduce") ||
                 RawText.Contains("slumber")))
            {
                Spam("Got feared/charmed/sleeped.");
                Feared.Reset();
            }
            if (RawText.Contains("fades from you"))
            {
                if (RawText.Contains("terror") ||
                    RawText.Contains("fear") ||
                    RawText.Contains("terrify") ||
                    RawText.Contains("psychic scream") ||
                    RawText.Contains("shriek"))
                {
                    Spam("Fear Ran out.");
                    Feared.ForceReady();
                }
            }
            if (RawText.Contains("your") &&
               (RawText.Contains("heroic strike") ||
                RawText.Contains("thunder clap") ||
                RawText.Contains("overpower") ||
                RawText.Contains("slam") ||
                RawText.Contains("rend") ||
                RawText.Contains("victory rush") ||
                RawText.Contains("bloodthirst") ||
                RawText.Contains("execute") ||
                RawText.Contains("cleave") ||
                RawText.Contains("whirlwind") ||
                RawText.Contains("mortal strike") ||
                RawText.Contains("shield bash") ||
                RawText.Contains("shield slam") ||
                RawText.Contains("intercept") ||
                RawText.Contains("revenge") ||
                RawText.Contains("sweeping strikes") ||
                RawText.Contains("pummel") ||
                RawText.Contains("taunt") ||
                RawText.Contains("hamstring")
                ))
            {
                if (!RawText.Contains("suffers") && !RawText.Contains("heals"))
                    Spam("  " + RawTextOriginal);
            }

            if (RawText.Contains("afflicted by") &&
               (RawText.Contains("charge stun") ||
                RawText.Contains("demoralizing shout") ||
                RawText.Contains("thunder clap") ||
                RawText.Contains("war stomp") ||
                RawText.Contains("concussion blow") ||
                RawText.Contains("revenge stun") ||
                RawText.Contains("hamstring") ||
                RawText.Contains("taunt") ||
                RawText.Contains("rend")
                ))
            {
                Spam("  " + RawTextOriginal);
            }

            if (RawText.Contains("you gain"))
            {
                if (RawText.Contains("battle shout") ||
                    RawText.Contains("bloodrage") ||
                    RawText.Contains("berserker rage"))
                {
                    if (!RawText.Contains("rage from"))
                        Spam("  " + RawTextOriginal);
                }
                else if (RawText.Contains("stance"))
                {
                    if (RawText.Contains("battle stance"))
                        Stance = Stance_e.Battle;
                    if (RawText.Contains("defensive stance"))
                        Stance = Stance_e.Defensive;
                    if (RawText.Contains("berserker stance"))
                        Stance = Stance_e.Berserker;
                    Spam("  " + RawTextOriginal);
                    //Context.Log("Changed stance to " + Stance);
                }
                /*else if(RawText.Contains("experience"))
                  {
                  Spam("  "+ RawTextOriginal);
                  }*/
            }

            // 13:45 You attack. Felmusk Shadowstalker dodges.
            // 13:45 You attack. Felmusk Shadowstalker parries.
            // 13:53 You hit Felmusk Satyr for 51. (13 blocked)
            // 13:54 You crit Felmusk Felsworn for 125.
            // 13:55 You miss Felmusk Shadowstalker.

            if (RawText.Contains("you attack.") ||
               RawText.Contains("you hit ") ||
               RawText.Contains("you crit ") ||
               RawText.Contains("you miss ") ||
               RawText.Contains("your cleave ") ||
               RawText.Contains("your heroic strike "))
            {
                int t = -AttackTimer.TicksLeft;
                //if(t < 5000)
                //Context.Log("attack timer " + t + " '" + RawTextOriginal + "'");
                AttackTimer.Reset();
            }


        }

        void Context_ChatLog(string RawText, string ParsedText)
        {
            if (!ParriorRunning) return;
            //if (Context.CurrentMode != GGlideMode.Glide && Context.CurrentMode != GGlideMode.OneKill) return;

            if (ParsedText.Contains("attempts to run away") ||
               ParsedText.Contains("senses danger and flees"))
            {
                int i = ParsedText.IndexOf(" attempts");
                if (i != -1)
                {
                    string MonsterName = ParsedText.Substring(0, i);
                    AddRunner(MonsterName);
                    Context.Log(MonsterName + " attempts to run away");
                    IsRunning = true;
                }
            }
            else if (ParsedText.Contains("calls for help") ||
                    ParsedText.Contains("lets out a shriek, calling for help"))
            {
                int i = ParsedText.IndexOf(" calls");
                if (i == -1) i = ParsedText.IndexOf(" lets out");
                if (i != -1)
                {
                    string MonsterName = ParsedText.Substring(0, i);
                    AddCrybaby(MonsterName);
                    Context.Log(MonsterName + " calls for help");
                }
            }
        }

        #region Mob tendencies

        bool IsRanged(string Name) { return MobTendencies.MobHasTendency(Name, "ranged"); }
        void AddRanged(string Name) { MobTendencies.AddTendency(Name, "ranged"); }

        bool IsCaster(string Name) { return MobTendencies.MobHasTendency(Name, "caster"); }
        void AddCaster(string Name) { MobTendencies.AddTendency(Name, "caster"); }

        bool IsUnmovable(string Name) { return MobTendencies.MobHasTendency(Name, "unmovable"); }
        void AddUnmovable(string Name) { MobTendencies.AddTendency(Name, "unmovable"); }

        bool IsFearer(string Name) { return MobTendencies.MobHasTendency(Name, "fearer"); }
        void AddFearer(string Name) { MobTendencies.AddTendency(Name, "fearer"); }

        bool IsCrybaby(string Name) { return MobTendencies.MobHasTendency(Name, "crybaby"); }
        void AddCrybaby(string Name) { MobTendencies.AddTendency(Name, "crybaby"); }

        bool IsRunner(string Name) { return MobTendencies.MobHasTendency(Name, "runner"); }
        void AddRunner(string Name) { MobTendencies.AddTendency(Name, "runner"); }

        bool IsRendImmune(string Name) { return MobTendencies.MobHasTendency(Name, "rendimmune"); }
        void AddRendImmune(string Name) { MobTendencies.AddTendency(Name, "rendimmune"); }

        bool IsDisarmImmune(string Name) { return MobTendencies.MobHasTendency(Name, "disarmimmune"); }
        void AddDisarmImmune(string Name) { MobTendencies.AddTendency(Name, "disarmimmune"); }

        #endregion


        #region Things that burns

        List<string> BurningThings = new List<string>(); // Gief set class plx

        bool IsBurner(string Name)
        {
            return BurningThings.Contains(Name);
        }


        void AddBurner(string Name)
        {
            if (IsBurner(Name)) return;
            BurningThings.Add(Name);
        }
        #endregion





        #region TendencyManager

        private class TendencyManager
        {

            // Class to manage tendency of one mob
            private class MobTendency
            {
                private string Name;
                private List<string> TendencyList = new List<string>();
                private bool locked = false;

                // create and decode a line from the tendency file
                // Syntax is "mobname:tendeny(,tendency)*"
                public MobTendency(string Line)
                {
                    //split it
                    char[] splitter = { ':', ',' };
                    string[] fields = Line.Split(splitter);

                    if (fields != null && fields.Length > 1)
                    {
                        Name = fields[0];

                        for (int x = 1; x < fields.Length; x++)
                        {
                            AddTendency(fields[x]);
                        }
                    }
                }

                public MobTendency(string MobName, string InitialTendency)
                {
                    Name = MobName;
                    AddTendency(InitialTendency);
                }

                public string MobName
                {
                    get { return Name; }
                }

                public bool HasTendency(string Tendency)
                {
                    return TendencyList.Contains(Tendency);
                }

                public bool AddTendency(string Tendency)
                {
                    if (locked) return false;
                    if (Tendency == "") return false;
                    if (Tendency == "locked")
                    {
                        locked = true;
                        //GContext.Main.Log(MobName + " is locked");
                    }
                    bool retval;
                    if (!HasTendency(Tendency))
                    {
                        TendencyList.Add(Tendency);
                        //GContext.Main.Log(MobName + " is '" + Tendency + "'");
                        retval = true;
                    }
                    else
                    {
                        retval = false;
                    }
                    return retval;
                }

                public override string ToString()
                {
                    StringBuilder x = new StringBuilder();

                    x.Append(Name + ":");

                    for (int idx = 0; idx < TendencyList.Count; idx++)
                    {
                        x.Append(TendencyList[idx]);
                        if (idx < TendencyList.Count - 1)
                            x.Append(",");
                    }
                    if (locked)
                    {
                        if (TendencyList.Count > 0)
                            x.Append(",");
                        x.Append("locked");
                    }

                    return x.ToString();
                }
            }
            private Dictionary<string, MobTendency> MobList = new Dictionary<string, MobTendency>();

            public bool SaveToFile()
            {
                return SaveToFile("Classes/MobTendencies.txt");
            }

            public bool SaveToFile(string FileName)
            {
                bool retval = false;

                try
                {
                    if (MobList != null)
                    {
                        System.IO.StreamWriter fileout = System.IO.File.CreateText(FileName);

                        if (fileout != null)
                        {
                            retval = true;

                            foreach (KeyValuePair<string, MobTendency> kvp in MobList)
                            {
                                MobTendency x = kvp.Value;
                                fileout.WriteLine(x.ToString());
                            }

                            fileout.Flush();
                            fileout.Close();

                        }
                        else
                        {
                            retval = false;
                        }

                    }
                    else
                    {
                        retval = false;
                    }
                }
                catch (Exception e)
                {
                    GContext.Main.Log("Failed to save '" + FileName + "'");
                    GContext.Main.Log("" + e);
                }

                return retval;

            }


            public bool LoadFromFile()
            {
                return LoadFromFile("Classes\\MobTendencies.txt");
            }

            public bool LoadFromFile(string FileName)
            {
                //System.IO.StreamWriter fileout = System.IO.File.CreateText(FileName);
                bool retval = false;
                MobList.Clear();

                try
                {
                    if (FileName != "" && System.IO.File.Exists(FileName))
                    {
                        System.IO.StreamReader filein = System.IO.File.OpenText(FileName);

                        if (filein != null)
                        {
                            //read the lines of the file....

                            while (!filein.EndOfStream)
                            {
                                try
                                {
                                    MobTendency t = new MobTendency(filein.ReadLine());
                                    MobList.Add(t.MobName, t);
                                }
                                catch
                                {
                                    //error parsing the line...
                                }
                            }

                            filein.Close();
                        }
                        else
                        {
                            retval = false;
                        }


                    }
                    else
                    {
                        retval = false;
                    }
                }
                catch (Exception e)
                {
                    GContext.Main.Log("Failed to load '" + FileName + "'");
                    GContext.Main.Log("" + e);
                }
                //Context.Log("Loaded info for " + MobList.Count + " mobs");

                return retval;
            }

            public bool KnownMob(string MobName)
            {
                return MobList.ContainsKey(MobName);
            }

            public int GetMobCount()
            {
                return MobList.Count;
            }

            public bool MobHasTendency(string MobName, string Tendency)
            {
                MobTendency x;
                if (MobList.TryGetValue(MobName, out x))
                {
                    return x.HasTendency(Tendency);
                }
                return false;
            }

            public bool AddTendency(string MobName, string Tendency)
            {
                MobTendency x;
                if (MobList.TryGetValue(MobName, out x))
                {
                    if (x.HasTendency(Tendency) || x.AddTendency(Tendency))
                        return true;
                }
                else
                {
                    MobList.Add(MobName, new MobTendency(MobName, Tendency));
                }
                return false;
            }

            public bool AddMob(string MobName)
            {
                MobTendency x;
                if (MobList.TryGetValue(MobName, out x))
                {
                    return false;
                }
                else
                {
                    MobList.Add(MobName, new MobTendency(MobName, ""));
                    return true;
                }
            }
        }
        #endregion

    }


    /////////////////////////////////////////////////////////////////
    // START PPather

    public abstract class PPather : GGameClass
    {

        /*
          WTB: 

        */

        public const double PI = Math.PI;
        public static Random random = new Random();
        public static Mover mover;
        static UnitRadar radar;


      
        // settings

       
        
         bool BGMode = false;

        // state


        public PullTask CurrentPullTask = null;
        public string CurrentContinent = null;
        public PathGraph world = null;
        Spot WasAt = null;

        public enum RunState_e { Stopped, Paused, Running };
        public RunState_e RunState = RunState_e.Stopped; 
        public RunState_e WantedState = RunState_e.Stopped; 
        public NPCDatabase NPCs = new NPCDatabase();

        public static ToonState ToonData = new ToonState();

        Thread glideThread = null;
        

        GSpellTimer SaveTimer = new GSpellTimer(60 * 1000);
        int XPInitial;
        int XPCurrent;
        GSpellTimer GliderStart;
        int Kills = 0;
        int Deaths = 0;
        int Loots = 0;
        int Harvests = 0;
        int TTL = 0; // time to level in minutes
        int XPh = 0; // XP/h since last level/start
        int KPh = 0;

        //AdvancedMap.Map newMap;

        // GUI

        PatherForm form;



        public override string DisplayName
        {
            get {
              return "0.3";
            }
        }

        private Dictionary<string, GSpellTimer> blacklisted = new Dictionary<string, GSpellTimer>();


        public void Blacklist(string name, int howlong_seconds)
        {
            GSpellTimer t = null;
            if (blacklisted.TryGetValue(name, out t))
            {
                t.Reset();
            }
            else
            {
                t = new GSpellTimer(howlong_seconds * 1000);
                blacklisted.Add(name, t);
            }
            Context.Log("Blacklist " + name + " for " + howlong_seconds + "s");
        }
        public void Blacklist(long GUID, int howlong_seconds)
        {
            Blacklist("GUID" + GUID, howlong_seconds); 
        }

        public void Blacklist(GUnit unit)
        {
            Blacklist(unit.GUID, 15 * 60); // 15 minutes
        }

        public void Blacklist(String name)
        {
            Blacklist(name, 15 * 60); // 15 minutes
        }

        public void UnBlacklist(string name)
        {
            blacklisted.Remove(name);
            Context.Log("UnBlacklist " + name);
        }
        public void UnBlacklist(long GUID)
        {
            UnBlacklist("GUID" + GUID);
        }

        public void UnBlacklist(GUnit u)
        {
            UnBlacklist(u.GUID);
        }

        public bool IsBlacklisted(string name)
        {
            GSpellTimer t = null;
            if (!blacklisted.TryGetValue(name, out t))
                return false;

            return !t.IsReady;
        }

        public bool IsBlacklisted(long GUID)
        {
            return IsBlacklisted("GUID" + GUID);
        }

        public bool IsBlacklisted(GUnit unit)
        {
            return IsBlacklisted(unit.GUID);
        }




        public void Killed(GUnit unit)
        {
            //Context.Log("Killed unit " + unit.Name);
            Kills++;
        }

        public void TargetIs(GUnit unit)
        {
            form.SetTarget(unit);
        }


        public void Looted(GUnit unit)
        {
            Context.Log("Looted unit " + unit.Name);
            Loots++;
        }

        public void PickedUp(GNode node)
        {
            Context.Log("Picked up node " + node.Name);
            Harvests++;
        }

        public override void LoadConfig()
        {
         

        }

        public override void CreateDefaultConfig()
        {
           
        }


        // static methods to handle popups
        public class Popup
        {
            // 1-4
            public static bool IsVisible(int popNr)
            {
                String name = "StaticPopup" + popNr;
                GInterfaceObject obj = GContext.Main.Interface.GetByName(name);
                if (obj != null && obj.IsVisible) return true;
                return false;
            }


            public static bool IsCloseable(int popNr)
            {
                String name = "StaticPopup" + popNr + "CloseButton";
                GInterfaceObject obj = GContext.Main.Interface.GetByName(name);
                if (obj != null && obj.IsVisible) return true;
                return false;
            }


            public static string GetText(int popNr)
            {
                String name = "StaticPopup" + popNr;
                GInterfaceObject obj = GContext.Main.Interface.GetByName(name);
                GContext.Main.Log("ugh " + obj);
                if (obj == null || !obj.IsVisible) return null;
                GInterfaceObject text = obj.GetChildObject(name + "Text");
                if(text == null) return null;
                return text.LabelText;
                
            }

            public static bool ClickButton(int popNr, int buttonNr)
            {
                String name = "StaticPopup" + popNr + "Button" + buttonNr;
                GInterfaceObject obj = GContext.Main.Interface.GetByName(name);
                if (obj != null && obj.IsVisible)
                {
                    obj.ClickMouse(false);
                    return true;
                }
                return false;
            }

            public static bool ClickClose(int popNr)
            {
                String name = "StaticPopup" + popNr + "CloseButton";
                GInterfaceObject obj = GContext.Main.Interface.GetByName(name);
                if (obj != null && obj.IsVisible)
                {
                    obj.ClickMouse(false);
                    return true;
                }
                return false;
            }
        }

        // static methods to handle Gossip frames
        public class GossipFrame
        {
            /*
             V GossipFrame
V GossipNpcNameFrame
V GossipFrameCloseButton
V GossipFrameGreetingPanel
V GossipFrameGreetingGoodbyeButton
V GossipGreetingScrollFrame
V GossipGreetingScrollChildFrame
V GossipTitleButton1
  GossipTitleButton2
...
  GossipTitleButton32
V GossipSpacerFrame
V GossipGreetingScrollFrameScrollBar
V GossipGreetingScrollFrameScrollBarScrollUpButton
V GossipGreetingScrollFrameScrollBarScrollDownButton
*/
            public static GInterfaceObject GetFrame()
            {
                return GContext.Main.Interface.GetByName("GossipFrame");
            }

            public static bool IsVisible()
            {
                GInterfaceObject obj = GetFrame();
                if (obj != null && obj.IsVisible) return true;
                return false;
            }

            public static int[] VisibleOptions()
            {
                List<int> options = new List<int>();
                for (int i = 1; i <= 32; i++)
                {
                    GInterfaceObject btn = GContext.Main.Interface.GetByName("GossipTitleButton" + i);
                    if (btn != null && btn.IsVisible) options.Add(i);
                }
                return options.ToArray();
            }

            public static string[] VisibleOptionsText()
            {
                List<string> options = new List<string>();
                for (int i = 1; i <= 32; i++)
                {
                    GInterfaceObject btn = GContext.Main.Interface.GetByName("GossipTitleButton" + i);
                    if (btn != null && btn.IsVisible) 
                    {
                        options.Add(btn.LabelText);
                        GInterfaceObject text = btn.GetChildObject("GossipTitleButton" + i + "Text");
                        if(text == null)                         
                            options.Add("");
                        else
                            options.Add(text.LabelText);
                    }
                }
                return options.ToArray();
            }

            public static void ClickOption(int i)
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("GossipTitleButton" + i);
                if (btn != null && btn.IsVisible) 
                    btn.ClickMouse(false); // left click
            }

            public static void Close()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("GossipFrameCloseButton");
                if (btn != null && btn.IsVisible)
                    btn.ClickMouse(false);
            }
        }

        public class QuestFrame
        {
            /*

Pickup quest (many optioss): 
V QuestLogMicroButton
V QuestFrame
V QuestNpcNameFrame
V QuestFrameCloseButton
V QuestFrameGreetingPanel
V QuestFrameGreetingGoodbyeButton
V QuestGreetingScrollFrame
V QuestGreetingScrollChildFrame
V QuestTitleButton1
V QuestTitleButton2
V QuestTitleButton3
V QuestGreetingScrollFrameScrollBar
V QuestGreetingScrollFrameScrollBarScrollUpButton
V QuestGreetingScrollFrameScrollBarScrollDownButton
V dQuestWatch



Hand in items: 

QuestFrame
QuestNpcNameFrame
QuestFrameCloseButton
QuestFrameProgressPanel
QuestFrameGoodbyeButton
QuestFrameCompleteButton
QuestProgressScrollFrame
QuestProgressScrollChildFrame
QuestProgressItem1
QuestProgressScrollFrameScrollBar
QuestProgressScrollFrameScrollBarScrollUpButton
QuestProgressScrollFrameScrollBarScrollDownButton
QuestWatchFrame

Complete Quest: (no reward selection)

QuestFrame
QuestNpcNameFrame
QuestFrameCloseButton
QuestFrameRewardPanel
QuestFrameCancelButton
QuestFrameCompleteQuestButton
QuestRewardScrollFrame
QuestRewardScrollChildFrame
QuestRewardItem1
QuestRewardMoneyFrame
QuestRewardMoneyFrameCopperButton
QuestRewardScrollFrameScrollBar
QuestRewardScrollFrameScrollBarScrollUpButton
QuestRewardScrollFrameScrollBarScrollDownButton
QuestWatchFrame

Complete Quest: (2 rewards selection)

V QuestFrame
V QuestNpcNameFrame
V QuestFrameCloseButton
V QuestFrameRewardPanel
V QuestFrameCancelButton
V QuestFrameCompleteQuestButton
V QuestRewardScrollFrame
V QuestRewardScrollChildFrame
V QuestRewardItem1
V QuestRewardItem2
V QuestRewardScrollFrameScrollBar
V QuestRewardScrollFrameScrollBarScrollUpButton
V QuestRewardScrollFrameScrollBarScrollDownButton
V QuestWatchFrame

             */

            public static GInterfaceObject GetFrame()
            {
                return GContext.Main.Interface.GetByName("QuestFrame");
            }

            public static string GetCompleteTitle()
            {
              GInterfaceObject QuestDetailScrollChildFrame = GContext.Main.Interface.GetByName("QuestRewardScrollChildFrame"); 
              GInterfaceObject QuestTitle =                  QuestDetailScrollChildFrame.GetChildObject("QuestRewardTitleText"); 
              GContext.Main.Log("Reward title: " + QuestTitle.LabelText + " v: " + QuestTitle.IsVisible);
              return QuestTitle.LabelText;
            }
          
            public static string GetAcceptTitle()
            {
                GInterfaceObject QuestDetailScrollChildFrame = GContext.Main.Interface.GetByName("QuestDetailScrollChildFrame"); 
                GInterfaceObject QuestTitle =                  QuestDetailScrollChildFrame.GetChildObject("QuestTitleText"); 
                GContext.Main.Log("Quest title: " + QuestTitle.LabelText + " v: " + QuestTitle.IsVisible);
                return QuestTitle.LabelText;
            }

            public static bool IsVisible()
            {
                GInterfaceObject obj = GetFrame();
                if (obj != null && obj.IsVisible) return true;
                return false;
            }

            public static bool IsSelect()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestTitleButton1");
                if (btn != null && btn.IsVisible) return true;
                return false;
            }

            public static bool IsAccept()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameAcceptButton");
                if (btn != null && btn.IsVisible) return true;
                return false;
            }

            public static bool IsContinue()
            {
                 GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameCompleteButton");
                 if (btn != null && btn.IsVisible) return true;
                 return false;
            }

            public static bool IsComplete()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameCompleteQuestButton");
                if (btn != null && btn.IsVisible) return true;
                return false;
            }

            public static int[] AvailableRewards()
            {
                List<int> options = new List<int>();
                for (int i = 1; i <= 10; i++)
                {
                    GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestRewardItem" + i);
                    if (btn != null && btn.IsVisible) options.Add(i);
                }
                return options.ToArray();
            }

            public static void SelectReward(int nr)
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestRewardItem" + nr);
                if (btn != null && btn.IsVisible)
                    btn.ClickMouse(false);
            }

            public static void Accept()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameAcceptButton");
                if (btn != null && btn.IsVisible)
                    btn.ClickMouse(false);
            }

            public static void Continue()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameCompleteButton");
                if (btn != null && btn.IsVisible)
                    btn.ClickMouse(false);

            }

            public static void Complete()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameCompleteQuestButton");
                if (btn != null && btn.IsVisible)
                    btn.ClickMouse(false);
            }

            public static void Close()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameCloseButton");
                if (btn != null && btn.IsVisible)
                    btn.ClickMouse(false);
            }

            public static void Cancel()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameCancelButton");
                if (btn != null && btn.IsVisible)
                {
                    GContext.Main.Log("  click QuestFrameCancelButton");
                    btn.ClickMouse(false);
                }
                else
                    GContext.Main.Log("  can't find cancel button");
                    
            }

            public static void Goodbye()
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestFrameGoodbyeButton");
                if (btn != null && btn.IsVisible)
                {
                    GContext.Main.Log("  click QuestFrameGoodbyeButton");
                    btn.ClickMouse(false);
                }
                else
                    GContext.Main.Log("  can't find goodbye button");
                    
            }

            public static int[] VisibleOptions()
            {
                List<int> options = new List<int>();
                for (int i = 1; i <= 32; i++)
                {
                    GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestTitleButton" + i);
                    if (btn != null && btn.IsVisible) options.Add(i);
                }
                return options.ToArray();
            }

            public static void ClickOption(int i)
            {
                GInterfaceObject btn = GContext.Main.Interface.GetByName("QuestTitleButton" + i);
                if (btn != null && btn.IsVisible) 
                    btn.ClickMouse(false); // left click
            }

        }





        /*
          Macro: 

13:43 Quest accepted: Galgar's Cactus Apple Surprise
13:44 Quest accepted: Sting of the Scorpid
13:44 Quest accepted: Vile Familiars
13:48 Galgar's Cactus Apple Surprise completed.

13:49 Lazy Peons failed: Inventory is full.

13:50 Quest accepted: Lazy Peons

14:00 Vile Familiars failed: Inventory is full.

14:00 Quest accepted: Burning Blade Medallion

/script ChatFrame1:AddMessage("Zone#" .. GetSubZoneText() .. ":" .. GetZoneText() .."#");
/script ChatFrame1:AddMessage ("Quest#" .. GetTitleText().."#");

         */
        private string FoundZone = null;
        void Pather_ChatLog(string RawText, string ParsedText)
        {
            
            /*if (ParsedText.StartsWith("Quest accepted: "))
            {
                string Name = ParsedText.Substring(16);
                QuestAccepted(Name);
            }
            else  if (ParsedText.Contains(" failed: "))
            {
                int end = ParsedText.IndexOf(" failed: "); 
                int len = ParsedText.Length;
                string Name = ParsedText.Substring(0, end);
                QuestFailed(Name);
            }
            else if (ParsedText.EndsWith(" completed"))
            {
                int end = ParsedText.IndexOf(" completed.");
                int len = ParsedText.Length;
                string Name = ParsedText.Substring(0, end);
                QuestCompleted(Name);                
            }
            else */if (ParsedText.StartsWith("Zone#"))
            {
                // yeah
                char[] splitter = { '#' };
                string[] fields = ParsedText.Split(splitter);
                string zone = fields[1];
                FoundZone = zone;
            }
            else if (ParsedText.StartsWith("HotSpot"))
            {
                GLocation loc = GContext.Main.Me.Location;
                //Location isAt2 = new Location(loc.X, loc.Y, loc.Z);
                //Context.Log("Add new hotspot");
                //hotSpots.Add(isAt2);
                Context.Log(String.Format("[ {0,2:#0.0}, {1,2:#0.0}, {2,2:#0.0}]", loc.X, loc.Y, loc.Z));
            }
            else if (ParsedText.StartsWith("Dump"))
            {
                GNode[] nodes = GObjectList.GetNodes();
                foreach (GNode node in nodes)
                {
                    node.Refresh(true);
                    Context.Log("node: " + node.Name + " at " + node.Location.Z);
                }
                GUnit[] units = GObjectList.GetUnits();
                foreach (GUnit unit in units)
                {
                    Context.Log("unit: " + unit.Name);
                }
                
              
            }
            else if (ParsedText.Contains("The Horde wins!") ||
                    ParsedText.Contains("The Alliance wins!"))
            {
                Context.Log("BG ended. Stop glider");
                Context.KillAction("BG ended", false);                
            }

        }

        void Pather_CombatLog(string rawText)
        {
            if (rawText == null) return;
            if (rawText.StartsWith("You have slain"))
            {
                int start = rawText.IndexOf("slain") + 6;
                int end = rawText.IndexOf("!");
                String mob = rawText.Substring(start, end - start);
                //Context.Log("Killed monster '" + mob + "'");
                if (CurrentPullTask != null)
                    CurrentPullTask.KilledMob(mob);
            }

        }

        private string FigureOutZone()
        {
            FoundZone = null;
            GSpellTimer futile = new GSpellTimer(10 * 1000);
            GSpellTimer recast = new GSpellTimer(2 * 1000); recast.ForceReady();
            do
            {
                if (recast.IsReady)
                {
                    GContext.Main.CastSpell("Pather.ContinentMacro");
                    recast.Reset();
                }
            } while (FoundZone == null && !futile.IsReadySlow);

            if (FoundZone == null)
                FoundZone = "Unknown";
            return FoundZone;
        }


        public override void OnStartGlide()
        {
            
            glideThread = Thread.CurrentThread; 

            RunState = RunState_e.Paused;
            WantedState = RunState_e.Running;
            CurrentPullTask = null; 

            base.OnStartGlide();
            Context.Log("TotalMemory before " + System.GC.GetTotalMemory(true) / (1024 * 1024) + " MB");

            WasAt = null;
            CurrentPullTask = null; 

            string zone = FigureOutZone();

            MPQTriangleSupplier mpq = new MPQTriangleSupplier();
            CurrentContinent = mpq.SetZone(zone);
            
            BGMode = false;
            Context.Log("Continent is : " + CurrentContinent);
            if (CurrentContinent == null)
            {
                Context.KillAction("Unknown zone " + zone, false);                                
            }
            else if (CurrentContinent.StartsWith("PVPZone"))
            {
                BGMode = true;
            }

            string myFaction = "Unknown";
            if (IsHordePlayerFaction(Me)) myFaction = "Horde";
            if (IsAlliancePlayerFaction(Me)) myFaction = "Alliance"; 
            NPCs.SetContinent(CurrentContinent, myFaction); 
            ToonData.SetToonName(Me.Name);
            


            ChunkedTriangleCollection triangleWorld = new ChunkedTriangleCollection(512);
            triangleWorld.SetMaxCached(9);
            triangleWorld.AddSupplier(mpq);

            world = new PathGraph(CurrentContinent, triangleWorld, null);
            world.locationHeuristics = radar;
            //newMap = new AdvancedMap.Map();
            //newMap.RunMap();

        }

        private void SaveAllState()
        {
            NPCs.Save();
            ToonData.Save(); 
            if (world != null)
            {
                world.Save();
            }
          
        }

        public override void OnStopGlide()
        {
            Context.Log("Inside OnStopGlider()");

            //newMap.StopMap();

            /*
            if (Thread.CurrentThread != glideThread && glideThread != null)
            {
                // kill glide thread first
                GSpellTimer timeout = new GSpellTimer(15000);
                GContext.Main.Log("kill glide thread");
                
                glideThread.Abort();
                while (glideThread.IsAlive)
                {
                    GContext.Main.Log("wait for glide thread to stop");
                    Thread.Sleep(500);
                    if (timeout.IsReady) break; 
                }
                Context.Log("glide thread state: " + glideThread.ThreadState); 
            }
            glideThread = null;
            */
            WantedState = RunState_e.Stopped;
            RunState = RunState_e.Stopped;

            SaveAllState();

            if(ToonData != null)
              ToonData.SetToonName(null);
            if(NPCs != null)
              NPCs.SetContinent(null, null); // stop tracking

            if(world != null)
              world.Close();
            world = null; 
            CurrentPullTask = null; 
            Context.Log("TotalMemory " + System.GC.GetTotalMemory(false) / (1024 * 1024) + " MB");
            //world = null; // release RAM

            Context.Log("TotalMemory after GC " + System.GC.GetTotalMemory(true) / (1024 * 1024) + " MB");
            base.OnStopGlide();
        }


        public override void Startup()
        {
            GContext.Main.Log("Startup in PPather");
            mover = new Mover(Context);
	    radar = new UnitRadar();
            form = new PatherForm(this);
            form.Show();
            base.Startup();            
            GContext.Main.ChatLog += new GContext.GChatLogHandler(Pather_ChatLog);
            GContext.Main.CombatLog += new GContext.GCombatLogHandler(Pather_CombatLog);


/*
            string []ui = GInterfaceHelper.GetAllInterfaceObjectNames();
            System.IO.StreamWriter fileout = null;
            fileout = System.IO.File.CreateText("GossipUIObjects");            
            int i = 0;
            foreach(string s in ui)
            {
              if(s == null) continue;
                if(s.IndexOf("Quest") != -1 || s.IndexOf("quest") != -1 ||
                   s.IndexOf("Gossip") != -1 || s.IndexOf("gossip") != -1 )
                {
                    GInterfaceObject obj  = Context.Interface.GetByName(s);
                    if(obj == null)
                    {
                    }
                    else
                    {
                        if(obj.IsVisible)
                            fileout.WriteLine("V " + s);
                        //else
                        //    fileout.WriteLine("  " + s);
                    }
                    i++; 
                }
            }
            Context.Log("wrote " + i + " ui objects");
            fileout.Flush();
            fileout.Close();
*/

        }

        public override void Shutdown()
        {
            GContext.Main.CombatLog -= new GContext.GCombatLogHandler(Pather_CombatLog);
            GContext.Main.ChatLog -= new GContext.GChatLogHandler(Pather_ChatLog);
            form.Dispose();
            base.Shutdown();
        }




        public override void Patrol()
        {
            OnStartGlide();

            Kills = 0;
            Loots = 0;
            Harvests = 0;

            XPInitial = Me.Experience;
            GliderStart = new GSpellTimer(0);

            if(!Me.IsInCombat)
                Rest();
                while (true)
                {
                    MyPather();
                    Thread.Sleep(1000);
                }
        }

        private void UpdateXP()
        {
            XPCurrent = Me.Experience;
            if (XPCurrent < XPInitial)
            {
                Context.Log("GZ! ding");
                XPInitial = Me.Experience;
                XPCurrent = XPInitial;
                GliderStart = new GSpellTimer(0);
            }
            else
            {
                double XPGained = (double)(XPCurrent - XPInitial);
                double time = (double)(-GliderStart.TicksLeft) / 3600000.0; // hours
                if (time != 0.0)
                {
                    int XpNeeded = Me.NextLevelExperience - Me.Experience;
                    int XPPerHour = (int)(XPGained / time);
                    KPh = (int)((double)Kills / time);

                    int minsToLvl = XPPerHour == 0 ? 0 : (60 * XpNeeded) / XPPerHour;
                    //Context.Log("Kills: " + Kills + " Kills/h: " + KillsPerHour + " XP/h: " + XPPerHour + " TTL: " + minsToLvl + " min");
                    TTL = minsToLvl;
                    XPh = XPPerHour;
                }
            }
        }

        private GSpellTimer ChunkLoadT = new GSpellTimer(5000, true);

        public void UpdateMyPos()
        {
            radar.Update();
            if (world != null)
            {
                GLocation loc = GContext.Main.Me.Location;
                Location isAt = new Location(loc.X, loc.Y, loc.Z);
                //if(WasAt != null)  Context.Log("was " + WasAt.location);
                //Context.Log("isAt " + isAt); 
                if(WasAt != null)
                {
                    if(WasAt.GetLocation().GetDistanceTo(isAt) > 20)
                        WasAt = null;
                }
                WasAt = world.TryAddSpot(WasAt, isAt);
            }
        }

        public static string GetQuestStatus(string quest)
        {
            string val = ToonData.Get("Quest:" + quest);
            return val;
        }

        // Quest have 3 states:  accepted, failed, completed
        public void QuestAccepted(string name)
        {
            Context.Log("Quest accepted: '"+name+"'"); 
            ToonData.Set("Quest:"+name,  "accepted"); 
        }

        public void QuestFailed(string name)
        {
            Context.Log("Quest failed: '" + name + "'");
            ToonData.Set("Quest:"+name,  "failed"); 
        }

        public void QuestCompleted(string name)
        {
            Context.Log("Quest completed: '"+name+"'"); 
            ToonData.Set("Quest:"+name,  "completed"); 
        }

        // completed or failed
        public bool IsQuestDone(string name)
        {
            string val = ToonData.Get("Quest:"+name);
            if(val == null) return false;
            if(val == "failed" || val == "completed") return true;
            return false;
        }

        public bool IsQuestFailed(string name)
        {
            string val = ToonData.Get("Quest:"+name);
            if(val == null) return false;
            if(val == "failed") return true;
            return false;
        }

        public bool IsQuestAccepted(string name)
        {
            string val = ToonData.Get("Quest:"+name);
            if(val == null) return false;
            if(val == "accepted") return true;
            return false;
        }


        public class ToonState
        {
            // Simple saved storage or key=>value pairs

            Dictionary <string, string> dic = new Dictionary<string,string>();
            string toonName = null;
            bool changed = false;

            public void Save()
            {
                lock (this)
                {
                    if(!changed) return;
                    if (toonName == null) return;
                    string filename = "pathing2\\" + toonName;
                    try
                    {
                        System.IO.TextWriter s = System.IO.File.CreateText(filename);
                        foreach (string key in dic.Keys)
                        {
                            string val = dic[key];
                            s.WriteLine(key + "|" + val);
                        }
                        s.Close();
                    }
                    catch (Exception e)
                    {
                        GContext.Main.Log("Exception writing toon state data: " + e);
                    }
                    changed = false;
                }

            }

            public void Load()
            {
                lock (this)
                {
                    if (toonName == null) return;
                    dic = new Dictionary<string,string>();
                    
                    // Load from file
                    try
                    {
                        GContext.Main.Log("Load toon data for "+ toonName);
                        string filename = "pathing2\\" + toonName;
                        System.IO.TextReader s = System.IO.File.OpenText(filename);

                        int nr = 0;
                        string line;
                        while ((line = s.ReadLine()) != null)
                        {
                            char[] splitter = {'|'};
                            string[] st = line.Split(splitter);
                            if(st.Length == 2)
                            {
                                string key = st[0];
                                string val = st[1];
                                Set(key, val);
                                nr++; 
                            }
                        }
                        GContext.Main.Log("Loaded " + nr + " toon state data"); 

                        s.Close();
                    }
                    catch (Exception e)
                    {
                        GContext.Main.Log("Exception reading toon state: " + e);
                    }
                    changed = false;
                    
                }

            }

            public void SetToonName(string name)
            {
                Save();
                toonName = name;
                Load();
            }

            public string Get(string key)
            {
                string val;
                if (dic.TryGetValue(key, out val))
                {
                    return val; 
                }
                return null;
            }

            public void Set(string key, string name)
            {
                if (dic.ContainsKey(key))
                    dic.Remove(key);
                dic.Add(key, name);
                changed = true;                    
            }
        }

        public class NPCDatabase
        {
            public class NPC
            {
                public String name;
                public GLocation location;
                public int faction;
                public GReaction reaction;

                public override string ToString()
                {
                    return String.Format("{0}|{1},{2},{3}|{4}|{5}",
                                         name, location.X, location.Y, location.Z, faction, reaction); 
                }

                public bool FromString(string s)
                {
                    char[] splitter = { '|' };
                    string[] sp = s.Split(splitter); 
                    if (sp.Length < 4) return false;
                    name = sp[0];
                    string locs = sp[1];
                    char[] splitter2 = { ',' };
                    string[] coords = locs.Split(splitter2);
                    if (coords.Length == 3)
                    {
                        float x = float.Parse(coords[0]);
                        float y = float.Parse(coords[1]);
                        float z = float.Parse(coords[2]);
                        location = new GLocation(x, y, z);
                    }
                    else return false;
                    faction = Int32.Parse(sp[2]);
                    string rs = sp[3];
                    if(rs == "Frienfly")
                        reaction = GReaction.Friendly;
                    if (rs == "Hostile")
                        reaction = GReaction.Hostile;
                    if (rs == "Neutral")
                        reaction = GReaction.Neutral;
                    if (rs == "Unknown")
                        reaction = GReaction.Unknown;

                    return true;
                }                           
            }
            
            Dictionary<string, NPC> NPCs ;
            string continent = null;
            string myFaction = "";
            bool changed = false;

            public void SetContinent(string continent, string myFaction)
            {
              
                lock(this)
                {
                    // Continent change
                    Save(); 
                    
                    this.continent = continent;
                    this.myFaction = myFaction; 
                    
                    Load();
                }
               
              
            }


            public void Update()
            {
                
                lock (this)
                {
                    if (continent == null) return;
                    if (NPCs == null) return;
                    GUnit[] units = GObjectList.GetUnits();
                    foreach (GUnit unit in units)
                    {
                      if ((unit.Reaction == GReaction.Friendly || unit.Reaction == GReaction.Neutral) 
                          && !unit.IsPlayer &&
                            unit.CreatureType != GCreatureType.Critter &&
                            unit.CreatureType != GCreatureType.Totem && 
                            !PPather.IsPlayerFaction(unit))
                        {
                            string name = unit.Name;
                            NPC n = null;
                            if(!NPCs.TryGetValue(name, out n))                            
                            {
                                n = new NPC();
                                n.name = name;
                                n.faction = unit.FactionID;
                                n.location = unit.Location;
                                n.reaction = unit.Reaction;
                                GContext.Main.Log("New NPC found: " + name);
                                NPCs.Add(name, n);
                                changed = true;
                            }
                        }
                    }
                }
            }

            public void Save()
            {
                if(!changed)  return;
                lock (this)
                {
                    if (continent == null) return;
                    string filename = "pathing2\\" + continent + "\\NPC_" + myFaction;
                    try
                    {
                        System.IO.TextWriter s = System.IO.File.CreateText(filename);
                        foreach (string name in NPCs.Keys)
                        {
                            NPC n = NPCs[name];
                            s.WriteLine(n.ToString());
                        }
                        s.Close();
                    }
                    catch (Exception e)
                    {
                        GContext.Main.Log("Exception writing NPC data: " + e);
                    }
                    changed = false; 

                }
            }
            
            public void Load()
            {
                lock (this)
                {
                    if (continent == null) return;
                    NPCs = new Dictionary<string, NPC>();
                    // Load from file
                    try
                    {
                        string filename = "pathing2\\" + continent + "\\NPC_" + myFaction;
                        System.IO.TextReader s = System.IO.File.OpenText(filename);

                        int nr = 0;
                        string line;
                        while ((line = s.ReadLine()) != null)
                        {
                            NPC n = new NPC();
                            if (n.FromString(line))
                            {
                                if(!NPCs.ContainsKey(n.name))
                                {
                                    NPCs.Add(n.name, n);
                                    nr++;
                                }
                            }
                           
                        }
                        GContext.Main.Log("Loaded " + nr + " NPCs"); 

                        s.Close();
                    }
                    catch (Exception e)
                    {
                        GContext.Main.Log("Exception reading NPC data: " + e);
                    }
                    changed = false; 
                }
            }

            public NPC Find(string name)
            {
                NPC n;
                if (NPCs.TryGetValue(name, out n))
                {
                    return n; 
                }
                return null;
            }
        }

        // Called by gui thread
        public void UpdateNPCs()
        {
            if (NPCs == null) return; 
            
            NPCs.Update();
        }

        public Location FindNPCLocation(string name)
        {
            if (NPCs == null) return null;
            NPCDatabase.NPC npc = NPCs.Find(name);
            //Context.Log("found '" + name + "' or? " + npc);
            if (npc == null) return null;
            return new Location(npc.location);
        }

        public GLocation PredictedLocation(GUnit mob)
        {
            GLocation currentLocation = mob.Location;
            double x = currentLocation.X;
            double y = currentLocation.Y;
            double z = currentLocation.Z;
            double heading = mob.Heading;
            double dist = 4;

            x += Math.Cos(heading) * dist;
            y += Math.Sin(heading) * dist;

            GLocation predictedLocation = new GLocation((float)x, (float)y, (float)z);

            GLocation closestLocatition = currentLocation;
            if (predictedLocation.DistanceToSelf < closestLocatition.DistanceToSelf)
                closestLocatition = predictedLocation;
            return closestLocatition;
        }


        public static bool IsStupidItem(GUnit unit)
        {
            if (unit.CreatureType == GCreatureType.Totem) return true;
            // Filter out all stupid sting found in outland
            string name = unit.Name.ToLower();
            if (name.Contains("target") || name.Contains("trigger") || 
                name.Contains("flak cannon") ||name.Contains("trip wire") ||
                name.Contains("infernal rain") || name.Contains("anilia") ||
                name.Contains("teleporter credit") || name.Contains("door fel cannon") ||
                name.Contains("Ethereum Glaive") || name.Contains("orb flight"))
                return true;
            return false;
        }

        public bool IsItSafeAt(GUnit ignore, GUnit u)
        {
            return IsItSafeAt(ignore, u.Location);
        }

        public bool IsItSafeAt(GUnit ignore, Location l)
        {
            return IsItSafeAt(ignore, new GLocation(l.X, l.Y, l.Z));
        }

        public bool IsItSafeAt(GUnit ignore, GLocation l)
        {
            return true; 
/*
            GMonster[] adds = GObjectList.GetMonsters();
            if (adds.Length == 0) return true;



            foreach (GMonster Add in adds)
            {
                if ((ignore == null || Add != ignore) && !IsStupidItem(Add) && !IsBlacklisted(Add))
                {
                    GLocation loc = PredictedLocation(Add);
                    double dangerd = 20 + Add.Level - Me.Level;
                    if (!Add.IsDead &&
                        Add.Reaction == GReaction.Hostile &&
                        !Add.IsTagged &&
                        Add.DistanceToSelf < dangerd) // TODO need to be a setting
                    {
                        //return true;
                        return false;
                    }
                }
            }
            return true;
*/
        }

        public double DistanceToClosestHostileFrom(GUnit target)
        {

            GMonster m = GObjectList.GetNearestHostile(target.Location, target.GUID, false);
            if (m != null)
                return m.GetDistanceTo(target);
            else
                return 1E100;
        }

        public GPlayer GetClosestPvPPlayer()
        {
            GPlayer[] plys = GObjectList.GetPlayers();
            GPlayer ClosestPlayer = null;

            foreach (GPlayer p in plys)
            {
                if (!p.IsSameFaction && !p.IsDead)
                {
                    double d = p.GetDistanceTo(Me);
                    if ((ClosestPlayer == null || d < ClosestPlayer.GetDistanceTo(Me)))
                        ClosestPlayer = p;
                }
            }
            return ClosestPlayer;
        }

        public GPlayer GetClosestPvPPlayerAttackingMe()
        {
            GPlayer[] plys = GObjectList.GetPlayers();
            GPlayer ClosestPlayer = null;

            foreach (GPlayer p in plys)
            {
                if (!p.IsSameFaction && p.Target == Me)
                {
                    if (ClosestPlayer == null || p.GetDistanceTo(Me) < ClosestPlayer.GetDistanceTo(Me))
                        ClosestPlayer = p;
                }
            }
            return ClosestPlayer;
        }

        public GPlayer GetClosestFriendlyPlayer()
        {
            GPlayer[] plys = GObjectList.GetPlayers();
            GPlayer ClosestPlayer = null;

            foreach (GPlayer p in plys)
            {
                if (p.IsSameFaction && p != Me)
                {
                    if (ClosestPlayer == null || p.GetDistanceTo(Me) < ClosestPlayer.GetDistanceTo(Me))
                        ClosestPlayer = p;
                }
            }
            return ClosestPlayer;
        }
        public GUnit FindAttacker()
        {
            // Find attackers
            GUnit attacker = GObjectList.GetNearestAttacker(0);
            if (attacker != null)
            {
                if (attacker.IsPlayer)
                {
                    // hmmm
                    if (attacker.IsInCombat &&
                        attacker.Target != null &&
                        attacker.Target == GContext.Main.Me)
                    {
                        // looks like this sucker is attacking me!
                        return attacker;
                    }
                }
                else
                {
                    return attacker; // a monster
                }
            }
            return null;
        }

        public bool Face(GUnit monster)
        {
            return Face(monster, PI / 8);
        }

        public bool Face(GNode node)
        {
            return Face(node, PI / 8);
        }

        public bool Face(GUnit monster, double tolerance)
        {
            int timeout = 3000;
            if (monster == null) return false;
            GSpellTimer approachTimeout = new GSpellTimer(timeout, false);
            if (Math.Abs(monster.Bearing) < tolerance) return true;
            bool wasDead = monster.IsDead;
            do
            {
                if (Me.IsDead || wasDead != monster.IsDead) { mover.Stop(); return false; }

                double b = monster.Bearing;
                if (b < -tolerance)
                {
                    // to the left
                    mover.RotateLeft(true);
                }
                else if (b > tolerance)
                {
                    // to the rigth
                    mover.RotateRight(true);
                }
                else
                {
                    // ahead
                    mover.Stop();
                    return true;
                }

                UpdateMyPos();
            } while (!approachTimeout.IsReadySlow);

            mover.Stop();
            Context.Log("Face timed out");
            return false;

        }
        public bool Face(GNode monster, double tolerance)
        {
 
            if(monster == null) return false;
            int timeout = 3000;

            if(mover == null) GContext.Main.Log("mover is null"); 
            GSpellTimer approachTimeout = new GSpellTimer(timeout, false);
            if (Math.Abs(monster.Location.Bearing) < tolerance) return true;
            do
            {
                if (Me.IsDead) { mover.Stop(); return false; }

                double b = monster.Location.Bearing;
                if (b < -tolerance)
                {
                    // to the left
                    mover.RotateLeft(true);
                }
                else if (b > tolerance)
                {
                    // to the rigth
                    mover.RotateRight(true);
                }
                else
                {
                    // ahead
                    mover.Stop();
                    return true;
                }

                UpdateMyPos();
            } while (!approachTimeout.IsReadySlow);

            mover.Stop();
            Context.Log("Face timed out");
            return false;

        }

        public static bool IsHordePlayerFaction(GUnit u)
        {
            int f = u.FactionID;
            if (f == 2 ||
                f == 5 ||
                f == 6 ||
                f == 116 ||
                f == 1610)
                return true;
            return false;
        }

        public static bool IsAlliancePlayerFaction(GUnit u)
        {
            int f = u.FactionID;
            if (f == 1 ||
                f == 3 ||
                f == 4 ||
                f == 115 ||
                f == 1629)
                return true;
          
            return false;
        }

        public static bool IsPlayerFaction(GUnit u)
        {
            return IsHordePlayerFaction(u) || IsAlliancePlayerFaction(u);
        }


        public bool MoveToGetThemInFront(GUnit Target, GUnit Add)
        {
            double bearing = Add.Bearing;
            if (!IsInFrontOfMe(Add))
            {
                Context.Log("Got the add " + Add.Name + " behind me");
                /*
                  hmm, just back up? or turn a bit too?
                */

                mover.Backwards(true);
                if (bearing < 0)
                {
                    Context.Log("  back up left");
                    mover.RotateLeft(true);
                }
                else
                {
                    Context.Log("  back up right");
                    mover.RotateRight(true);
                }
                Thread.Sleep(300);
                mover.RotateLeft(false);
                mover.RotateRight(false);
                Thread.Sleep(300);
                mover.Backwards(false);
                return true;
            }
            return false;
        }

        public void TweakMelee(GUnit Monster)
        {
            double Distance = Monster.DistanceToSelf;
            double sensitivity = 2.5; // default melee distance is 4.8 - 2.5 = 2.3, no monster will chase us at 2.3
            double min = Context.MeleeDistance - sensitivity;
            if (min < 1.0) min = 1.0;

            if (Distance > Context.MeleeDistance)
            {
                // Too far
                //Spam("Tweak forwards. "+ Distance + " > " + Context.MeleeDistance);
                mover.Forwards(true);
                Thread.Sleep(100);
                mover.Forwards(false);
            }
            else if (Distance < min)
            {
                // Too close
                //Spam("Tweak backwards. "+ Distance + " < " + min);
                mover.Backwards(true);
                Thread.Sleep(200);
                mover.Backwards(false);
            }
        }

        /*
         */
        // return value from -PI to PI
        // 
        double BearingToMe(GUnit unit)
        {
            GLocation MyLocation = Me.Location;
            float bearing = (float)unit.GetHeadingDelta(MyLocation);
            return bearing;
        }

        public bool IsInFrontOfMe(GUnit unit)
        {
            double bearing = unit.Bearing;
            return bearing < PI / 2.0 && bearing > -PI / 2.0;
        }



        public bool Approach(GUnit monster, bool AbortIfUnsafe)
        {
            return Approach(monster, AbortIfUnsafe, 10000);
        }

        public bool Approach(GUnit monster, bool AbortIfUnsafe, int timeout)
        {
            return WalkTo(monster.Location, AbortIfUnsafe, timeout, false);
        }

        public bool WalkTo(GLocation loc, bool AbortIfUnsafe, int timeout, bool AllowDead)
        {
            if (loc.DistanceToSelf < Context.MeleeDistance &&
                Math.Abs(loc.Bearing) < PI / 8)
            {
                mover.Stop();
                return true;
            }

            GSpellTimer approachTimeout = new GSpellTimer(timeout, false);
            StuckDetecter sd = new StuckDetecter(this, 1, 2);
            GSpellTimer t = new GSpellTimer(0);
            bool doJump = random.Next(4) == 0;
            EasyMover em = null;
            GSpellTimer NewTargetUpdate = new GSpellTimer(2000);
            do
            {
                UpdateMyPos();

                // Check for stuck
                if (sd.checkStuck())
                {
                    Context.Log("Major stuck on approach. Giving up");
                    mover.Stop();
                    return false;
                }


                double distance = loc.DistanceToSelf;
                bool moved;
                if (distance < 8)
                {
                    moved = mover.moveTowardsFacing(Me, loc, Context.MeleeDistance, loc);
                }
                else
                {
                    if (em == null)
                        em = new EasyMover(this, new Location(loc), false, AbortIfUnsafe);
                    if (NewTargetUpdate.IsReady)
                    {
                        em.SetNewTarget(new Location(loc));
                        NewTargetUpdate.Reset();
                    }
                    EasyMover.MoveResult mr = em.move();

                    moved = true;
                    if (mr != EasyMover.MoveResult.Moving)
                    {
                        moved = false;
                    }
                }

                if (!moved)
                {
                    mover.Stop();
                    Context.Log("did not move");
                    return true;
                }

            } while (!approachTimeout.IsReadySlow && (!Me.IsDead || AllowDead));
            mover.Stop();
            Context.Log("Approach timed out");
            return false;
        }



        public GLocation InFrontOf(GUnit unit, double d)
        {
            double x = unit.Location.X;
            double y = unit.Location.Y;
            double z = unit.Location.Z;
            double heading = unit.Heading;
            x += Math.Cos(heading) * d;
            y += Math.Sin(heading) * d;

            return new GLocation((float)x, (float)y, (float)z);
        }

        public GLocation InFrontOf(GLocation loc, double heading, double d)
        {
            double x = loc.X;
            double y = loc.Y;
            double z = loc.Z;

            x += Math.Cos(heading) * d;
            y += Math.Sin(heading) * d;

            return new GLocation((float)x, (float)y, (float)z);
        }


        private void DoPatrolerLearnTravelMode()
        {

            while (true)
            {
                Thread.Sleep(1000);

                GUnit target = Me.Target;

                if (target != null)
                {
                    Context.Log("Target GUID: " + target.GUID);
                }
            }
        }


        // called when we have died, return when we are alive again
        private void GhostRun()
        {
            Context.Log("I died. Let's resurrect");
            GLocation CorpseLocation = null;
            // 1. Release
            while (Me.IsDead && !Me.IsGhost)
            {
                if (CorpseLocation == null)
                    CorpseLocation = Me.Location;
                for (int n = 1; n <= 4; n++)
                {
                    if (Popup.IsVisible(n))
                    {
                        Context.Log("Found the release dialog, #" + n);
                        Popup.ClickButton(n, 1);
                    }
                }
                Thread.Sleep(1000);
            }

            if (BGMode)
            {
                GSpellTimer s = new GSpellTimer(1000 * 60); // 1 minute
                Context.Log("BGMode, waiting for res");
                while (Me.IsDead)
                {
                    Thread.Sleep(500);
                }
                Context.Log("Alive!");
            }
            else
            {

                GLocation gloc = Me.CorpseLocation;
                if (CorpseLocation != null) gloc = CorpseLocation;

                Location target = null;
                GLocation gtarget; 
                Context.Log("Corpse is at " + gloc);

                if (gloc.Z == 0)
                {
                    Context.Log("hmm, corpse Z == 0");
                    target = new Location(gloc);
                    for (int q = 0; q < 50; q += 5)
                    {
                      float stand_z = 0; 
                      int flags = 0;
                      float x = gloc.X + random.Next(20)-10;
                      float y = gloc.Y + random.Next(20)-10;
                      bool ok = world.triangleWorld.FindStandableAt(x,y,
                                                                    -5000, 
                                                                    5000,
                                                                    out stand_z, out flags, 0, 0); 
                      if(ok)
                        {
                          target = new Location(x,y,stand_z);
                          break;
                        }
                    }
                }
                else
                {
                    target = new Location(gloc);

                }
                gtarget = new GLocation(target.X, target.Y, target.Z);

                Context.Log("Corpse is at " + target);
                Context.Log(" me is at " + new Location(Me.Location));
                EasyMover em = new EasyMover(this, target, false, false);

                // 2. Run to corpse
                while (Me.IsDead && Me.GetDistanceTo(gloc) > 20)
                {
                    EasyMover.MoveResult mr = em.move();
                    if (mr != EasyMover.MoveResult.Moving) return; // buhu
                    UpdateMyPos();
                    Thread.Sleep(50);

                }
                mover.Stop();

                // 3. Find a safe place to res
                // is within 20 yds of corpse now, dialog must be up
                float SafeDistance = 25.0f;
                while (true)
                {
                    // some brute force :p
                    GMonster[] monsters = GObjectList.GetMonsters();
                    GContext.Main.Log("Look for safe spot");
                    float best_score = 1E30f;
                    float best_distance = 1E30f; 
                    Location best_loc = null;
                    for(float x = -35; x<=35; x+=5)
                    {
                        for(float y = -35; y<=35; y+=5)
                        {
                            float rx = target.X+x;
                            float ry = target.Y+y;
                            GLocation xxx = new GLocation(rx, ry, 0);
                            if(xxx.GetDistanceTo(gtarget) < 35)
                            {
                                float stand_z = 0; 
                                int flags = 0;
                                bool ok = world.triangleWorld.FindStandableAt(rx, ry, 
                                                                              target.Z - 20, 
                                                                              target.Z + 20,
                                                                              out stand_z, out flags, 0, 0); 
                                if(ok)
                                {
                                    float score = 0.0f;
                                    GLocation l = new GLocation(rx, ry, stand_z); 
                                    foreach (GMonster monster in monsters)
                                    {
                                        if(monster != null && monster.Reaction == GReaction.Hostile && !monster.IsDead && !PPather.IsStupidItem(monster))
                                        {
                                            float d = l.GetDistanceTo(monster.Location);
                                            if(d < 35)
                                            {
                                                // one point per yard 
                                                score += 35-d;
                                            }
                                        }
                                    }
                                    float this_d = Me.GetDistanceTo(l);
                                    if(score <= best_score && this_d < best_distance)
                                    {
                                        best_score = score;
                                        best_distance = this_d;
                                        best_loc = new Location(l);
                                    }
                                }
                            }                            
                        }
                    }
                    if(best_loc != null)
                    {
                        GLocation best_gloc = new GLocation(best_loc.X, best_loc.Y, best_loc.Z); 
                        GContext.Main.Log("Looks safe at " + best_gloc +" score " + best_score + " i am at " + Me.Location);
                        // walk over there
                        WalkTo(best_gloc, false, 10000, true);
                        
                        // Check if I am safe
                        bool safe = true;
                        GMonster unsafe_monster = null;
                        foreach (GMonster monster in monsters)
                        {
                            if(monster.Reaction == GReaction.Hostile && !monster.IsDead && !PPather.IsStupidItem(monster))
                            {
                                float d = Me.GetDistanceTo(monster);
                                if(d < SafeDistance)
                                    if(Math.Abs(monster.Location.Z - Me.Location.Z) < 25)
                                    {
                                        safe = false;
                                        unsafe_monster = monster;
                                    }

                            }
                        }
                        if(safe)
                        {
                            GContext.Main.Log("It was safe. resurrect");
                            break; // yeah
                        }
                        else
                        {
                            if(unsafe_monster != null)
                                GContext.Main.Log( unsafe_monster.Name + " is around there.");
                            else
                                GContext.Main.Log("unknown monster is around there.");
                        }
                    }                    

                    // hmm, look again
                    GContext.Main.Log("It was not safe, wait a little and lower standards. safe distance now is: " + SafeDistance);
                    Thread.Sleep(2000);
                    SafeDistance -= 0.5f;
                }

                // 4. Accept

                // dialog should be up now
                while (Me.IsDead)
                {
                    for (int n = 1; n <= 4; n++)
                    {
                        if (Popup.IsVisible(n))
                        {
                            Context.Log("Found the accept dialog, #" + n);
                            Popup.ClickButton(n, 1);
                        }
                    }
                    Thread.Sleep(1000);
                }
            }
        }

        public Task CreateTaskFromNode(NodeTask node, Task parent)
        {
            Task n = null; 
            // Built in Tasks
            if (node.type == "When")
            {
                n = new WhenTask(this, node);
            }
            else if (node.type == "Until")
            {
                n = new UntilTask(this, node);
            }
            else if (node.type == "Oneshot")
            {
                n = new OneshotTask(this, node);
            }
            else if (node.type == "Parallel" || node.type == "Par")
            {
                n = new ParTask(this, node);
            }
            else if (node.type == "Sequence"|| node.type == "Seq")
            {
                n = new SeqTask(this, node);
            }
            else if (node.type == "Rest")
            {
                n = new RestTask(this, node);
            }
            else if (node.type == "Defend")
            {
                n = new DefendTask(this, node);
            }
            else if (node.type == "Danger")
            {
                n = new DangerTask(this, node);
            }
            else if (node.type == "Pull")
            {
                n = new PullTask(this, node);

            }
            else if (node.type == "Loot")
            {
                n = new LootTask(this, node);
            }
            else if (node.type == "Harvest")
            {
                n = new HarvestTask(this, node);
            }
            else if (node.type == "Hotspots")
            {
                n = new HotspotTask(this, node);
            }
            else if (node.type == "Walk")
            {
                n = new WalkTask(this, node);
            }
            else if (node.type == "QuestPickup")
            {
                n = new QuestPickupTask(this, node);
            }
            else if (node.type == "QuestHandin")
            {
                n = new QuestHandinTask(this, node);
            }
            else if (node.type == "QuestGoal")
            {
                n = new QuestGoalTask(this, node);
            }
            else if (node.type == "Vendor")
            {
                n = new VendorTask(this, node);

            }
            else if (node.type == "Mail")
            {
                n = new MailTask(this, node);

            }
            else
            {
                Context.Log("Unknown task type " + node.type);
            }
            

            if(n != null)
                n.parent = parent;
            else
                Context.KillAction("PPather, script corrupt", false);
            return n;
        }

        private void MyPather()
        {
            System.IO.TextReader reader = System.IO.File.OpenText("tasks.psc");

            TaskParser.TaskParser t = new TaskParser.TaskParser(reader);
            NodeTask astRoot = t.ParseTask(null);
            reader.Close();


            RootNode root = new RootNode();
            root.AddTask(astRoot);
            root.BindSymbols(); // Just to make it a tad faster


            
            Task rootTask = CreateTaskFromNode(root, null);
            form.CreateTreeFromTasks(rootTask);
            Activity activity = null;
            GSpellTimer taskTimer = new GSpellTimer(300);
            GSpellTimer updateStatusTimer = new GSpellTimer(2000);
            GSpellTimer nothingToDoTimer = new GSpellTimer(3 * 1000);
            bool exit = false;
            GSpellTimer Tick = new GSpellTimer(100);
            do
            {
                if (RunState != WantedState)
                {
                    if (RunState == RunState_e.Running)
                    {
                        if (activity != null)
                            activity.Stop(); 
                    }
                    RunState = WantedState;
                }

                if (updateStatusTimer.IsReady)
                {
                    UpdateXP();
                    form.SetStatus(Kills, KPh, Loots, XPh, Harvests, TTL, Deaths);
                    updateStatusTimer.Reset();
                }
                if (RunState == RunState_e.Stopped)
                {
                    Context.Log("Stop wanted. Stopping glide");
                    Context.KillAction("PPather wants to stop", false);
                    Thread.Sleep(500); // pause
                }
                else if (RunState == RunState_e.Paused)
                {
                    UpdateMyPos();
                    Thread.Sleep(100); // pause
                }
                else if (RunState == RunState_e.Running)
                {
                    UpdateMyPos();
                    if (Me.IsDead)
                    {
                        Thread.Sleep(1000);
                        activity = null;
                        GhostRun();
                        Thread.Sleep(1500);
                        if (Me.IsDead)
                        {
                            //!!!
                        }
                        else 
                        {
                            Deaths++;
                            Rest(); 
                        }
                    }

                    
                    

                    if (activity == null || taskTimer.IsReady)
                    {
                        // Reevaluate what to do
                        Location l = new Location(Me.Location);
                        taskTimer.Reset();

                        Activity newActivity = null;
                        if (rootTask.WantToDoSomething())
                        {                            
                            newActivity = rootTask.GetActivity();
                        }

                        if (newActivity != activity)
                        {
                            if (activity != null)
                            {
                                // change activity before it was finished
                                activity.Stop();
                                Task tr = activity.task;
                                while (tr != null)
                                {
                                    tr.isActive = false;
                                    tr = tr.parent;
                                }
                            }
                            activity = newActivity;
                            {
                                Task tr = activity.task;
                                while (tr != null)
                                {
                                    tr.isActive = true;
                                    tr = tr.parent;
                                }
                            }

                            form.SetActivity(activity);
                            if (activity != null)
                            {
                                Context.Log("Got a new activity " + activity);
                                if (SaveTimer.IsReady)
                                {
                                    SaveAllState();
                                    SaveTimer.Reset();
                                }
                                activity.Start();
                            }
                        }
                        if (newActivity == null) activity = null;

                    }

                    if (activity == null)
                    {
                        if (nothingToDoTimer.IsReady)
                        {
                            Context.Log("Script ended. Stopping glide");
                            Context.KillAction("PPather, nothing more to do", false);
                            return;
                        }
                    }
                    else
                        nothingToDoTimer.Reset();
                    //form.SetTask(task); 

                    if (activity != null)
                    {
                        bool done = activity.Do();
                        nothingToDoTimer.Reset(); // did something
                        if (done)
                        {
                            //Context.Log("Finished activity " + activity);
                            activity.task.ActivityDone(activity);
                            Task tr = activity.task;
                            while (tr != null)
                            {
                                tr.isActive = false;
                                tr = tr.parent;
                            }
                            activity = null;
                        }
                    }

                    
                    Tick.Wait();
                    Thread.Sleep(10); // min sleep time
                    Tick.Reset();
                    RunningAction();
                }
            } while (!exit);
        }
    }


        class UnitRadar : ILocationHeuristics
        {
            class UnitData
            {
                public long guid;
                public GUnit unit;
                public GLocation oldLocation;
                public double movementSpeed;

                public UnitData(GUnit u)
                {
                    unit = u;
                    guid = u.GUID;
                    movementSpeed = 0.0;
                    oldLocation = u.Location;
                }
                public void Update(int dt)  // dt is milliseconds
                {
                    if(dt == 0) return;
                    double ds = (double)dt / 1000.0;
                    double d = oldLocation.GetDistanceTo(unit.Location);
                    movementSpeed = d/ds;
                    oldLocation = unit.Location;                     
                }
            }

            Dictionary<long, UnitData> dic = new Dictionary<long, UnitData>();
            GSpellTimer updateTimer = new GSpellTimer(0);

            public UnitRadar()
            {
            }


            public  float Score(float x, float y, float z)
            {
                GLocation l = new GLocation(x, y, z);
                GLocation me = GContext.Main.Me.Location;
                if(l.GetDistanceTo(l)> 100.0) return 0;
                float s = 0;
                foreach (UnitData ud in dic.Values)
                {
                    GUnit unit = ud.unit;
                    if (unit.Reaction == GReaction.Hostile)
                    {

                        float d = unit.Location.GetDistanceTo(l);
                        if (d < 30)
                        {
                            float n = 25-d;
                            int ld = unit.Level - GContext.Main.Me.Level; 
                            if(ld < 0)
                                n /= -ld+2;
                            s += n / 10.0f;                                                                     
                        }
                    }
                }
                //if(s>0)
                //    GContext.Main.Log("  " + l + " score " + s);
                return s;
            }
            
            public void Update()
            {
                int dt = -updateTimer.TicksLeft;
                if(dt >= 1000)
                {
                    GUnit[] units = GObjectList.GetUnits();
                    Update(units);
                }
            }

            public void Update(GUnit [] units)
            {
                int dt = -updateTimer.TicksLeft;
                foreach(GUnit u in units)
                {
                    UnitData ud;
                    if(dic.TryGetValue(u.GUID, out ud))
                    {
                        ud.Update(dt);
                    }
                    else
                    {
                        // new one
                        ud = new UnitData(u);
                        dic.Add(u.GUID, ud); 
                    }
                }
                
                List<long> rem = new List<long>();
                foreach(UnitData ud in dic.Values)
                {
                    if(!ud.unit.IsValid) rem.Add(ud.guid);
                }
                foreach (long guid in rem)
                {
                    dic.Remove(guid);
                }
                updateTimer.Reset();
            }

            public double GetSpeed(GUnit u)
            {
                UnitData ud;
                if (dic.TryGetValue(u.GUID, out ud))
                {
                    return ud.movementSpeed;
                }
                return 0.0; 
            }
        }    

    public class EasyMover
    {
        Location target;
        GPlayerSelf Me;
        GContext Context;
        PathGraph world = null;

        Mover mover;
        PPather pather;
        bool GiveUpIfStuck = false;
        bool GiveUpIfUnsafe = false;

        GSpellTimer PathTimeout = new GSpellTimer(25000); // no path can be older than this
        MoveAlonger MoveAlong;

        public enum MoveResult { Reached, Stuck, CantFindPath, Unsafe, Moving, GotThere };

        public EasyMover(PPather pather, Location target, bool GiveUpIfStuck, bool GiveUpIfUnsafe)
        {
            this.target = target;
            this.Me = GContext.Main.Me;
            this.Context = GContext.Main;
            this.world = pather.world;
            mover = PPather.mover;
            this.GiveUpIfStuck = GiveUpIfStuck;
            this.GiveUpIfUnsafe = GiveUpIfUnsafe;
            this.pather = pather;
        }
        public void SetPathTimeout(int ms)
        {
            PathTimeout = new GSpellTimer(ms); // no path can be older than this                
        }

        public void SetNewTarget(Location target)
        {
            MoveAlong = null;
            this.target = target;
        }

        public MoveResult move()
        {
            if (GiveUpIfUnsafe)
            {
                if (!pather.IsItSafeAt(Me.Target, Me.Location))
                    return MoveResult.Unsafe;
            }
            if (PathTimeout.IsReady)
            {
                MoveAlong = null;
            }
            if (MoveAlong == null)
            {
                Location from = new Location(Me.Location);
                mover.Stop();
                Path path = world.CreatePath(from, target, (float)Context.MeleeDistance);
                PathTimeout.Reset();
                if (path == null || path.Count() == 0)
                {
                    Context.Log("EasyMover: Can not create path . giving up");
                    mover.MoveRandom();
                    Thread.Sleep(500);
                    mover.Stop();
                    return MoveResult.CantFindPath;
                }
                else
                {
                    //Context.Log("Save path to " + pathfile); 
                    //path.Save(pathfile);
                    MoveAlong = new MoveAlonger(pather, path);
                }
            }

            if (MoveAlong != null)
            {
                Location from = new Location(Me.Location);

                if (MoveAlong.path.Count() == 0 || from.GetDistanceTo(target) < (float)Context.MeleeDistance)
                {
                    //Context.Log("Move along used up");
                    MoveAlong = null;
                    mover.Stop();
                    return MoveResult.GotThere;
                }
                else if (!MoveAlong.MoveAlong())
                {
                    MoveAlong = null; // got stuck!
                    if (GiveUpIfStuck) return MoveResult.Stuck;
                }
            }
            return MoveResult.Moving;
        }
    }

    public class MoveAlonger
    {
        public Path path;
        StuckDetecter sd;
        GPlayerSelf Me;
        GContext Context;
        Location prev;
        Location current;
        Location next;
        Mover mover;
        PathGraph world = null;

        public MoveAlonger(PPather pather, Path path)
        {

            this.Context = GContext.Main;
            this.Me = Context.Me;
            this.path = path;
            this.world = pather.world;
            mover = PPather.mover;
            sd = new StuckDetecter(pather, 1, 2);
            prev = null;
            current = path.GetFirst();
            next = path.GetSecond();
        }

        public bool MoveAlong()
        {
            double max = 3.0;
            GLocation loc = GContext.Main.Me.Location;
            Location isAt = new Location(loc.X, loc.Y, loc.Z);
            while (isAt.GetDistanceTo(current) < max && next != null)
            {
                //Context.Log(current + " - " + next);
                path.RemoveFirst();
                if (path.Count() == 0)
                {
                    //Context.Log("ya");
                    //return true; // good in some way
                }
                else
                {
                    prev = current;
                    current = path.GetFirst();
                    next = path.GetSecond();
                    if (current != null)
                    {

                        //Context.Log("next is " + current.GetDistanceTo(prev));
                    }
                }
            }

            {
                //Context.Log("Move towards " + current);
                GLocation gto = new GLocation((float)current.X, (float)current.Y, (float)current.Z);
                GLocation face;
                if (next != null)
                    face = new GLocation(next.X, next.Y, next.Z);
                else
                    face = gto;

                if (!mover.moveTowardsFacing(Me, gto, 0.5, face))
                {
                    Context.Log("Can't move " + current);
                    world.BlacklistStep(prev, current);
                    //world.MarkStuckAt(loc, Me.Heading);                        
                    mover.MoveRandom();
                    Thread.Sleep(500);
                    mover.Stop();
                    return false;
                    // hmm, mover does not want to move, must be up or down
                }

                {
                    double h; double speed;
                    h = mover.GetMoveHeading(out speed);
                    
                    float stand_z = 0.0f; 
                    int flags = 0;
                    float x = isAt.X + (float)Math.Cos(h) * 1.0f;  
                    float y = isAt.Y + (float)Math.Sin(h) * 1.0f; 
                    float z = isAt.Z; 
                    bool aheadOk = world.triangleWorld.FindStandableAt(x, y, 
                                                                       z - 4, 
                                                                       z + 6,
                                                                       out stand_z, out flags, 0, 0); 
                    if(!aheadOk)
                    {
                        GContext.Main.Log("Heading into a wall or off a cliff");
                        mover.Stop();
                        world.BlacklistStep(prev, current);
                        return false;
                    }
                }
                    

                if (sd.checkStuck())
                {
                    Context.Log("Stuck at " + isAt);
                    world.MarkStuckAt(isAt, (float)Me.Heading);
                    world.BlacklistStep(prev, current);
                    mover.Stop();
                    return false;
                }
            }
            return true;
        }
    }

    public class Mover
    {

        private bool runForwards = false;
        private bool runBackwards = false;
        private bool strafeLeft = false;
        private bool strafeRight = false;
        private bool rotateLeft = false;
        private bool rotateRight = false;

        private const float PI = (float)Math.PI;
        private GContext Context;

        public Mover(GContext Context)
        {
            this.Context = Context;
        }

        private GSpellTimer KeyT = new GSpellTimer(50);
        private bool old_runForwards = false;
        private bool old_runBackwards = false;
        private bool old_strafeLeft = false;
        private bool old_strafeRight = false;
        private bool old_rotateLeft = false;
        private bool old_rotateRight = false;


        void PushKeys()
        {

            if (old_runForwards != runForwards)
            {
                KeyT.Wait();
                KeyT.Reset();
                if (runForwards)
                    PressKey("Common.Forward");
                else
                    ReleaseKey("Common.Forward");
                //Context.Log("Forwards: " + runForwards);
            }
            /*

                            if(runForwards)
                            {
                                GContext.Main.StartRun(); // 
                            }
                            else
                            {
                                GContext.Main.ReleaseRun(); // 
                            }
            */
            if (old_runBackwards != runBackwards)
            {
                KeyT.Wait();
                KeyT.Reset();
                if (runBackwards)
                    PressKey("Common.Back");
                else
                    ReleaseKey("Common.Back");
                //Context.Log("Backwards: " + runBackwards);
            }
            if (old_strafeLeft != strafeLeft)
            {
                KeyT.Wait();
                KeyT.Reset();
                if (strafeLeft)
                    PressKey("Common.StrafeLeft");
                else
                    ReleaseKey("Common.StrafeLeft");
                //Context.Log("StrageLeft: " + strafeLeft);
            }
            if (old_strafeRight != strafeRight)
            {
                KeyT.Wait();
                KeyT.Reset();
                if (strafeRight)
                    PressKey("Common.StrafeRight");
                else
                    ReleaseKey("Common.StrafeRight");
                //Context.Log("StrageRight: " + strafeRight);
            }

            /*
                            if(rotateRight || rotateLeft)
                            {
                                double head = GContext.Main.Me.Heading;
                                if(rotateRight) head -= Math.PI/2;
                                else if(rotateLeft)  head += Math.PI/2;
                                GContext.Main.StartSpinTowards(head);
                            }
                            else
                            {
                                GContext.Main.ReleaseSpin();
                            }
            */

            if (old_rotateLeft != rotateLeft)
            {
                KeyT.Wait();
                KeyT.Reset();
                if (rotateLeft)
                    PressKey("Common.RotateLeft");
                else
                    ReleaseKey("Common.RotateLeft");
                //Context.Log("RotateLeft: " + rotateLeft);
            }
            if (old_rotateRight != rotateRight)
            {
                KeyT.Wait();
                KeyT.Reset();
                if (rotateRight)
                    PressKey("Common.RotateRight");
                else
                    ReleaseKey("Common.RotateRight");
                //Context.Log("RotateRight: " + rotateRight);
            }

            old_runForwards = runForwards;
            old_runBackwards = runBackwards;
            old_strafeLeft = strafeLeft;
            old_strafeRight = strafeRight;
            old_rotateLeft = rotateLeft;
            old_rotateRight = rotateRight;
        }

        void PressKey(string name)
        {
            //Context.Log("Press : " + name);
            Context.PressKey(name);
        }

        void ReleaseKey(string name)
        {
            //Context.Log("Release: " + name);
            Context.ReleaseKey(name);
        }

        void SendKey(string name)
        {
            //Context.Log("Send: " + name);
            Context.SendKey(name);
        }


        public void Jump()
        {
            SendKey("Common.Jump");
        }

        public void SwimUp(bool go)
        {
            if (go)
                PressKey("Common.Jump");
            else
                ReleaseKey("Common.Jump");
        }

        public void ResyncKeys()
        {
            KeyT.ForceReady();
            PushKeys();
        }

        public void MoveRandom()
        {
            int d = PPather.random.Next(4);
            if (d == 0) Forwards(true);
            if (d == 1) StrafeRight(true);
            if (d == 2) Backwards(true);
            if (d == 3) StrafeLeft(true);
        }

        public void StrafeLeft(bool go)
        {
            strafeLeft = go;
            if (go) strafeRight = false;
            PushKeys();
        }

        public void StrafeRight(bool go)
        {
            strafeRight = go;
            if (go) strafeLeft = false;
            PushKeys();
        }

        public void RotateLeft(bool go)
        {
            rotateLeft = go;
            if (go) rotateRight = false;
            PushKeys();
        }


        public void RotateRight(bool go)
        {
            rotateRight = go;
            if (go) rotateLeft = false;
            PushKeys();
        }


        public void Forwards(bool go)
        {
            runForwards = go;
            if (go) runBackwards = false;
            PushKeys();
        }

        public void Backwards(bool go)
        {
            runBackwards = go;
            if (go) runForwards = false;
            PushKeys();
        }

        public void StopRotate()
        {
            rotateLeft = false;
            rotateRight = false;
            PushKeys();
        }

        public void StopMove()
        {
            runForwards = false;
            runBackwards = false;
            strafeLeft = false;
            strafeRight = false;
            rotateLeft = false;
            rotateRight = false;
            SwimUp(false);
            PushKeys();
        }


        public void Stop()
        {
            StopMove();
            StopRotate();
        }

        public bool IsMoving()
        {
            return runForwards || runBackwards || strafeLeft || strafeRight;
        }


        public bool IsRotating()
        {
            return rotateLeft || rotateRight;
        }

        public bool IsRotatingLeft()
        {
            return rotateLeft;
        }
        public bool IsRotatingRight()
        {
            return rotateLeft;
        }


        /*
          1 - location is front
          2 - location is right
          3 - location is back
          4 - location is left
        */
        int GetLocationDirection(GLocation loc)
        {
            int dir = 0;
            double b = loc.Bearing;
            if (b > -PI / 4 && b <= PI / 4)  // Front
            {
                dir = 1;
            }
            if (b > -3 * PI / 4 && b <= -PI / 4) // Left
            {
                dir = 4;
            }
            if (b <= -3 * PI / 4 || b > 3 * PI / 4) //  Back   
            {
                dir = 3;
            }
            if (b > PI / 4 && b <= 3 * PI / 4) //  Right  
            {
                dir = 2;
            }
            if (dir == 0)
                Context.Log("Odd, no known direction");

            return dir;
        }

        public static double GetDistance3D(GLocation l0, GLocation l1)
        {
            double dx = l0.X - l1.X;
            double dy = l0.Y - l1.Y;
            double dz = l0.Z - l1.Z;
            return Math.Sqrt(dx * dx + dy * dy + dz * dz);
        }

        public bool moveTowardsFacing(GPlayerSelf Me, GLocation to, double distance, GLocation facing)
        {
            bool moving = false;
            double d = Me.Location.GetDistanceTo(to);
            if (d > distance)
            {
                int dir = GetLocationDirection(to);
                if (dir != 0) moving |= true;
                if (dir == 1 || dir == 3 || dir == 0) { StrafeLeft(false); StrafeRight(false); };
                if (dir == 2 || dir == 4 || dir == 0) { Forwards(false); Backwards(false); };
                if (dir == 1) Forwards(true);
                if (dir == 2) StrafeRight(true);
                if (dir == 3) Backwards(true);
                if (dir == 4) StrafeLeft(true);
                //Context.Log("Move dir: " + dir);
            }
            else
            {
                //Context.Log("Move is close");
                StrafeLeft(false);
                StrafeRight(false);
                Forwards(false);
                Backwards(false);
            }
            double bearing = Me.GetHeadingDelta(facing);
            if (bearing < -PI / 8)
            {
                moving |= true;
                RotateLeft(true);
            }
            else if (bearing > PI / 8)
            {
                moving |= true;
                RotateRight(true);
            }
            else
                StopRotate();

            return moving;
        }

    public double GetMoveHeading(out double speed)
    {
        double head = GContext.Main.Me.Heading;
        double r = 0; ;
        speed = 0.0;
        if(runForwards)  
        { 
            speed = 7.0; r = head; 
            if(strafeRight) r += PI/2;
            if(strafeLeft)  r -= PI/2;
            if(runBackwards)  speed = 0.0;
        }
        else if(runBackwards) 
        { 
            speed = 4.5; r = head + PI;  
            if(strafeRight) r -= PI/2;
            if(strafeLeft)  r += PI/2;
            if(runBackwards)  speed = 0.0;
        } 
        else if(strafeLeft)
        {
            speed = 7.0; r = head + PI*3.0/4.0;
            if(strafeRight) speed = 0;             
        }
        else if(strafeRight)
        {
            speed = 7.0; r = head + PI/4;
        }

        if(head >= 2*PI) head -= 2*PI;
        return head;
    }
    }

    public class StuckDetecter
    {
        GLocation oldLocation = null;
        float predictedDX;
        float predictedDY;

        GSpellTimer StuckTimeout = new GSpellTimer(333); // Check every 333ms
        GPlayerSelf Me;
        GContext Context;
        Mover mover;
        int stuckSensitivity;
        int abortSensitivity;
        int stuckMove = 0;
        GSpellTimer lastStuckCheck = new GSpellTimer(0);
        bool firstStuckCheck = true;
        //GLocation StuckLocation = null;

        public StuckDetecter(PPather pather, int stuckSensitivity, int abortSensitivity)
        {
            this.Me = GContext.Main.Me;
            this.Context = GContext.Main;
            this.stuckSensitivity = stuckSensitivity;
            this.abortSensitivity = abortSensitivity;
            this.mover = PPather.mover;
            firstStuckCheck = true;
        }

        public bool checkStuck()
        {
            if(firstStuckCheck)
            {
                oldLocation = GContext.Main.Me.Location;
                predictedDX = 0;
                predictedDY = 0; 
                firstStuckCheck = false;
                lastStuckCheck.Reset();
            }
            else
            {
                // update predicted location
                double h; double speed;
                h = mover.GetMoveHeading(out speed);
                    
                float dt = (float)-lastStuckCheck.TicksLeft / 1000f;
                float dx = (float)Math.Cos(h) * (float)speed * dt;  
                float dy = (float)Math.Sin(h) * (float)speed * dt; 
                //GContext.Main.Log("speed: " + speed + " dt: " + dt + " dx: " + dx + " dy : " + dy);
                predictedDX += dx;
                predictedDY += dy;

                lastStuckCheck.Reset();
                if(StuckTimeout.IsReady)
                {
                    // Check stuck
                    GLocation loc = Me.Location;
                    float realDX = loc.X - oldLocation.X;
                    float realDY = loc.Y - oldLocation.Y;
                    //GContext.Main.Log(" dx: " + predictedDX + " dy : " + predictedDY + " Real dx: " + realDX + " dy : " + realDY );

                    float predictDist = (float)Math.Sqrt(predictedDX*predictedDX + predictedDY*predictedDY);
                    float realDist = (float)Math.Sqrt(realDX*realDX + realDY*realDY);

                    //GContext.Main.Log(" pd " + predictDist + " rd " + realDist);


                    if(predictDist > realDist*2)
                    {
                        // stuck
                            Context.Log("I am stuck " + stuckMove); //. Jumping to get free");
                            if (stuckMove == 0)
                            {
                                mover.Forwards(false);
                                mover.Forwards(true);
                                mover.StrafeLeft(true);
                                //mover.Jump();
                                //mover.StrafeRight(false);
                            }
                            else if (stuckMove == 1)
                            {
                                mover.Forwards(false);
                                mover.Forwards(true);
                                mover.StrafeLeft(true);
                                //Context.Log("  strafe left"); 
                                //mover.Jump();
                                //mover.StrafeLeft(false);
                            }
                            else if (stuckMove == 2)
                            {
                                mover.Forwards(false);
                                mover.Forwards(true);
                                mover.StrafeRight(true);
                                //Context.Log("  strafe left"); 
                                //mover.StrafeLeft(true);
                            }
                            else if (stuckMove == 2)
                            {
                                mover.Forwards(false);
                                mover.Forwards(true);
                                mover.StrafeRight(true);
                                //Context.Log("  strafe left"); 
                                //mover.StrafeLeft(true);

                            }
                            stuckMove++;
                            if (stuckMove >= abortSensitivity)
                            {
                                return true;
                            }

                    }
                    else
                    {
                        stuckMove = 0;
                        
                    }
                    predictedDX = 0;
                    predictedDY = 0; 
                    oldLocation = loc;
                    StuckTimeout.Reset();
                }


            }
            return false;
        }

    }
   
}

 


        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////
        public abstract class Task
        {
            public enum State_e { Idle, Want, Active, Done }; 
            public bool isActive;

            public Task parent; 

            public virtual bool IsParserTask() { return false; }
            public virtual State_e State 
            {
                get
                {
                    if(isActive) return State_e.Active;
            if (IsFinished()) return State_e.Done;
                    return State_e.Idle;
                }
            }


            public PPather ppather;
            public Task(PPather pather)
            {
                ppather = pather;
            }

            public abstract Location GetLocation(); 

            public virtual void Restart()
            {

            }

            public virtual Task[] GetChildren()
            {
                return null;
            }

            public abstract bool WantToDoSomething();
    public abstract bool IsFinished();

            public abstract Activity GetActivity();
            public abstract bool ActivityDone(Activity task); // called when activity is done

            public virtual void GetParams(List<string> l) { }

        }

        public abstract class ParserTask : Task
        {
            public NodeTask nodetask;
            public ParserTask(PPather pather, NodeTask nodetask)
                : base(pather)
            {
                this.nodetask = nodetask;
            }
            public override bool IsParserTask() { return true; }
        }

        public class OneshotTask : ParserTask
        {
            Task childTask;
            public OneshotTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                childTask = pather.CreateTaskFromNode(node.subTasks[0], this);
            }


            public override Task[] GetChildren()
            {
                return new Task[] { childTask };
            }

            public override Location GetLocation()
            {
                return childTask.GetLocation();
            }

            public override void Restart()
            {
                childTask.Restart();
            }

    public override bool IsFinished()
            {
        return childTask.IsFinished();
            }

            public override bool WantToDoSomething()
            {
                return childTask.WantToDoSomething();
            }

            public override Activity GetActivity()
            {
                return childTask.GetActivity();
            }

            public override bool ActivityDone(Activity task)
            {
                bool childDone = childTask.ActivityDone(task);
        return childDone;
            }
            public override void GetParams(List<string> l) { }
        }

        // A task that is never done
        public class WhenTask : ParserTask
        {
            Task childTask;
            public WhenTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                childTask = pather.CreateTaskFromNode(node.subTasks[0], this);
            }

            public override void GetParams(List<string> l)
            {
                l.Add("cond");
                base.GetParams(l);
            }

    public override bool IsFinished()
            {
        return childTask.IsFinished();        
            }

            public override Location GetLocation()
            {
                return childTask.GetLocation();
            }

            public override Task[] GetChildren()
            {
                return new Task[] { childTask };
            }


            public override void Restart()
            {
                childTask.Restart(); // restart my baby
            }

            public override bool WantToDoSomething()
            {
                bool want;

                want = nodetask.GetBoolValueOfId("cond");
                if (want)
                {
                    want = childTask.WantToDoSomething();
                }

                return want;
            }

            public override Activity GetActivity()
            {
                return childTask.GetActivity();
            }

            public override bool ActivityDone(Activity task)
            {
                bool childDone = childTask.ActivityDone(task);
                if (childDone)
                {
                    // TODO hmm, my child is done... cool
                }
                return childDone;
            }


        }

        // similar to when but the cond is inverted and this one is considered done when the condition is true
        public class UntilTask : ParserTask
        {
            Task childTask;
            public UntilTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                if(node.subTasks.Count == 1)
                    childTask = pather.CreateTaskFromNode(node.subTasks[0], this);
            }


            public override void GetParams(List<string> l)
            {
                l.Add("cond");
                base.GetParams(l);
            }

            public override Location GetLocation()
            {
                if(childTask == null) return null;
                return childTask.GetLocation();
            }

            public override Task[] GetChildren()
            {
                if(childTask == null) return null;
                return new Task[] { childTask };
            }


    public override bool IsFinished()
            {
                bool done = nodetask.GetBoolValueOfId("cond");
                return done || (childTask != null && childTask.IsFinished());
            }

            public override void Restart()
            {
                childTask.Restart(); // restart my baby
            }

            public override bool WantToDoSomething()
            {

                bool done = nodetask.GetBoolValueOfId("cond");
                //GContext.Main.Log("Until  cond = " + done);
                if (done)
                    return false;

                if(childTask == null) return false;

                bool child = childTask.WantToDoSomething();
                //GContext.Main.Log("Until child is " + child);

                return  child;
            }

            public override Activity GetActivity()
            {
                if(childTask == null) return null;
                
                return childTask.GetActivity();
            }

            public override bool ActivityDone(Activity task)
            {

                // cool
                return false;
            }
        }

        public class ParTask : ParserTask
        {
            SortedList<int, List<Task>> orderedChildTasks = new SortedList<int, List<Task>>();
            bool done = false;


            public ParTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                foreach (NodeTask nt in node.subTasks)
                {
                    Task t = pather.CreateTaskFromNode(nt, this);
                    if (t != null)
                    {
                        int prio = nt.GetPrio();
                        List<Task> l;
                        if (orderedChildTasks.TryGetValue(prio, out l))
                        {
                            l.Add(t);
                        }
                        else
                        {
                            l = new List<Task>();
                            l.Add(t);
                            orderedChildTasks.Add(prio, l);
                        }
                        //GContext.Main.Log("Par add prio " + prio + " task " + t);

                    }
                }
            }


    public override bool IsFinished()
            {
                if (done) return true;
                foreach (List<Task> l in orderedChildTasks.Values)
                {
                    foreach (Task t in l)
                    {
                if (!t.IsFinished()) return false;
                    }
                }
                done = true;
                return true;
            }

            public override void GetParams(List<string> l)
            {
                base.GetParams(l);
            }


            public override Task[] GetChildren()
            {
                List<Task> ts = new List<Task>();
                foreach (int prio in orderedChildTasks.Keys)
                {
                    List<Task> l;
                    orderedChildTasks.TryGetValue(prio, out l);
                    foreach (Task t in l)
                    {
                        ts.Add(t);
                    }
                }
                return ts.ToArray();
            }


            public override void Restart()
            {
                foreach (List<Task> l in orderedChildTasks.Values)
                {
                    foreach (Task t in l)
                    {
                        t.Restart();
                    }
                }
                done = false;

            }

            private Task GetBestTask()
            {
                Location meLoc = new Location(GContext.Main.Me.Location);
                Task bestFound = null;
                float bestFoundDistance = 1E30f;
                foreach (int prio in orderedChildTasks.Keys)
                {
                    List<Task> l;
                    orderedChildTasks.TryGetValue(prio, out l);
                    foreach (Task t in l)
                    {
                //GContext.Main.Log("Consider " + t);
                // GContext.Main.Log("  f: "  + t.IsFinished() + " wtd " + t.WantToDoSomething());
                if (!t.IsFinished() && t.WantToDoSomething())
                        {
                            float d = 0;
                            Location loc = t.GetLocation();
                            if (loc != null)
                                d = loc.GetDistanceTo(meLoc);
                            if (d < bestFoundDistance)
                            {
                                bestFound = t;
                                bestFoundDistance = d;
                            }
                        }
                    }
                    if(bestFound != null)
                    {
                      return bestFound; // Found one
                    }
                }
                return bestFound;
            }

            public override Location GetLocation()
            {
                return GetBestTask().GetLocation();
            }

            public override bool WantToDoSomething()
            {
                Task bestFound = GetBestTask();
                return bestFound != null;
            }

            public override Activity GetActivity()
            {
                Task bestFound = GetBestTask();
        //GContext.Main.Log("par beast task: " + bestFound);
                if (bestFound == null) return null; // huh?
        Activity a = bestFound.GetActivity();
        //GContext.Main.Log("par beast a: " + a);
        return a;
            }

            public override bool ActivityDone(Activity task)
            {
                Task bestFound = GetBestTask();
                if (bestFound == null) return false; // huh?
                bestFound.ActivityDone(task);
                return false; // I am never done
            }
        }

        public class SeqTask : ParserTask
        {
            List<Task> sequence;
            int currentSequence = 0;
            public SeqTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                sequence = new List<Task>();
                foreach (NodeTask nt in node.subTasks)
                {
                    Task t = pather.CreateTaskFromNode(nt, this);
                    if (t != null)
                    {
                        sequence.Add(t);
                    }
                }
                currentSequence = 0;
            }

            public override void GetParams(List<string> l)
            {             
                base.GetParams(l);
            }

            public override Task[] GetChildren()
            {
                return sequence.ToArray();
            }

            private void PickChild()
            {
                if (currentSequence < sequence.Count)
                {
                    do
                    {
                        Task child = sequence[currentSequence];
                if (child.IsFinished())
                        {
                    //GContext.Main.Log("Seq " + currentSequence + " is done. " + " " + child);
                            currentSequence++;
                        }
                        else
                            return;
                    } while (currentSequence < sequence.Count);
                }
            }
            public override void Restart()
            {
                currentSequence = 0;
                foreach (Task t in sequence)
                {
                    t.Restart();
                }
            }
    public override bool IsFinished()
            {
                PickChild();
                if (currentSequence >= sequence.Count)
        {
                    return true;
        }
                return false;
            }
            public override bool WantToDoSomething()
            {
                PickChild();
                if (currentSequence >= sequence.Count) return false; // all done
                return sequence[currentSequence].WantToDoSomething();
            }

            public override Location GetLocation()
            {
                PickChild();
                return sequence[currentSequence].GetLocation();
            }

            public override Activity GetActivity()
            {
                PickChild();
                if (currentSequence >= sequence.Count) 
                {
                    GContext.Main.Log("all seqeuences done. no activity");
                    return null; // doh!
                }
                Activity a = sequence[currentSequence].GetActivity();
                //GContext.Main.Log("seq a " + currentSequence + " : " + a);
                return a;
            }

            public override bool ActivityDone(Activity task)
            {
                bool childDone = sequence[currentSequence].ActivityDone(task);

                PickChild();

                return currentSequence >= sequence.Count;
            }
        }


        public class RestTask : ParserTask
        {
            double RestHealth;
            double RestMana;
         

            public RestTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
        RestHealth = GContext.Main.RestHealth;
        RestMana = GContext.Main.RestMana;

                GContext.Main.Log("Rest  health: " + RestHealth  + " mana: " + RestMana );
            }
            public override string ToString()
            {
                return "Rest";
            }

            public override Location GetLocation()
            {
                return null; // anywhere
            }

            public override void GetParams(List<string> l)
            {
                base.GetParams(l);
            }

    public override bool IsFinished()
            {
                return false;
            }


            public override bool WantToDoSomething()
            {

                if (ppather.FindAttacker() != null) return false; // can't rest while attacked
                if(GContext.Main.Me.IsInCombat) return false; 
                bool wantRest = false;
                double hp = GContext.Main.Me.Health;
        if (hp  < RestHealth)
                {
                    wantRest = true;
                }
                if (ppather.CanDrink)
                {
                    double mana = GContext.Main.Me.Mana;
            if (mana  < RestMana)
                    {
                        wantRest = true;
                    }
                }
                // TODO: check for safety
                return wantRest;
            }

            public override Activity GetActivity()
            {
                Activity restTask = new ActivityRest(this);
 
                return restTask;
            }

            public override bool ActivityDone(Activity task)
            {
                task.Stop();
             
                return false; // never done
            }

        }

        // Fight back attackers
        public class DefendTask : ParserTask
        {
            GUnit monster = null;
            

            public DefendTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
            }

            public override Location GetLocation()
            {
                return null; // anywhere
            }

            public override void GetParams(List<string> l)
            {
                base.GetParams(l);
            }

            public override string ToString()
            {
                return "Defend";
            }

    public override bool IsFinished()
            {
                return false;
            }
            public override bool WantToDoSomething()
            {
                monster = ppather.FindAttacker();
                return monster != null;
            }

            public override Activity GetActivity()
            {
                Activity attackTask = new ActivityAttack(this, monster);
            
                return attackTask;
            }

            public override bool ActivityDone(Activity task)
            {
                task.Stop();
                
                return false; // never done
            }
        }

        // Fight back attackers
        public class DangerTask : ParserTask
        {
            GUnit monster = null;
            float DangerDistance;
          
            public DangerTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                DangerDistance = node.GetValueOfId("DangerDistance").GetFloatValue();
                if(DangerDistance == 0) DangerDistance = 20; 
            }

            public override Location GetLocation()
            {
                return null; // anywhere
            }
            public override void GetParams(List<string> l)
            {
                l.Add("DangerDistance"); 
                base.GetParams(l);
            }

            public override string ToString()
            {
                return "Danger";
            }

    public override bool IsFinished()
            {
                return false;
            }

            GUnit FindMobToPull()
            {
                // Find stuff to pull
                GUnit closest = null;
                GMonster[] monsters = GObjectList.GetMonsters();
                foreach (GMonster monster in monsters)
                {
                    if (!monster.IsDead && 
              (!monster.IsTagged || monster.IsTargetingMe || monster.IsTargetingMyPet) && 
                        !ppather.IsBlacklisted(monster) && 
                        !PPather.IsStupidItem(monster))
                    {
                        double dangerd = (double)DangerDistance + monster.Level - GContext.Main.Me.Level;
                        if (monster.Reaction == GReaction.Hostile && 
                            monster.DistanceToSelf < dangerd &&
                            Math.Abs(monster.Location.Z - GContext.Main.Me.Location.Z)< 15.0) // TODO need a setting
                        {
                            if (closest == null || monster.DistanceToSelf < closest.DistanceToSelf)
                            {
                                closest = monster;
                            }
                        }
                    }
                }
                return closest;
            }

            public override bool WantToDoSomething()
            {
                GUnit prevMonster = monster;
                monster = FindMobToPull();
                if (monster != prevMonster)
                {
                    attackTask = null;
                    
                }
                return monster != null;
            }

            private Activity attackTask = null;
            public override Activity GetActivity()
            {
                if (attackTask == null)
                    attackTask = new ActivityAttack(this, monster);
             
                return attackTask;
            }

            public override bool ActivityDone(Activity task)
            {
                task.Stop();
               
                return false;
            }
        }

        // Look for monsters and go kill them
        public class PullTask : ParserTask
        {
            GUnit monster = null;
            int MinLevel = 0;
            int MaxLevel = 1000;
            List<String> names;
            List<int> factions;
            Dictionary<string, int> killedMobs = new Dictionary<string, int>();


            public override void GetParams(List<string> l)
            {
                l.Add("Names");
                l.Add("Factions");
                l.Add("MinLevel");
                l.Add("MaxLevel");
                base.GetParams(l);
            }

            public PullTask(PPather pather, NodeTask node)
                : base(pather, node)
            {

                
                Value v_names = node.GetValueOfId("Names");
                if (v_names != null)
                {
                    names = v_names.GetStringCollectionValues();
                    if(names.Count == 0) names = null; 
 
                    
                }

                Value v_factions = node.GetValueOfId("Factions");
                if (v_factions != null)
                {
                    factions = v_factions.GetIntCollectionValues();
                    if(factions.Count == 0 ) factions = null;
                    if(factions != null) foreach (int faction in factions)
                    {
                        GContext.Main.Log("  faction '" + faction + "'");
                    }
                }
 
                MinLevel = node.GetValueOfId("MinLevel").GetIntValue();
                MaxLevel = node.GetValueOfId("MaxLevel").GetIntValue();
               
                
                if (MaxLevel == 0) MaxLevel = 10000;
                //GContext.Main.Log("  Max level " + MaxLevel);
                //GContext.Main.Log("  Min level " + MinLevel);
                    SetKillCount();
                    
            }

            private void SetKillCount()
            {
                Value v = new Value(killedMobs);
                nodetask.SetValueOfId("KillCount", v); 
            }

            public void KilledMob(String name)
            {
                // called my combat log parser
                if (IsValidTargetName(name))
                {
                    // one of mine
                 

                    int count = 0;
                    killedMobs.TryGetValue(name, out count);
                    count++;
                    killedMobs.Remove(name);
                    killedMobs.Add(name, count);

                    GContext.Main.Log("Killed " + count + " " + name); 
                    SetKillCount();
                }

            }

            public override void Restart()
            {
               // ActualKillCount = 0;
            }

            public override string ToString()
            {
                String s = "Pull ";
                if (monster != null)
                    s += monster.Name;
                return s;
            }

            public override Location GetLocation()
            {
                if (monster != null)
                    return new Location(monster.Location);
                return null;
            }

            private bool IsValidTargetName(String name)
            {
                if (names == null) return true;
                foreach (string tst_name in names)
                {
                    if (tst_name == name) return true;
                }
                return false;
            }

            private bool IsValidTarget(GUnit monster)
            {
                bool ok = true;
                if (monster.Level < MinLevel || monster.Level > MaxLevel) return false;
                if (factions != null)
                {
                    ok = false;
                    // Faction must match
                    foreach (int faction in factions)
                    {
                        if (monster.FactionID == faction) ok = true;
                    }
                }

                if (ok == false) return false;

                ok =  IsValidTargetName(monster.Name);
                if (ok == false) return false;


                return ok;
            }

            GUnit FindMobToPull()
            {
                // Find stuff to pull
                GUnit closest = null;
                GMonster[] monsters = GObjectList.GetMonsters();
                float me_z = GContext.Main.Me.Location.Z;
                foreach (GMonster monster in monsters)
                {                   
                    if (!monster.IsDead && monster.Reaction != GReaction.Friendly &&
                (!monster.IsTagged || monster.IsTargetingMe || monster.IsTargetingMyPet) && 

                        !ppather.IsBlacklisted(monster) && IsValidTarget(monster) && 
                        !PPather.IsStupidItem(monster))
                    {
                        Location ml = new Location(monster.Location);
                        float dz = (float)Math.Abs(ml.Z -  me_z);
                        if(dz < 30.0f)
                        {
                            if(ppather.world.IsUnderwaterOrInAir(ml))
                            {
                                GContext.Main.Log(monster.Name + " is underwater or flying"); 
                                ppather.Blacklist(monster);                            
                            }
                            else 
                            {
                                if (closest == null || monster.DistanceToSelf < closest.DistanceToSelf)
                                {
                                    closest = monster;
                                }
                            }
                        }
                    }
                }
                return closest;
            }

    public override bool IsFinished()
            {               
                return false;
            }

            public override bool WantToDoSomething()
            {               
                MinLevel = nodetask.GetValueOfId("MinLevel").GetIntValue();
                MaxLevel = nodetask.GetValueOfId("MaxLevel").GetIntValue();

                GUnit prevMonster = monster;
                monster = FindMobToPull();
                if (monster != prevMonster)
                {
                    if(prevMonster != null && prevMonster.IsValid && !prevMonster.IsDead)
                    {
                        GContext.Main.Log("new monster to attack. ban old one:  " + prevMonster.Name + "");                        
                        ppather.Blacklist(prevMonster.GUID, 45); // ban for 45 seconds
                    }
                    attackTask = null;
                    walkTask = null;
                }
                if(monster == null)
                {
                    attackTask = null;
                    walkTask = null;
                }
                return monster != null;
            }

            private Activity attackTask = null;
            private ActivityApproach walkTask = null;
            public override Activity GetActivity()
            {
            
                if (walkTask != null)
                {
                    // check result of walking
                    if (walkTask.MoveResult != EasyMover.MoveResult.Moving &&
                        walkTask.MoveResult != EasyMover.MoveResult.GotThere)
                    {
                        GContext.Main.Log("Can't reach " + monster.Name + ". blacklist. " + walkTask.MoveResult);
                        ppather.Blacklist(monster);
                        return null;
                    }

                }
                // check distance
                if (monster.DistanceToSelf < ppather.PullDistance)
                {
                    
                    
                    PPather.mover.Stop();
                    if (attackTask == null)
                        attackTask = new ActivityAttack(this, monster);
                    walkTask = null;
                    ppather.CurrentPullTask = this;
                    return attackTask;
                }
                else
                {
                    // walk over there
                    if (walkTask == null)
                walkTask = new ActivityApproach(this, monster, 2.0f);
                    attackTask = null;
                    return walkTask;
                }
            }

            public override bool ActivityDone(Activity task)
            {

                if (task == attackTask)
                {
                    monster = null;
                    attackTask = null;
                    walkTask = null;

                }
             
                task.Stop();
                
                return false;
            }
        }

        // Look for lootables and go loot them
        public class LootTask : ParserTask
        {
            GUnit monster = null;


            public LootTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
            }
            public override void GetParams(List<string> l)
            {
                base.GetParams(l);
            }
            public override string ToString()
            {
                String s = "Loot ";
                if (monster != null)
                    s += monster.Name;
                return s;
            }
    public override bool IsFinished()
            {
                return false;
            }

            public override Location GetLocation()
            {
                if (monster != null)
                    return new Location(monster.Location);
                return null;
            }

            private bool ShouldLoot(GUnit u)
            {
                bool looted = ppather.IsBlacklisted(u.GUID);  // hmm, blacklisted mob
                // Check for safety
                return !looted;
            }

            private void DidLoot(GUnit u)
            {
                ppather.Blacklist(u.GUID, 5 * 60);
            }

            GUnit FindMobToLoot()
            {
                // Find stuff to loot
                GUnit closest = null;
                GMonster[] monsters = GObjectList.GetMonsters();
                foreach (GMonster monster in monsters)
                {
                    if (monster.IsLootable && ShouldLoot(monster))
                    {
                        if (closest == null || monster.DistanceToSelf < closest.DistanceToSelf)
                        {
                            closest = monster;
                        }
                    }
                }
                return closest;
            }

            public override bool WantToDoSomething()
            {
                if (GObjectList.GetNearestAttacker(0) != null) return false;
              
                GUnit prevMonster = monster;
                monster = FindMobToLoot();
                if (monster != prevMonster)
                {
                    lootTask = null;
                    walkTask = null;
                }

                if (walkTask != null)
                {
                    // check result of walking
                    if (walkTask.MoveResult != EasyMover.MoveResult.Moving &&
                        walkTask.MoveResult != EasyMover.MoveResult.GotThere)
                    {
                        GContext.Main.Log("Can't reach " + monster.Name + ". blacklist. " + walkTask.MoveResult);
                        ppather.Blacklist(monster);
                        return false;
                    }
                }


                // at my pos and at target pos
                if (monster != null && !ppather.IsItSafeAt(null, monster))
                {
                    GContext.Main.Log("It is not safe at: " + monster.Name);
                    DidLoot(monster); // ignore that              
                    monster = null;
                }
                if (monster != null && !ppather.IsItSafeAt(null, GContext.Main.Me))
                {
                    monster = null;
                }

                return monster != null;
            }

            private Activity lootTask = null;
            private ActivityApproach walkTask = null;
            public override Activity GetActivity()
            {
         
                // check distance
                if (monster.DistanceToSelf < 5.0)
                {
                    if (walkTask != null)
                        walkTask.Stop();
                    if (lootTask == null)
                        lootTask = new ActivityLoot(this, monster);
                    walkTask = null;
                    return lootTask;
                }
                else
                {
                    // walk over there
                    if (walkTask == null)
                        walkTask = new ActivityApproach(this, monster, 2f);
                    lootTask = null;
                    return walkTask;
                }
            }

            public override bool ActivityDone(Activity task)
            {
                if (task == lootTask)
                {
                    DidLoot(monster);
                    monster = null;
                }
           
                task.Stop();
                return false; // never done
            }

        }

      
        public class VendorTask : NPCInteractTask
        {
            public VendorTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                NPC=GetRepairNPC();
                if(GetLocationOfNPC() == null)
                    GContext.Main.Log("*** NPC " + NPC + " is unknown"); 
                NPC=GetSellNPC();
                if(GetLocationOfNPC() == null)
                    GContext.Main.Log("*** NPC " + NPC + " is unknown"); 
            }

            private int GetCooldown()
            {
                return 60 * 3; // 3 minutes
            }

            public override void GetParams(List<string> l)
            {
                l.Add("RepairNPC");
                l.Add("SellNPC");
                l.Add("MinDurability");
                l.Add("MinFreeBagSlots");
                l.Add("SellGrey"); l.Add("SellGray");
                l.Add("SellWhite"); l.Add("SellGreen");
                l.Add("Protected"); 
                base.GetParams(l);
            }

            private string GetRepairNPC()
            {
                Value v = nodetask.GetValueOfId("RepairNPC");
                if (v == null) return null;
                return v.GetStringValue();
            }

            private string GetSellNPC()
            {
                Value v = nodetask.GetValueOfId("SellNPC");
                if (v == null) return null;
                return v.GetStringValue();
            }

            private float GetMinDurabillity()
            {
                Value v = nodetask.GetValueOfId("MinDurability");
                if (v == null) return -1.0f;
                return v.GetFloatValue();
            }

            private float GetDurabillity()
            {
                return nodetask.GetFloatValueOfId("MyDurability");
            }

            private int GetMinFreeBagslots()
            {
                Value v = nodetask.GetValueOfId("MinFreeBagSlots");
                if (v == null) return -1;
                return v.GetIntValue(); 
            }

            private float GetFreeBagslots()
            {
                return nodetask.GetIntValueOfId("FreeBagSlots");
            }

            private List<string> GetProtectedItems()
            {
                Value v = nodetask.GetValueOfId("Protected");
                if(v == null) return null;
                List<string> prot = v.GetStringCollectionValues();
                for (int i = 0; i < prot.Count; i++)
                    prot[i] = prot[i].ToLower(); 
                return prot; 
            }

            private bool GetSellGrey()
            {
                return nodetask.GetBoolValueOfId("SellGrey") || nodetask.GetBoolValueOfId("SellGray"); 
            }

            private bool GetSellWhite()
            {
                return nodetask.GetBoolValueOfId("SellWhite");
            }

            private bool GetSellGreen()
            {
                return nodetask.GetBoolValueOfId("SellGreen");
            }

    public override bool IsFinished()
            {
                return false;
            }

            private bool wantSell = false;
            private bool wantRepair = false;

            private void UpdateWants()
            {
                //GContext.Main.Log(" sell ?: " + GetFreeBagslots() + " <= " + GetMinFreeBagslots()); 
                //GContext.Main.Log(" rapair ?: " + GetDurabillity() + " <= " + GetMinDurabillity()); 
                // Check repair
                wantRepair = false;
                NPC = GetRepairNPC();
                //GContext.Main.Log("Repair NPC: " + NPC);
                if (NPC != null && !ppather.IsBlacklisted(NPC))
                {
                    Location l = GetLocationOfNPC();
                    //GContext.Main.Log("Repair NPC loc: " + l);
                    //GContext.Main.Log("My dur: " + GetDurabillity());
                    //GContext.Main.Log("min dur: " + GetMinDurabillity());

                    if (l == null)
                    {
                    }
                    else if ((GetDurabillity() <= GetMinDurabillity()) ||
                             l.GetDistanceTo(new Location(GContext.Main.Me.Location)) < 50.0)
                    {
                      //GContext.Main.Log("  Need repair: " + GetDurabillity() + " <=  "+ GetMinDurabillity());
                        wantRepair = true;
                    }
                }


                // Check sell
                wantSell = false;
                NPC = GetSellNPC();
                if (NPC != null && !ppather.IsBlacklisted(NPC))
                {
                    Location l = GetLocationOfNPC();
                    if (l == null)
                    {
                        //GContext.Main.Log("want to  sell. dont know where vendor " + NPC + " is");
                    }
                    else if (GetFreeBagslots() <= GetMinFreeBagslots()   ||
                             l.GetDistanceTo(new Location(GContext.Main.Me.Location)) < 50.0)
                    {
                      //GContext.Main.Log(" Need sell : " + GetFreeBagslots() + " <= " + GetMinFreeBagslots()); 

                        wantSell = true;
                    }
                }
            
            }

            public override Location GetLocation()
            {
                Location loc = null;
                UpdateWants();
                if (wantSell)   { NPC = GetSellNPC(); loc = GetLocationOfNPC(); }
                if (wantRepair) { NPC = GetRepairNPC(); loc = GetLocationOfNPC(); }
                return loc;
            }

            public override bool WantToDoSomething()
            {
                UpdateWants();
                if (wantSell || wantRepair) return true;
                return false;
            }

            ActivitySellAndRepair sellActivity;
            public override Activity GetActivity()
            {
               
                // GContext.Main.Log("Pickup::GetActivity()");
                if (!IsCloseToNPC())
                {
                    return GetWalkToActivity();
                }
                else
                {
                    if (sellActivity == null)
                    {
                        sellActivity = new ActivitySellAndRepair(this, FindNPC(), 
                            GetSellGrey(), GetSellWhite(), GetSellGreen(), GetProtectedItems());
                    }
                    return sellActivity;
                }

            }

            public override bool ActivityDone(Activity task)
            {
                if (task == sellActivity)
                {
                    ppather.Blacklist(GetSellNPC(), 15*60);
                    ppather.Blacklist(GetRepairNPC(), 15 * 60); 
                    return true;
                }
                return false;
            }

        }

        public class MailTask : ParserTask
        {
            public MailTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
            }

            public override Location GetLocation()
            {
              return null;
            }


    public override bool IsFinished()
            {
                return false;
            }

            public override bool WantToDoSomething()
            {
              return false;
            }


            public override Activity GetActivity()
            {
              return null;
            }
            public override bool ActivityDone(Activity task)
            {
              return true;
            }
        }

        // Look for harvestable items and go use them
        public class HarvestTask : ParserTask
        {
            GNode node = null;

            List<String> names;
            bool HarvestFlower = false;
            bool HarvestMineral = false;
            bool HarvestTreasure = false;

    int times = 0;
    int harvest_times = 0; 

            public override void GetParams(List<string> l)
            {
                l.Add("Names");
                l.Add("Types");
        l.Add("Times");
               
                base.GetParams(l);
            }
            public HarvestTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                Value v_names = node.GetValueOfId("Names");

                if (v_names != null)
                {
                    names = v_names.GetStringCollectionValues();
                }


                Value v_types = node.GetValueOfId("Types");

                List<Value> types_list = v_types.GetCollectionValue();
                foreach (Value v in types_list)
                {
                    string s = v.GetStringValue();
                    if (s == "Herb" || s == "Flower")
                    {
                        HarvestFlower = true;
                        GContext.Main.Log("Want to harvest flowers");
                        
                    }
                    if (s == "Mine" || s == "Mineral")
                    {
                        HarvestMineral = true;
                        GContext.Main.Log("Want to harvest minerals");
                    }
                    if (s == "Chest" || s == "Treasure")
                    {
                        HarvestTreasure = true;
                        GContext.Main.Log("Want to harvest chests");
                    }
                }
        times = node.GetValueOfId("Times").GetIntValue();
            }
         

            public override string ToString()
            {
                String s = "Harvest ";
                if (node != null)
                    s += node.Name;
                return s;
            }

    public override bool IsFinished()
            {
        if(times <= 0) return false;
        return harvest_times >= times;
            }
            public override Location GetLocation()
            {
                if (node != null)
                    return new Location(node.Location);
                return null;
            }

            private bool ShouldHarvest(GNode u)
            {
                if (u.IsMineral && HarvestMineral ||
                    u.IsFlower && HarvestFlower ||
                    u.IsTreasure && HarvestTreasure ||
                    names != null && names.Contains(u.Name))
                {
                    return !ppather.IsBlacklisted(u.GUID);
                }
                return false;
            }

            private void DidHarvest(GNode u)
            {
                ppather.Blacklist(u.GUID, 15 * 60); // 15 minutes
        harvest_times ++;
            }

            GNode FindItemToHarvest()
            {
                // Find stuff to loot
                GNode closest = null;
                GNode[] nodes = GObjectList.GetNodes();
                foreach (GNode node in nodes)
                {
                    if (ShouldHarvest(node))
                    {
                        if (closest == null || node.DistanceToSelf < closest.DistanceToSelf)
                        {
                            closest = node;
                        }
                    }
                }
                return closest;
            }

            public override bool WantToDoSomething()
            {
                GNode prevNode = node;
                node = FindItemToHarvest();
                if(prevNode != null && node == null)
                {
                    // hmmm, lost a node
                    GContext.Main.Log("Lost " + prevNode.Name + ". blacklist");
                    
                    ppather.Blacklist(prevNode.GUID, 60); // ban for 1 mins
                }

                if (node != prevNode || prevNode == null || node == null)
                {
                    // new target
                    lootTask = null;
                    walkTask = null;
                }
                if (walkTask != null)
                {
                    // check result of walking
                    if (walkTask.MoveResult != EasyMover.MoveResult.Moving &&
                        walkTask.MoveResult != EasyMover.MoveResult.GotThere)
                    {
                        GContext.Main.Log("Can't reach " + node.Name + ". blacklist. " + walkTask.MoveResult);
                        ppather.Blacklist(node.GUID, 60 * 10);
                        return false;
                    }
                }

                // at my pos and at target pos
                if (node != null && !ppather.IsItSafeAt(null, node.Location))
                {
                    GContext.Main.Log("Unsafe at " + node.Name + ".");
                    ppather.Blacklist(node.GUID, 60 * 10); // 10 mins
                    node = null;
                }
                if (node != null && !ppather.IsItSafeAt(null, GContext.Main.Me))
                {
                    node = null;
                }
                return node != null;
            }

            private Activity lootTask = null;
            private ActivityWalkTo walkTask = null;
            public override Activity GetActivity()
            {
                // check distance
                if (node.DistanceToSelf < 5.0)
                {
                    if (walkTask != null)
                        walkTask.Stop();
                    if (lootTask == null)
                        lootTask = new ActivityPickup(this, node);
                    walkTask = null;
                    return lootTask;
                }
                else
                {
                    // walk over there
                    if (walkTask == null)
                    {
                        walkTask = new ActivityWalkTo(this, new Location(node.Location), 2f);
                        GContext.Main.Log("new walk task to node " + node.Name);
                    }

                    else
                    {
                        // check status of mover
                    }
                    lootTask = null;
                    return walkTask;
                }
            }

            public override bool ActivityDone(Activity task)
            {
                if (task == lootTask)
                {
                    DidHarvest(node);
                    node = null;
                }
            
                task.Stop();
                return false;
            } 
        }

        public abstract class NPCInteractTask : ParserTask
        {
            public string NPC; 
            GUnit npcUnit;         

            public NPCInteractTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                NPC = node.GetValueOfId("NPC").GetStringValue(); 
            }


            public override void GetParams(List<string> l)
            {
                l.Add("NPC");
                base.GetParams(l);
            }

            public GUnit FindNPC()
            {
                if (npcUnit == null || !npcUnit.IsValid)
                    npcUnit = GObjectList.FindUnit(NPC);
                return npcUnit;
            }


            public override Location GetLocation()
            {
                Location loc = GetLocationOfNPC();                
                return loc;
            }

            public bool KnowNPCLocation()
            {
                return GetLocationOfNPC() != null; 
            }
            public bool CanSeeNPC()
            {
               
                return FindNPC() != null;
            }

            public bool IsCloseToNPC()
            {
                GUnit npc = FindNPC();
                if(npc == null) return false;
                Location mel = new Location(GContext.Main.Me.Location);
                Location npcl = new Location(npc.Location);

                float d = mel.GetDistanceTo(npcl);
        if (d < GContext.Main.MeleeDistance && Math.Abs(mel.Z - npcl.Z) < 2.0) return true;
                return false;
            }

            public Location GetLocationOfNPC()
            {
                GUnit npc = FindNPC();
                if(npc == null)
                    return ppather.FindNPCLocation(NPC); ;
                Location l  = new Location(npc.Location);
                return l;
            }

            protected ActivityApproach approachTask;
            protected ActivityWalkTo walkToTask;

            string prevNPC = ""; 
            public Activity GetWalkToActivity()
            {

                GUnit npc = FindNPC();
                if(npc == null)
                {
                    Location  l = GetLocationOfNPC();
                    if (l == null)
                        return null; 
                    if(walkToTask == null || NPC != prevNPC)
                        walkToTask = new ActivityWalkTo(this, l, 2f);
                    prevNPC = NPC; 
                    return walkToTask; 

                }
                else
                {
                    if (approachTask == null || NPC != prevNPC)
                        approachTask = new ActivityApproach(this, npc, 2f);
                    prevNPC = NPC; 
                    return approachTask; 
                }
                                               
            }
        }


        public class QuestPickupTask : NPCInteractTask
        {
            String Name;
            String ID;


            public QuestPickupTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                Name = node.GetValueOfId("Name").GetStringValue(); 
                ID = node.GetValueOfId("ID").GetStringValue(); 
                if(ID == null || ID == "") ID = Name;
            }

    public override string ToString()
    {
        return "Pickup " + Name + " " + ID;
    }

            public override void GetParams(List<string> l)
            {
                l.Add("Name");
                l.Add("ID");
                base.GetParams(l);
            }
            
    public override bool IsFinished()
            {
                if(ppather.IsQuestDone(ID)) return true;
                if(ppather.IsQuestAccepted(ID)) return true;
                return false; 
            }

            public override bool WantToDoSomething()
            {
        if (IsFinished()) return false;
                if (!KnowNPCLocation()) return false;
                return true;
            }

            ActivityPickupQuest gossipActivity;
            public override Activity GetActivity()
            {

               // GContext.Main.Log("Pickup::GetActivity()");
                if (!IsCloseToNPC())
                {
                    return GetWalkToActivity();
                }
                else
                {
                    if (gossipActivity == null)
                        gossipActivity = new ActivityPickupQuest(this, FindNPC(), Name, ID);
                    return gossipActivity; 
                }
          
            }

            public override bool ActivityDone(Activity task)
            {
                if(task == approachTask)
                {
                    ActivityApproach wt = (ActivityApproach)task;
                    EasyMover.MoveResult mr = wt.MoveResult;
                    if(mr != EasyMover.MoveResult.GotThere)
                    {
                        GContext.Main.Log("Can't reach guy that hands out quest. Quest failed"); 
                        ppather.QuestFailed(ID);
                    }
                        
                }

                if(task == walkToTask)
                {
                    ActivityWalkTo wt = (ActivityWalkTo)task;
                    EasyMover.MoveResult mr = wt.MoveResult;
                    if(mr != EasyMover.MoveResult.GotThere)
                    {
                        GContext.Main.Log("Can't reach guy that hands out quest. Quest failed"); 
                        ppather.QuestFailed(ID);
                    }                        
                }

                if (task == gossipActivity)
                {
                    // The gossip is done
                    return true;
                }              
                return false;
            }
        }

        public class QuestGoalTask : ParserTask
        {

            String Name;
            String ID;
            Task childTask;

            public QuestGoalTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                Name = node.GetValueOfId("Name").GetStringValue();
                ID   = node.GetValueOfId("ID").GetStringValue();
                if(ID == null || ID == "") ID = Name;
                childTask = pather.CreateTaskFromNode(node.subTasks[0], this);
            }


            public override void GetParams(List<string> l) { 
                l.Add("Name");
                l.Add("ID");
            }

            public override string ToString()
            {
                return "Goal " + Name + " " + ID;
            }

            public override Task[] GetChildren()
            {
                return new Task[] { childTask };
            }

            public override Location GetLocation()
            {
                return childTask.GetLocation();
            }

            public override void Restart() // doh!
            {
                childTask.Restart();
            }

            public override bool IsFinished()
            {
                if (ppather.IsQuestDone(ID)) return true;                
                return childTask.IsFinished();
            }

            public override bool WantToDoSomething()
            {
                if (ppather.IsQuestDone(ID)) return false;
                if (!ppather.IsQuestAccepted(ID)) return false; 
                return childTask.WantToDoSomething();
            }
            public override Activity GetActivity()
            {
                return childTask.GetActivity();
            }

            public override bool ActivityDone(Activity task)
            {
                bool childDone = childTask.ActivityDone(task);
                return childDone;
            }

            
        }

        public class QuestHandinTask : NPCInteractTask
        {

            String Name;
            String ID;
            int Reward;

            public QuestHandinTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                Name   = node.GetValueOfId("Name").GetStringValue(); 
                ID = node.GetValueOfId("ID").GetStringValue(); 
                if(ID == null || ID == "") ID = Name;

                Reward = node.GetValueOfId("Reward").GetIntValue(); 
                if(Reward == 0) Reward = 1;
            }

    public override string ToString()
    {
        return "Handin " + Name + " " + ID;
    }

            public override void GetParams(List<string> l)
            {
                l.Add("Name");
                l.Add("ID");
                l.Add("Reward");
                base.GetParams(l);
            }
    public override bool IsFinished()
            {
                if (ppather.IsQuestDone(ID)) return true;
                return false; 
            }

            public override bool WantToDoSomething()
            {
                if (ppather.IsQuestDone(ID)) return false;
                if (!ppather.IsQuestAccepted(ID)) return false;
                if (!KnowNPCLocation()) return false;

                return true;
            }

            ActivityHandinQuest gossipActivity;
            public override Activity GetActivity()
            {
                if (!IsCloseToNPC())
                {
                    return GetWalkToActivity();
                }
                else
                {
                    if (gossipActivity == null)
                        gossipActivity = new ActivityHandinQuest(this, FindNPC(), Name, ID, Reward);
                    return gossipActivity; 
                }
          
            }

            public override bool ActivityDone(Activity task)
            {
                if (task == gossipActivity)
                {
                    return true;
                }
                
                return false;
            }
        }

        public abstract class RunnerTask : ParserTask
        {
            public List<Location> Locations;
            Location currentHotSpot = null;
            ActivityWalkTo currentWalker = null;


            public override void GetParams(List<string> l)
            {
                l.Add("Locations");
                base.GetParams(l);
            }
            public RunnerTask(PPather pather, NodeTask node)
                : base(pather, node)
            {
                Locations = new List<Location>();

                Value hs = node.GetValueOfId("Locations");
                
                List<Value> hs_list = hs.GetCollectionValue();
                
                foreach(Value v in hs_list)
                {
                    Location l = v.GetLocationValue();
                    Locations.Add(l); 
                }
            }
            
            public abstract Location GetNextLocation(); 


            public override Location GetLocation()
            {
                if (currentHotSpot == null)
        {
                    currentHotSpot = GetNextLocation();
            GContext.Main.Log("GetLoc need next . got " + currentHotSpot );
        }
                return currentHotSpot;
            }

            public override bool WantToDoSomething()
            {
                if(GetLocation() == null) return false;
                return true; // always want to run
            }

            public override Activity GetActivity()
            {
       
                if (currentHotSpot == null)
        {
            GContext.Main.Log("GetAct need next");
                    currentHotSpot = GetNextLocation();
        }
                if (currentWalker == null)
                    currentWalker = new ActivityWalkTo(this, currentHotSpot, 10.0f);
                return currentWalker;
            }

            public override bool ActivityDone(Activity task)
            {
              
            GContext.Main.Log("ActDone need next");
                currentHotSpot = GetNextLocation();
                currentWalker = null;
                task.Stop();
                return false;
            }

        }

        // Run along hotspots
        public class HotspotTask : RunnerTask
        {
            int currentHotSpotIndex = 0;
            String order;
    
            public HotspotTask(PPather pather, NodeTask node)
                : base(pather, node)
            {

            
                Value or = node.GetValueOfId("Order");
                order = or.GetStringValue();

            }

            public override void GetParams(List<string> l)
            {
                l.Add("Order");
                base.GetParams(l);
            }

    public override bool IsFinished()
            {
                return false;
            }

            public override string ToString()
            {
                return "Go to hotspot";
            }

            public override Location GetNextLocation()
            {
                if(order == "Order" || order == "order")
                {
                    currentHotSpotIndex++;
                    if (currentHotSpotIndex >= Locations.Count)
                        currentHotSpotIndex = 0;
                }
                else
                {
                    currentHotSpotIndex = PPather.random.Next(Locations.Count); 
                }
                return Locations[currentHotSpotIndex]; 
            }
        }

        public class WalkTask : RunnerTask
        {
    int currentHotSpotIndex = -1;

            public WalkTask(PPather pather, NodeTask node)
                : base(pather, node)
            {            
            }

            public override void GetParams(List<string> l)
            {
             
                base.GetParams(l);
            }
            public override void Restart()
            {
                currentHotSpotIndex = 0;
            }

    public override bool IsFinished()
            {
                return currentHotSpotIndex >= Locations.Count;
            }

            public override string ToString()
            {
                return "Go to";
            }

            public override Location GetNextLocation()
            {
        GContext.Main.Log("Walk " + currentHotSpotIndex + " " + Locations.Count);
                currentHotSpotIndex++;
        if (currentHotSpotIndex >= Locations.Count) return null;
        Location l =  Locations[currentHotSpotIndex];
        return l;
            }
        }


      

        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////

        /*
            Basic Activities

              # Hearth
                Logout
                Stop glide
              # Rest (hand over control to CC)
              # Move to pos L to distance D
              # Approach unit U to distance D
              # Attack monster U (hand over control to CC)
              # Pickup item I (no movement)
              # Loot monster U (no movement)
                Vendor/repair/restock at vendor U (no movement) 
                Release corpse
                Go to corpse and resurrect
                Die

                U - Unit
                L - Location 
                I - Item
                D - distance
         */
        public abstract class Activity
        {
            public string name;
            public PPather ppather;
            public Task task; // Who produced me

            public Activity(Task task, String name)
            {
                this.name = name;
                this.task = task;
                ppather = task.ppather;
            }

            public override string ToString()
            {
                return name;
            }
            public abstract Location GetLocation(); // return the target location for this task
            public virtual void Start() { } // Task selected for execution
            public abstract bool Do();    // Called periodically when this task is activated, return true if task is done
            public virtual void Stop() { }  // 
        }

        public class ActivityHearth : Activity
        {
            public ActivityHearth(Task t)
                : base(t, "Hearth")
            {
            }
            public override Location GetLocation()
            {
                return null;
            }


            public override bool Do()
            {
                GContext.Main.CastSpell("Common.Hearth");
                return true; // !?!?
            }

        }


        public class ActivityRest : Activity
        {
            public ActivityRest(Task t)
                : base(t, "Rest")
            {
            }
            public override Location GetLocation()
            {
                return null;
            }


            public override bool Do()
            {
                ppather.Rest();
                return true; // !?!?
            }

        }


        public class ActivityAttack : Activity
        {
            GUnit monster;
            public ActivityAttack(Task t, GUnit monster)
                : base(t, "Attack " + monster.Name)
            {
                this.monster = monster;
            }

            public override Location GetLocation()
            {
                return new Location(monster.Location);
            }

            public override bool Do()
            {

                GPlayerSelf Me = GContext.Main.Me;

                ppather.Face(monster);

                if (monster.SetAsTarget(false))
                {
            GUnit target = monster;
            GCombatResult res; 
            do
            {
                ppather.UnBlacklist(target);
                ppather.TargetIs(target);
                target.TouchHealthDrop();
                    ppather.StartCombat();
                res = ppather.KillTarget(target, Me.IsInCombat);
                    if (res == GCombatResult.Bugged || res == GCombatResult.OtherPlayerTag)
                    ppather.Blacklist(target);
                    if (res == GCombatResult.Died)
                    {
                        return true; // sigh
                    }
                    if (res == GCombatResult.Success ||
                       res == GCombatResult.SuccessWithAdd)
                    {
                    ppather.Killed(target);
                    }
                
                if(res == GCombatResult.SuccessWithAdd)
                    {
                    target = Me.Target;
                    }
                else
                {
                    target.Refresh(true);
                    Thread.Sleep(100);

                    // wait for combat flag to expire unless we have attackers
                    {
                        GSpellTimer t = new GSpellTimer(2000);
                        while (Me.IsInCombat && GObjectList.GetNearestAttacker(0) == null && !t.IsReadySlow) ;
                        GContext.Main.Log("t: " + (2000 - t.TicksLeft));
                    }
                    if(ppather.IsItSafeAt(null, GContext.Main.Me) && !Me.IsInCombat)
                    {
                      ppather.Rest();
                    }
                }
            } while(res == GCombatResult.SuccessWithAdd && target != null);
        }
                else
                {
                    GContext.Main.Log("Can not target monster " + monster.Name);
                    ppather.Blacklist(monster);
                }

                return true; // !?!?
            }

        }


        public class ActivityLoot : Activity
        {
            GUnit monster;
            public ActivityLoot(Task t, GUnit monster)
                : base(t, "Loot " + monster.Name)
            {
                this.monster = monster;
            }

            public override Location GetLocation()
            {
                return null; // I will not move
            }

            public override bool Do()
            {
        ppather.Face(monster);
                monster.Interact();
                bool clicked = false;
                GSpellTimer bop = new GSpellTimer(500);
                do
                {
                    for (int i = 1; i <= 4; i++)
                    {
                        if (PPather.Popup.IsVisible(i))
                        {
                            GContext.Main.Log("Got a loot dialog(" + i + "). Click first button");
                            PPather.Popup.ClickButton(i, 1);
                            clicked = true;
                        }
                    }
                } while (!bop.IsReadySlow && !clicked);
                Thread.Sleep(500);
                ppather.Looted(monster);

                return true;
            }
        }


/*
  hmm dialog navigation: 
   
    If there are many options you will get either a
        GossipFrame or a QuestFrame.IsSelect
 
    After that was selected you want to get a
       QuestFrame.IsAccept

 */

        public class ActivityPickupQuest : Activity
        { 
            GUnit unit;
            String QuestName;
            String QuestID;

            public ActivityPickupQuest(Task t, GUnit unit, String QuestName, String QuestID)
                : base(t, "PickupQuest " + QuestName)
            {
                this.unit = unit;
                this.QuestName = QuestName;
                this.QuestID = QuestID;
            }

            public override Location GetLocation()
            {
                return null; // I will not move
            }
            public override bool Do()
            {
                ppather.Face(unit);
                int option = 0; 
                while(true)
                {
                    bool got_option = false;
                    if(ppather.IsQuestAccepted(QuestID)) return true; // weee

            ppather.Face(unit);
                    unit.Interact();
                    Thread.Sleep(2000);
                    if (PPather.GossipFrame.IsVisible())
                    {
                        GContext.Main.Log("Got a gossip frame");
                        got_option = true;
                        int[] options = PPather.GossipFrame.VisibleOptions();
                        if(option >= options.Length) 
                        {
                            GContext.Main.Log("Can not find the quest option in the gossip frame");
                            ppather.QuestFailed(QuestID);
                            return true; // cry
                        }
                        PPather.GossipFrame.ClickOption(options[option]);
                        option++; 
                        Thread.Sleep(1000);
                    }

                    if (PPather.QuestFrame.IsVisible() && PPather.QuestFrame.IsSelect())
                    {
                        GContext.Main.Log("Got a quest select frame");
                        got_option = true;
                        int[] options = PPather.QuestFrame.VisibleOptions();
                        if(option >= options.Length) 
                        {
                            GContext.Main.Log("Can not find the quest option in the quest select frame");
                            ppather.QuestFailed(QuestID);
                                return true; // cry
                        }
                        PPather.QuestFrame.ClickOption(options[option]);
                        option++; 
                        Thread.Sleep(1000);
                        
                    }
                    if (PPather.QuestFrame.IsVisible() && PPather.QuestFrame.IsAccept())
                    {                        
                        GContext.Main.Log("Great! An accept frame");
                        string quest = PPather.QuestFrame.GetAcceptTitle(); 
                        if (quest.Contains(QuestName))
                        {
                            GContext.Main.Log("Names matched on quest pickup " + quest);
                            ppather.QuestAccepted(QuestID);
                            PPather.QuestFrame.Accept();
                            Thread.Sleep(3000);
                            return true;
                        }
                        else
                        {
                            GContext.Main.Log("Wrong quest");
                            GContext.Main.SendKey("Common.Escape");
                            Thread.Sleep(1000);
                            if(!got_option)
                            {
                                ppather.QuestFailed(QuestID);
                                return true; // cry                        
                            }                            
                        }
                    }
                    else
                    {
                        GContext.Main.Log("hmm, what strange frame was that?!");
                        GContext.Main.SendKey("Common.Escape");
                        Thread.Sleep(1000);
                        if(!got_option)
                        {
                            ppather.QuestFailed(QuestID);
                            return true; // cry                        
                        }
                    }
                }
            }    
        }


        public class ActivityHandinQuest : Activity
        {
            GUnit unit;
            String QuestName;
            String QuestID;
            int Reward;

            public ActivityHandinQuest(Task t, GUnit unit, String QuestName, String QuestID, int Reward)
                : base(t, "HandinQuest " + QuestName)
            {
                this.unit = unit;
                this.QuestName = QuestName;
                this.QuestID = QuestID;
                this.Reward = Reward;
            }

            public override Location GetLocation()
            {
                return null; // I will not move
            }


/*
  hmm dialog navigation: 
   
    If there are many options you will get either a
        GossipFrame or a QuestFrame.IsSelect
 
    After that was selected you want to get a
       QuestFrame.IsContinue followed by a
       QuestFrame.IsComplete
    or 
       QuestFrame.IsComplete

 */

            public override bool Do()
            { 
                ppather.Face(unit);
                int option = 0; 
                while(true)
                {
                    if(ppather.IsQuestDone(QuestID)) return true; // weee
                    
                    bool got_option = false;
                    unit.Interact();
                    Thread.Sleep(2000);
                    if (PPather.GossipFrame.IsVisible())
                    {
                        GContext.Main.Log("Got a gossip frame");
                        got_option = true;

                        int[] options = PPather.GossipFrame.VisibleOptions();
                        if(option >= options.Length) 
                        {
                            GContext.Main.Log("Can not find the quest option in the gossip frame");
                            ppather.QuestFailed(QuestID);
                            return true; // cry
                        }
                        PPather.GossipFrame.ClickOption(options[option]);
                        option++; 
                        Thread.Sleep(1000);
                    }

                    if (PPather.QuestFrame.IsVisible())
                    {
                        if(PPather.QuestFrame.IsSelect())
                        {
                            got_option = true;
                            GContext.Main.Log("Got a quest select frame");
                            int[] options = PPather.QuestFrame.VisibleOptions();
                            if(option >= options.Length) 
                            {
                                GContext.Main.Log("Can not find the quest option in the quest select frame");
                                ppather.QuestFailed(QuestID);
                                return true; // cry
                            }
                            PPather.QuestFrame.ClickOption(options[option]);
                            option++; 
                            Thread.Sleep(1000);                            
                        }
                    }                    

                    if (PPather.QuestFrame.IsVisible() && PPather.QuestFrame.IsContinue())
                    {
                        GContext.Main.Log("Hmm, its a continue frame");
                        PPather.QuestFrame.Continue();
                        Thread.Sleep(1000); 
                    }
                    
                    if(PPather.QuestFrame.IsVisible() && PPather.QuestFrame.IsComplete())
                    {
                        GContext.Main.Log("Great! A quest complete frame");
                        string quest = PPather.QuestFrame.GetCompleteTitle(); 
                        if (quest.Contains(QuestName))
                        {
                            GContext.Main.Log("Complete quest name match for " + quest);
                            PPather.QuestFrame.SelectReward(Reward);
                            Thread.Sleep(300); 
                            PPather.QuestFrame.Complete();
                            ppather.QuestCompleted(QuestID);
                            Thread.Sleep(3000);
                            return true;
                        }
                        else
                        {
                            GContext.Main.Log("Not the right quest");
                            GContext.Main.SendKey("Common.Escape");
                            Thread.Sleep(1000);
                            if (!got_option)
                            {
                                ppather.QuestFailed(QuestID);
                                return true; // cry                        
                            }
                        }
                    }
                    else
                    {
                        GContext.Main.Log("hmm, what strange frame was that?!");
                        GContext.Main.SendKey("Common.Escape");
                        Thread.Sleep(1000);
                        if(!got_option)
                        {
                            ppather.QuestFailed(QuestID);
                            return true; // cry       
                        }
                    }

                }

            }
        }

        public class ActivityPickup : Activity
        {
            GNode node;
            public ActivityPickup(Task t, GNode node)
                : base(t, "Pickup " + node.Name)
            {
                this.node = node;
            }

            public override Location GetLocation()
            {
                return null; // I will not move
            }

            public override bool Do()
            {
                ppather.Face(node);
                int n = 3;
                // Todo, special for mines
                if (node.IsMineral)
                    n = 6;
                do
                {
            ppather.Face(node);
                    node.Interact();
                    if(GContext.Main.Me.IsInCombat) return false;

                    Thread.Sleep(500);
                    while (GContext.Main.Me.IsCasting)
                        Thread.Sleep(200);

                    if (GContext.Main.Me.IsInCombat) return false;
                    bool clicked = false;
                    GSpellTimer bop = new GSpellTimer(500);
                    do
                    {
                        for (int i = 1; i <= 4; i++)
                        {
                            if (PPather.Popup.IsVisible(i))
                            {
                                GContext.Main.Log("Got a loot dialog(" + i + "). Click first button");
                                PPather.Popup.ClickButton(i, 1);
                                clicked = true;
                            }
                        }
                    } while (!bop.IsReadySlow && !clicked);
                    if (GContext.Main.Me.IsInCombat) return false;
                    Thread.Sleep(2500);
                    if (GContext.Main.Me.IsInCombat) return false;
                    n--;
                } while (node.IsValid && n > 0);
                ppather.PickedUp(node);


                return true;
            }
        }

        public class ActivitySellAndRepair : Activity
        {
            GUnit npc;
            bool SellGrey; 
            bool SellWhite; 
            bool SellGreen;
            List<string> Protected; 

            public ActivitySellAndRepair(Task t, GUnit npc, 
                        bool SellGrey, bool SellWhite, bool SellGreen, 
                        List<string> Protected)
                : base(t, "SellRepair")
            {
                this.npc = npc;
                this.SellGrey = SellGrey; 
                this.SellWhite= SellWhite; 
                this.SellGreen = SellGreen;
                this.Protected = Protected; 
            }

            public override Location GetLocation()
            {
                return null; // I will not move
            }


            /*
              This will not work if you have "holes" in your bag slots. 
              All bags must be packed to the right 
            */
            bool SellStuff(int bagNr)
            {
                // cb=0 default bag
                // cb=1 bar #1 ...
                long[] AllBags = GPlayerSelf.Me.Bags;
                long[] Contents;
                int SlotCount;
                bool SellAnything = false;
                if (bagNr == 0)
                {
                    Contents = GContext.Main.Me.BagContents;
                    SlotCount = 16;
                }
                else
                {
                    GContainer bag = (GContainer)GObjectList.FindObject(AllBags[bagNr - 1]);
                    if (bag != null)
                    {
                        Contents = bag.BagContents;
                        SlotCount = bag.SlotCount;
                    }
                    else
                        return false;
                }
                
                for (int i = 0; i < Contents.Length; i++)
                {
                    bool Skip = false;
                    if (Contents[i] == 0)
                        continue;
                    
                    GItem CurItem = (GItem)GObjectList.FindObject(Contents[i]);
                    //Context.Log("Checking: " + CurItem.Name);
                    string ItemName = CurItem.Name.ToLower();
                    foreach (string ProtItem in Protected)
                    {
                        if (ProtItem != "" && ItemName.Contains(ProtItem))
                        {
                            //Context.Log("Not Selling Item: " + CurItem.Name + " Reason=\"Is on safe list\"");
                            Skip = true;
                            break;
                        }
                    }
                    //GContext.Main.Log("quality: " + CurItem.Definition.Quality);
                    //GContext.Main.Log(" gray " + SellGrey + " white " + SellWhite + " green" + SellGrey);
                    if ((CurItem.Definition.Quality == GItemQuality.Poor && SellGrey) ||
                        (CurItem.Definition.Quality == GItemQuality.Common && SellWhite) ||
                        (CurItem.Definition.Quality == GItemQuality.Uncommon && SellGreen))
                    {
                        // Sell the crap
                    }
                    else
                        Skip = true;
                    
                    //If we got here, we plan on selling the item
                    if (!Skip)
                    {
                        GContext.Main.Log("  Will sell item: " + CurItem.Name);
                        SellAnything = true;

                        GInterfaceObject CurItemObj = GContext.Main.Interface.GetByName("ContainerFrame" + (bagNr + 1) + "Item" + (SlotCount - i));
                        CurItemObj.ClickMouse(true);
                        Thread.Sleep(500);
                        
                    }
                }
                return SellAnything;
            }

            bool CheckBags()
            {
              bool sell = false;
              for (int i = 0; i < 5; i++)
              {
                  if (SellStuff(i))
                      sell = true;
              }
              return sell;
            }


            public override bool Do()
            {
                ppather.Face(npc);
                npc.Interact();
                Thread.Sleep(500);

                /*
                if (GPlayerSelf.Me.Target != npc)
                  {
                    GContext.Main.Log("Never managed to click on vendor");
                    return true;
                  }
                */
                GMerchant Merchant = new GMerchant();
                
                if (Merchant.IsVisible)
                {                                            
                    for (int b = 0; b < 4; b++)
                    {
                        GInterfaceObject CurBag = GContext.Main.Interface.GetByName("CharacterBag" + b + "Slot");
                        if (CurBag != null )
                        {
                            CurBag.ClickMouse(false);
                            Thread.Sleep(100);
                        }
                    }
                    
                    CheckBags();
                    
                    
                    if (Merchant.IsRepairEnabled)   // Might as well fix it up while we're here.  
                    {
                        GContext.Main.Log("  Reparing");
                        Merchant.ClickRepairButton();
                    }
                    
                    Merchant.Close();
                }
                
                return true;
            }
        }

        public class ActivityWalkTo : Activity
        {
            private Location to;
            private EasyMover em;
            private float howClose;
            public EasyMover.MoveResult MoveResult = EasyMover.MoveResult.Moving;

            public ActivityWalkTo(Task t, Location to, float howClose)
                : base(t, "Walk to " + to)
            {
                this.to = to;
                this.howClose = howClose;
            }

            public override Location GetLocation()
            {
                return to;
            }

            public override void Start()
            {
                // Create a path
                em = new EasyMover(ppather, to, false, true);
            }

            public override bool Do()
            {
                if (em == null) return true; // WTF!

                MoveResult = em.move();
                if (MoveResult != EasyMover.MoveResult.Moving) return true; // done, can't do more

                Location meLocation = new Location(GContext.Main.Me.Location);
                if (meLocation.GetDistanceTo(to) < howClose)
                {
                    PPather.mover.Stop();
                    return true;
                }
                return false;
            }

            public override void Stop()
            {
                PPather.mover.Stop();
                em = null;

            }
        }

        public class ActivityApproach : Activity
        {
            private GUnit monster;
            private EasyMover em;
            private Location to;
            private float howClose;
            public EasyMover.MoveResult MoveResult = EasyMover.MoveResult.Moving;

            public ActivityApproach(Task t, GUnit monster, float howClose)
                : base(t, "Approach " + monster.Name)
            {
                this.monster = monster;
                this.howClose = howClose;
            }

            public override Location GetLocation()
            {
                return new Location(monster.Location);
            }

            public override void Start()
            {
                // Create a path
                to = GetLocation();
                em = new EasyMover(ppather, to, false, true);
            }

    GSpellTimer tabSpam = new GSpellTimer(600);
            public override bool Do()
            {
                if (em == null) return true; // WTF!

                if (GContext.Main.Me.Target != monster && tabSpam.IsReady && monster.DistanceToSelf < 50)
                {
                    GContext.Main.SendKey("Common.Target");
                    tabSpam.Reset();
                }

        if (GetLocation().GetDistanceTo(to) > GContext.Main.MeleeDistance)
                {
                    // need a new path, monster moved
                    to = GetLocation();
                    em = new EasyMover(ppather, to, false, true);
                }

                MoveResult = em.move();
                if (MoveResult != EasyMover.MoveResult.Moving) return true; // done, can't do more

                Location meLocation = new Location(GContext.Main.Me.Location);
                if (meLocation.GetDistanceTo(to) < howClose)
                {
                    PPather.mover.Stop();
                    return true;
                }
                return false;
            }

            public EasyMover.MoveResult GetMoveResult()
            {
                return MoveResult;
            }
            
            public override void Stop()
            {
                PPather.mover.Stop();
                em = null;

            }
        }




    


        // END PPather
        ///////////////////////////////////////////////////////

        ///////////////////////////////////////////////////////
        // START PathGraph
        public class Location
        {
            private float x;
            private float y;
            private float z;

            public Location(GLocation l)
            {
                this.x = l.X; this.y = l.Y; this.z = l.Z;
            }


            public Location(float x, float y, float z)
            {
                this.x = x; this.y = y; this.z = z;
            }

            public float X { get { return x; } }
            public float Y { get { return y; } }
            public float Z { get { return z; } }
            public float GetDistanceTo(Location l)
            {
                float dx = x - l.X;
                float dy = y - l.Y;
                float dz = z - l.Z;
                return (float)Math.Sqrt(dx * dx + dy * dy + dz * dz);
            }

            public override String ToString()
            {
                //String s = String.Format(
                String s = "{" + x + ":" + y + ":" + z + "}";
                return s;
            }


            public Location InFrontOf(float heading, float d)
            {
                float nx = x + (float)Math.Cos(heading) * d;
                float ny = y + (float)Math.Sin(heading) * d;
                float nz = z;
                return new Location(nx, ny, nz);
            }

            public ulong GUID()
            {
                ulong ix = (ulong)(x + 100000.0);
                ulong iy = (ulong)(y + 100000.0);
                ulong iz = (ulong)(z + 100000.0);
                ulong g = ix | (iy << 24) | (iz << 48);
                return g;
            }
        }

        public class GraphChunk
        {
            public const int CHUNK_SIZE = 512;


            float base_x, base_y;
            public int ix, iy;
            public bool modified = false;
            public long LRU = 0;

            Spot[,] spots;

            public GraphChunk(float base_x, float base_y, int ix, int iy)
            {
                this.base_x = base_x;
                this.base_y = base_y;
                this.ix = ix;
                this.iy = iy;
                spots = new Spot[CHUNK_SIZE, CHUNK_SIZE];
                modified = false;
            }

            public void Clear()
            {
                foreach (Spot s in spots)
                    if (s != null) s.traceBack = null;

                spots = null;
            }

            private void LocalCoords(float x, float y, out int ix, out int iy)
            {
                ix = (int)(x - base_x);
                iy = (int)(y - base_y);
            }

            public Spot GetSpot2D(float x, float y)
            {
                int ix, iy;
                LocalCoords(x, y, out ix, out iy);
                Spot s = spots[ix, iy];
                return s;
            }

            public Spot GetSpot(float x, float y, float z)
            {
                Spot s = GetSpot2D(x, y);

                while (s != null && !s.IsCloseZ(z))
                {
                    s = s.next;
                }

                return s;
            }

            // return old spot at conflicting poision
            // or the same as passed the function if all was ok
            public Spot AddSpot(Spot s)
            {
                Spot old = GetSpot(s.X, s.Y, s.Z);
                if (old != null) return old;
                int x, y;

                s.chunk = this;

                LocalCoords(s.X, s.Y, out x, out y);

                s.next = spots[x, y];
                spots[x, y] = s;
                modified = true;
                return s;
            }




            public List<Spot> GetAllSpots()
            {
                List<Spot> l = new List<Spot>();
                for (int x = 0; x < CHUNK_SIZE; x++)
                {
                    for (int y = 0; y < CHUNK_SIZE; y++)
                    {
                        Spot s = spots[x, y];
                        while (s != null)
                        {
                            l.Add(s);
                            s = s.next;
                        }
                    }
                }
                return l;
            }

            private string FileName()
            {
                return String.Format("c_{0,3:000}_{1,3:000}.bin", ix, iy);
            }

            private const uint FILE_MAGIC = 0x12341234;
            private const uint FILE_ENDMAGIC = 0x43214321;
            private const uint SPOT_MAGIC = 0x53504f54;


            // Per spot: 
            // uint32 magic
            // uint32 reserved;
            // uint32 flags;
            // float x;
            // float y;
            // float z;
            // uint32 no_paths
            //   for each path
            //     float x;
            //     float y;
            //     float z;


            public bool Load(string baseDir)
            {
                string fileName = FileName();
                string filenamebin = baseDir + fileName;

                System.IO.Stream stream = null;
                System.IO.BinaryReader file = null;
                int n_spots = 0;
                int n_steps = 0;
                try
                {
                    stream = System.IO.File.OpenRead(filenamebin);
                    if (stream != null)
                    {
                        file = new System.IO.BinaryReader(stream);
                        if (file != null)
                        {
                            uint magic = file.ReadUInt32();
                            if (magic == FILE_MAGIC)
                            {

                                uint type;
                                while ((type = file.ReadUInt32()) != FILE_ENDMAGIC)
                                {
                                    n_spots++;
                                    uint reserved = file.ReadUInt32();
                                    uint flags = file.ReadUInt32();
                                    float x = file.ReadSingle();
                                    float y = file.ReadSingle();
                                    float z = file.ReadSingle();
                                    uint n_paths = file.ReadUInt32();
                                    Spot s = new Spot(x, y, z);
                                    s.flags = flags;

                                    for (uint i = 0; i < n_paths; i++)
                                    {
                                        n_steps++;
                                        float sx = file.ReadSingle();
                                        float sy = file.ReadSingle();
                                        float sz = file.ReadSingle();
                                        s.AddPathTo(sx, sy, sz);
                                    }
                                    AddSpot(s);
                                }
                            }
                        }
                    }
                }
                catch { }
                if (file != null)
                {
                    file.Close();
                }
                if (stream != null)
                {
                    stream.Close();
                }


                Log("Loaded " + fileName + " " + n_spots + " spots " + n_steps + " steps");

                modified = false;
                return false;
            }




            public bool Save(string baseDir)
            {
                if (!modified) return true; // doh

                string fileName = FileName();
                string filename = baseDir + fileName;

                System.IO.Stream fileout = null;
                System.IO.BinaryWriter file = null;

                try
                {
                    System.IO.Directory.CreateDirectory(baseDir);
                }
                catch { };

                int n_spots = 0;
                int n_steps = 0;
                try
                {

                    fileout = System.IO.File.Create(filename + ".new");

                    if (fileout != null)
                    {
                        file = new System.IO.BinaryWriter(fileout);

                        if (file != null)
                        {
                            file.Write(FILE_MAGIC);

                            List<Spot> spots = GetAllSpots();
                            foreach (Spot s in spots)
                            {
                                file.Write(SPOT_MAGIC);
                                file.Write((uint)0); // reserved
                                file.Write((uint)s.flags);
                                file.Write((float)s.X);
                                file.Write((float)s.Y);
                                file.Write((float)s.Z);
                                uint n_paths = (uint)s.n_paths;
                                file.Write((uint)n_paths);
                                for (uint i = 0; i < n_paths; i++)
                                {
                                    uint off = i * 3;
                                    file.Write((float)s.paths[off]);
                                    file.Write((float)s.paths[off + 1]);
                                    file.Write((float)s.paths[off + 2]);
                                    n_steps++;
                                }
                                n_spots++;

                            }

                            file.Write(FILE_ENDMAGIC);
                        }

                        if (file != null)
                        {
                            file.Close(); file = null;
                        }

                        if (fileout != null)
                        {
                            fileout.Close(); fileout = null;
                        }

                        String old = filename + ".bak";

                        if (System.IO.File.Exists(old))
                            System.IO.File.Delete(old);
                        if (System.IO.File.Exists(filename))
                            System.IO.File.Move(filename, old);
                        System.IO.File.Move(filename + ".new", filename);
                        if (System.IO.File.Exists(old))
                            System.IO.File.Delete(old);

                        modified = false;
                    }
                    else
                    {
                        Log("Save failed");
                    }
                }
                catch (Exception e)
                {
                    Log("Save failed " + e);
                }

                if (file != null)
                {
                    file.Close(); file = null;
                }

                if (fileout != null)
                {
                    fileout.Close(); fileout = null;
                }

                Log("Saved " + fileName + " " + n_spots + " spots " + n_steps + " steps");

                return false;
            }

            private void Log(String s)
            {
                Console.WriteLine(s);
                //GContext.Main.Log(s);
            }
        }

        public class Spot
        {
            public const float Z_RESOLUTION = 2.0f; // Z spots max this close

            public const uint FLAG_VISITED = 0x0001;
            public const uint FLAG_BLOCKED = 0x0002;
            public const uint FLAG_MPQ_MAPPED = 0x0004;
            public const uint FLAG_WATER = 0x0008;

            public float X, Y, Z;
            public uint flags;


            public int n_paths = 0;
            public float[] paths; // 3 floats per outgoing path


            public GraphChunk chunk = null;
            public Spot next;  // list on same x,y, used by chunk

            public int searchID = 0;
            public Spot traceBack; // Used by search
            public float score; // Used by search
            public bool closed, scoreSet;


            public Spot(float x, float y, float z)
            {
                this.X = x;
                this.Y = y;
                this.Z = z;
            }

            public Spot(Location l)
            {
                this.X = l.X;
                this.Y = l.Y;
                this.Z = l.Z;
            }

            public bool IsBlocked()
            {
                return GetFlag(FLAG_BLOCKED);
            }

            public Location location { get { return new Location(X, Y, Z); } }
            public float GetDistanceTo(Location l)
            {
                float dx = l.X - X;
                float dy = l.Y - Y;
                float dz = l.Z - Z;
                return (float)Math.Sqrt(dx * dx + dy * dy + dz * dz);
            }

            public float GetDistanceTo(Spot s)
            {
                float dx = s.X - X;
                float dy = s.Y - Y;
                float dz = s.Z - Z;
                return (float)Math.Sqrt(dx * dx + dy * dy + dz * dz);
            }

            public bool IsCloseZ(float z)
            {
                float dz = z - this.Z;
                if (dz > Z_RESOLUTION) return false;
                if (dz < -Z_RESOLUTION) return false;
                return true;
            }

            public void SetFlag(uint flag, bool val)
            {
                uint old = flags;
                if (val)
                    flags |= flag;
                else
                    flags &= ~flag;
                if (chunk != null && old != flags) chunk.modified = true;
            }

            public bool GetFlag(uint flag)
            {
                return (flags & flag) != 0;
            }

            public void SetLocation(Location l)
            {
                X = l.X;
                Y = l.Y;
                Z = l.Z;
                if (chunk != null) chunk.modified = true;
            }

            public Location GetLocation()
            {
                return new Location(X, Y, Z);
            }

            public bool GetPath(int i, out float x, out float y, out float z)
            {
                x = y = z = 0;
                if (i > n_paths) return false;
                int off = i * 3;
                x = paths[off];
                y = paths[off + 1];
                z = paths[off + 2];
                return true;
            }


            public Spot GetToSpot(PathGraph pg, int i)
            {
                float x, y, z;
                GetPath(i, out x, out y, out z);
                return pg.GetSpot(x, y, z);

            }

            public List<Spot> GetPathsToSpots(PathGraph pg)
            {
                List<Spot> list = new List<Spot>(n_paths);
                for (int i = 0; i < n_paths; i++)
                {
                    list.Add(GetToSpot(pg, i));
                }
                return list;
            }

            public List<Location> GetPaths()
            {
                List<Location> l = new List<Location>();
                if (paths == null) return l;
                for (int i = 0; i < n_paths; i++)
                {
                    int off = i * 3;
                    Location loc = new Location(paths[off], paths[off + 1], paths[off + 2]);
                    l.Add(loc);
                }
                return l;
            }

            public bool HasPathTo(PathGraph pg, Spot s)
            {
                for (int i = 0; i < n_paths; i++)
                {
                    Spot to = GetToSpot(pg, i);
                    if (to == s) return true;
                }
                return false;
            }

            public bool HasPathTo(Location l)
            {
                return HasPathTo(l.X, l.Y, l.Z);
            }



            public bool HasPathTo(float x, float y, float z)
            {
                if (paths == null) return false;
                for (int i = 0; i < n_paths; i++)
                {
                    int off = i * 3;
                    if (x == paths[off] &&
                       y == paths[off + 1] &&
                       z == paths[off + 2])
                        return true;
                }
                return false;
            }

            public void AddPathTo(Spot s)
            {
                AddPathTo(s.X, s.Y, s.Z);
            }

            public void AddPathTo(Location l)
            {
                AddPathTo(l.X, l.Y, l.Z);
            }

            public void AddPathTo(float x, float y, float z)
            {
                if (HasPathTo(x, y, z)) return;
                int old_size;
                if (paths == null) old_size = 0; else old_size = paths.Length / 3;
                if (n_paths + 1 > old_size)
                {
                    int new_size = old_size * 2;
                    if (new_size < 4) new_size = 4;
                    Array.Resize<float>(ref paths, new_size * 3);
                }

                int off = n_paths * 3;
                paths[off] = x;
                paths[off + 1] = y;
                paths[off + 2] = z;
                n_paths++;
                if (chunk != null) chunk.modified = true;
            }

            public void RemovePathTo(Location l)
            {
                RemovePathTo(l.X, l.Y, l.Z);
            }

            public void RemovePathTo(float x, float y, float z)
            {
                // look for it
                int found_index = -1;
                for (int i = 0; i < n_paths && found_index == -1; i++)
                {
                    int off = i * 3;
                    if (paths[off] == x &&
                       paths[off + 1] == y &&
                       paths[off + 2] == z)
                    {
                        found_index = i;
                    }
                }
                if (found_index != -1)
                {
                    GContext.Main.Log("Remove path (" + found_index + ") to " + x + " " + y + " " + n_paths);
                    for (int i = found_index; i < n_paths - 1; i++)
                    {
                        int off = i * 3;
                        paths[off] = paths[off + 3];
                        paths[off + 1] = paths[off + 4];
                        paths[off + 2] = paths[off + 5];
                    }
                    n_paths--;
                    if (chunk != null) chunk.modified = true;
                }
                else
                {
                    GContext.Main.Log("Found not path to remove (" + found_index + ") to " + x + " " + y + " ");

                }
            }

            // search stuff

            public bool SetSearchID(int id)
            {
                if (searchID != id)
                {
                    closed = false;
                    scoreSet = false;
                    searchID = id;
                    return true;
                }
                return false;
            }

            public bool SearchIsClosed(int id)
            {
                if (id == searchID) return closed;
                return false;
            }

            public void SearchClose(int id)
            {
                SetSearchID(id);
                closed = true;
            }

            public bool SearchScoreIsSet(int id)
            {
                if (id == searchID) return scoreSet;
                return false;
            }

            public float SearchScoreGet(int id)
            {
                return score;
            }

            public void SearchScoreSet(int id, float score)
            {
                SetSearchID(id);
                this.score = score;
                scoreSet = true;
            }
        }

        class SpotData<T>
        {
            Dictionary<Spot, T> data = new Dictionary<Spot, T>();

            public T Get(Spot s)
            {
                T t = default(T);
                data.TryGetValue(s, out t);
                return t;
            }

            public void Set(Spot s, T t)
            {
                if (data.ContainsKey(s))
                    data.Remove(s);
                data.Add(s, t);
            }

            public bool IsSet(Spot s)
            {
                return data.ContainsKey(s);
            }

        }

        public class Path
        {
            List<Location> locations = new List<Location>();

            public Path()
            {
            }

            public Path(List<Spot> steps)
            {
                foreach (Spot s in steps)
                {
                    AddLast(s.location);
                }
            }

            public int Count()
            {
                return locations.Count;
            }

            public Location GetFirst()
            {
                return Get(0);

            }
            public Location GetSecond()
            {
                if (locations.Count > 1)
                    return Get(1);
                return null;
            }

            public Location GetLast()
            {
                return locations[locations.Count - 1];
            }

            public Location RemoveFirst()
            {
                Location l = Get(0);
                locations.RemoveAt(0);
                return l;
            }

            public Location Get(int index)
            {
                return locations[index];
            }

            public void AddFirst(Location l)
            {
                locations.Insert(0, l);
            }

            public void AddFirst(Path l)
            {
                locations.InsertRange(0, l.locations);
            }

            public void AddLast(Location l)
            {
                locations.Add(l);
            }


            public void AddLast(Path l)
            {
                locations.AddRange(l.locations);
            }
        }

        public interface ILocationHeuristics
        {
          float Score(float x, float y, float z); 
        }

        public class PathGraph
        {
            const float toonHeight = 2.0f;
            const float toonSize = 0.5f;


            public const float MinStepLength = 2f;
            public const float WantedStepLength = 3f;
            public const float MaxStepLength = 5f;

            public const float CHUNK_BASE = 100000.0f; // Always keep positive
            string BaseDir = "pathing2";
            string Continent;
            SparseMatrix2D<GraphChunk> chunks;

            public ILocationHeuristics locationHeuristics = null;

    public ChunkedTriangleCollection triangleWorld;
            public TriangleCollection paint;

            List<GraphChunk> ActiveChunks = new List<GraphChunk>();
            long LRU = 0;


            public PathGraph(string continent,
                             ChunkedTriangleCollection triangles,
                             TriangleCollection paint)
            {
                this.Continent = continent;
                this.triangleWorld = triangles;
                this.paint = paint;
                Clear();
            }

            public void Close()
            {
                triangleWorld.Close();
            }

            public void Clear()
            {
                chunks = new SparseMatrix2D<GraphChunk>(8);
            }

            private void GetChunkCoord(float x, float y, out int ix, out int iy)
            {
                ix = (int)((CHUNK_BASE + x) / GraphChunk.CHUNK_SIZE);
                iy = (int)((CHUNK_BASE + y) / GraphChunk.CHUNK_SIZE);
            }

            private void GetChunkBase(int ix, int iy, out float bx, out float by)
            {
                bx = (float)ix * GraphChunk.CHUNK_SIZE - CHUNK_BASE;
                by = (float)iy * GraphChunk.CHUNK_SIZE - CHUNK_BASE;
            }

            private GraphChunk GetChunkAt(float x, float y)
            {
                int ix, iy;
                GetChunkCoord(x, y, out ix, out iy);
                GraphChunk c = chunks.Get(ix, iy);
                if (c != null) c.LRU = LRU++;
                return c;
            }

            private void CheckForChunkEvict()
            {
                lock(this)
                {
                    if (ActiveChunks.Count < 25) return;
                    
                    GraphChunk evict = null;
                    foreach (GraphChunk gc in ActiveChunks)
                    {
                        if (evict == null || gc.LRU < evict.LRU)
                        {
                            evict = gc;
                        }
                    }
                    
                    // It is full!
                    evict.Save(BaseDir + "\\" + Continent + "\\");
                    ActiveChunks.Remove(evict);
                    chunks.Clear(evict.ix, evict.iy);
                    evict.Clear();
                }
            }



            public void Save()
            {
                lock(this)
                {
                    ICollection<GraphChunk> l = chunks.GetAllElements();
                    foreach (GraphChunk gc in l)
                    {
                        if (gc.modified)
                        {
                            gc.Save(BaseDir + "\\" + Continent + "\\");
                        }
                    }
                }
            }

            // Create and load from file if exisiting
            private void LoadChunk(float x, float y)
            {
                GraphChunk gc = GetChunkAt(x, y);
                if (gc == null)
                {
                    int ix, iy;
                    GetChunkCoord(x, y, out ix, out iy);

                    float base_x, base_y;
                    GetChunkBase(ix, iy, out base_x, out base_y);

                    gc = new GraphChunk(base_x, base_y, ix, iy);
                    gc.LRU = LRU++;


                    CheckForChunkEvict();

                    gc.Load(BaseDir + "\\" + Continent + "\\");
                    chunks.Set(ix, iy, gc);
                    ActiveChunks.Add(gc);

                }
            }

            public Spot AddSpot(Spot s)
            {
                LoadChunk(s.X, s.Y);
                GraphChunk gc = GetChunkAt(s.X, s.Y);
                return gc.AddSpot(s);
            }

            // Connect according to MPQ data
            public Spot AddAndConnectSpot(Spot s)
            {
                s = AddSpot(s);
                List<Spot> close = FindAllSpots(s.location, MaxStepLength);
                if (!s.GetFlag(Spot.FLAG_MPQ_MAPPED))
                {

                    foreach (Spot cs in close)
                    {
                        if (cs.HasPathTo(this, s) && s.HasPathTo(this, cs) ||
                            cs.IsBlocked())
                        {
                        }
                        else if (!triangleWorld.IsStepBlocked(s.X, s.Y, s.Z, cs.X, cs.Y, cs.Z,
                                                         toonHeight, toonSize, null))
                        {
                            float mid_x = (s.X + cs.X) / 2;
                            float mid_y = (s.Y + cs.Y) / 2;
                            float mid_z = (s.Z + cs.Z) / 2;
                            float stand_z;
                            int flags;
                            if (triangleWorld.FindStandableAt(mid_x, mid_y,
                                                              mid_z - WantedStepLength * .75f, mid_z + WantedStepLength * .75f,
                                                              out stand_z, out flags, toonHeight, toonSize))
                            {
                                s.AddPathTo(cs);
                                cs.AddPathTo(s);
                            }
                        }
                    }
                }
                return s;
            }

            public Spot GetSpot(float x, float y, float z)
            {
                LoadChunk(x, y);
                GraphChunk gc = GetChunkAt(x, y);
                return gc.GetSpot(x, y, z);
            }

            public Spot GetSpot2D(float x, float y)
            {
                LoadChunk(x, y);
                GraphChunk gc = GetChunkAt(x, y);
                return gc.GetSpot2D(x, y);
            }

            public Spot GetSpot(Location l)
            {
                if (l == null) return null;
                return GetSpot(l.X, l.Y, l.Z);
            }



            // this can be slow...

            public Spot FindClosestSpot(Location l_d)
            {
                return FindClosestSpot(l_d, 30.0f, null);
            }

            public Spot FindClosestSpot(Location l_d, Set<Spot> Not)
            {
                return FindClosestSpot(l_d, 30.0f, Not);
            }


            public Spot FindClosestSpot(Location l, float max_d)
            {
                return FindClosestSpot(l, max_d, null);
            }

            // this can be slow...
            public Spot FindClosestSpot(Location l, float max_d, Set<Spot> Not)
            {
                Spot closest = null;
                float closest_d = 1E30f;
                int d = 0;
                while ((float)d <= max_d + 0.1f)
                {
                    for (int i = -d; i <= d; i++)
                    {
                        float x_up = l.X + (float)d;
                        float x_dn = l.X - (float)d;
                        float y_up = l.Y + (float)d;
                        float y_dn = l.Y - (float)d;

                        Spot s0 = GetSpot2D(x_up, l.Y + i);
                        Spot s2 = GetSpot2D(x_dn, l.Y + i);

                        Spot s1 = GetSpot2D(l.X + i, y_dn);
                        Spot s3 = GetSpot2D(l.X + i, y_up);
                        Spot[] sv = { s0, s1, s2, s3 };
                        foreach (Spot s in sv)
                        {
                            Spot ss = s;
                            while (ss != null)
                            {
                                float di = ss.GetDistanceTo(l);
                                if (di < max_d && !ss.IsBlocked() &&
                                    (di < closest_d))
                                {
                                    closest = ss;
                                    closest_d = di;
                                }
                                ss = ss.next;
                            }
                        }
                    }

                    if (closest_d < d) // can't get better
                    {
                        //Log("Closest2 spot to " + l + " is " + closest);
                        return closest;
                    }
                    d++;
                }
                //Log("Closest1 spot to " + l + " is " + closest);
                return closest;
            }

            public List<Spot> FindAllSpots(Location l, float max_d)
            {
                List<Spot> sl = new List<Spot>();

                int d = 0;
                while ((float)d <= max_d + 0.1f)
                {
                    for (int i = -d; i <= d; i++)
                    {
                        float x_up = l.X + (float)d;
                        float x_dn = l.X - (float)d;
                        float y_up = l.Y + (float)d;
                        float y_dn = l.Y - (float)d;

                        Spot s0 = GetSpot2D(x_up, l.Y + i);
                        Spot s2 = GetSpot2D(x_dn, l.Y + i);

                        Spot s1 = GetSpot2D(l.X + i, y_dn);
                        Spot s3 = GetSpot2D(l.X + i, y_up);
                        Spot[] sv = { s0, s1, s2, s3 };
                        foreach (Spot s in sv)
                        {
                            Spot ss = s;
                            while (ss != null)
                            {
                                float di = ss.GetDistanceTo(l);
                                if (di < max_d)
                                {
                                    sl.Add(ss);
                                }
                                ss = ss.next;
                            }
                        }
                    }
                    d++;
                }
                return sl;
            }

            public List<Spot> FindAllSpots(float min_x, float min_y, float max_x, float max_y)
            {
                // hmm, do it per chunk
                List<Spot> l = new List<Spot>();
                for (float mx = min_x; mx <= max_x + GraphChunk.CHUNK_SIZE - 1; mx += GraphChunk.CHUNK_SIZE)
                {
                    for (float my = min_y; my <= max_y + GraphChunk.CHUNK_SIZE - 1; my += GraphChunk.CHUNK_SIZE)
                    {
                        LoadChunk(mx, my);
                        GraphChunk gc = GetChunkAt(mx, my);
                        List<Spot> sl = gc.GetAllSpots();
                        foreach (Spot s in sl)
                        {
                            if (s.X >= min_x && s.X <= max_x &&
                               s.Y >= min_y && s.Y <= max_y)
                            {
                                l.Add(s);
                            }
                        }
                    }
                }
                return l;
            }



            public Spot TryAddSpot(Spot wasAt, Location isAt)
            {
                Spot isAtSpot = FindClosestSpot(isAt, WantedStepLength);
                if (isAtSpot == null)
                {
                    isAtSpot = GetSpot(isAt);
                    if (isAtSpot == null)
                    {
                        Spot s = new Spot(isAt);
                        s = AddSpot(s);
                        isAtSpot = s;
                    }
                    if (isAtSpot.GetFlag(Spot.FLAG_BLOCKED))
                    {
                        isAtSpot.SetFlag(Spot.FLAG_BLOCKED, false);
                        Log("Cleared blocked flag");
                    }
                    if (wasAt != null)
                    {
                        wasAt.AddPathTo(isAtSpot);
                        isAtSpot.AddPathTo(wasAt);
                    }

                    List<Spot> sl = FindAllSpots(isAtSpot.location, MaxStepLength);
                    Log("Learned a new spot at " + isAtSpot.location + " connected to " + sl.Count + " other spots");
                    foreach (Spot other in sl)
                    {
                        if (other != isAtSpot)
                        {
                            other.AddPathTo(isAtSpot);
                            isAtSpot.AddPathTo(other);
                            Log("  connect to " + other.location);
                        }
                    }

                    wasAt = isAtSpot;
                }
                else
                {
                    if (wasAt != null && wasAt != isAtSpot)
                    {
                        // moved to an old spot, make sure they are connected
                        wasAt.AddPathTo(isAtSpot);
                        isAtSpot.AddPathTo(wasAt);
                    }
                    wasAt = isAtSpot;
                }

                return wasAt;
            }

            private bool LineCrosses(Location line0, Location line1, Location point)
            {
                float LineMag = line0.GetDistanceTo(line1); // Magnitude( LineEnd, LineStart );

                float U =
                    (((point.X - line0.X) * (line1.X - line0.X)) +
                      ((point.Y - line0.Y) * (line1.Y - line0.Y)) +
                      ((point.Z - line0.Z) * (line1.Z - line0.Z))) /
                    (LineMag * LineMag);

                if (U < 0.0f || U > 1.0f) return false;

                float InterX = line0.X + U * (line1.X - line0.X);
                float InterY = line0.Y + U * (line1.Y - line0.Y);
                float InterZ = line0.Z + U * (line1.Z - line0.Z);

                float Distance = point.GetDistanceTo(new Location(InterX, InterY, InterZ));
                if (Distance < 0.5f) return true;
                return false;
            }

            public void MarkBlockedAt(Location loc)
            {
                Spot s = new Spot(loc);
                s = AddSpot(s);
                s.SetFlag(Spot.FLAG_BLOCKED, true);
                // Find all paths leading though this one

                List<Spot> sl = FindAllSpots(loc, 5.0f);
                foreach (Spot sp in sl)
                {
                    List<Location> paths = sp.GetPaths();
                    foreach (Location to in paths)
                    {
                        if (LineCrosses(sp.location, to, loc))
                        {
                            sp.RemovePathTo(to);
                        }
                    }
                }

            }

            public void BlacklistStep(Location from, Location to)
            {
                Spot froms = GetSpot(from);
                if (froms != null)
                    froms.RemovePathTo(to);
            }

            public void MarkStuckAt(Location loc, float heading)
            {
                // TODO another day...
                Location inf = loc.InFrontOf(heading, 1.0f);
                MarkBlockedAt(inf);

                // TODO
            }


            //////////////////////////////////////////////////////
            // Searching
            //////////////////////////////////////////////////////



            public Path InterpolatePath(Location from, Location to)
            {
                Path p = new Path();

                //Log("Interpolate from " + from + " to " + to);
                Location prev = from;

                int maxSteps = 100; // max 100 steps
                for (int i = 0; i <= maxSteps; i++)
                {
                    float distance = prev.GetDistanceTo(to);
                    int ss = (int)(distance / WantedStepLength);
                    if (ss == 0) return p;

                    float dx = (to.X - prev.X) / (float)ss;
                    float dy = (to.Y - prev.Y) / (float)ss;
                    float dz = (to.Z - prev.Z) / (float)ss;

                    Location rover = new Location(
                        prev.X + dx,
                        prev.Y + dy,
                        prev.Z + dz);

                    Spot closest = FindClosestSpot(rover, MaxStepLength);
                    if (closest != null && closest.GetDistanceTo(rover) <= WantedStepLength)
                    {
                        // something is there
                        // TODO do something
                    }
                    prev = rover;
                    p.AddLast(rover);
                }
                return p;
            }

            public void Paint()
            {
                if (paint == null) return;
                ICollection<GraphChunk> l = chunks.GetAllElements();
                foreach (GraphChunk gc in l)
                {
                    List<Spot> spots = gc.GetAllSpots();
                    foreach (Spot s in spots)
                    {
                        PaintSpot(s);

                        for (int i = 0; i < s.n_paths; i++)
                        {
                            float x, y, z;
                            s.GetPath(i, out x, out y, out z);
                            paint.PaintPath(s.X, s.Y, s.Z, x, y, z);
                        }
                    }
                }
            }

            void PaintSpot(Spot s)
            {
                if (paint != null)
                    paint.AddMarker(s.X, s.Y, s.Z);
            }

            void PaintBigSpot(Spot s)
            {
                if (paint != null)
                    paint.AddBigMarker(s.X, s.Y, s.Z);
            }


            float TurnCost(Spot from, Spot to)
            {
                Spot prev = from.traceBack;
                if (prev == null) return 0.0f;
                return TurnCost(prev.X, prev.Y, prev.Z, from.X, from.Y, from.Z, to.X, to.Y, to.Z);

            }

            float TurnCost(float x0, float y0, float z0, float x1, float y1, float z1, float x2, float y2, float z2)
            {
                float v1x = x1 - x0;
                float v1y = y1 - y0;
                float v1z = z1 - z0;
                float v1l = (float)Math.Sqrt(v1x * v1x + v1y * v1y + v1z * v1z);
                v1x /= v1l;
                v1y /= v1l;
                v1z /= v1l;

                float v2x = x2 - x1;
                float v2y = y2 - y1;
                float v2z = z2 - z1;
                float v2l = (float)Math.Sqrt(v2x * v2x + v2y * v2y + v2z * v2z);
                v2x /= v2l;
                v2y /= v2l;
                v2z /= v2l;

                float ddx = v1x - v2x;
                float ddy = v1y - v2y;
                float ddz = v1z - v2z;
                return (float)Math.Sqrt(ddx * ddx + ddy * ddy + ddz * ddz);
            }

            // return null if failed or the last spot in the path found

            int searchID = 0;
            private Spot search(Spot src, Spot dst,
                                Location realDst,
                                float minHowClose, bool AllowInvented)
            {
                searchID++;
                int count = 0;
                int prevCount = 0;
                int currentSearchID = searchID;
                float heuristicsFactor = 1.3f;
                System.DateTime pre = System.DateTime.Now;
                System.DateTime lastSpam = pre;

                // lowest first queue
                PriorityQueue<Spot, float> q = new PriorityQueue<Spot, float>(); // (new SpotSearchComparer(dst, score)); ;
                q.Enqueue(src, -src.GetDistanceTo(dst) * heuristicsFactor);
                Spot BestSpot = null;

                //Set<Spot> closed      = new Set<Spot>();
                //SpotData<float> score = new SpotData<float>();

                src.SearchScoreSet(currentSearchID, 0.0f);
                src.traceBack = null;

                // A* -ish algorithm

                while (q.Count != 0) // && count < 100000)
                {
                    float prio;
                    Spot spot = q.Dequeue(out prio); // .Value; 
                    //q.Remove(spot);


                    if (spot.SearchIsClosed(currentSearchID)) continue;
                    spot.SearchClose(currentSearchID);

                    if (count % 100 == 0)
                    {
                        System.TimeSpan span = System.DateTime.Now.Subtract(lastSpam);
                        if (span.Seconds != 0 && BestSpot != null)
                        {
                            Thread.Sleep(50); // give glider a chance to stop us
                            int t = span.Seconds * 1000 + span.Milliseconds;
                            if (t == 0)
                                Log("searching.... " + (count + 1) + " d: " + BestSpot.location.GetDistanceTo(realDst));
                            else
                                Log("searching.... " + (count + 1) + " d: " + BestSpot.location.GetDistanceTo(realDst) + " " + (count - prevCount) * 1000 / t + " steps/s");
                            lastSpam = System.DateTime.Now;
                            prevCount = count;
                        }
                    }
                    count++;


                    if (spot.Equals(dst) || spot.location.GetDistanceTo(realDst) < minHowClose)
                    {
                        System.TimeSpan ts = System.DateTime.Now.Subtract(pre);
                        int t = ts.Seconds * 1000 + ts.Milliseconds;
                        /*if(t == 0)
                            Log("  search found the way there. " + count); 
                        else
                            Log("  search found the way there. " + count + " " + (count * 1000) / t + " steps/s");
                          */
                        return spot; // got there
                    }

                    if (BestSpot == null ||
                       spot.location.GetDistanceTo(realDst) < BestSpot.location.GetDistanceTo(realDst))
                    {
                        BestSpot = spot;
                    }
                    {
                        System.TimeSpan ts = System.DateTime.Now.Subtract(pre);
                        if (ts.Seconds > 15)
                        {
                            Log("too long search, aborting");
                            break;
                        }
                    }

                    float src_score = spot.SearchScoreGet(currentSearchID);

                    //GContext.Main.Log("inspect: " + c + " score " + s);


                    int new_found = 0;
                    List<Spot> ll = spot.GetPathsToSpots(this);
                    foreach (Spot to in ll)
                    {
                        //Spot to = GetSpot(l);

                        if (to != null && !to.IsBlocked() && !to.SearchIsClosed(currentSearchID))
                        {
                            float old_score = 1E30f;

                            float new_score = src_score + spot.GetDistanceTo(to) + TurnCost(spot, to);
                            if(locationHeuristics != null)
                              new_score += locationHeuristics.Score(spot.X, spot.Y, spot.Z);
                            if (to.GetFlag(Spot.FLAG_WATER))
                                new_score += 30;

                            if (to.SearchScoreIsSet(currentSearchID))
                            {
                                old_score = to.SearchScoreGet(currentSearchID);
                            }

                            if (new_score < old_score)
                            {
                                // shorter path to here found
                                to.traceBack = spot;
                                //if (q.Contains(to)) 
                                //   q.Remove(to); // very sloppy to not dequeue it
                                to.SearchScoreSet(currentSearchID, new_score);
                                q.Enqueue(to, -(new_score + to.GetDistanceTo(dst) * heuristicsFactor));
                                new_found++;
                            }
                        }
                    }

                    //hmm search the triangles :p
                    if (!spot.GetFlag(Spot.FLAG_MPQ_MAPPED))
                    {

                        float PI = (float)Math.PI;

                        spot.SetFlag(Spot.FLAG_MPQ_MAPPED, true);
                        for (float a = 0; a < PI * 2; a += PI / 8)
                        {
                            float nx = spot.X + (float)Math.Sin(a) * WantedStepLength;// *0.8f;
                            float ny = spot.Y + (float)Math.Cos(a) * WantedStepLength;// *0.8f;
                            Spot s = GetSpot(nx, ny, spot.Z);
                            if (s == null)
                                s = FindClosestSpot(new Location(nx, ny, spot.Z), MinStepLength); // TODO: this is slow
                            if (s != null)
                            {

                            }
                            else
                            {
                                float new_z;
                                int flags;
                                // gogo find a new one
                                //GContext.Main.Log("gogo brave new world");
                                if (!triangleWorld.FindStandableAt(nx, ny,
                                                                   spot.Z - WantedStepLength * .75f, spot.Z + WantedStepLength * .75f,
                                                                   out new_z, out flags, toonHeight, toonSize))
                                {
                                    Spot blocked = new Spot(nx, ny, spot.Z);
                                    blocked.SetFlag(Spot.FLAG_BLOCKED, true);
                                    AddSpot(blocked);
                                }
                                else
                                {
                                    s = FindClosestSpot(new Location(nx, ny, new_z), MinStepLength);
                                    if (s == null)
                                    {
                                        Spot n = new Spot(nx, ny, new_z);
                                        Spot to = AddAndConnectSpot(n);
                                        if ((flags & ChunkedTriangleCollection.TriangleFlagDeepWater) != 0)
                                        {
                                            to.SetFlag(Spot.FLAG_WATER, true);
                                        }
                                        if (to != n || to.SearchIsClosed(currentSearchID))
                                        {
                                            // GContext.Main.Log("/sigh");
                                        }
                                        else
                                        {
                                            // There should be a path from source to this one now
                                            if (spot.HasPathTo(to.location))
                                            {
                                                float old_score = 1E30f;

                                                float new_score = src_score + spot.GetDistanceTo(to) + TurnCost(spot, to);
                                                if(locationHeuristics != null)
                                                  new_score += locationHeuristics.Score(spot.X, spot.Y, spot.Z);


                                                if (to.GetFlag(Spot.FLAG_WATER))
                                                    new_score += 30;

                                                if (to.SearchScoreIsSet(currentSearchID))
                                                {
                                                    old_score = to.SearchScoreGet(currentSearchID);
                                                }

                                                if (new_score < old_score)
                                                {
                                                    // shorter path to here found
                                                    to.traceBack = spot;
                                                    //if (q.Contains(to)) 
                                                    //    q.Remove(to);
                                                    to.SearchScoreSet(currentSearchID, new_score);
                                                    q.Enqueue(to, -(new_score + to.GetDistanceTo(dst) * heuristicsFactor));
                                                    new_found++;
                                                }
                                            }
                                            else
                                            {
                                                // woot! I added a new one and it is not connected!?!?
                                                //GContext.Main.Log("/cry");
                                            }
                                        }
                                    }
                                }
                            }
                        }

                    }

                }
                {
                    System.TimeSpan ts = System.DateTime.Now.Subtract(pre);
                    int t = ts.Seconds * 1000 + ts.Milliseconds; if (t == 0) t = 1;
                    Log("  search failed. " + (count * 1000) / t + " steps/s");
                    PaintBigSpot(BestSpot);
                }
                return BestSpot; // :(
            }


            private List<Spot> FollowTraceBack(Spot from, Spot to)
            {
                List<Spot> path = new List<Spot>();
                int count = 0;

                Spot r = to;
                path.Insert(0, to); // add last
                while (r != null)
                {
                    Spot s = r.traceBack;

                    if (s != null)
                    {
                        path.Insert(0, s); // add first
                        r = s;
                        if (r == from) r = null;  // fount source
                    }
                    else
                        r = null;
                    count++;
                }
                path.Insert(0, from); // add first
                return path;

            }

            public bool IsUnderwaterOrInAir(Location l)
            {
                int flags;
                float z;
                if (triangleWorld.FindStandableAt(l.X, l.Y, l.Z - 50.0f, l.Z + 5.0f, out z, out  flags, toonHeight, toonSize))
                {
                    if ((flags & ChunkedTriangleCollection.TriangleFlagDeepWater) != 0) 
                      return true; 
                    else
                        return false;
                }
                return true; 
            }

            public Path CreatePath(Spot from, Spot to, Location realDst,
                                   float minHowClose, bool AllowInvented)
            {

                Spot newTo = search(from, to, realDst, minHowClose, AllowInvented);
                if (newTo != null)
                {
                    if (newTo.GetDistanceTo(to) <= minHowClose)
                    {
                        List<Spot> path = FollowTraceBack(from, newTo);
                        return new Path(path);
                    }
                }
                return null;
            }


            public Path CreatePath(Location fromLoc, Location toLoc,
                                   float howClose)
            {

                Spot from = FindClosestSpot(fromLoc, MinStepLength);
                Spot to = FindClosestSpot(toLoc, MinStepLength);

                if (from == null)
                {
                    from = AddAndConnectSpot(new Spot(fromLoc));
                }
                if (to == null)
                {
                    to = AddAndConnectSpot(new Spot(toLoc));
                }

                Path rawPath = CreatePath(from, to, to.location, howClose, true);


                if (rawPath != null && paint != null)
                {
                    Location prev = null;
                    for (int i = 0; i < rawPath.Count(); i++)
                    {
                        Location l = rawPath.Get(i);
                        paint.AddBigMarker(l.X, l.Y, l.Z);
                        if (prev != null)
                        {
                            paint.PaintPath(l.X, l.Y, l.Z + 3, prev.X, prev.Y, prev.Z + 3);
                        }
                        prev = l;
                    }
                }
                if (rawPath == null)
                {
                    return null;
                }
                return rawPath;
            }

            private void Log(String s)
            {
                //Console.WriteLine(s); 
                GContext.Main.Log(s);
            }
        }

        // END PathGrapgh
        ///////////////////////////////////////////////////////


        public class PatherForm : Form
        {
            private PPather pather;
            TreeNode rootNode = null;

            public PatherForm(PPather pather)
            {
                this.pather = pather; 
                InitializeComponent();
            }


            private TreeNode CreateNodeFromTask(Task task)
            { 
                Task[] children = task.GetChildren();
                TreeNode[] childNodes = null;
                if(children != null)
                {
                    childNodes = new TreeNode[children.Length];
                    for (int i = 0; i < children.Length; i++)
                    {
                        childNodes[i] = CreateNodeFromTask(children[i]); 
                    }
                }

                TreeNode n;
                if (childNodes != null)
                    n = new TreeNode(task.ToString(), childNodes); 
                else
                    n = new TreeNode(task.ToString());
                n.Tag = task; 
                return n; 
            }

            private Color white = System.Drawing.Color.FromArgb(255, 255, 255);
            private Color yellow = System.Drawing.Color.FromArgb(255, 255, 128);
            private Color red    = System.Drawing.Color.FromArgb(255, 128, 128);
            private Color green = System.Drawing.Color.FromArgb(128, 255, 128);
            private Color blue  = System.Drawing.Color.FromArgb(155, 165, 255); 

            private void UpdateTreeNodeStatus(TreeNode n)
            {
                Task t = (Task)n.Tag;

                if (t != null)
                {
                    Task.State_e state = t.State;
                    if (state == Task.State_e.Idle)                    
                        n.BackColor = white;                     
                    else if(state == Task.State_e.Done)                    
                        n.BackColor = blue;                     
                    else if (state == Task.State_e.Active)                    
                        n.BackColor = green;                     
                    else if (state == Task.State_e.Want)                    
                        n.BackColor = yellow;                     
                     
                }

                TreeNode child = n.FirstNode;
                while (child != null)
                {
                    UpdateTreeNodeStatus(child);
                    child = child.NextNode; 
                }
            }

            public void CreateTreeFromTasks(Task rootTask)
            {                     
                rootNode = CreateNodeFromTask(rootTask); 
            }

            public void SetStatus(int kills, int KPh, int loots, int XPh, int harvests, int ttl, int deaths)
            {
                lbl_kills.Text = "" + kills + ",  " + KPh + "K/h";
                lbl_loots.Text = "" + loots;
                lbl_XPh.Text = "" + XPh;
                lbl_harvest.Text = "" + harvests;
                int mins = ttl % 60;
                int hs = (ttl - mins) / 60;
                lbl_ttl.Text = "" + hs + "h " + mins + "m";
                lbl_deaths.Text = "" + deaths;
            }


            public void SetTarget(GUnit target)
            {
                if (target == null)
                {
                    lbl_name.Text = "";
                    lbl_reaction.Text = "";
                    lbl_level.Text = "";
                    lbl_faction.Text = "";
                }
                else
                {
                    lbl_name.Text = target.Name;
                    lbl_reaction.Text = target.Reaction.ToString();
                    lbl_level.Text = target.Level.ToString();
                    lbl_faction.Text = target.FactionID.ToString();
                }
            }


            public void SetActivity(Activity activity)
            {
                if (activity == null)
                {
                    lbl_activity.Text = "";
                }
                else
                {
                    lbl_activity.Text = activity.ToString();
                }
            }

            private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
            {
                TreeNode n = e.Node;
                lb_defs.Items.Clear();
                lb_params.Items.Clear();
                if (n == null) return;
                Task t = (Task)n.Tag;
                if (t == null)
                {

                }
                else
                {
                    if (!t.IsParserTask())
                    {
          
                    }
                    else
                    {
                //GContext.Main.Log("marked a task " + t);
                        ParserTask pt = (ParserTask)t;
                        List<string> parms = new List<string>();
                        pt.GetParams(parms);
                        NodeTask tn = pt.nodetask;

                        foreach (string par in parms)
                        {
                            Value v = tn.GetValueOfId(par);
                            string val = "undefined";
                            if (v != null) val = v.GetStringValue();
                            lb_params.Items.Add(par + " = " + val); 
                        }

                    }
                }
            }

            private void btn_go_Click(object sender, EventArgs e)
            {
                pather.WantedState = PPather.RunState_e.Running; 
            }

            private void btn_pause_Click(object sender, EventArgs e)
            {
                pather.WantedState = PPather.RunState_e.Paused; 
            }

            private void btn_stop_Click(object sender, EventArgs e)
            {
                pather.WantedState = PPather.RunState_e.Stopped; 
            }

            private GSpellTimer npc_update = new GSpellTimer(3000); 
            
            private void timer1_Tick(object sender, EventArgs e)
            {
                if (GContext.Main != null && GContext.Main.Me != null && GContext.Main.Me.IsValid)
                {
                    GUnit target = GContext.Main.Me.Target;
                    SetTarget(target);
                    if (npc_update.IsReady)
                    {
                        pather.UpdateNPCs();
                        npc_update.Reset();
                    }
                }
                if (pather.RunState != pather.WantedState)
                {
                    lbl_state.Text = pather.RunState.ToString() + " (" + pather.WantedState.ToString() + ")";
                }
                else 
                { 
                        lbl_state.Text = pather.RunState.ToString();
                }
                if (rootNode != null)
                {
                    treeView1.Nodes.Clear();
                    treeView1.Nodes.Add(rootNode);
                    rootNode = null;
                }

                foreach(TreeNode n in treeView1.Nodes)
                {
                    UpdateTreeNodeStatus(n); 
                }
            }

            /// <summary>
            /// Required designer variable.
            /// </summary>
            private System.ComponentModel.IContainer components = null;

            /// <summary>
            /// Clean up any resources being used.
            /// </summary>
            /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
            protected override void Dispose(bool disposing)
            {
                if (disposing && (components != null))
                {
                    components.Dispose();
                }
                base.Dispose(disposing);
            }

            #region Windows Form Designer generated code

            /// <summary>
            /// Required method for Designer support - do not modify
            /// the contents of this method with the code editor.
            /// </summary>
            private void InitializeComponent()
            {
                this.components = new System.ComponentModel.Container();
                this.label1 = new System.Windows.Forms.Label();
                this.lbl_name = new System.Windows.Forms.Label();
                this.label3 = new System.Windows.Forms.Label();
                this.lbl_reaction = new System.Windows.Forms.Label();
                this.label9 = new System.Windows.Forms.Label();
                this.lbl_level = new System.Windows.Forms.Label();
                this.lbl_faction = new System.Windows.Forms.Label();
                this.label12 = new System.Windows.Forms.Label();
                this.grpBox = new System.Windows.Forms.GroupBox();
                this.groupBox2 = new System.Windows.Forms.GroupBox();
                this.lbl_deaths = new System.Windows.Forms.Label();
                this.label16 = new System.Windows.Forms.Label();
                this.lbl_ttl = new System.Windows.Forms.Label();
                this.label18 = new System.Windows.Forms.Label();
                this.lbl_harvest = new System.Windows.Forms.Label();
                this.label14 = new System.Windows.Forms.Label();
                this.lbl_XPh = new System.Windows.Forms.Label();
                this.label11 = new System.Windows.Forms.Label();
                this.lbl_loots = new System.Windows.Forms.Label();
                this.label8 = new System.Windows.Forms.Label();
                this.lbl_kills = new System.Windows.Forms.Label();
                this.label6 = new System.Windows.Forms.Label();
                this.treeView1 = new System.Windows.Forms.TreeView();
                this.timer1 = new System.Windows.Forms.Timer(this.components);
                this.btn_pause = new System.Windows.Forms.Button();
                this.btn_go = new System.Windows.Forms.Button();
                this.btn_stop = new System.Windows.Forms.Button();
                this.lb_params = new System.Windows.Forms.ListBox();
                this.label4 = new System.Windows.Forms.Label();
                this.label7 = new System.Windows.Forms.Label();
                this.lb_defs = new System.Windows.Forms.ListBox();
                this.label10 = new System.Windows.Forms.Label();
                this.label2 = new System.Windows.Forms.Label();
                this.lbl_activity = new System.Windows.Forms.Label();
                this.label5 = new System.Windows.Forms.Label();
                this.lbl_state = new System.Windows.Forms.Label();
                this.grpBox.SuspendLayout();
                this.groupBox2.SuspendLayout();
                this.SuspendLayout();
                // 
                // label1
                // 
                this.label1.AutoSize = true;
                this.label1.BackColor = System.Drawing.SystemColors.Control;
                this.label1.Location = new System.Drawing.Point(9, 16);
                this.label1.Name = "label1";
                this.label1.Size = new System.Drawing.Size(35, 13);
                this.label1.TabIndex = 0;
                this.label1.Text = "Name";
                // 
                // lbl_name
                // 
                this.lbl_name.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_name.Location = new System.Drawing.Point(50, 16);
                this.lbl_name.Name = "lbl_name";
                this.lbl_name.Size = new System.Drawing.Size(197, 13);
                this.lbl_name.TabIndex = 1;
                // 
                // label3
                // 
                this.label3.AutoSize = true;
                this.label3.BackColor = System.Drawing.SystemColors.Control;
                this.label3.Location = new System.Drawing.Point(9, 29);
                this.label3.Name = "label3";
                this.label3.Size = new System.Drawing.Size(44, 13);
                this.label3.TabIndex = 2;
                this.label3.Text = "Rection";
                // 
                // lbl_reaction
                // 
                this.lbl_reaction.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_reaction.Location = new System.Drawing.Point(50, 29);
                this.lbl_reaction.Name = "lbl_reaction";
                this.lbl_reaction.Size = new System.Drawing.Size(91, 13);
                this.lbl_reaction.TabIndex = 3;
                // 
                // label9
                // 
                this.label9.AutoSize = true;
                this.label9.BackColor = System.Drawing.SystemColors.Control;
                this.label9.Location = new System.Drawing.Point(144, 29);
                this.label9.Name = "label9";
                this.label9.Size = new System.Drawing.Size(33, 13);
                this.label9.TabIndex = 8;
                this.label9.Text = "Level";
                // 
                // lbl_level
                // 
                this.lbl_level.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_level.Location = new System.Drawing.Point(183, 29);
                this.lbl_level.Name = "lbl_level";
                this.lbl_level.Size = new System.Drawing.Size(64, 13);
                this.lbl_level.TabIndex = 9;
                // 
                // lbl_faction
                // 
                this.lbl_faction.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_faction.Location = new System.Drawing.Point(50, 42);
                this.lbl_faction.Name = "lbl_faction";
                this.lbl_faction.Size = new System.Drawing.Size(91, 13);
                this.lbl_faction.TabIndex = 11;
                // 
                // label12
                // 
                this.label12.AutoSize = true;
                this.label12.BackColor = System.Drawing.SystemColors.Control;
                this.label12.Location = new System.Drawing.Point(9, 42);
                this.label12.Name = "label12";
                this.label12.Size = new System.Drawing.Size(42, 13);
                this.label12.TabIndex = 10;
                this.label12.Text = "Faction";
                // 
                // grpBox
                // 
                this.grpBox.Controls.Add(this.label1);
                this.grpBox.Controls.Add(this.lbl_name);
                this.grpBox.Controls.Add(this.lbl_reaction);
                this.grpBox.Controls.Add(this.lbl_level);
                this.grpBox.Controls.Add(this.lbl_faction);
                this.grpBox.Controls.Add(this.label12);
                this.grpBox.Controls.Add(this.label3);
                this.grpBox.Controls.Add(this.label9);
                this.grpBox.Location = new System.Drawing.Point(12, 74);
                this.grpBox.Name = "grpBox";
                this.grpBox.Size = new System.Drawing.Size(265, 65);
                this.grpBox.TabIndex = 15;
                this.grpBox.TabStop = false;
                this.grpBox.Text = "Target";
                // 
                // groupBox2
                // 
                this.groupBox2.Controls.Add(this.lbl_deaths);
                this.groupBox2.Controls.Add(this.label16);
                this.groupBox2.Controls.Add(this.lbl_ttl);
                this.groupBox2.Controls.Add(this.label18);
                this.groupBox2.Controls.Add(this.lbl_harvest);
                this.groupBox2.Controls.Add(this.label14);
                this.groupBox2.Controls.Add(this.lbl_XPh);
                this.groupBox2.Controls.Add(this.label11);
                this.groupBox2.Controls.Add(this.lbl_loots);
                this.groupBox2.Controls.Add(this.label8);
                this.groupBox2.Controls.Add(this.lbl_kills);
                this.groupBox2.Controls.Add(this.label6);
                this.groupBox2.Location = new System.Drawing.Point(12, 6);
                this.groupBox2.Name = "groupBox2";
                this.groupBox2.Size = new System.Drawing.Size(265, 62);
                this.groupBox2.TabIndex = 17;
                this.groupBox2.TabStop = false;
                this.groupBox2.Text = "Status";
                // 
                // lbl_deaths
                // 
                this.lbl_deaths.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_deaths.Location = new System.Drawing.Point(173, 42);
                this.lbl_deaths.Name = "lbl_deaths";
                this.lbl_deaths.Size = new System.Drawing.Size(74, 13);
                this.lbl_deaths.TabIndex = 26;
                // 
                // label16
                // 
                this.label16.AutoSize = true;
                this.label16.BackColor = System.Drawing.SystemColors.Control;
                this.label16.Location = new System.Drawing.Point(132, 42);
                this.label16.Name = "label16";
                this.label16.Size = new System.Drawing.Size(41, 13);
                this.label16.TabIndex = 25;
                this.label16.Text = "Deaths";
                // 
                // lbl_ttl
                // 
                this.lbl_ttl.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_ttl.Location = new System.Drawing.Point(50, 42);
                this.lbl_ttl.Name = "lbl_ttl";
                this.lbl_ttl.Size = new System.Drawing.Size(74, 13);
                this.lbl_ttl.TabIndex = 24;
                // 
                // label18
                // 
                this.label18.AutoSize = true;
                this.label18.BackColor = System.Drawing.SystemColors.Control;
                this.label18.Location = new System.Drawing.Point(9, 42);
                this.label18.Name = "label18";
                this.label18.Size = new System.Drawing.Size(27, 13);
                this.label18.TabIndex = 23;
                this.label18.Text = "TTL";
                // 
                // lbl_harvest
                // 
                this.lbl_harvest.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_harvest.Location = new System.Drawing.Point(173, 29);
                this.lbl_harvest.Name = "lbl_harvest";
                this.lbl_harvest.Size = new System.Drawing.Size(74, 13);
                this.lbl_harvest.TabIndex = 22;
                // 
                // label14
                // 
                this.label14.AutoSize = true;
                this.label14.BackColor = System.Drawing.SystemColors.Control;
                this.label14.Location = new System.Drawing.Point(132, 29);
                this.label14.Name = "label14";
                this.label14.Size = new System.Drawing.Size(44, 13);
                this.label14.TabIndex = 21;
                this.label14.Text = "Harvest";
                // 
                // lbl_XPh
                // 
                this.lbl_XPh.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_XPh.Location = new System.Drawing.Point(50, 29);
                this.lbl_XPh.Name = "lbl_XPh";
                this.lbl_XPh.Size = new System.Drawing.Size(74, 13);
                this.lbl_XPh.TabIndex = 20;
                // 
                // label11
                // 
                this.label11.AutoSize = true;
                this.label11.BackColor = System.Drawing.SystemColors.Control;
                this.label11.Location = new System.Drawing.Point(9, 29);
                this.label11.Name = "label11";
                this.label11.Size = new System.Drawing.Size(32, 13);
                this.label11.TabIndex = 19;
                this.label11.Text = "XP/h";
                // 
                // lbl_loots
                // 
                this.lbl_loots.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_loots.Location = new System.Drawing.Point(173, 16);
                this.lbl_loots.Name = "lbl_loots";
                this.lbl_loots.Size = new System.Drawing.Size(74, 13);
                this.lbl_loots.TabIndex = 18;
                // 
                // label8
                // 
                this.label8.AutoSize = true;
                this.label8.BackColor = System.Drawing.SystemColors.Control;
                this.label8.Location = new System.Drawing.Point(132, 16);
                this.label8.Name = "label8";
                this.label8.Size = new System.Drawing.Size(33, 13);
                this.label8.TabIndex = 17;
                this.label8.Text = "Loots";
                // 
                // lbl_kills
                // 
                this.lbl_kills.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_kills.Location = new System.Drawing.Point(50, 16);
                this.lbl_kills.Name = "lbl_kills";
                this.lbl_kills.Size = new System.Drawing.Size(74, 13);
                this.lbl_kills.TabIndex = 16;
                // 
                // label6
                // 
                this.label6.AutoSize = true;
                this.label6.BackColor = System.Drawing.SystemColors.Control;
                this.label6.Location = new System.Drawing.Point(9, 16);
                this.label6.Name = "label6";
                this.label6.Size = new System.Drawing.Size(25, 13);
                this.label6.TabIndex = 15;
                this.label6.Text = "Kills";
                // 
                // treeView1
                // 
                this.treeView1.Anchor = System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom
                    | System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right;
                this.treeView1.Location = new System.Drawing.Point(283, 22);
                this.treeView1.Name = "treeView1";
                this.treeView1.Size = new System.Drawing.Size(253, 242);
                this.treeView1.TabIndex = 18;
                this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
                // 
                // timer1
                // 
                this.timer1.Enabled = true;
                this.timer1.Interval = 333;
                this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
                // 
                // btn_pause
                // 
                this.btn_pause.Location = new System.Drawing.Point(65, 203);
                this.btn_pause.Name = "btn_pause";
                this.btn_pause.Size = new System.Drawing.Size(49, 27);
                this.btn_pause.TabIndex = 19;
                this.btn_pause.Text = "Pause";
                this.btn_pause.UseVisualStyleBackColor = true;
                this.btn_pause.Click += new System.EventHandler(this.btn_pause_Click);
                // 
                // btn_go
                // 
                this.btn_go.Location = new System.Drawing.Point(15, 203);
                this.btn_go.Name = "btn_go";
                this.btn_go.Size = new System.Drawing.Size(44, 27);
                this.btn_go.TabIndex = 20;
                this.btn_go.Text = "Go";
                this.btn_go.UseVisualStyleBackColor = true;
                this.btn_go.Click += new System.EventHandler(this.btn_go_Click);
                // 
                // btn_stop
                // 
                this.btn_stop.Location = new System.Drawing.Point(120, 203);
                this.btn_stop.Name = "btn_stop";
                this.btn_stop.Size = new System.Drawing.Size(49, 27);
                this.btn_stop.TabIndex = 21;
                this.btn_stop.Text = "Stop";
                this.btn_stop.UseVisualStyleBackColor = true;
                this.btn_stop.Click += new System.EventHandler(this.btn_stop_Click);
                // 
                // lb_params
                // 
                this.lb_params.Anchor = System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right;
                this.lb_params.FormattingEnabled = true;
                this.lb_params.Location = new System.Drawing.Point(546, 22);
                this.lb_params.Name = "lb_params";
                this.lb_params.Size = new System.Drawing.Size(179, 108);
                this.lb_params.TabIndex = 22;
                // 
                // label4
                // 
                this.label4.Anchor = System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right;
                this.label4.AutoSize = true;
                this.label4.BackColor = System.Drawing.SystemColors.Control;
                this.label4.Location = new System.Drawing.Point(546, 6);
                this.label4.Name = "label4";
                this.label4.Size = new System.Drawing.Size(60, 13);
                this.label4.TabIndex = 8;
                this.label4.Text = "Parameters";
                // 
                // label7
                // 
                this.label7.Anchor = System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right;
                this.label7.AutoSize = true;
                this.label7.BackColor = System.Drawing.SystemColors.Control;
                this.label7.Location = new System.Drawing.Point(546, 140);
                this.label7.Name = "label7";
                this.label7.Size = new System.Drawing.Size(56, 13);
                this.label7.TabIndex = 23;
                this.label7.Text = "Interesting";
                // 
                // lb_defs
                // 
                this.lb_defs.Anchor = System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right;
                this.lb_defs.FormattingEnabled = true;
                this.lb_defs.Location = new System.Drawing.Point(546, 156);
                this.lb_defs.Name = "lb_defs";
                this.lb_defs.Size = new System.Drawing.Size(179, 108);
                this.lb_defs.TabIndex = 24;
                // 
                // label10
                // 
                this.label10.AutoSize = true;
                this.label10.BackColor = System.Drawing.SystemColors.Control;
                this.label10.Location = new System.Drawing.Point(283, 6);
                this.label10.Name = "label10";
                this.label10.Size = new System.Drawing.Size(34, 13);
                this.label10.TabIndex = 25;
                this.label10.Text = "Script";
                // 
                // label2
                // 
                this.label2.AutoSize = true;
                this.label2.BackColor = System.Drawing.SystemColors.Control;
                this.label2.Location = new System.Drawing.Point(14, 143);
                this.label2.Name = "label2";
                this.label2.Size = new System.Drawing.Size(41, 13);
                this.label2.TabIndex = 28;
                this.label2.Text = "Activity";
                // 
                // lbl_activity
                // 
                this.lbl_activity.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_activity.Location = new System.Drawing.Point(55, 143);
                this.lbl_activity.Name = "lbl_activity";
                this.lbl_activity.Size = new System.Drawing.Size(197, 13);
                this.lbl_activity.TabIndex = 29;
                // 
                // label5
                // 
                this.label5.AutoSize = true;
                this.label5.BackColor = System.Drawing.SystemColors.Control;
                this.label5.Location = new System.Drawing.Point(14, 187);
                this.label5.Name = "label5";
                this.label5.Size = new System.Drawing.Size(32, 13);
                this.label5.TabIndex = 26;
                this.label5.Text = "State";
                // 
                // lbl_state
                // 
                this.lbl_state.BackColor = System.Drawing.SystemColors.Info;
                this.lbl_state.Location = new System.Drawing.Point(55, 187);
                this.lbl_state.Name = "lbl_state";
                this.lbl_state.Size = new System.Drawing.Size(197, 13);
                this.lbl_state.TabIndex = 27;
                // 
                // PatherForm
                // 
                this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
                this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
                this.ClientSize = new System.Drawing.Size(733, 273);
                this.ControlBox = false;
                this.Controls.Add(this.label2);
                this.Controls.Add(this.lbl_activity);
                this.Controls.Add(this.label5);
                this.Controls.Add(this.lbl_state);
                this.Controls.Add(this.label10);
                this.Controls.Add(this.label7);
                this.Controls.Add(this.lb_defs);
                this.Controls.Add(this.label4);
                this.Controls.Add(this.lb_params);
                this.Controls.Add(this.btn_stop);
                this.Controls.Add(this.btn_go);
                this.Controls.Add(this.btn_pause);
                this.Controls.Add(this.treeView1);
                this.Controls.Add(this.groupBox2);
                this.Controls.Add(this.grpBox);
                this.MaximumSize = new System.Drawing.Size(741, 1000);
                this.MinimumSize = new System.Drawing.Size(290, 262);
                this.Name = "PatherForm";
                this.Text = "Form1";
                this.grpBox.ResumeLayout(false);
                this.grpBox.PerformLayout();
                this.groupBox2.ResumeLayout(false);
                this.groupBox2.PerformLayout();
                this.ResumeLayout(false);
                this.PerformLayout();

            }

            #endregion

            private System.Windows.Forms.Label label1;
            private System.Windows.Forms.Label lbl_name;
            private System.Windows.Forms.Label label3;
            private System.Windows.Forms.Label lbl_reaction;
            private System.Windows.Forms.Label label9;
            private System.Windows.Forms.Label lbl_level;
            private System.Windows.Forms.Label lbl_faction;
            private System.Windows.Forms.Label label12;
            private System.Windows.Forms.GroupBox grpBox;
            private System.Windows.Forms.GroupBox groupBox2;
            private System.Windows.Forms.Label lbl_deaths;
            private System.Windows.Forms.Label label16;
            private System.Windows.Forms.Label lbl_ttl;
            private System.Windows.Forms.Label label18;
            private System.Windows.Forms.Label lbl_harvest;
            private System.Windows.Forms.Label label14;
            private System.Windows.Forms.Label lbl_XPh;
            private System.Windows.Forms.Label label11;
            private System.Windows.Forms.Label lbl_loots;
            private System.Windows.Forms.Label label8;
            private System.Windows.Forms.Label lbl_kills;
            private System.Windows.Forms.Label label6;
            private System.Windows.Forms.TreeView treeView1;
            private System.Windows.Forms.Timer timer1;
            private System.Windows.Forms.Button btn_pause;
            private System.Windows.Forms.Button btn_go;
            private System.Windows.Forms.Button btn_stop;
            private System.Windows.Forms.ListBox lb_params;
            private System.Windows.Forms.Label label4;
            private System.Windows.Forms.Label label7;
            private System.Windows.Forms.ListBox lb_defs;
            private System.Windows.Forms.Label label10;
            private System.Windows.Forms.Label label2;
            private System.Windows.Forms.Label lbl_activity;
            private System.Windows.Forms.Label label5;
            private System.Windows.Forms.Label lbl_state;
        }


    

   



namespace TaskParser
{

    public class RootNode : NodeTask
    {
        public RootNode()
            : base(null)
        {
            type = "Oneshot";
        }

   
        public override Value GetValueOfFcall(string def, List<Value> parms)
        {
            Console.WriteLine("fcall " + def + "(" + parms + ")");

            if (def == "QuestStatus")
            { 
                String q = parms[0].GetStringValue();
                String status = PPather.GetQuestStatus(q);
                //GContext.Main.Log("Quest status of '" + q + "' is " + status);
                return new Value(status);
            }
            return null;
        }


        private int CountFreeBagSlots()
        {
            int count = 0;

            long[] AllBags = GPlayerSelf.Me.Bags;

            for (int bagNr = 0; bagNr < 5; bagNr++)
            {
                long[] Contents;
                int SlotCount;
                if (bagNr == 0)
                {
                    Contents = GContext.Main.Me.BagContents;
                    SlotCount = 16;
                }
                else
                {
                    GContainer bag = (GContainer)GObjectList.FindObject(AllBags[bagNr - 1]);
                    if (bag != null)
                    {
                        Contents = bag.BagContents;
                        SlotCount = bag.SlotCount;
                    }
                    else
                    {
                        SlotCount = 0;
                        Contents = null;
                    }
                }
                for (int i = 0; i < SlotCount; i++)
                {
                    if (Contents[i] == 0)
                        count++;
                }
            }
            return count; 
        }

     

        private Value CreateItemCount()
        {
            Dictionary<String, int> items = new Dictionary<String, int>();
            long[] AllBags = GPlayerSelf.Me.Bags;

            for (int bagNr = 0; bagNr < 5; bagNr++)
            { 
                long[] Contents;
                int SlotCount;
                if(bagNr == 0)
                {
                    Contents = GContext.Main.Me.BagContents;
                    SlotCount = 16;                    
                }
                else
                {
                    GContainer bag = (GContainer)GObjectList.FindObject(AllBags[bagNr - 1]);
                    if (bag != null)
                    {
                        Contents = bag.BagContents;
                        SlotCount = bag.SlotCount;
                    }
                    else
                    {
                        SlotCount = 0;
                        Contents = null; 
                    }                    
                }
                for (int i = 0; i < SlotCount; i++)
                {
                    if (Contents[i] == 0)
                        continue;
                    GItem CurItem = (GItem)GObjectList.FindObject(Contents[i]);
                    if(CurItem != null)
                      {
                        string ItemName = CurItem.Name;
                        int ItemCount = CurItem.StackSize;
                        int OldCount = 0;
                        items.TryGetValue(ItemName, out OldCount);
                        items.Remove(ItemName);
                        items.Add(ItemName, OldCount + ItemCount);
                      }
                }
            }

            Value res = new Value(items);
            return res;
        }

        // compute the works equipped item durability
        float GetDurability()
        {
            float worst = 1.0f;
            
            GItem[] items = GObjectList.GetEquippedItems();
            foreach(GItem item in items)
            {
                if (item.DurabilityMax > 0)
                {
                    float dur = (float)item.Durability;
                    if (dur < worst) worst = dur; 
                }
            }
   
            return worst;
        }

        public override Value GetValueOfId(string def)
        {
            String val = null;
            if(def == "MyLevel")
            {
                val = GContext.Main.Me.Level.ToString();
            }
            else if (def == "ItemCount")
            {
                // Update the item count assoc array from bags
                return CreateItemCount();
            }
           
            else if (def == "FreeBagSlots")
            {
                //GContext.Main.Log("FreeBagSlots not implemented yet");
                return new Value(CountFreeBagSlots());
            }
            else if (def == "MyDurability")
            {
                float dur = GetDurability();
                return new Value(dur);
            }
            else
            {
                val = GContext.Main.GetConfigString(def);
            }
            //    Console.WriteLine("GetValue " + def + " = " + val);
            return new Value(val);
        }

        public override NodeExpression GetExpressionOfId(string def)
        {
            return null; // dynamic value, not defined my expression
        }
    }

    public class Value
    {
        string value; // for scalars
        List<Value> values; // for collections
        Dictionary<String, Value> dic; // for associative arrays

        public Value(string val)
        {
            value = val;
            values = null;
        }

        public Value(int val)
        {
            value = val.ToString();
            values = null;
        }

        public Value(float val)
        {
            value = val.ToString();
            values = null;
        }
        
        public Value(List<Value> val)
        {
            values = null;
            values = val;
        }

        public Value(Dictionary<String, Value> val)
        {
            values = null;
            values = null;
            dic = val;
        }

        // handy utility function 
        public Value(Dictionary<String, int> val)
        {
            values = null;
            values = null;
            dic = new Dictionary<string, Value>();
            foreach (string key in val.Keys)
            {
                int c = 0;
                val.TryGetValue(key, out c);
                Value v = new Value(c);
                SetAssocValue(key, v); 
            }
        }

        public static Value NilValue = new Value("");
        public static Value FalseValue = new Value("false");
        public static Value TrueValue = new Value("true");
        public static Value ZeroValue = new Value("0");

        public bool GetBoolValue()
        {
            string s = GetStringValue();
            if (s == "false" || s == "False") return false;
            if (s == "0") return false;
            if (s == "") return false;
            return true;
        }

        public string GetStringValue()
        {
            if (value != null) return value;
            if (values != null)
            {
                String vs = "[";
                foreach (Value v in values)
                {
                    vs += v.GetStringValue() + ", ";
                }
                return vs + "]"; 
            }
            if (dic != null)
            {
                String vs = "{";
                foreach(String s in dic.Keys)
                {
                    Value val = dic[s];
                    vs += s + " => " + val + ", "; 
                }

                return vs + "}";
            }
            return "";
        }

        public bool IsInt()
        {
            if(this == NilValue) return true; 
            try
            {
                Int32.Parse(GetStringValue());
                return true;
            }
            catch { }
            return false;
        }

        public bool IsFloat()
        {
            if(this == NilValue) return true; 
            try
            {
                Single.Parse(GetStringValue());
                return true;
            }
            catch { }
            return false;
        }
        public bool IsCollection()
        {
            return values != null;
        }
        public bool IsAssocArray()
        {
            return dic != null;
        }

        public void SetAssocValue(string key, Value value)
        {
            if (dic == null)
                dic = new Dictionary<string, Value>();
            this.value  = null;
            this.values = null;

            dic.Remove(key);
            dic.Add(key, value);
        }

        public Value GetAssocValue(string key)
        {
            Value val = null;
            if (dic == null) return null; 
            dic.TryGetValue(key, out val);
            if(val == null) return NilValue;
            return val; 
        }

        public int GetIntValue()
        {
            if(this == NilValue) return 0; 
            try
            {
                return Int32.Parse(GetStringValue());
            }
            catch { }
            return 0;
        }

        public float GetFloatValue()
        {
            if(this == NilValue) return 0; 
            try
            {
                return Single.Parse(GetStringValue());
            }
            catch { }
            return 0.0f;
        }

        public List<string> GetStringCollectionValues()
        {
            List<string> vals = new List<string>();
            if(values == null)
            {
                if (value != null && this != NilValue)
                    vals.Add(GetStringValue()); // not a collection 
            }
            else
            {
                foreach(Value v in values)
                {
                    vals.Add(v.GetStringValue());
                }
            }
            return vals; 
        }

        public List<int> GetIntCollectionValues()
        {
            List<int> vals = new List<int>();
            if(values == null)
            {
                if(value != null && this != NilValue)
                    vals.Add(GetIntValue()); // not a collection 
            }
            else
            {
                foreach(Value v in values)
                {
                    vals.Add(v.GetIntValue());
                }
            }
            return vals; 
        }


        // this has to be a collection of floats with at least 3 items
        public Location GetLocationValue()
        {
            float x = 0,y = 0,z = 0;
            if(values == null) return null;

            int i =  0;
            foreach(Value v in values)
            {
                float f = v.GetFloatValue();
                if(i == 0) x = f;
                if(i == 1) y = f;
                if(i == 2) z = f;    
                i++;
            }            
            return new Location(x,y,z);
        }

        public List<Value> GetCollectionValue()
        {
            if (values != null) return values;
            List<Value> c = new List<Value>();
            if (value != null)
                c.Add(new Value(value));
            return c;
        }
        public override string ToString()
        {
            return GetStringValue();
        }
    }

    public abstract class ASTNode
    {
        public void Error(string err)
        {
            Console.WriteLine("Error: " + err);
        }
        public abstract void dump(int d);
        public string prefix(int d)
        {
            String s = "";
            while (d-- > 0)
                s += "  ";
            return s;
        }
    }

    ////////////////////////////////////////////////////////////////////////
    public abstract class NodeExpression : ASTNode
    {
        protected NodeTask task;

        public NodeExpression(NodeTask task)
        {
            this.task = task;
        }
        public abstract Value GetValue();

        public abstract bool BindSymbols();

    }

    public class LiteralExpression : NodeExpression
    {
        Value val;
        public LiteralExpression(NodeTask task, string val)
            : base(task)
        {
            this.val = new Value(val);
        }
        public LiteralExpression(NodeTask task, Value val)
            : base(task)
        {
            this.val = val;
        }
        public override Value GetValue()
        {
            return val;
        }
        public override void dump(int d)
        {
            Console.Write(val);
        }

        public override bool BindSymbols() { return true; }
    }

    public class IDExpression : NodeExpression
    {
        string id;
        NodeExpression expression;
        public IDExpression(NodeTask task, string id)
            : base(task)
        {
            this.id = id;
        }
        public override Value GetValue()
        {
            if (expression != null)
            {
                // know where it is
                expression.GetValue();
            }

            return task.GetValueOfId(id);
        }
        public override void dump(int d)
        {
            Console.Write("$" + id);
        }

        public override bool BindSymbols()
        {
            expression = task.GetExpressionOfId(id);
            return expression != null;
        }
    }

    public class FcallExpression : NodeExpression
    {
        string id;
        List<NodeExpression> parms;
        public FcallExpression(NodeTask task, string id, List<NodeExpression> parms)
            : base(task)
        {
            this.id = id;
            this.parms = parms;
        }
        public override Value GetValue()
        {
            List<Value> vals = new List<Value>(parms.Count);
            foreach (NodeExpression e in parms)
            {
                Value v = e.GetValue();
                if (v == null) return null;
                vals.Add(v);
            }

            return task.GetValueOfFcall(id, vals);
        }
        public override void dump(int d)
        {
            Console.Write("call " + id + "(");
            foreach (NodeExpression e in parms)
            {
                e.dump(d);
                Console.Write(", ");
            }
            Console.Write(")");
        }

        public override bool BindSymbols()
        {
            bool ok = true;
            foreach (NodeExpression e in parms)
            {
                ok &= e.BindSymbols();
            }
            // TODO check fcall name
            return ok;
        }
    }
    public class CollectionExpression : NodeExpression
    {
        List<NodeExpression> expressions;
        public CollectionExpression(NodeTask task, List<NodeExpression> expressions)
            : base(task)
        {
            this.expressions = expressions;
        }
        public override Value GetValue()
        {
            List<Value> vals = new List<Value>();
            foreach (NodeExpression e in expressions)
            {
                vals.Add(e.GetValue());
            }
            return new Value(vals);
        }
        public override void dump(int d)
        {
            Console.Write("[");
            foreach (NodeExpression e in expressions)
            {
                e.dump(d);
                Console.Write(", ");
            }
            Console.Write("]");
        }
        public override bool BindSymbols()
        {
            bool ok = true;
            foreach (NodeExpression e in expressions)
            {
                ok &= e.BindSymbols();
            }
            return ok;
        }
    }

    public class NegExpression : NodeExpression
    {
        NodeExpression e;
        public NegExpression(NodeTask task, NodeExpression e)
            : base(task)
        {
            this.e = e;
        }
        public override Value GetValue()
        {
            Value v = e.GetValue();
            if (v.IsInt())
            {
                int i = -v.GetIntValue();
                v = new Value(i.ToString());
            }
            else if (v.IsFloat())
            {
                float f = -v.GetFloatValue();
                v = new Value(f.ToString());
            }
            else
            {
                Error("Negating non numerical value " + v);
            }
            return v;
        }
        public override void dump(int d)
        {
            Console.Write("-"); e.dump(d);
        }

        public override bool BindSymbols()
        {
            return e.BindSymbols();
        }
    }

    public abstract class BinExpresssion : NodeExpression
    {
        protected NodeExpression left;
        protected NodeExpression right;
        public BinExpresssion(NodeTask task, NodeExpression left, NodeExpression right)
            : base(task)
        {
            this.left = left;
            this.right = right;
        }
        public abstract string OpName();
        public override void dump(int d)
        {
            Console.Write("(");
            left.dump(d);
            Console.Write(OpName());
            right.dump(d);
            Console.Write(")");
        }

        public override bool BindSymbols()
        {
            return left.BindSymbols() && right.BindSymbols();
        }
    }

    public class AssocReadExpression : BinExpresssion
    {
        public AssocReadExpression(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override Value GetValue()
        {
            Value assoc = left.GetValue();
            Value key = right.GetValue();
            if (assoc == null || key == null) return null;


            String key_s = key.GetStringValue();
            Value val =  assoc.GetAssocValue(key_s);
            //GContext.Main.Log("lookup " + key + " in "+ assoc + " found "+ val);

            return val;

        }
        public override string OpName() { return null; } // not used
        
        public override void dump(int d)
        {
            left.dump(d);
            Console.Write("{");
            right.dump(d);
            Console.Write("}"); 

        }

    }

    public abstract class BoolBinExpression : BinExpresssion
    {
        public BoolBinExpression(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override Value GetValue()
        {
            Value val0 = left.GetValue();
            Value val1 = right.GetValue();

            if(val0 == null || val1 == null) return null;
            bool c0 = val0.GetBoolValue();
            bool c1 = val1.GetBoolValue();

            bool res = BoolOp(c0, c1);
            if(res) return Value.TrueValue;
            else return Value.FalseValue;
                        
        }
        public abstract bool BoolOp(bool a, bool b);

    }

    public class ExprAnd : BoolBinExpression
    {
        public ExprAnd(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool BoolOp(bool a, bool b) { return a && b; }
        public override string OpName() { return "&&"; }
    }

    public class ExprOr : BoolBinExpression
    {
        public ExprOr(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        {

        }
        public override bool BoolOp(bool a, bool b) { return a || b; }
        public override string OpName() { return "||"; }
    }

    public abstract class ArithBinExpression : BinExpresssion
    {
        public ArithBinExpression(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override Value GetValue()
        {
            Value val0 = left.GetValue();
            Value val1 = right.GetValue();
            if (val0.IsInt() && val1.IsInt())
            {
                int c0 = val0.GetIntValue();
                int c1 = val1.GetIntValue();
                return new Value(IntOp(c0, c1).ToString());

            }
            if ((val0.IsFloat() && val1.IsFloat()) ||
                (val0.IsInt() && val1.IsFloat()) ||
                (val0.IsFloat() && val1.IsInt()))
            {
                float c0 = val0.GetFloatValue();
                float c1 = val1.GetFloatValue();
                float sum = c0 + c1;
                return new Value(FloatOp(c0, c1).ToString());
            }
            return GenericOp(val0, val1);
        }

        public abstract float FloatOp(float a, float b);
        public abstract int IntOp(int a, int b);
        public virtual Value GenericOp(Value a, Value b)
        {
            Error("op " + this + " can not handle " + a + " and " + b);
            return null;
        }

    }
    public abstract class CmpExpression : BinExpresssion
    {
        public CmpExpression(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override Value GetValue()
        {
            Value val0 = left.GetValue();
            Value val1 = right.GetValue();
            if (val0.IsInt() && val1.IsInt())
            {
                int c0 = val0.GetIntValue();
                int c1 = val1.GetIntValue();
                bool v = IntOp(c0, c1);
                if (v)
                    return Value.TrueValue;
                else
                    return Value.FalseValue;

            }
            if ((val0.IsFloat() && val1.IsFloat()) ||
                (val0.IsInt() && val1.IsFloat()) ||
                (val0.IsFloat() && val1.IsInt()))
            {
                float c0 = val0.GetFloatValue();
                float c1 = val1.GetFloatValue();
                bool v = FloatOp(c0, c1);
                if (v)
                    return Value.TrueValue;
                else
                    return Value.FalseValue;
            }

            bool sv = StringOp(val0.GetStringValue(), val1.GetStringValue());
            if (sv)
                return Value.TrueValue;
            else
                return Value.FalseValue;
        }

        public abstract bool FloatOp(float a, float b);
        public abstract bool IntOp(int a, int b);
        public abstract bool StringOp(string a, string b);

    }
    public class ExprAdd : ArithBinExpression
    {
        public ExprAdd(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override float FloatOp(float a, float b) { return a + b; }
        public override int IntOp(int a, int b) { return a + b; }
        public override string OpName() { return "+"; }
    }

    public class ExprSub : ArithBinExpression
    {
        public ExprSub(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override float FloatOp(float a, float b) { return a - b; }
        public override int IntOp(int a, int b) { return a - b; }
        public override string OpName() { return "-"; }
    }
    public class ExprMul : ArithBinExpression
    {
        public ExprMul(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override float FloatOp(float a, float b) { return a * b; }
        public override int IntOp(int a, int b) { return a * b; }
        public override string OpName() { return "*"; }
    }
    public class ExprDiv : ArithBinExpression
    {
        public ExprDiv(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override float FloatOp(float a, float b) { return a / b; }
        public override int IntOp(int a, int b) { return a / b; }
        public override string OpName() { return "/"; }
    }

    public class ExprCmpGt : CmpExpression
    {
        public ExprCmpGt(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool FloatOp(float a, float b) { return a > b; }
        public override bool IntOp(int a, int b) { return a > b; }
        public override bool StringOp(string a, string b) { return a.CompareTo(b) > 0; }
        public override string OpName() { return ">"; }
    }
    public class ExprCmpGe : CmpExpression
    {
        public ExprCmpGe(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool FloatOp(float a, float b) { return a >= b; }
        public override bool IntOp(int a, int b) { 
            return a >= b; 
        }
        public override bool StringOp(string a, string b) { return a.CompareTo(b) >= 0; }
        public override string OpName() { return ">="; }
    }
    public class ExprCmpEq : CmpExpression
    {
        public ExprCmpEq(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool FloatOp(float a, float b) { return a == b; }
        public override bool IntOp(int a, int b) { return a == b; }
        public override bool StringOp(string a, string b) { return a == b; }
        public override string OpName() { return "=="; }
    }
    public class ExprCmpLe : CmpExpression
    {
        public ExprCmpLe(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool FloatOp(float a, float b) { return a <= b; }
        public override bool IntOp(int a, int b) { return a <= b; }
        public override bool StringOp(string a, string b) { return a.CompareTo(b) <= 0; }
        public override string OpName() { return "<="; }
    }
    public class ExprCmpLt : CmpExpression
    {
        public ExprCmpLt(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool FloatOp(float a, float b) { return a < b; }
        public override bool IntOp(int a, int b) { 
            return a < b; 
        }
        public override bool StringOp(string a, string b) { return a.CompareTo(b) < 0; }
        public override string OpName() { return "<"; }
    }
    public class ExprCmpNe : CmpExpression
    {

        public ExprCmpNe(NodeTask task, NodeExpression a0, NodeExpression a1)
            : base(task, a0, a1)
        { }
        public override bool FloatOp(float a, float b) { return a != b; }
        public override bool IntOp(int a, int b) { return a != b; }
        public override bool StringOp(string a, string b) { return a.CompareTo(b) != 0; }
        public override string OpName() { return "!="; }
    }
    ////////////////////////////////////////////////////////////////////////


    public class NodeDefinition : ASTNode
    {
        NodeTask task;
        string name;
        NodeExpression expression;
        public NodeDefinition(NodeTask task, string name, NodeExpression expression)
        {
            this.task = task;
            this.name = name;
            this.expression = expression;
        }

        public bool IsNamed(string s)
        {
            if (String.Compare(s, name) == 0) return true;
            return false;
        }

        public NodeExpression GetExpression()
        {
            return expression;
        }
        public override void dump(int d)
        {
            Console.Write(prefix(d) + "$" + name + " = ");
            expression.dump(d);
            Console.WriteLine(";");
        }

    }


    public abstract class FuncDefinition
    {
        public abstract bool IsNamed(string s); 
        public abstract Value call(List<Value> parms);
    }


    public class NodeTask : ASTNode
    {
        public NodeTask parent;
        public string type;
        public string name; // might be null
        List<NodeDefinition> definitions = new List<NodeDefinition>();
        List<FuncDefinition> funcDefinitions = new List<FuncDefinition>();
        public List<NodeTask> subTasks = new List<NodeTask>();

        public NodeTask(NodeTask parent)
        {
            this.parent = parent;
        }

        public void AddDefinition(NodeDefinition def)
        {
            definitions.Add(def);
        }

        public void AddTask(NodeTask task)
        {
            subTasks.Add(task);
            task.parent = this;
        }

        public int GetPrio()
        {
            Value val = GetValueOfId("Prio");
            if (!val.IsInt())
                Error("$Prio has bad value " + val);
            return val.GetIntValue();
        }

        public void AddFunction(FuncDefinition fd)
        {
            funcDefinitions.Add(fd); 
        }

        public virtual Value GetValueOfFcall(string def, List<Value> parms)
        {
            int dotIndex = def.IndexOf('.');
            if (dotIndex != -1)
            {
                // dot in name, search in named chilren tasks for it
                String cname = def.Substring(0, dotIndex);
                String cdef = def.Substring(dotIndex + 1);
                foreach (NodeTask t in subTasks)
                {
                    if (t.name != null && t.name == cname)
                    {
                        Value v = t.GetValueOfFcall(cdef, parms);
                        return v;
                    }
                }
            }
            else
            {
                foreach (FuncDefinition d in funcDefinitions)
                {
                    if (d.IsNamed(def))
                    {
                        Value val = d.call(parms);                         
                        return val;
                    }
                }
                if (parent != null)
                    return parent.GetValueOfFcall(def, parms);
            }

            Error("Undfined function " + def);
            return null;
        }

        public bool GetBoolValueOfId(string id)
        {
            Value v = GetValueOfId(id);
            return v.GetBoolValue();
        }

        public float GetFloatValueOfId(string id)
        {
            Value v = GetValueOfId(id);
            return v.GetFloatValue();
        }

        public int GetIntValueOfId(string id)
        {
            Value v = GetValueOfId(id);
            return v.GetIntValue();
        }

        public void SetValueOfId(string def, Value val)
        { 
            NodeDefinition n = null;
            foreach (NodeDefinition d in definitions)
            {
                if (d.IsNamed(def)) n = d;
            }
            if (n != null)            
                definitions.Remove(n);

            n = new NodeDefinition(this, def, new LiteralExpression(this, val));
            definitions.Add(n);

        }

        public virtual Value GetValueOfId(string def)
        {
            int dotIndex = def.IndexOf('.'); 
            if (dotIndex != -1)
            { 
                // dot in name, search in named chilren tasks for it
                String cname = def.Substring(0, dotIndex);
                String cdef  = def.Substring(dotIndex + 1);
                foreach (NodeTask t in subTasks)
                {
                    if (t.name != null && t.name == cname)
                    {
                        Value v = t.GetValueOfId(cdef);
                        return v; 
                    }
                }
            }
            else
            {
                foreach (NodeDefinition d in definitions)
                {
                    if (d.IsNamed(def))
                    {
                        NodeExpression e = d.GetExpression();
                        Value val = e.GetValue();

                        //  GContext.Main.Log(" def: " + def + " got e " + e + " and val " + val);

                        return val;
                    }
                }
                if (parent != null)
                {
                    Value e = parent.GetValueOfId(def);
                    return e;
                }
            }
            Error("No definition of idenfifier " + def);
            return null;
        }

        public virtual NodeExpression GetExpressionOfId(string def)
        {
            /*int dotIndex = def.IndexOf('.'); 
            if (dotIndex != -1)
            {
                // dot in name, search in named chilren tasks for it
                String cname = def.Substring(0, dotIndex);
                String cdef  = def.Substring(dotIndex + 1);
                foreach (
                    NodeTask t in subTasks)
                {
                    if (t.name != null && t.name == cname)
                        return t.GetExpressionOfId(def); 
                }
            }
            else*/
            {
                foreach (NodeDefinition d in definitions)
                {
                    if (d.IsNamed(def))
                    {
                        return d.GetExpression();
                    }
                }
            }
            if (parent != null)
            {
                NodeExpression e = parent.GetExpressionOfId(def);
                return e;
            }
            Error("No definition of idenfifier " + def);
            return null;
        }

        public override void dump(int d)
        {
            Console.WriteLine(prefix(d) + type);
            Console.WriteLine(prefix(d) + "{");

            foreach (NodeDefinition nd in definitions)
            {
                nd.dump(d + 1);
            }
            foreach (NodeTask task in subTasks)
            {
                task.dump(d + 1);
            }
            Console.WriteLine(prefix(d) + "}");


        }


        public bool BindSymbols()
        {
            bool ok = true;
            // Traverse the tree and connect ID expression to their expression
            foreach (NodeDefinition d in definitions)
            {
                NodeExpression e = d.GetExpression();
                ok &= e.BindSymbols();
            }
            foreach (NodeTask t in subTasks)
            {
                ok &= t.BindSymbols();
            }
            return ok;
        }
    }

    class RootTask : NodeTask
    {
        public RootTask()
            : base(null)
        {
        }
        public override Value GetValueOfId(string def)
        {
            Error("Someone is getting value of " + def);
            return null;
        }


    }


    public class TaskParser
    {


        Tokenizer tn;
        public TaskParser(System.IO.TextReader reader)
        {
            tn = new Tokenizer(reader);
        }


        public void Error(string msg)
        {
            GContext.Main.Log("Line " + tn.line + ": " + msg);
        }

        private bool Expect(Token.Type type, string val)
        {
            Token t = tn.Next();
            if (t.type != type || t.val != val)
            {
                Error("Exprected " + val + " found " + t.val);
                return false;
            }
            return true;
        }

        private NodeExpression ParseExpressionP(NodeTask t)
        {
            Token next = tn.Peek();
            if (next.type == Token.Type.Literal)
            {
                // literal expression
                tn.Next();
                Token lpar = tn.Peek();
                if (lpar.type == Token.Type.Keyword && lpar.val == "(")
                {
                    //fcall
                 
                    List<NodeExpression> exprs = new List<NodeExpression>();
                    Token comma = null;
                    do
                    {
                        tn.Next(); // eat ( or , 
                        NodeExpression n = ParseExpression(t);
                        exprs.Add(n);
                        comma = tn.Peek();
                    } while (comma.type == Token.Type.Keyword && comma.val == ",");

                    Expect(Token.Type.Keyword, ")");

                    NodeExpression e = new FcallExpression(t, next.val, exprs);
                    return e;
                }
                else
                {
                    NodeExpression e = new LiteralExpression(t, next.val);

                    return e;
                }
            }
            else if (next.type == Token.Type.ID)
            {
                // ID expression
                tn.Next();

                Token lpar = tn.Peek();

                // assoc lookup
                if (lpar.type == Token.Type.Keyword && lpar.val == "{")
                {
                    tn.Next(); // eat {
                    NodeExpression id = new IDExpression(t, next.val);

                    NodeExpression key = ParseExpression(t);

                    Expect(Token.Type.Keyword, "}");


                    NodeExpression e = new AssocReadExpression(t, id, key);
                    return e;
                }
                else
                {
                    NodeExpression e = new IDExpression(t, next.val);

                    return e;
                }

            }
            else if (next.type == Token.Type.Keyword && next.val == "(")
            {
                // par expressions
                tn.Next();
                NodeExpression n = ParseExpressionE(t);
                Expect(Token.Type.Keyword, ")");
                return n;
            }
            else if (next.type == Token.Type.Keyword && next.val == "[")
            {
                // collection expressions

                List<NodeExpression> exprs = new List<NodeExpression>();
                Token comma = null;
                do
                {
                    tn.Next();
                    Token p = tn.Peek();
                    if (p.type == Token.Type.Keyword && p.val == "]") break; // empty collection
                    NodeExpression n = ParseExpressionE(t);
                    exprs.Add(n);
                    comma = tn.Peek();
                } while (comma.type == Token.Type.Keyword && comma.val == ",");

                Expect(Token.Type.Keyword, "]");
                CollectionExpression ce = new CollectionExpression(t, exprs);
                return ce;
            }
            else if (next.type == Token.Type.Keyword && next.val == "-")
            {
                // unary neg
                Token neg = tn.Next();
                NodeExpression P = ParseExpressionP(t);
                NodeExpression e = new NegExpression(t, P);
                return e;
            }
            else
            {
                Error("Currupt expression");
            }
            return null;
        }


        private NodeExpression ParseExpressionT(NodeTask t)
        {
            // this is the hard one
            NodeExpression o0 = ParseExpressionP(t);

            Token next = tn.Peek();
            while (next.type == Token.Type.Keyword &&
                (next.val == "*" || next.val == "/"))
            {
                Token op = tn.Next();
                NodeExpression o1 = ParseExpressionP(t);
                if (op.val == "*")
                {
                    o0 = new ExprMul(t, o0, o1);

                }
                if (op.val == "/")
                {
                    o0 = new ExprDiv(t, o0, o1);
                }
                next = tn.Peek();
            }
            return o0;
        }

        private NodeExpression ParseExpressionE(NodeTask t)
        {
            // this is the hard one
            NodeExpression o0 = ParseExpressionT(t);

            Token next = tn.Peek();
            while (next.type == Token.Type.Keyword &&
                (next.val == "+" || next.val == "-"))
            {
                Token op = tn.Next();
                NodeExpression o1 = ParseExpressionT(t);
                if (op.val == "+")
                {
                    o0 = new ExprAdd(t, o0, o1);
                }
                if (op.val == "-")
                {
                    o0 = new ExprSub(t, o0, o1);
                }
                next = tn.Peek();
            }
            return o0;
        }

        private NodeExpression ParseExpressionC(NodeTask t)
        {
            NodeExpression o0 = ParseExpressionE(t);

            Token next = tn.Peek();
            while (next.type == Token.Type.Keyword &&
                (next.val == "<" || next.val == "<=" || next.val == "==" ||
                 next.val == ">=" || next.val == ">" || next.val == "!="))
            {
                Token op = tn.Next();
                NodeExpression o1 = ParseExpressionE(t);
                if (op.val == "<")
                    o0 = new ExprCmpLt(t, o0, o1);
                else if (op.val == "<=")
                    o0 = new ExprCmpLe(t, o0, o1);
                else if (op.val == "==")
                    o0 = new ExprCmpEq(t, o0, o1);
                else if (op.val == ">=")
                    o0 = new ExprCmpGe(t, o0, o1);
                else if (op.val == ">")
                    o0 = new ExprCmpGt(t, o0, o1);
                else if (op.val == "!=")
                    o0 = new ExprCmpNe(t, o0, o1);

                next = tn.Peek();
            }
            return o0;
        }

        private NodeExpression ParseExpressionBAnd(NodeTask t)
        {
            NodeExpression o0 = ParseExpressionC(t);

            Token next = tn.Peek();
            while (next.type == Token.Type.Keyword &&
                (next.val == "&&"))
            {
                Token op = tn.Next();
                NodeExpression o1 = ParseExpressionBOr(t);
                if (op.val == "&&")
                    o0 = new ExprAnd(t, o0, o1);
                next = tn.Peek();
            }
            return o0;
        }
        private NodeExpression ParseExpressionBOr(NodeTask t)
        {
            NodeExpression o0 = ParseExpressionBAnd(t);

            Token next = tn.Peek();
            while (next.type == Token.Type.Keyword &&
                (next.val == "||"))
            {
                Token op = tn.Next();
                NodeExpression o1 = ParseExpressionBAnd(t);
                if (op.val == "||")
                    o0 = new ExprOr(t, o0, o1);
                next = tn.Peek();
            }
            return o0;
        }

     

        private NodeExpression ParseExpression(NodeTask t)
        {
            // this is the hard one
            NodeExpression e = ParseExpressionBOr(t);

            Token next = tn.Peek();
            if (next.type == Token.Type.Keyword && next.val == ";")
            {
                // all fine
            }
            else
            {

            }

            return e;
        }

        public NodeTask ParseTask(NodeTask parent)
        {
            NodeTask t = new NodeTask(parent);
            Token r = tn.Peek();
            if (r.type == Token.Type.EOF) return null;

            String s_name = null;
            String s_type = null;

            // Type (or name)
            Token t1 = tn.Next();
            if (t1.type != Token.Type.Literal) // !!!
            {
                Error("Task must have a type or name");
                return null;
            }

            Token colon = tn.Peek();
            if (colon.type == Token.Type.Keyword && colon.val == ":")
            {
                tn.Next(); // eat colon
                Token t2 = tn.Next(); // type
                if (t2.type != Token.Type.Literal) // !!!
                {
                    Error("Expected task type after : in task definition");
                    return null;
                }
                s_name = t1.val;
                s_type = t2.val; 
            }
            else
            {
                s_name = null;
                s_type = t1.val;
            }

            t.type = s_type;
            t.name = s_name; 

            // {            

            if (!Expect(Token.Type.Keyword, "{"))
                return null;



            // definitions
            Token next = tn.Peek();
            while (next.type == Token.Type.ID)
            {
                Token ID = tn.Next(); // chomp ID


                if (!Expect(Token.Type.Keyword, "="))
                    return null;
                NodeExpression expr = ParseExpression(t);


                if (!Expect(Token.Type.Keyword, ";"))
                    return null;
                t.AddDefinition(new NodeDefinition(t, ID.val, expr));
                next = tn.Peek();
            }

            // child tasks
            next = tn.Peek();
            while (next.type == Token.Type.Literal)
            {
                NodeTask child = ParseTask(t);

                t.AddTask(child);
                next = tn.Peek();
            }

            // }

            if (!Expect(Token.Type.Keyword, "}"))
                return null;

            return t;
        }


    }




    class Token
    {
        public enum Type { ID, Literal, Newline, Keyword, EOF };
        public Type type;
        public string val;

        public Token(string s)
        {
            if (s[0] == '$')
            {
                type = Type.ID;
                val = s.Substring(1);
            }
            else
            {
                type = Type.Literal;
                val = s;
            }
        }

        private bool IsIDChar(char c)
        {
            if ((c >= 'a' && c <= 'z') ||
               (c >= 'A' && c <= 'Z') ||
               (c >= '0' && c <= '9') ||
               c == '.' ||
               c == '_'
               )
                return true;
            return false;
        }

        public Token(System.IO.TextReader reader)
        {
            type = Type.EOF;
            try
            {
                bool done = false;
                bool foundNonWhite = false;
                do
                {
                    int c = reader.Peek();
                    if (c == -1) break;
                    if (!foundNonWhite && Char.IsWhiteSpace((char)c))
                    {
                        reader.Read();
                        if ((char)c == '\n')
                        {
                            type = Type.Newline;
                            return;
                        }
                    }
                    else
                    {
                        foundNonWhite = true;
                        if (c == '$')
                        {
                            reader.Read(); // chomp $
                            readLiteral(reader);
                            type = Type.ID;
                            return;
                        }
                        if (c == '"')
                        {
                            readString(reader);
                            return;
                        }
                        else if (IsKeyChar(c))
                        {
                            if (readKeyWord(reader))
                            {
                                // a comment, keep on reading
                                foundNonWhite = false;
                                type = Type.Newline;
                                return;
                            }
                            else
                                return;
                        }
                        else
                        {
                            readLiteral(reader);
                            type = Type.Literal;
                            return;
                        }
                    }
                } while (!done);
            }
            catch (ObjectDisposedException)
            {
                type = Type.EOF;
            }
            catch (System.IO.IOException)
            {
                type = Type.EOF;
            }
            type = Type.EOF;
        }


        private bool IsKeyChar(int c)
        {
            if (c == '+') return true;
            if (c == '-') return true;
            if (c == '*') return true;
            if (c == '/') return true;
            if (c == '>') return true;
            if (c == '=') return true;
            if (c == '!') return true;
            if (c == '<') return true;
            if (c == '{') return true;
            if (c == '}') return true;
            if (c == ':') return true;
            if (c == ';') return true;
            if (c == '(') return true;
            if (c == ')') return true;
            if (c == ',') return true;
            if (c == ']') return true;
            if (c == '[') return true;
            if (c == '&') return true;
            if (c == '|') return true;
            if (c == '^') return true;
            return false;
        }

        // return true if it is a comment
        private bool readKeyWord(System.IO.TextReader reader)
        {
            int i = reader.Read();
            char c = (char)i;
            type = Type.Keyword;
            // some are 2 chars
            char c2 = (char)reader.Peek();

            if (c == '>' && c2 == '=')
            {
                reader.Read();
                val = "" + c + c2;
            }
            else if (c == '<' && c2 == '=')
            {
                reader.Read();
                val = "" + c + c2;
            }
            else if (c == '=' && c2 == '=')
            {
                reader.Read();
                val = "" + c + c2;
            }
            else if (c == '!' && c2 == '=')
            {
                reader.Read();
                val = "" + c + c2;
            }
            else if (c == '&' && c2 == '&')
            {
                reader.Read();
                val = "" + c + c2;
            }
            else if (c == '|' && c2 == '|')
            {
                reader.Read();
                val = "" + c + c2;
            }
            else if (c == '/' && c2 == '/')
            {
                reader.ReadLine();
                return true;
            }
            else
                val = "" + c;
            return false;
        }

        private void readString(System.IO.TextReader reader)
        {
            val = "";
            type = Type.Literal;
            int c = reader.Read(); // read "
            do
            {
                c = reader.Read();

                val += (char)c;
                c = reader.Peek();
            } while (c != -1 && c != '"');
            if (c == '"')
                reader.Read(); // read "
        }

        private void readLiteral(System.IO.TextReader reader)
        {
            val = "";
            type = Type.Literal;
            int c = -1;
            do
            {
                c = reader.Read();
                val += (char)c;
                c = reader.Peek();
            } while (IsIDChar((char)c) && c != -1);
        }



    }

    class Tokenizer
    {
        public int line;
        System.IO.TextReader reader;
        public Tokenizer(System.IO.TextReader reader)
        {
            this.reader = reader;
            line = 1;
        }
        Token current = null;

        public Token Peek()
        {
            if (current == null)
                current = Next();
            return current;
        }

        public Token Next()
        {
            if (current != null)
            {
                Token t = current;
                current = null;
                return t;
            }
            Token r = null;
            do
            {
                r = new Token(reader);
                if (r.type == Token.Type.Newline) line++;
            } while (r.type == Token.Type.Newline);
            return r;
        }
    }

}
